window.addEventListener('message', function(e) {
  if (e.data.action === 'updateCode') {
    document.querySelector('#pb-ac-container #ac-code').innerHTML = decodeEntities(e.data.code);
  } else if (e.data.action === 'updateProgress') {
    var progress = document.querySelector('#pb-ac-container #ac-progress');
    progress.style.width = e.data.percentage;
    progress.innerHTML = decodeEntities(e.data.percentage);
  } else if (e.data.action === 'updateSavings') {
    document.querySelector('#pb-ac-container #ac-title span').innerHTML = decodeEntities(e.data.savings);
    document.querySelector('#pb-ac-container table tr:first-child td:last-child div').innerHTML = decodeEntities(e.data.without);
    document.querySelector('#pb-ac-container table tr:last-child td:last-child div').innerHTML = decodeEntities(e.data.with);
  } else if (e.data.action === 'updateMessage') {
    document.querySelector('#pb-ac-container #ac-title').innerHTML = decodeEntities(e.data.message);
  }
});

var decodeEntities = (function() {
  // this prevents any overhead from creating the object each time
  var element = document.createElement('div');

  function decodeHTMLEntities (str) {
    if(str && typeof str === 'string') {
      // strip script/html tags
      str = str.replace(/<script[^>]*>([\S\s]*?)<\/script>/gmi, '');
      str = str.replace(/<\/?\w(?:[^"'>]|"[^"]*"|'[^']*')*>/gmi, '');
      element.innerHTML = str;
      str = element.textContent;
      element.textContent = '';
    }

    return str;
  }

  return decodeHTMLEntities;
})();