(function() {
  var DEBUG            = ('no' === 'yes');
  var titles           = {
    'ihprices': 'Price Comparison',
    'pb-coupons': '__MSG_coupon_text__s',
    'pb-search': 'Search',
  };
  var isCheckoutPage   = false;
  var isPopupMinimized = true;

  var observerCallback = function(mutationsList) {
    if (isPopupMinimized) {
      setTimeout(function() {
        resizeParent('pb-minimized');
      }, 100);
    }
  };

  var observer = new MutationObserver(observerCallback);

  var setObserverIntervalId = setInterval(function() {
    var element = window.document.querySelector('#pbpopup-container #pb-minimized');

    if (element) {
      observer.observe(element, { childList: true, subtree: true });
      clearInterval(setObserverIntervalId);
    }
  }, 100);

  window.addEventListener('message', function(e) {
    if (e.data.action === 'setPopupContent') {
      var coupons = e.data.content.coupons[0];
      var c_rid = e.data.content.rid;
      var products = e.data.content.products && e.data.content.products[0];
      
      if (coupons) {
        var headerTitle = document.querySelector('#pbpopup-container #pb-header .title');
        titles['pb-coupons'] = coupons.retailer.name + ' __MSG_coupon_text__s';
        headerTitle.innerText = titles['pb-coupons'];

        if (coupons.coupons && coupons.coupons.length > 0) {
          var container = document.querySelector('#pbpopup-container #pb-coupons');
          var placeholder = document.querySelector('#pbpopup-container #pb-coupons .placeholder-text');
          if(placeholder){
            placeholder.remove();
          }
          var titleBar = document.createElement("div");
          titleBar.className  = 'title-bar';
          titleBar.textContent = 'Showing 0 __MSG_coupon_text__s';
          var couponList = document.createElement("div");
          couponList.className  = 'coupons-list';
          container.textContent = '';
          container.appendChild(titleBar);
          container.appendChild(couponList);

          /*container.innerHTML = `
            <div class="title-bar">Showing 0 __MSG_coupon_text__s</div>
            <div class="coupons-list"></div>
          `;*/

          var couponsTitleBar = document.querySelector('#pbpopup-container #pb-coupons .title-bar');
          couponsTitleBar.innerText = 'Showing ' + coupons.coupons.length + ' __MSG_coupon_text__s';

          //addAutoApplyButton();

          var footerCouponAmount = document.querySelector('#pbpopup-container #pb-footer .coupon-amount');
          footerCouponAmount.innerText = coupons.coupons.length;

          var couponsList = document.querySelector('#pbpopup-container #pb-coupons .coupons-list');
          couponsList.textContent  = '';
          insertCoupons(coupons.coupons, couponsList);

          postMessage({
            action: 'setBadge',
            couponCount: coupons.coupons.length,
          }, '*');
        }
      }

      if (e.data.isRetailerHalfSuppressed) {
        retailerHalfSuppressedMsg();
      }

      if (products && products.retailers) {
        if (products.retailers.length > 0) {
          var placeholder = document.querySelector('#pbpopup-container #ihprices .placeholder-text');
          if(placeholder){
            placeholder.remove();
          }          
          var ih_price_container  = document.querySelector('#pbpopup-container #ihprices');
          var headDivContainer = document.createElement("div");
          var tableContainer = document.createElement("table");
          var tableheader = tableContainer.createTHead();
          var tableBody = tableContainer.createTBody();
          headDivContainer.appendChild(tableContainer);
          var trContainer = document.createElement("tr");
          tableheader.appendChild(trContainer); 
          var thSeller = document.createElement("th");
          var thPrice = document.createElement("th");
          var thTotal = document.createElement("th");
          thSeller.textContent = 'Sellers';
          thPrice.textContent = 'Base Price';
          thTotal.textContent = 'Total';
          trContainer.appendChild(thSeller);
          trContainer.appendChild(thPrice);
          trContainer.appendChild(thTotal);

          var feedbackContainer = document.createElement("a");
          feedbackContainer.id  = 'pb-feedback-link';

          var feedbackContainerDiv = document.createElement("div");
          feedbackContainerDiv.className  = 'feedback';
          feedbackContainer.appendChild(feedbackContainerDiv);

          var fCDText = document.createElement("div");
          fCDText.className  = 'text';
          fCDText.textContent = 'Send us Feedback';
          var fCDIconDiv = document.createElement("div");
          fCDIconDiv.className  = 'icon';
          var fCDIcon = document.createElement("i");
          fCDIcon.className  = 'material-icons';
          fCDIcon.textContent = 'arrow_forward';
          fCDIconDiv.appendChild(fCDIcon);

          feedbackContainerDiv.appendChild(fCDText);
          feedbackContainerDiv.appendChild(fCDIconDiv);
          ih_price_container.textContent = '';
          ih_price_container.appendChild(headDivContainer);
          ih_price_container.appendChild(feedbackContainer);

          /*container.innerHTML = `
            <div>
              <table>
                <thead>
                  <tr>
                    <th>Sellers</th>
                    <th>Base Price</th>
                    <th>Total</th>
                  </tr>
                </thead>
                <tbody></tbody>
              </table>
            </div>
            <a id="pb-feedback-link">
              <div class="feedback">
                <div class="text">Send us Feedback</div>
                <div class="icon">
                  <i class="material-icons">arrow_forward</i>
                </div>
              </div>
            </a>
          `;*/
          document.querySelector('#pbpopup-container #ihprices tbody').textContent = '';
          insertRetailers(products.retailers, document.querySelector('#pbpopup-container #ihprices tbody'));
          setFeedbackLink(products.feedback);
        }

        if (products.retailers[0]) {
          var container = document.querySelector('#pbpopup-container #ihprices');
          var input = document.createElement('input');
          input.type = 'hidden';
          input.value = !!products.retailers[0].alert_persist;
          container.appendChild(input);
        }

        if (products.retailers.length === 1 && products.ship_message.includes('at eBay')) {
          setMinimizedMessage(`<div>${decodeEntities(products.ship_message)}</div>`);
          setIcon('alert');
        } else if (/(?:\$|&pound;)\d{1,3}(,\d{3})*\.\d\d less/i.test(products.message)) {
          setSavingsMessage(decodeEntities(products.message));
          setIcon('alert');
        } else if (/(?:\$|&pound;)\d{1,3}(,\d{3})*\.\d\d less/i.test(products.ship_message)) {
          setSavingsMessage(decodeEntities(products.ship_message));
          setIcon('alert');
        } else if (/costs (?:\$|&pound;)\d{1,3}(,\d{3})*\.\d\d/i.test(products.ship_message)) {
          var match = /costs ((?:\$|&pound;)\d{1,3}(,\d{3})*\.\d\d)/i.exec(products.ship_message);
          setMinimizedMessage(`<div>${decodeEntities(products.retailers.length)} offers available from ${decodeEntities(match[1])}</div>`);
          setIcon('alert');
        } else {
          setMinimizedMessage('<div>You\'ve found the <span class="check">best</span> price!</div>')
          setIcon('check');
        }
        updateOpenButtonLabel('Compare');
      } else {
        var featured = coupons.coupons.filter(function(coupon) { return coupon.featured === 'yes'; })
        if (featured.length > 0) {
          setMinimizedMessage(`<div><span class="local-offer">1 of ${decodeEntities(coupons.coupons.length)}</span> __MSG_coupon_text__${decodeEntities(coupons.coupons.length) != 1 ? 's' : ''}. ${decodeEntities(coupons.coupons[0].label)}</div>`);
          setIcon('localOffer');
        }else if(coupons.coupons.length == 0 && products){
          setMinimizedMessage('<div>Price comparison not available.</div>')
          setIcon('alert');
        }else {
          setMinimizedMessage(`<div><span class="local-offer">${decodeEntities(coupons.coupons.length)}</span> __MSG_coupon_text__${decodeEntities(coupons.coupons.length) != 1 ? 's' : ''} found!</div>`);
          setIcon('localOffer');
        }
        updateOpenButtonLabel('Show me');
        var placeholder = document.querySelector('#pbpopup-container #ihprices .placeholder-text');
        if(!placeholder){
            var container = document.querySelector('#pbpopup-container #ihprices');
            if(container){
            container.textContent  = '';
            var placeholder = document.createElement('div');
            placeholder.className  = 'placeholder-text';
            placeholder.textContent  = 'Price comparison not available for this product.';
            container.appendChild(placeholder);
          }
        }
      }
      
      if ((coupons && coupons.auto_expand === 'true') || (products && products.retailers && products.retailers.length > 0)) {
       if (coupons && coupons.maximized === 'true') {
          var codes = uniq(coupons.coupons.filter(function(coupon) {
            return coupon.code;
          }).map(function(coupon) {
            return coupon.code;
          }));

          if (codes && codes.length > 0 && coupons.isAutoCoupons) {
            var couponsAmount = document.querySelector('#pbpopup-container #pb-auto-coupons .coupons-amount');
            couponsAmount.textContent  = codes.length;
            if (codes.length === 1) {
              var couponsText = document.querySelector('#pbpopup-container #pb-auto-coupons .coupons-text');
              couponsText.textContent  = jsUcfirst('__MSG_coupon_text__ found!');
            } else {
              var couponsText = document.querySelector('#pbpopup-container #pb-auto-coupons .coupons-text');
              couponsText.textContent  = jsUcfirst('__MSG_coupon_text__s found!');
            }
            selectPopup('pb-auto-coupons');
            window.document.querySelector("#pbpopup-container #pb-auto-coupons .apply-button").addEventListener("click", applyCodes);

          } else {
            selectPopup('pb-maximized');
            // Push auto expand event
            postMessage({
              action: 'stats_auto_expand',
              c_rid : c_rid
            }, '*');
          }          
        }        
        if (e.data.openPopup) {
          postMessage({ action: 'showPopup' }, '*');
        }        
        if (e.data.openMinimizedPopup) {
          selectPopup('pb-minimized');
          postMessage({ action: 'showPopup' }, '*');
        }
      }
    } else if (e.data.action === 'openPopup') {
      if (e.data.priceComparison && !document.querySelector('#pbpopup-container #pb-minimized .icon > *')) {
        setIcon('check');
      }
      if(e.data.isRetailerHalfSuppressed){
       retailerHalfSuppressedMsg();
      }else if (e.data.isRetailerSuppressed) {
         function createMsg(){
          var suppressed_msg = document.createTextNode(jsUcfirst('__MSG_coupon_text__s')+' and Price Comparison are temporarily disabled for this merchant. ');
          var enableUrlmsg  = document.createElement('a');
          enableUrlmsg.className = 'enable-urlmsg';
          enableUrlmsg.setAttribute('href', 'https://invisiblehand.zendesk.com/hc/en-us/articles/360003285193');
          enableUrlmsg.setAttribute('target', '_blank');
          enableUrlmsg.textContent = 'Why does this happen? ';
          var reEnable = document.createElement('a');
          reEnable.className = 're-enable';
          reEnable.setAttribute('href', '#');
          reEnable.textContent = 'Click here to re-enable.';
          return [suppressed_msg,enableUrlmsg,reEnable];
        }
        var placeholders = document.querySelectorAll('#pbpopup-container .placeholder-text');
        placeholders.forEach(function(placeholder) {
          var placeholder_msg = createMsg();
          placeholder.textContent = '';
          placeholder.appendChild(placeholder_msg[0]);
          placeholder.appendChild(placeholder_msg[1]);
          placeholder.appendChild(placeholder_msg[2]);
        });
        var reEnableSpans = document.querySelectorAll('#pbpopup-container .placeholder-text .re-enable');
        reEnableSpans.forEach(function(span) {
          span.addEventListener('click', function() {
            postMessage({
              action: 'unsuppressRetailer',
            }, '*');
          });
        });
      } else if (e.data.isRetailerPermanentlyDisabled) {
         function createMsg(){
          var disabled_msg = document.createTextNode(jsUcfirst('__MSG_coupon_text__s')+' are disabled for this store. ');
          var reEnable = document.createElement('a');
          reEnable.className = 're-enable';
          reEnable.setAttribute('href', '#');
          reEnable.textContent = 'Re-enable __MSG_coupon_text__s.';
          return [disabled_msg,reEnable];
        }
        var placeholders = document.querySelectorAll('#pbpopup-container .placeholder-text');
        placeholders.forEach(function(placeholder) {
          var placeholder_msg = createMsg();
          placeholder.textContent = '';
          placeholder.appendChild(placeholder_msg[0]);
          placeholder.appendChild(placeholder_msg[1]);
        });
        var reEnableSpans = document.querySelectorAll('#pbpopup-container .placeholder-text .re-enable');
        reEnableSpans.forEach(function(span) {
          span.addEventListener('click', function() {
            window.dispatchEvent(new Event('ih_Restore_Event'));
            removePopup();
          });
        });
      }

      showPopup();
    } else if (e.data.action === 'isCheckoutPage') {
      if (e.data.content.isCheckoutPage) {
        isCheckoutPage = true;
        addAutoApplyButton();
      }
    }
  });

  function retailerHalfSuppressedMsg(){
    var suppressed_msg = document.createTextNode(jsUcfirst('__MSG_coupon_text__s')+' are temporarily disabled for this merchant. ');
    var enableUrlmsg  = document.createElement('a');
    enableUrlmsg.className = 'enable-urlmsg';
    enableUrlmsg.setAttribute('href', 'https://invisiblehand.zendesk.com/hc/en-us/articles/360003285193');
    enableUrlmsg.setAttribute('target', '_blank');
    enableUrlmsg.textContent = 'Why does this happen? ';
    var reEnable = document.createElement('a');
    reEnable.className = 're-enable';
    reEnable.setAttribute('href', '#');
    reEnable.textContent = 'Click here to re-enable.';
    var placeholder = document.querySelector('#pbpopup-container #pb-coupons .placeholder-text');
    placeholder.textContent = '';
    placeholder.appendChild(suppressed_msg);
    placeholder.appendChild(enableUrlmsg);
    placeholder.appendChild(reEnable);
    var reEnableSpans = document.querySelectorAll('#pbpopup-container .placeholder-text .re-enable');
    reEnableSpans.forEach(function(span) {
      span.addEventListener('click', function() {
        postMessage({
          action: 'unsuppressRetailer',
        }, '*');
      });
    });
  }

  function addAutoApplyButton() {
    var autoApply = document.getElementById('pb-auto-apply');
    if (!autoApply) {
      autoApply = document.createElement('div');
      autoApply.id = 'pb-auto-apply';
      autoApply.textContent = 'Auto Apply';
      autoApply.addEventListener('click', applyCodesAside);
      var couponsTitleBar = document.querySelector('#pbpopup-container #pb-coupons .title-bar');
      couponsTitleBar.appendChild(autoApply);
    }
  }

  /**
   ** <div class="coupon">
   **   <div class="coupon-label">
   **     20% off all winter clothing
   **   </div>
   **   <div class="bottom-container">
   **     <div class="coupon-code">
   **       WINTER20
   **     </div>
   **     <div class="restrictions-button">
   **       See Restrictions<i class="material-icons">keyboard_arrow_down</i>
   **     </div>
   **   </div>
   **   <div class="restrictions">
   **     Lorem ipsum dolor set amet...
   **   </div>
   ** </div>
  **/

  function insertCoupons(coupons, container) {
    coupons.forEach(function(coupon) {
      var couponEl = document.createElement('div');
      couponEl.className = 'coupon';

      var couponLabel = document.createElement('div');
      couponLabel.className = 'coupon-label';
      couponLabel.innerHTML = decodeEntities(coupon.label);
      couponEl.appendChild(couponLabel);

      var bottomContainer = document.createElement('div');
      bottomContainer.className = 'bottom-container';
      couponEl.appendChild(bottomContainer);

      if (coupon.code) {
        var couponCode = document.createElement('div');
        couponCode.className = 'coupon-code';
        couponCode.textContent = 'View & Copy Code';
        couponCode.dataset.code = coupon.code;
        couponEl.addEventListener('click', copyCouponCode);
        bottomContainer.appendChild(couponCode);
      }

      if (coupon.restrictions) {
        var restrictionsButton = document.createElement('div');
        restrictionsButton.className = 'restrictions-button';
        restrictionsButton.innerText = 'See Restrictions ';

        var restrictionsIcon = document.createElement('i');
        restrictionsIcon.className = 'material-icons';
        restrictionsIcon.innerText = 'keyboard_arrow_down';
        restrictionsButton.appendChild(restrictionsIcon);

        restrictionsButton.addEventListener('click', toogleRestrictions);

        bottomContainer.appendChild(restrictionsButton);

        var restrictions = document.createElement('div');
        restrictions.className = 'restrictions';
        restrictions.innerHTML = decodeEntities(coupon.restrictions);
      }

      var couponLink = createLink(coupon.url, couponEl);
      container.appendChild(couponLink);

      if (coupon.restrictions) {
        container.appendChild(restrictions);
      }
    });

    var disableMerchant = document.createElement('div');
    disableMerchant.className = 'coupon';

    var disableMerchantLabel = document.createElement('div');
    disableMerchantLabel.className = 'coupon-label';
    disableMerchantLabel.textContent = 'Hide __MSG_coupon_text__s for this Merchant';
    disableMerchant.appendChild(disableMerchantLabel);

    var disableMerchantContainer = document.createElement('div');
    disableMerchantContainer.appendChild(disableMerchant);
    disableMerchant.addEventListener('click', function() {
      if (confirm('Are you sure you want to PERMANENTLY disable __MSG_coupon_text__ notifications for this merchant? If you\' just like to hide __MSG_coupon_text__ notifications for this browsing session, click "Cancel" below and then close the popup.')) {
        window.dispatchEvent(new Event('ih_Disable_Event'));
        removePopup();
      }
    });

    container.appendChild(disableMerchant);

    showContent('pb-coupons');
  }

  /**
   ** <tr class="featured">
   **   <td>Groupon</td>
   **   <td>
   **     <div>£3.00</div>
   **     <div class="shipping">£2.5 Shipping</div>
   **   </td>
   **   <td><span class="total">£6.99</span></td>
   ** </tr>
  **/

  function insertRetailers(retailers, container) {
    var best = false;
    retailers.forEach(function(retailer) {
      var tr = document.createElement('tr');

      var name = document.createElement('td');
      name.innerHTML = decodeEntities(retailer['retailer_name'] || retailer['retailer name']);
      tr.appendChild(name);

      var pricing = document.createElement('td');
      var price = document.createElement('div');
      var shipping = document.createElement('div');
      shipping.className = 'shipping';

      if (retailer.price === 'Check New & Used Prices') {
        var spaceIndex = retailer.price.indexOf(' ');
        price.innerHTML = decodeEntities(retailer.price.substring(0, spaceIndex));
        shipping.innerHTML = decodeEntities(retailer.price.substring(spaceIndex));
      } else  {
        price.innerHTML = decodeEntities(retailer.base_price);
        shipping.innerHTML = decodeEntities(retailer.shipping_short);
      }

      pricing.appendChild(price);
      pricing.appendChild(shipping);
      tr.appendChild(pricing);

      if (retailer.price) {
        // TODO JOAO: verify this in the future, try not to split
        var totalPrice = retailer.price.split(' ')[0];
        var total = document.createElement('td');
        var label = document.createElement('span');
        label.className = 'total';
        label.innerHTML = decodeEntities(totalPrice);
        total.appendChild(label);

        tr.appendChild(total);

        if (retailer.highlight === 'yes') {
          tr.className = 'featured';
          if (!best) {
            best = true;
            var ribbon = document.createElement('div');
            ribbon.className = 'ribbon';
            ribbon.innerText = 'BEST';
            total.appendChild(ribbon);
          }
        }
      }

      tr.dataset.url = retailer.url;

      tr.addEventListener('click', function(e) {
        window.open(e.currentTarget.dataset.url);
      });

      container.appendChild(tr);
    });

    showContent('ihprices')
  }


  function setFeedbackLink(feedback) {
    var feedbackLink = document.querySelector('#pbpopup-container #pb-feedback-link');
    feedbackLink.href = feedback.url;
    feedbackLink.target = '_blank';
  }

  var saveMessage = '<div><span class="alert">Save {savedValue}.</span> Lower price found!</div>';

  function setSavingsMessage(originalMessage) {
    var match = /((?:\$|£)\d{1,3}(,\d{3})*\.\d\d) less/i.exec(originalMessage);
    var message = saveMessage.replace('{savedValue}', match[1]);

    setMinimizedMessage(message);
  }

  function setMinimizedMessage(message) {
    var minimizedMessage = document.querySelector('#pbpopup-container #pb-minimized .message');
    minimizedMessage.innerHTML = message; // pending dompurify here
    $clamp(minimizedMessage.children[0], { clamp: 2, useNativeClamp: true });

    var byInvisibleHand = document.createElement('div');
    byInvisibleHand.className = 'ih';
    byInvisibleHand.innerText = 'by InvisibleHand';

    minimizedMessage.appendChild(byInvisibleHand);
  }

  var basicIcon = '<div class="icon {icon}"><i class="material-icons">{icon}</i></div>'
  var localOfferIcon = '<div class="icon local-offer"><i class="material-icons">local_offer</i></div>'

  var icons = {
    alert: basicIcon.replace(/{icon}/g, 'warning'),
    check: basicIcon.replace(/{icon}/g, 'check'),
    localOffer: localOfferIcon,
    savings: basicIcon.replace(/{icon}/g, 'money_off'),
  }

  function setIcon(color) {
    var icon = document.querySelector('#pbpopup-container #pb-minimized .icon');
    icon.outerHTML = icons[color];
    addEventListenerWhenLoaded('#pbpopup-container #pb-minimized .icon', 'click', showPopup);
  }

  function updateOpenButtonLabel(label) {
    var button = document.querySelector('#pbpopup-container #pb-minimized .buttons .open');
    button.innerText = label;
  }

  function addEventListenerWhenLoaded(selector, event, handler) {
    var intervalId = setInterval(function() {
      var elements = window.document.querySelectorAll(selector);

      if (elements.length > 0) {
        elements.forEach(function(el) {
          el.addEventListener(event, function(e) {
            e.stopPropagation();
            handler(e);
          });
        })

        clearInterval(intervalId);
      }
    }, 1000);
  }

  addEventListenerWhenLoaded('#pbpopup-container #pb-footer .footer-item-main', 'click', handleFooterClick);
  addEventListenerWhenLoaded('#pbpopup-container #pb-footer #pb-pricealert', 'click', function(){
    window.open('https://alerts.getinvisiblehand.com/product_list.php', '_blank');
  });

  function hideChildren(element) {
    var children = toArray(element.children);
    children.forEach(function(child) {
      child.style.display = 'none';
    });
  }

  function handleFooterClick(e) {
    var el = e.currentTarget;

    showContent(el.dataset.contentId);
  }

  function showContent(contentId) {
    var button = document.querySelector(`#pbpopup-container #pb-footer [data-content-id="${contentId}"]`);

    var title = window.document.querySelector('#pbpopup-container #pb-header .title');
    title.innerText = titles[button.dataset.contentId];

    var footers = window.document.querySelectorAll('#pbpopup-container #pb-footer .footer-item-main');
    footers.forEach(function (footer) {
      footer.classList.remove('selected');
    });

    button.classList.add('selected');
    updateIcon(button);

    hideChildren(window.document.querySelector('#pbpopup-container #pb-content'));

    var display = 'block';
    if (button.dataset.display) {
      display = button.dataset.display;
    }

    updateDisplay(button.dataset.contentId, display);

    if (button.dataset.contentId === 'pb-coupons') {
      var couponLabel = window.document.querySelectorAll('#pbpopup-container .coupon-label');
      couponLabel.forEach(function(couponLabel) {
        $clamp(couponLabel, { clamp: 'auto', useNativeClamp: false });
      });
    }
  }

  function updateIcon(button) {
    var imgs = window.document.querySelectorAll('#pbpopup-container #pb-footer .footer-item-main img');
    imgs.forEach(function (img) {
      var originalSrc = img.src;
      if(originalSrc) {
        var dashIndex = originalSrc.lastIndexOf('-');
        var newSrc = originalSrc.slice(0, dashIndex + 1) + 'normal' + originalSrc.slice(dashIndex + 7);
        img.src = newSrc;
      }
    });

    var img = button.children[0];
    var originalSrc = img.src;
    if(originalSrc) {
      var dashIndex = originalSrc.lastIndexOf('-');
      var newSrc = originalSrc.slice(0, dashIndex + 1) + 'active' + originalSrc.slice(dashIndex + 7);
      img.src = newSrc;
    }
  }

  addEventListenerWhenLoaded('#pbpopup-container #pb-minimized .close', 'click', removePopup);

  function removePopup() {
    postMessage({ action: 'closePopup' }, '*');
  }

  addEventListenerWhenLoaded('#pbpopup-container #pb-minimized .open', 'click', showPopup);
  addEventListenerWhenLoaded('#pbpopup-container #pb-minimized .message', 'click', showPopup);

  function selectPopup(id) {
    isPopupMinimized = false;
    ['pb-minimized', 'pb-maximized', 'pb-auto-coupons'].forEach(function(item) {
      if (item === id) {
        updateDisplay(item, 'flex');
      } else {
        updateDisplay(item, 'none')
      }
    });
    resizeParent(id);

    if (id === 'pb-maximized') {
      var icon = document.querySelector('#pbpopup-container #pb-minimized .icon');
      if (icon.classList.contains('check') || icon.classList.contains('warning')) {
        showContent('ihprices');
      } else {
        showContent('pb-coupons');
      }
    }
  }

  function showPopup() {
    selectPopup('pb-maximized');
    postMessage({ action: 'showPopup' }, '*');
  }

  function toArray(collection) {
    return Array.prototype.slice.call(collection);
  }

  function updateDisplay(id, displayValue) {
    var el = document.querySelector('#pbpopup-container #' + id);
    el.style.display = displayValue;
  }

  function createLink(url, content) {
    var link = document.createElement('a');
    link.href = url;
    link.target = '_blank';
    if (content) {
      link.appendChild(content);
    }
    return link;
  }

  addEventListenerWhenLoaded('#pbpopup-container #pb-maximized #pb-header .right .pb-close', 'click', removePopup);
  addEventListenerWhenLoaded('#pbpopup-container #pb-maximized #pb-header .right .settings', 'click', openOptions);

  function openOptions() {
    postMessage({ action: 'sendOpenOptionsPage' }, '*');
  }


  addEventListenerWhenLoaded('#pbpopup-container #pb-search button', 'click', search);

  function search() {
    var input = document.querySelector('#pbpopup-container #pb-search input');
    if (input.value) {
      window.open(`http://shopping.getinvisiblehand.com/search?q=${input.value}`)
    }
  }

  addEventListenerWhenLoaded('#pbpopup-container #pb-auto-coupons .close-icon', 'click', removePopup);

  function applyCodes() {
   window.document.querySelector('#pbpopup-container #pb-auto-coupons .apply-button').removeEventListener("click", applyCodes);   
   postMessage({ action: 'autoApplyCodes' }, '*');
  }

  function applyCodesAside() {  
    postMessage({ action: 'autoApplyCodes' }, '*');
    removePopup();
  }

  function resizeParent(id) {
    postMessage({
      action: 'resizePopup',
      height: document.querySelector('#pbpopup-container #' + id).offsetHeight + 'px',
      width: document.querySelector('#pbpopup-container #' + id).offsetWidth + 'px',
    }, '*');
  }

  function toogleRestrictions(e) {
    e.preventDefault();
    e.stopPropagation();
    var restrictionsButton = e.currentTarget;
    var couponLinkEl = restrictionsButton.parentElement.parentElement.parentElement;
    var restrictions = couponLinkEl.nextSibling;
    var restrictionsIcon = restrictionsButton.children[0];

    if (restrictions.style.display === 'block') {
      restrictions.style.display = 'none';
      restrictionsIcon.innerText = 'keyboard_arrow_down';
    } else {
      restrictions.style.display = 'block';
      restrictionsIcon.innerText = 'keyboard_arrow_up';
    }
  }

  function copyCouponCode(e) {
    var couponEl = e.currentTarget;
    var couponCode = couponEl.querySelector('.coupon-code');
    var code = couponCode.dataset.code;

    e.preventDefault();
    e.stopPropagation();

    postMessage({
      action: 'sendOpenUrl',
      url: couponCode.parentElement.parentElement.parentElement.href
    }, '*');

    var temp = document.createElement('textarea');
    document.body.appendChild(temp);
    temp.value = code;
    temp.select();
    document.execCommand("copy");
    temp.remove();

    couponCode.innerText = code + ' (copied)';
  }

  function getUID() {
    return getParamFromCouponOrRetailer('uid');
  }

  function getParamFromCouponOrRetailer(param) {
    return getParamFromUrl(getCouponUrl(), param) || getParamFromUrl(getRetailerUrl(), param) || '';
  }

  function getCouponUrl() {
    var link = document.querySelector('#pbpopup-container #pb-coupons .coupons-list a');
    if (link) {
      return link.href;
    }
    return false;
  }

  function getRetailerUrl() {
    var tr = document.querySelector('#pbpopup-container #ihprices tbody tr');
    if (tr) {
      return tr.dataset.url;
    }
    return false;
  }

  function getParamFromUrl(url, param) {
    if (url) {
      return (new URL(url)).searchParams.get(param);
    }
    return false;
  }

  function createButton(label) {
    var button = document.createElement('button');
    button.style = `
      background-color: #fff;
      border: 2px solid black;
      color: #000;
      cursor: pointer;
      margin: 10px;
      padding: 10px;
    `
    button.onmouseover = function() {
      button.style.backgroundColor = '#888';
      button.style.color = '#fff';
    }
    button.onmouseout = function() {
      button.style.backgroundColor = '#fff';
      button.style.color = '#000';
    }
    button.innerHTML = decodeEntities(label);
    return button;
  }

  function uniq(array) {
    return array.reduce(function(result, currentElement) {
      if (result.indexOf(currentElement) < 0) {
        return result.concat([currentElement]);
      }
      return result;
    }, []);
  }

  if (DEBUG) {
    addEventListenerWhenLoaded('#pbpopup-container #pb-header .debug-yes', 'click', openDebugDialog);
  }

  function openDebugDialog() {
    removePopup();
    postMessage({ action: 'openDebugDialog' }, '*');
  }

  function jsUcfirst(string){
    return string.charAt(0).toUpperCase() + string.slice(1);
 }


var decodeEntities = (function() {
  // this prevents any overhead from creating the object each time
  var element = document.createElement('div');

  function decodeHTMLEntities (str) {
    if(str && typeof str === 'string') {
      // strip script/html tags
      str = str.replace(/<script[^>]*>([\S\s]*?)<\/script>/gmi, '');
      str = str.replace(/<\/?\w(?:[^"'>]|"[^"]*"|'[^']*')*>/gmi, '');
      element.innerHTML = str;
      str = element.textContent;
      element.textContent = '';
    }

    return str;
  }

  return decodeHTMLEntities;
})();

})();