var auto_coupon_retailers = {
  apply_shopify: {
      preApplyCodes: function(callback) {
        console.log('shopify');
        const elTotal = $('.payment-due__price');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        const prevCode = $('.edit_checkout .reduction-code__text').first().text();
        callback(prevValue,prevCode);
      },
      applyCode: function(code, callback) {
        if(document.querySelector('#checkout_discount_code')){
          const formData = getFormFieldsAsJson(document.querySelector('#discount_form'));
          const url = $("#discount_form ").attr('action');
          const previous_step = $('#checkout_previous_step').val();
          const step = $('#checkout_step').val();
          const locale = $('#locale').val();
          const ga_client_id = $('#checkout_ga_client_id').val();
          formData['checkout[discount_code]'] = code;
          formData['checkout[shipping_rate_name]'] = '';
          formData['checkout[previous_step]'] = previous_step;
          formData['checkout[step]'] = step;
          formData['locale'] = locale;
          formData['primary_locale'] = 'en';
          formData['checkout[ga_client_id]'] = ga_client_id;
          $.ajax({
              url: url,
              type: 'POST',
              data: formData,
              contentType: 'application/x-www-form-urlencoded; charset=UTF-8',
              success: (response) => {              
               const elTotal = $(response.totals).find('.payment-due__price');
               const value = elTotal.length > 0 ? 
                                Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                                Number.POSITIVE_INFINITY;
                  callback(value);
              },
              error: (xhr, status, error) => {
                console.log(error);
                callback(Number.POSITIVE_INFINITY);
              }
            });
        }else{
            const authenticity_token = $('input[name="authenticity_token"]:last').val();
            const url = 'https://'+window.location.hostname+$(".edit_checkout ").attr('action');
            $.ajax({
              url: url,
              type: 'POST',
              data: {
                _method: 'patch',
                authenticity_token: authenticity_token,
                'checkout[reduction_code]': code,
                'checkout[client_details][browser_width]': 1349,
                'checkout[client_details][browser_height]': 657,
                'checkout[client_details][javascript_enabled]': 1
              },
              success: () => {
                $.get('https://'+window.location.hostname+window.location.pathname, (responseGet) => {             
                  const elTotal = $(responseGet).find('.payment-due__price');
                  const value = elTotal.length > 0 ? 
                                Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                                Number.POSITIVE_INFINITY;
                  callback(value);
                });
              },
              error: (xhr, status, error) => {
                console.log(error);
                callback(Number.POSITIVE_INFINITY);
              },
              fail: (xhr, status, error) => {
                console.log(error);
                callback(Number.POSITIVE_INFINITY);
              }
            });
         }
      },
      applyBestCode: (bestCode) => {
        document.querySelector('[name="checkout[reduction_code]"], #checkout_discount_code').value = bestCode;
        document.querySelector('[name="checkout[reduction_code]"], #checkout_discount_code').dispatchEvent(new MouseEvent('input', { bubbles: true } ));
        if(document.querySelector('[data-trekkie-id="apply_discount_button"], #apply-discount')){
           setTimeout(function(){
            document.querySelector('[data-trekkie-id="apply_discount_button"], #apply-discount').click(); 
          }, 500);
        }else{
         $("button:contains(Apply)").click();
        }
      }
    },

    apply_fanaticsbrand: {
      preApplyCodes: function(callback) {
        console.log('fanaticsbrand');
        const elTotal = $('.total-line .shipping-val, [data-talos="labelOrderTotal"]');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
         callback(prevValue);
      },
      applyCode: function(code, callback) {
        this._applyCode(code, function(value) {
             callback(value);
          }); 
      },
      applyBestCode: function(bestCode) {
        document.querySelector('.coupon-giftcard-container [data-talos="textCoupon"]:last-child').value = bestCode;
        document.querySelector('.coupon-giftcard-container [data-talos="textCoupon"]:last-child').dispatchEvent(new MouseEvent('input', {bubbles: true}));
        document.querySelector('.coupon-giftcard-container button[data-talos="buttonCouponApply"]:last-child').click();
      },
      _applyCode: function(code, callback) {
        const windowVariables = retrieveWindowVariables(["__platform_data__"]);
        var cartID,value;
        if(document.location.pathname.indexOf("/cart") === 0){
           cartID = windowVariables['__platform_data__']['cart-data'].cart.cartInfo.cartId;
        }else{
           cartID = windowVariables['__platform_data__']['chkt-data'].initialPaymentStore.cart.cartInfo.cartId;
        }
        const csrf = decodeURI(document.cookie.split(';').filter(function(c) { return c.indexOf('xsrft') !== -1 })[0]).trim().split('=')[1];
    
      $.ajax({
          url: 'https://'+window.location.hostname+'/api/cart/'+cartID+'/promotion',
          type: 'POST',
          data: JSON.stringify({promoCode: code}),
           headers: {
                    'x-xsrf-token': csrf,
                    'x-frg-promo': code,
                    'x-frg-pt': 'CART',
                    'content-type': 'application/json;charset=UTF-8'
                  },
          success: (response) => {            
            this._getPrice(function(value) {
               callback(value);
            }); 
          },
          error: (xhr, status, error) => {
            this._getPrice(function(value) {
               callback(value);
            });
          }
        });
      },
      _getPrice: function(callback) {
        $.get('https://'+window.location.hostname+window.location.pathname, (responseGet) => {             
          const elTotal = $(responseGet).find('.total-line .shipping-val, [data-talos="labelOrderTotal"]');
          const value = elTotal.length > 0 ? 
                        Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                        Number.POSITIVE_INFINITY;
          callback(value);
        });
      }
    },

    apply_potterybrand: {
      preApplyCodes: function(callback) {
        var elTotal,prevValue,prevCode,prevCodeSelector;
         if(document.querySelector('checkout-app')){
            elTotal = document.querySelector('checkout-app').shadowRoot.querySelector('summary-view').shadowRoot.querySelector('summary-feature').shadowRoot.querySelector('[title="Total"]').shadowRoot.querySelector('.value').innerText;
            prevValue = elTotal.replace(/[a-zA-Z,$,£\n]/g, '').trim();
            prevCodeSelector = document.querySelector('checkout-app').shadowRoot.querySelector('#payment-region #payment-content checkout-module-feature payment-view promotion-view').shadowRoot.querySelector('promotion-applied-feature');
            if(prevCodeSelector){
              prevCode = prevCodeSelector.getAttribute('code');
              prevCodeSelector.shadowRoot.querySelector('[name="promotion-remove-button"]').shadowRoot.querySelector('button').click();
              setTimeout(function(){ 
                callback(prevValue,prevCode);
              }, 4000);   
             }else{
                callback(prevValue); 
             }             
         }else{
            elTotal = $('div.order-summary-tally-total-block div span.price-amount');
            prevValue = elTotal.length > 0 ? 
                          Number(elTotal.first().text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                          Number.POSITIVE_INFINITY;        
            callback(prevValue); 
        }       
      },
      applyCode: function(code, callback) {
        if(document.querySelector('checkout-app')){          
          const promotionView = document.querySelector('checkout-app').shadowRoot.querySelector('#payment-region #payment-content checkout-module-feature payment-view promotion-view');
          promotionView.shadowRoot.querySelector('promotion-input-feature').shadowRoot.querySelector('[name="promotion-input"]').shadowRoot.querySelector('#promotion-input').value = '';
          promotionView.shadowRoot.querySelector('promotion-input-feature').shadowRoot.querySelector('[name="promotion-input"]').shadowRoot.querySelector('#promotion-input').value = code.toUpperCase();
          promotionView.shadowRoot.querySelector('promotion-input-feature').shadowRoot.querySelector('[name="promotion-input"]').shadowRoot.querySelector('#promotion-input').dispatchEvent(new MouseEvent('input', {bubbles: true}));
          promotionView.shadowRoot.querySelector('promotion-input-feature').shadowRoot.querySelector('[name="promotion-input"]').shadowRoot.querySelector('#promotion-input').dispatchEvent(new Event('change', {bubbles: true}));
          promotionView.shadowRoot.querySelector('promotion-input-feature').shadowRoot.querySelector('[name="promotion-input"]').shadowRoot.querySelector('#promotion-input').dispatchEvent(new Event('blur'));
          setTimeout(function(){ 
            promotionView.shadowRoot.querySelector('promotion-input-feature').shadowRoot.querySelector('[name="promotion-input-button"]').shadowRoot.querySelector('button').click();
           }, 500);
          setTimeout(function(){
               const elTotal = document.querySelector('checkout-app').shadowRoot.querySelector('summary-view').shadowRoot.querySelector('summary-feature').shadowRoot.querySelector('[title="Total"]').shadowRoot.querySelector('.value').innerText;
               const value = elTotal.replace(/[a-zA-Z,$,£\n]/g, '').trim(); 
               prevCodeSelector = document.querySelector('checkout-app').shadowRoot.querySelector('#payment-region #payment-content checkout-module-feature payment-view promotion-view').shadowRoot.querySelector('promotion-applied-feature');
               if(prevCodeSelector){
                  prevCodeSelector.shadowRoot.querySelector('[name="promotion-remove-button"]').shadowRoot.querySelector('button').click();
                  setTimeout(function(){ 
                    callback(value); 
                   }, 4000);
                 }else{
                  callback(value); 
                 } 
           }, 4000);
        }else{
          const formData = getFormFieldsAsJson(document.querySelector('#paymentInformation'));
          formData['promoCode'] = code;
          $.post('https://'+window.location.hostname+'/checkout/payment.html', formData, 
          (response) => {
            const orderValueEl = $(response).find('div.order-summary-tally-total-block div span.price-amount');
            const value = orderValueEl.length > 0 ? 
                          Number(orderValueEl.first().text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                          Number.POSITIVE_INFINITY;
                  const formData2 = formData;
                  delete formData2['promoCode'];
                  delete formData2['promoApply'];
                  formData2['releasePromo'] = code.toUpperCase();
                  formData2['removePromoButton'] = 'Remove';
                  $.post('https://'+window.location.hostname+'/checkout/payment.html', formData2, 
                     (response) => {
                      callback(value);
                  });        
          });
        }
      },
      applyBestCode: (bestCode) => {  
       if(document.querySelector('checkout-app')){     
          const promotionView = document.querySelector('checkout-app').shadowRoot.querySelector('#payment-region #payment-content checkout-module-feature payment-view promotion-view');
          promotionView.shadowRoot.querySelector('promotion-input-feature').shadowRoot.querySelector('[name="promotion-input"]').shadowRoot.querySelector('#promotion-input').value = bestCode.toUpperCase();
          promotionView.shadowRoot.querySelector('promotion-input-feature').shadowRoot.querySelector('[name="promotion-input"]').shadowRoot.querySelector('#promotion-input').dispatchEvent(new MouseEvent('input', {bubbles: true}));
          promotionView.shadowRoot.querySelector('promotion-input-feature').shadowRoot.querySelector('[name="promotion-input"]').shadowRoot.querySelector('#promotion-input').dispatchEvent(new Event('change', {bubbles: true}));
          promotionView.shadowRoot.querySelector('promotion-input-feature').shadowRoot.querySelector('[name="promotion-input"]').shadowRoot.querySelector('#promotion-input').dispatchEvent(new Event('blur'));
           setTimeout(function(){ 
            promotionView.shadowRoot.querySelector('promotion-input-feature').shadowRoot.querySelector('[name="promotion-input-button"]').shadowRoot.querySelector('button').click();
           }, 500);    
       }else{
          document.querySelector('#promoCode').value = bestCode.toUpperCase();
          document.querySelector('#promoCode').dispatchEvent(new MouseEvent('input', { bubbles: true } ));
          document.querySelector('#applyPromo').click();
        }
      }
    },

    
    apply_merrellbrand: {
      preApplyCodes: function(callback) {
        console.log('merrellbrand');
        const elTotal = $('.order-total .textalign-right, .order-total td:last-child');
        const prevValue = elTotal.length > 0 ? 
                        Number(elTotal.text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                        Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        if(window.location.href.indexOf("cart") > -1){
           const windowVariables = retrieveWindowVariables(["CQuotient"]);
           const siteId = windowVariables.CQuotient.siteId;
            $.get('https://'+window.location.hostname+'/on/demandware.store/Sites-'+siteId+'-Site/default/Cart-AddCoupon?couponCode='+code+'&format=ajax', 
              (response) => {
               const value = response.basketTotal;
               callback(value);               
              });
          }else{
             const windowVariables = retrieveWindowVariables(["data"]);
             const url = windowVariables.data.urls.applyPromoCode;
             const csrf_token = windowVariables.data.csrfToken;
               $.ajax({
                  url: url,
                  type: 'POST',
                  data : {code: code, csrf_token: csrf_token},
                  headers: {
                    'content-type': 'application/x-www-form-urlencoded'
                  },
                  success: (response) => {
                    const elTotal = response.cart.totals.orderTotal;
                    const value = Number(elTotal.replace( /[^0-9.]/g, '').trim());
                    callback(value);
                  },
                  error: (xhr, status, error) => {
                    console.log(error);
                    callback(Number.POSITIVE_INFINITY);
                  }
                });
          }
      },
      applyBestCode: function(bestCode) {
        location.reload();
      }
    },


    apply_signetbrand: {
      preApplyCodes: function(callback) {
        const elTotal = $('.grand-total:last-child, .checkout-order-summary:last-child .totals span');
        const prevValue = elTotal.length > 0 ? 
                        Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) :  
                        Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        const formData = getFormFieldsAsJson(document.querySelector('form#promoForm'));       
        formData['voucherCode'] = code;
        const url = $('form#promoForm').attr('action');
        $.ajax({
          url: 'https://'+window.location.hostname+url,
          type: 'POST',
          data: formData,
          success: (data, textStatus, request) => {
             const elTotal = $(data).find('.grand-total:last-child, .checkout-order-summary:last-child .totals span');
                const value = elTotal.length > 0 ? 
                              Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                              Number.POSITIVE_INFINITY;
                callback(value);
            },
              error: (xhr, status, error) => {
                 callback(Number.POSITIVE_INFINITY);
              }
          });
      },
      applyBestCode: function(bestCode) {
        document.querySelector('#promoCode').value = bestCode;
        document.querySelector('#promoCode').dispatchEvent(new MouseEvent('input', {bubbles: true}));
        document.querySelector('#promo-btn').click()
      }
    },

  apply_roamansbrand: {
      preApplyCodes: function(callback) {
        console.log('roamansbrand');
        const elTotal = $('.order-total.order-detail span.order-value.value');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().trim().substr(1)) : 
                      Number.POSITIVE_INFINITY;
        const prevCode = $('#coupon-submitted .value, #dwfrm_billing .cartcoupon .value').first().text();       
        if(window.location.href.indexOf("cart") > -1){  
          const url = $('#cart-items-form').attr('action');
          const formData = getFormFieldsAsJson(document.querySelector('#cart-items-form'));
          formData['dwfrm_cart_coupons_i0_deleteCoupon'] = 'Remove';
          $.post(url, formData, 
            (response) => {
               callback(prevValue,prevCode);
          });
        }else{
          if(document.querySelector('#remove-coupon')){
            const removeId = $('#remove-coupon').attr('data-uuid');
            const removeUrl = 'https://'+window.location.hostname+'/on/demandware.store/Sites-oss-Site/default/Cart-RemoveCouponJson?uuid='+removeId+'&format=ajax;'                 
                $.post(removeUrl, 
                        (responsePost) => {
                          callback(prevValue,prevCode); 
                    });
          }else{
            callback(prevValue,prevCode);
          }          
        }
      },
      applyCode: function(code, callback) {
        if(window.location.href.indexOf("cart") > -1){    
          this.preApplyCodes(() => {
            const url = $('#cart-items-form').attr('action');
            const formData = getFormFieldsAsJson(document.querySelector('#cart-items-form'));
            formData['dwfrm_cart_couponCode'] = code;
            formData['dwfrm_cart_addCoupon'] = 'dwfrm_cart_addCoupon';
              $.post(url, formData, 
              (responsePost) => {
                $.get('https://'+window.location.hostname+'/cart', (response) => {
                    const orderValueEl = $(response).find('.order-total.order-detail span.order-value.value');
                    const value = orderValueEl.length > 0 ? 
                                    Number(orderValueEl.first().text().trim().substr(1)) : 
                                    Number.POSITIVE_INFINITY;  
                     callback(value);                 
                });
              }); 
          });
        }else{
          $.get('https://'+window.location.hostname+'/on/demandware.store/Sites-oss-Site/default/Cart-AddCouponJson?couponCode='+code+'&format=ajax', 
              (responseGet) => {
                 const el = $(responseGet).find('#remove-coupon');
                    if (el !== null && el !== undefined && el.length > 0) {
                      const removeId = el.attr('data-uuid');
                      $.get('https://'+window.location.hostname+'/on/demandware.store/Sites-oss-Site/default/COBilling-UpdateSummary?format=ajax&stepCount=2', 
                        (response) => {
                          const orderValueEl = $(response).find('.order-total.order-detail span.order-value.value');
                          const value = orderValueEl.length > 0 ? 
                                            Number(orderValueEl.text().replace( /[^0-9.]/g, '').trim()) : 
                                            Number.POSITIVE_INFINITY;
                           const removeUrl = 'https://'+window.location.hostname+'/on/demandware.store/Sites-oss-Site/default/Cart-RemoveCouponJson?uuid='+removeId+'&format=ajax;'                 
                          $.post(removeUrl, 
                                  (responsePost) => {
                                    callback(value); 
                              });
                        });
                    }else{
                      callback(Number.POSITIVE_INFINITY);
                    }
              });
        }
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#dwfrm_cart_couponCode, #dwfrm_billing_couponCode').value = bestCode;
        document.querySelector('#dwfrm_cart_couponCode, #dwfrm_billing_couponCode').dispatchEvent(new Event('input', { bubbles: true } ));
        document.querySelector('#add-coupon').click();
      }
    },

  apply_chicosbrand: {
      preApplyCodes: function(callback) {
        console.log('chicosbrand');
        const elTotal = $('#sb-sum-total .sb-price, [data-review-info="orderTotal"]');
        const prevValue = elTotal.length > 0 ? 
                        Number(elTotal.first().text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                        Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
      if(window.location.href.indexOf("cart") > -1){
        const formData = getFormFieldsAsJson(document.querySelector('form[name="couponForm"]'));
        const url = $('form[name="couponForm"]').attr('action');     
        formData['claimCodeField'] = code;
        formData['/atg/commerce/promotion/CouponFormHandler.claimCoupon'] = 'Apply';
        formData['_D:/atg/commerce/promotion/CouponFormHandler.claimCoupon'] = '';
        $.ajax({
          url: url+'&isCartPage=-1&reprice=true',
          type: 'POST',
          data: formData,
          success: (data, textStatus, request) => {
                const total = data.itemsTotalNoShipping;
                const value = Number(total.replace( /[^0-9.]/g, '').replace(',', '').trim());
                callback(value);
            },
            error: (xhr, status, error) => {
               callback(Number.POSITIVE_INFINITY);
            }
          });
      }else{
        const formData = getFormFieldsAsJson(document.querySelector('form[name="coupon"]'));
        const url = $('form[name="coupon"]').attr('action'); 
        formData['/atg/commerce/promotion/CouponFormHandler.couponClaimCode'] = code;
        $.ajax({
          url: url,
          type: 'POST',
          data: formData,
          success: (data, textStatus, request) => {
                const total = data.order.orderDetails.orderTotal;
                const value = Number(total.replace( /[^0-9.]/g, '').replace(',', '').trim());
                callback(value);
            },
            error: (xhr, status, error) => {
               callback(Number.POSITIVE_INFINITY);
            }
          });
      }
      },
      applyBestCode: function(bestCode) {
        location.reload();
      }
    },

  apply_thehutsbrand: {
      preApplyCodes: function(callback) {
        console.log('thehutsbrand');
        const elTotal = $('.responsiveBasket_totalValue');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;

        callback(prevValue);
      },
      applyCode: function(code, callback) {
         $.post('https://'+window.location.hostname+'/my.basket', {
            discountCode: code
          }, (response) => {
            const elTotal = $(response).find('.responsiveBasket_totalValue');
            const value = elTotal.length > 0 ? 
                          Number(elTotal.first().text().trim().substr(1)) : 
                          Number.POSITIVE_INFINITY;
            callback(value);
              if($(response).find('.responsiveBasket_removeItem-discount')){
                  var url = $(response).find('.responsiveBasket_removeItem-discount').attr('href');
                   $.get(url, () => {
                   });
              }
          });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#discountcode').value = bestCode;
        document.querySelector('#discountcode').dispatchEvent(new Event('input', {bubbles: true}));
        document.querySelector('#add-discount-code').click();
      }
    },

    steinmart: {
      id: 10180, 
      preApplyCodes: function(callback) {
        const elTotal = $('div#EstTaxShipItemTable_estBasketTotal, .ml-summary-total .ml-accordion-summary-item-value');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.last().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        if(window.location.href.indexOf("basket.do") > -1){
          $.ajax({
            url: 'https://'+window.location.hostname+'/basket.do?method=applySourceCode&r=0.8716907298950933',
            type: 'POST',
            data: {sourceCode: code},
            success: () => {
              $.ajax({
                url: 'https://'+window.location.hostname+'/basket.do',
                type: 'GET',
                success: (response) => {
                  const elTotal = $(response).find('div#EstTaxShipItemTable_estBasketTotal');
                  const value = elTotal.length > 0 ? 
                                Number(elTotal.last().text().replace( /[^0-9.]/g, '').trim()) : 
                                Number.POSITIVE_INFINITY;
                  callback(value);
                },
                error: (xhr, status, error) => {
                  console.log(error);
                  callback(Number.POSITIVE_INFINITY);
                }
              })
            },
            error: (xhr, status, error) => {
              console.log(error);
              callback(Number.POSITIVE_INFINITY);
            }
          });
      }else{
          $.ajax({
            url: 'https://'+window.location.hostname+'/checkout/accordion.do?method=applySourceCode',
            type: 'POST',
            data: {sourceCode: code},
            success: (response) => {
                const elTotal = response.targetDataForUpdate['2'].data.orderTotals['0'].value;
                  const value = elTotal.length > 0 ? 
                                Number(elTotal.replace( /[^0-9.]/g, '').trim()) : 
                                Number.POSITIVE_INFINITY;
                  callback(value);
            },
            error: (xhr, status, error) => {
              console.log(error);
              callback(Number.POSITIVE_INFINITY);
            }
          });
       }
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#sourceCode').value = bestCode;
        document.querySelector('#sourceCode').dispatchEvent(new MouseEvent('input', {bubbles: true}));
        document.querySelector('input.sourceCodeApplyBtn, .ml-payment-source-code-apply button').click();
      }
    },

  apply_shopify2: {
    preApplyCodes: function(callback) {
      console.log('shopify2');
      const elTotal = $('.payment-due__price');
      const prevValue = elTotal.length > 0 ? 
                    Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                    Number.POSITIVE_INFINITY;
      const prevCodeSelector = document.querySelector('.applied-reduction-code__information');
      if(prevCodeSelector){
        const prevCode = prevCodeSelector.innerText;
        callback(prevValue,prevCode);
      }else{
        callback(prevValue);
      }
    },
    applyCode: function(code, callback) {
      const formData = getFormFieldsAsJson(document.querySelector('.order-summary__section--discount .edit_checkout'));
      const url = $(".order-summary__section--discount .edit_checkout").attr('action');
      formData['applyCouponCode'] = code;
      $.ajax({
        url: 'https://'+window.location.hostname+url,
        type: 'POST',
        data: formData,
        contentType: 'application/x-www-form-urlencoded;',
        success: (response) => {            
         const elTotal = $(response).find('.payment-due__price');
         const value = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
          callback(value);
        },
        error: (xhr, status, error) => {
          console.log(error);
          callback(Number.POSITIVE_INFINITY);
        }
      });
    },
    applyBestCode: (bestCode) => {
      document.querySelector('#checkout_reduction_code').value = bestCode;
      document.querySelector('#checkout_reduction_code').dispatchEvent(new MouseEvent('input', { bubbles: true } ));
      document.querySelector('[name="checkout_reduction_code"]').click();
    }
  },

    karllagerfeldparis : {
      id: 36527, 
      preApplyCodes: function(callback) {
        const elTotal = $('div#EstTaxShipItemTable_estBasketTotal, .ml-summary-total .ml-accordion-summary-item-value');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.last().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;

        callback(prevValue);
      },
      applyCode: function(code, callback) {
        if(window.location.href.indexOf("basket.do") > -1){
          $.ajax({
            url: 'https://'+window.location.hostname+'/basket.do?method=applySourceCode&r=0.8716907298950933',
            type: 'POST',
            data: {sourceCode: code},
            success: () => {
              $.ajax({
                url: 'https://'+window.location.hostname+'/basket.do',
                type: 'GET',
                success: (response) => {
                  const elTotal = $(response).find('div#EstTaxShipItemTable_estBasketTotal');
                  const value = elTotal.length > 0 ? 
                                Number(elTotal.last().text().replace( /[^0-9.]/g, '').trim()) : 
                                Number.POSITIVE_INFINITY;
                  callback(value);
                },
                error: (xhr, status, error) => {
                  console.log(error);
                  callback(Number.POSITIVE_INFINITY);
                }
              })
            },
            error: (xhr, status, error) => {
              console.log(error);
              callback(Number.POSITIVE_INFINITY);
            }
          });
      }else{
          $.ajax({
            url: 'https://'+window.location.hostname+'/checkout/accordion.do?method=applySourceCode',
            type: 'POST',
            data: {sourceCode: code},
            success: (response) => {
                const elTotal = response.targetDataForUpdate['2'].data.orderTotals['0'].value;
                  const value = elTotal.length > 0 ? 
                                Number(elTotal.replace( /[^0-9.]/g, '').trim()) : 
                                Number.POSITIVE_INFINITY;
                  callback(value);
            },
            error: (xhr, status, error) => {
              console.log(error);
              callback(Number.POSITIVE_INFINITY);
            }
          });

       }
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#sourceCode').value = bestCode;
        document.querySelector('#sourceCode').dispatchEvent(new MouseEvent('input', {bubbles: true}));
        document.querySelector('input.sourceCodeApplyBtn, .ml-payment-source-code-apply button').click();
      }
    },

    ghbass: {
      id: 14429, 
      preApplyCodes: function(callback) {
        const elTotal = $('div#EstTaxShipItemTable_estBasketTotal, .ml-summary-total .ml-accordion-summary-item-value');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.last().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;

        callback(prevValue);
      },
      applyCode: function(code, callback) {
        if(window.location.href.indexOf("basket.do") > -1){
          $.ajax({
            url: 'https://'+window.location.hostname+'/basket.do?method=applySourceCode&r=0.8716907298950933',
            type: 'POST',
            data: {sourceCode: code},
            success: () => {
              $.ajax({
                url: 'https://'+window.location.hostname+'/basket.do',
                type: 'GET',
                success: (response) => {
                  const elTotal = $(response).find('div#EstTaxShipItemTable_estBasketTotal');
                  const value = elTotal.length > 0 ? 
                                Number(elTotal.last().text().replace( /[^0-9.]/g, '').trim()) : 
                                Number.POSITIVE_INFINITY;
                  callback(value);
                },
                error: (xhr, status, error) => {
                  console.log(error);
                  callback(Number.POSITIVE_INFINITY);
                }
              })
            },
            error: (xhr, status, error) => {
              console.log(error);
              callback(Number.POSITIVE_INFINITY);
            }
          });
      }else{
          $.ajax({
            url: 'https://'+window.location.hostname+'/checkout/accordion.do?method=applySourceCode',
            type: 'POST',
            data: {sourceCode: code},
            success: (response) => {
                const elTotal = response.targetDataForUpdate['2'].data.orderTotals['0'].value;
                  const value = elTotal.length > 0 ? 
                                Number(elTotal.replace( /[^0-9.]/g, '').trim()) : 
                                Number.POSITIVE_INFINITY;
                  callback(value);
            },
            error: (xhr, status, error) => {
              console.log(error);
              callback(Number.POSITIVE_INFINITY);
            }
          });

       }
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#sourceCode').value = bestCode;
        document.querySelector('#sourceCode').dispatchEvent(new MouseEvent('input', {bubbles: true}));
        document.querySelector('input.sourceCodeApplyBtn, .ml-payment-source-code-apply button').click();
      }
    },

    wilsonsleather: {
      id: 1774, 
      preApplyCodes: function(callback) {
        const elTotal = $('div#EstTaxShipItemTable_estBasketTotal, .ml-summary-total .ml-accordion-summary-item-value');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.last().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;

        callback(prevValue);
      },
      applyCode: function(code, callback) {
        if(window.location.href.indexOf("basket.do") > -1){
           const csrf = $('meta[name="_csrf"]').attr('content');
          $.ajax({
            url: 'https://'+window.location.hostname+'/basket.do?method=applySourceCode&r=0.7030118057703232',
            type: 'POST',
            data: {sourceCode: code},
             headers: {
              'x-xsrf-token': csrf
            },
            success: () => {
              $.ajax({
                url: 'https://'+window.location.hostname+'/basket.do',
                type: 'GET',
                success: (response) => {
                  const elTotal = $(response).find('div#EstTaxShipItemTable_estBasketTotal');
                  const value = elTotal.length > 0 ? 
                                Number(elTotal.last().text().replace( /[^0-9.]/g, '').trim()) : 
                                Number.POSITIVE_INFINITY;
                  callback(value);
                },
                error: (xhr, status, error) => {
                  console.log(error);
                  callback(Number.POSITIVE_INFINITY);
                }
              })
            },
            error: (xhr, status, error) => {
              console.log(error);
              callback(Number.POSITIVE_INFINITY);
            }
          });
      }else{
         const csrf = $('meta[name="_csrf"]').attr('content');
          $.ajax({
            url: 'https://www.wilsonsleather.com/basket.do',
            type: 'POST',
            data: {method:'applySourceCode', sourceCode: code},
            headers: {
              'x-xsrf-token': csrf
            },
            success: (response) => {
               $.ajax({
                url: 'https://www.wilsonsleather.com/checkout/accordioncheckout.do?method=view',
                type: 'GET',
                success: (responseget) => {
                  const elTotal = $(responseget).find('.ml-recommendation-page-context').attr('data-ml-recommendation-page-context');
                  const total = JSON.parse(elTotal);
                  const value = total.amount;
                  $.get('https://www.wilsonsleather.com/sourcecode.do?method=reomoveSourceCode&sourceCode='+code, 
                  (data) => {
                    callback(value);
                  });
                },
                error: (xhr, status, error) => {
                  console.log(error);
                  callback(Number.POSITIVE_INFINITY);
                }
              }) 
            },
            error: (xhr, status, error) => {
              console.log(error);
              callback(Number.POSITIVE_INFINITY);
            }
          });

       }
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#sourceCode').value = bestCode;
        document.querySelector('#sourceCode').dispatchEvent(new MouseEvent('input', {bubbles: true}));
        document.querySelector('input.sourceCodeApplyBtn, .ml-checkout-source-code-button .ml-secondary-button').click();
      }
    },

    donnakaran: {
      id: 7986, 
      preApplyCodes: function(callback) {
        const elTotal = $('div#EstTaxShipItemTable_estBasketTotal, .ml-summary-total .ml-accordion-summary-item-value');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.last().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;

        callback(prevValue);
      },
      applyCode: function(code, callback) {
        if(window.location.href.indexOf("basket.do") > -1){
          $.ajax({
            url: 'https://'+window.location.hostname+'/basket.do?method=applySourceCode&r=0.8716907298950933',
            type: 'POST',
            data: {sourceCode: code},
            success: () => {
              $.ajax({
                url: 'https://'+window.location.hostname+'/basket.do',
                type: 'GET',
                success: (response) => {
                  const elTotal = $(response).find('div#EstTaxShipItemTable_estBasketTotal');
                  const value = elTotal.length > 0 ? 
                                Number(elTotal.last().text().replace( /[^0-9.]/g, '').trim()) : 
                                Number.POSITIVE_INFINITY;
                  callback(value);
                },
                error: (xhr, status, error) => {
                  console.log(error);
                  callback(Number.POSITIVE_INFINITY);
                }
              })
            },
            error: (xhr, status, error) => {
              console.log(error);
              callback(Number.POSITIVE_INFINITY);
            }
          });
      }else{
          $.ajax({
            url: 'https://'+window.location.hostname+'/checkout/accordion.do?method=applySourceCode',
            type: 'POST',
            data: {sourceCode: code},
            success: (response) => {
                const elTotal = response.targetDataForUpdate['2'].data.orderTotals['0'].value;
                  const value = elTotal.length > 0 ? 
                                Number(elTotal.replace( /[^0-9.]/g, '').trim()) : 
                                Number.POSITIVE_INFINITY;
                  callback(value);
            },
            error: (xhr, status, error) => {
              console.log(error);
              callback(Number.POSITIVE_INFINITY);
            }
          });

       }
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#sourceCode').value = bestCode;
        document.querySelector('#sourceCode').dispatchEvent(new MouseEvent('input', {bubbles: true}));
        document.querySelector('input.sourceCodeApplyBtn, .ml-payment-source-code-apply button').click();
      }
    },

    '1800petmeds': {
      id: 264,
      preApplyCodes: function(callback) {
        const elTotal = $('div.checkout div.top div.price');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                      Number.POSITIVE_INFINITY;
        
        callback(prevValue);
      },
      applyCode: function(code, callback) {      
        const formData = getFormFieldsAsJson(document.querySelector('div.checkout form[name="couponForm_full"]'));
        formData['coupon'] = code;
        $.post('https://www.1800petmeds.com/cart.jsp?_DARGS=/cart.jsp.coupon_full', formData, 
          () => {
            const url = 'https://www.1800petmeds.com/cart.jsp';
            $.get(url, 
              (response) => {
                const elTotal = $(response).find('div.checkout div.top div.price');
                const value = elTotal.length > 0 ? 
                              Number(elTotal.first().text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                              Number.POSITIVE_INFINITY;
                callback(value);
              });
          });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#coupon_full').value = bestCode;
        document.querySelector('#coupon_full').dispatchEvent(new Event('input', { bubbles: true } ));
        document.querySelector('form[name="couponForm_full"]').submit();
      }
    },
  
    '18650batterystore': {
      id: 37142,
      preApplyCodes: (callback) => {
        let urlRemove = null;
        
        $('.v65-cart-item-remove-cell').each((index, el) => {
          const url = $(el).find('a').first().attr('href');
          if (url && url.indexOf('RemoveCouponCode') > 0) {
            urlRemove = url;
          }
        });
        
        $.post(urlRemove, (data) => {
          const elTotal = $(data).find('#v65-cart-total-estimate-cell');
          const value   = elTotal.length > 0 ? 
                              Number(elTotal.first().text().trim().substr(1)) : 
                              Number.POSITIVE_INFINITY;
          callback(value);
        });
      },
  
      applyCode: (code, callback) => {
        $.post('https://www.18650batterystore.com/ShoppingCart.asp', { CouponCode: code }, (data) => {
          const elTotal = $(data).find('#v65-cart-total-estimate-cell');
          const value = elTotal.length > 0 ? 
                              Number(elTotal.first().text().trim().substr(1)) : 
                              Number.POSITIVE_INFINITY;
          callback(value);
        });
      },
  
      applyBestCode: (bestCode) => {
        document.querySelector('#v65-cart-coupon-entry-details-input').value = bestCode;
        document.querySelector('#v65-cart-coupon-entry-details-input').dispatchEvent(new Event('input', {bubbles: true}));
        document.querySelector('#v65-cart-coupon-entry-details-button').click();
      }
    },
  
    advanceautoparts: {
      id: 311,
      preApplyCodes: function(callback) {
        const elTotal = $('.aap-cart-order-summary__total .aap-cart-order-summary__line-item-amount');
        const value   = elTotal.length > 0 ? 
                        Number(elTotal.first().text().trim().substr(1)) : 
                        Number.POSITIVE_INFINITY;
        const elRemove = $('.details--aside--close');
        if (elRemove.length > 0) {
          const tmpAry = $('.details--aside span').text().split(':');
          const assignedCouponCode = tmpAry[tmpAry.length - 1].trim();
          const storeId = getParam('storeId');
          const authToken = decodeURI(document.cookie.split(';').filter(function(c) { return c.indexOf('WC_AUTHENTICATION') !== -1 })[0]).trim().split('=')[1];
          $.ajax({
            url: `https://shop.advanceautoparts.com/wcs/resources/store/${storeId}/cart/@self/assigned_promotion_code/${assignedCouponCode}`,
            type: 'DELETE',
            contentType: 'application/json',
            beforeSend: function(request) {
              request.setRequestHeader("WCAuthToken", authToken);
            },
            success: () => {
              callback(value);
            }
          });
        } else {
          callback(value);
        }
      },
  
      applyCode: function(code, callback) {
        const catalogId = getParam('catalogId');
        const orderId   = getParam('orderId');
        const storeId   = getParam('storeId');
        let value = Number.POSITIVE_INFINITY;
        const authToken = decodeURI(document.cookie.split(';').filter(function(c) { return c.indexOf('WC_AUTHENTICATION') !== -1 })[0]).trim().split('=')[1];

        $.ajax({
          url: `https://shop.advanceautoparts.com/wcs/resources/store/${storeId}/cart/@self/assigned_promotion_code`,
          type: 'POST',
          data: JSON.stringify({ orderId: orderId, promoCode: code }),
          dataType: 'json',
          contentType: 'application/json;charset=UTF-8',
          beforeSend: function(request) {
              request.setRequestHeader("WCAuthToken", authToken);
          },
          success: () => {
            this.lastAppliedCode = code;
  
            $.get(`https://shop.advanceautoparts.com/web/FetchCartDetails?orderId=${orderId}&catalogId=${catalogId}&storeId=${storeId}&cvZipCode=10001`, (data) => {
              data = JSON.parse(data);
              if (data.orderInfo) {
                value = Number(data.orderInfo.orderTotal);
              }
              callback(value);
               $.ajax({
                  url: `https://shop.advanceautoparts.com/wcs/resources/store/${storeId}/cart/@self/assigned_promotion_code/${this.lastAppliedCode}`,
                  type: 'DELETE',
                  contentType: 'application/json',
                  beforeSend: function(request) {
                    request.setRequestHeader("WCAuthToken", authToken);
                  },
                  success: () => {
                    //
                  }
                });
            });
          },
          error: () => {
            callback(Number.POSITIVE_INFINITY);
          }
        });
      },  
      applyBestCode: function(bestCode) {
        document.querySelector('.aap-js-promo-textfield__input').value = bestCode;
        document.querySelector('.aap-js-promo-textfield__input').dispatchEvent(new MouseEvent('input', {bubbles: true}));
        document.querySelector('.aap-cart-order-summary__promo-code-button').click();
      },
      
      lastAppliedCode: null
    },

    allivet: {
      id: 24524,
      getServiceToken: function(callback) {
        $.ajax({
          url: 'https://www.allivet.com/ActionService.asmx/GetGlobalConfig',
          type: 'POST',
          dataType: 'json',
          headers: {
            'accept': 'application/json, text/javascript, */*; q=0.0',
            'content-type': 'application/json; charset=utf-8'
          },
          success: (response) => {
            if (response !== null && response.d !== undefined && response.d !== null) {
              const values = JSON.parse(response.d);
              this.allivetToken = values.find((element) => {
                return element.Key === 'Service.Token';
              }).Value;
              callback();
            } else {
              callback();
            }
          },
          error: (xhr, status, error) => {
            callback();
          }
        });
      },
      preApplyCodes: function(callback) {
        const elTotal = $('#sCartTotal');
        const prevValue = elTotal.length > 0 ? 
                          Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                          Number.POSITIVE_INFINITY;
        var removeCoupon = function(token) {
          $.ajax({
            url: 'https://www.allivet.com/ActionService.asmx/Allivet_RemoveCartCoupon',
            type: 'POST',
            headers: {
              'token': token,
              'content-type': 'application/json; charset=utf-8'
            },
            success: () => {
              callback(prevValue);
            },
            error: (xhr, status, error) => {
              console.log(error);
              callback(prevValue);
            }
          });
        }
        if (this.allivetToken !== undefined && this.allivetToken !== null) {
          removeCoupon(this.allivetToken);
        } else {
          this.getServiceToken(() => removeCoupon(this.allivetToken));
        }
      },
      applyCode: function(code, callback) {
        $.ajax({
          url: 'https://www.allivet.com/ActionService.asmx/Allivet_UpdateCartCoupon',
          type: 'POST',
          data: JSON.stringify({CouponCode: code, CurrentUser: 'website'}),
          dataType: 'json',
          headers: {
            'token': this.allivetToken,
            'content-type': 'application/json; charset=utf-8'
          },
          success: () => {
            $.ajax({
              url: 'https://www.allivet.com/ActionService.asmx/Allivet_CartHTML',
              type: 'POST',
              data: JSON.stringify({SizeMode: 'FullSize'}),
              dataType: 'json',
              headers: {
                'token': this.allivetToken,
                'content-type': 'application/json; charset=utf-8'
              },
              success: (response) => {
                if (response && response.d !== undefined && response.d !== null) {
                  if (response.d.length >= 2) {
                    const cartHtmlContent = response.d[1];
                    const elTotal = $(cartHtmlContent).find('#sCartTotal');
                    const value = elTotal.length > 0 ? 
                                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                                      Number.POSITIVE_INFINITY;
                    this.preApplyCodes(() => {
                      callback(value);
                    });
                    return;
                  }
                }
                callback(Number.POSITIVE_INFINITY);
              },
              error: (xhr, status, error) => {
                console.log(error);
                callback(Number.POSITIVE_INFINITY);
              }
            });
          },
          error: (xhr, status, error) => {
            console.log(error);
            callback(Number.POSITIVE_INFINITY);
          }
        });
        
      },
      applyBestCode: function(bestCode) {
        $.ajax({
          url: 'https://www.allivet.com/ActionService.asmx/Allivet_UpdateCartCoupon',
          type: 'POST',
          data: JSON.stringify({CouponCode: bestCode, CurrentUser: 'website'}),
          dataType: 'json',
          headers: {
            'token': this.allivetToken,
            'content-type': 'application/json; charset=utf-8'
          },
          success: () => {
            location.reload();
          }
        });
      }
    },
  
    banggood: {
      id: 6980,
      preApplyCodes: function(callback) {
        const elTotal = $('#chkout_panel_grandtotal');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        this.preApplyCodes(() => {
          $.post('https://'+window.location.hostname+'/index.php', {
            com: 'shopcartnew',
            t: 'useCoupon',
            coupon_code: code,
            step: 2,
            useCoupstep: 2,
            clearCoupon: ''
          }, (response) => {
            const elTotal = $(response).find('#chkout_panel_grandtotal');
            var value = Number.POSITIVE_INFINITY;
            if (elTotal.length > 0) {
              value = Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim());
            }
            callback(value);
          });
        });
      },
      applyBestCode: (bestCode) => {
        if ($('div.cnt-row').length > 0) {
          const elCoupon = $('div.cnt-row').first();
          if (elCoupon.hasClass('active') === true) {
            elCoupon.find('div.col-input input.input-text').first().val(bestCode);
            elCoupon.find('div.col-input span.input-btn').first().click();
          }
        }
      }
    },

     bathandbodyworks: {
      id: 3516,
      preApplyCodes: (callback) => {
        const orderValueEl = $('.cart-order-totals .order-total .order-value');
        const prevValue = orderValueEl.length > 0 ? 
                          Number(orderValueEl.first().text().trim().substr(1)) : 
                          Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: (code, callback) => {
        const url = $('#cart-items-form').attr('action');
        const formData = getFormFieldsAsJson(document.querySelector('#cart-items-form'));
        formData['dwfrm_cart_couponCode'] = code;
        formData['dwfrm_cart_addCoupon'] = 'dwfrm_cart_addCoupon';

        $.post(url, formData, 
          (response) => {
            const orderValueEl = $(response).find('.cart-order-totals .order-total .order-value');
            const value = orderValueEl.length > 0 ? 
                              Number(orderValueEl.first().text().trim().substr(1)) : 
                              Number.POSITIVE_INFINITY;
            callback(value);
          });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#dwfrm_cart_couponCode').value = bestCode;
        document.querySelector('#dwfrm_cart_couponCode').dispatchEvent(new Event('input', { bubbles: true } ));
        document.querySelector('#add-coupon').click();
      }
    },

    belk: {
      id: 7417,
      preApplyCodes: (callback) => {
        const orderValueEl = $('div.ordertotals td.order-value');
        const prevValue = orderValueEl.length > 0 ? 
                          Number(orderValueEl.first().text().trim().substr(1)) : 
                          Number.POSITIVE_INFINITY;
        const formData = getFormFieldsAsJson(document.querySelector('#cart-items-form'));
        formData['dwfrm_cart_coupons_i0_deleteCoupon'] = 'Remove';
        $.post('https://www.belk.com/missing-coupon/', formData, 
          (response) => {
            callback(prevValue);
        });
      },
      applyCode: (code, callback) => {
        const formData = getFormFieldsAsJson(document.querySelector('#cart-items-form'));
        formData['dwfrm_cart_couponCode'] = code;
        formData['dwfrm_cart_addCoupon'] = 'dwfrm_cart_addCoupon';
        $.post('https://www.belk.com/missing-coupon/', formData, 
          (response) => {
            const orderValueEl = $(response).find('div.ordertotals td.order-value');
            const value = orderValueEl.length > 0 ? 
                              Number(orderValueEl.first().text().trim().substr(1)) : 
                              Number.POSITIVE_INFINITY;
            callback(value);
          });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#dwfrm_cart_couponCode').value = bestCode;
        document.querySelector('#dwfrm_cart_couponCode').dispatchEvent(new Event('input', { bubbles: true } ));
        document.querySelector('#add-coupon').click();
      }
    },

    blair: {
      id: 2136,
      preApplyCodes: (callback) => {
        const elTotal = $('[data-testid="order-summary-order-total-value"]');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: (code, callback) => {
        const url = 'https://www.blair.com/api/user-service/user/order/brand/blair/promoCode/'+code;
        $.ajax({
          url: url,
          type: 'PUT',
          success: (response) => {
           const value = response.chosen.cart.price.total.amount;
           $.ajax({
              url: url,
              type: 'DELETE',
              success: () => { callback(value); },
              error: () => { callback(value); }
            });
          },
          error: (xhr, status, error) => {
            callback(Number.POSITIVE_INFINITY);
          }
        });       
      },
      applyBestCode: (bestCode) => {
        const url = 'https://www.blair.com/api/user-service/user/order/brand/blair/promoCode/'+bestCode;
        $.ajax({
          url: url,
          type: 'PUT',
          success: () => { location.reload(); },
          error: () => { location.reload(); }
        }); 
      }
    },

    oshkosh: {
      id: 5181,
      preApplyCodes: (callback) => {
        const orderValueEl = $('#orderTotal');
        const prevValue = orderValueEl.length > 0 ? 
                          Number(orderValueEl.first().text().trim().substr(1)) : 
                          Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: (code, callback) => {
        const url = $('#applyPromos').attr('action');
        const formData = getFormFieldsAsJson(document.querySelector('#applyPromos'));
        formData['dwfrm_cart_couponCode'] = code;
        formData['dwfrm_cart_addCoupon'] = 'dwfrm_cart_addCoupon';

        $.post(url, formData, 
          (response) => {
            const orderValueEl = $(response).find('#orderTotal');
            const value = orderValueEl.length > 0 ? 
                              Number(orderValueEl.first().text().trim().substr(1)) : 
                              Number.POSITIVE_INFINITY;
            callback(value);
            const formData2 = formData;
            delete  formData2['dwfrm_cart_couponCode'];
            delete  formData2['dwfrm_cart_addCoupon'];
            formData2['dwfrm_cart_coupons_i0_deleteCoupon'] = 'Remove';
              $.post(url, formData2, 
                (response) => {
                 
              });
          });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#dwfrm_cart_couponCode').value = bestCode;
        document.querySelector('#dwfrm_cart_couponCode').dispatchEvent(new Event('input', { bubbles: true } ));
        document.querySelector('#add-coupon').click();
      }
    },

    skiphop: {
      id: 5543,
      preApplyCodes: (callback) => {
        const orderValueEl = $('#orderTotal');
        const prevValue = orderValueEl.length > 0 ? 
                          Number(orderValueEl.first().text().trim().substr(1)) : 
                          Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: (code, callback) => {
        const url = $('#applyPromos').attr('action');
        const formData = getFormFieldsAsJson(document.querySelector('#applyPromos'));
        formData['dwfrm_cart_couponCode'] = code;
        formData['dwfrm_cart_addCoupon'] = 'dwfrm_cart_addCoupon';
        $.post(url, formData, 
          (response) => {
            const orderValueEl = $(response).find('#orderTotal');
            const value = orderValueEl.length > 0 ? 
                              Number(orderValueEl.first().text().trim().substr(1)) : 
                              Number.POSITIVE_INFINITY;
            callback(value);
            const formData2 = formData;
            delete  formData2['dwfrm_cart_couponCode'];
            delete  formData2['dwfrm_cart_addCoupon'];
            formData2['dwfrm_cart_coupons_i0_deleteCoupon'] = 'Remove';
              $.post(url, formData2, 
                (response) => {
                 
              });
          });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#dwfrm_cart_couponCode').value = bestCode;
        document.querySelector('#dwfrm_cart_couponCode').dispatchEvent(new Event('input', { bubbles: true } ));
        document.querySelector('#add-coupon').click();
      }
    },

    carters: {
      id: 5544,
      preApplyCodes: (callback) => {
        const orderValueEl = $('#orderTotal');
        const prevValue = orderValueEl.length > 0 ? 
                          Number(orderValueEl.first().text().trim().substr(1)) : 
                          Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: (code, callback) => {
        const url = $('#applyPromos').attr('action');
        const formData = getFormFieldsAsJson(document.querySelector('#applyPromos'));
        formData['dwfrm_cart_couponCode'] = code;
        formData['dwfrm_cart_addCoupon'] = 'dwfrm_cart_addCoupon';

        $.post(url, formData, 
          (response) => {
            const orderValueEl = $(response).find('#orderTotal');
            const value = orderValueEl.length > 0 ? 
                              Number(orderValueEl.first().text().trim().substr(1)) : 
                              Number.POSITIVE_INFINITY;
            callback(value);
            const formData2 = formData;
            delete  formData2['dwfrm_cart_couponCode'];
            delete  formData2['dwfrm_cart_addCoupon'];
            formData2['dwfrm_cart_coupons_i0_deleteCoupon'] = 'Remove';
              $.post(url, formData2, 
                (response) => {
                 
              });
          });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#dwfrm_cart_couponCode').value = bestCode;
        document.querySelector('#dwfrm_cart_couponCode').dispatchEvent(new Event('input', { bubbles: true } ));
        document.querySelector('#add-coupon').click();
      }
    },

    ediblearrangements: {
      id: 7439,
      preApplyCodes: (callback) => {
        const orderValueEl = $('.GrandTotal');
        console.log(orderValueEl);
        const prevValue = orderValueEl.length > 0 ? 
                          Number(orderValueEl.first().text().replace( /[^0-9.]/g, '').trim()) :
                          Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: (code, callback) => {
        const url = 'https://www.ediblearrangements.com/fruit-cart.aspx';
        const formData = getFormFieldsAsJson(document.querySelector('#aspnetForm'));
        formData['ctl00$cpBody$rptSale$ctl00$txtCoupon'] = code;
        formData['ctl00$cpBody$rptSale$ctl00$btnApplyCoupon'] = 'Apply';

        $.post(url, formData, 
          (response) => {
            const orderValueEl = $(response).find('.GrandTotal');
            const value = orderValueEl.length > 0 ? 
                              Number(orderValueEl.first().text().replace( /[^0-9.]/g, '').trim()) : 
                              Number.POSITIVE_INFINITY;
            callback(value);
          });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('input[name="ctl00$cpBody$rptSale$ctl00$txtCoupon"]').value = bestCode;
        document.querySelector('input[name="ctl00$cpBody$rptSale$ctl00$txtCoupon"]').dispatchEvent(new Event('input', { bubbles: true } ));
        document.querySelector('input[name="ctl00$cpBody$rptSale$ctl00$btnApplyCoupon"]').click();
      }
    },

    expedia: {
      id: 184,
      preApplyCodes: (callback) => {
        callback();
      },
      applyCode: (code, callback) => {
        callback(code);
      },
      applyBestCode: (bestCode) => {
        // document.querySelector('#couponId').value = bestCode;
        // document.querySelector('#couponId').dispatchEvent(new Event('input', {bubbles: true}));
        // document.querySelector('#apply_coupon_button').click();
      }
    },

    famousfootwear: {
      id: 786, 
      preApplyCodes: function(callback) {
        const elTotal = $('div.order-summary-total div.right');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;

        callback(prevValue);
      },
      applyCode: function(code, callback) {
        $.ajax({
          url: 'https://www.famousfootwear.com/WebServices/MarketingManager.asmx/GetPromoCodeType',
          type: 'POST',
          data: { promoCode: code },
          success: (response, status, xhr) => {
            $.ajax({
              url: 'https://www.famousfootwear.com/Checkout/Cart/AddPromoCode',
              type: 'POST',
              data: {
                'RewardsNumber' : '',
                'PromoCode' : code,
                'X-Requested-With' : 'XMLHttpRequest'
              },
              success: (response, status, xhr) => {
                const elTotal = $(response).find('div.order-summary-total div.right');
                const value = elTotal.length > 0 ? 
                              Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                              Number.POSITIVE_INFINITY;
                callback(value);
              },
              error: (xhr, status, error) => {
                callback(Number.POSITIVE_INFINITY);
              }
            });
          },
          error: (xhr, status, error) => {
            callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#PromoCode').value = bestCode;
        document.querySelector('#PromoCode').dispatchEvent(new Event('input', { bubbles: true } ));
        document.querySelector('#submitPromoCode').click();  
      }
    },

    eyebuydirect: {
      id: 780, 
      preApplyCodes: (callback) => {
        const elTotal   = $('dt.js-order-total span.price-symbol');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace(/[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: (code, callback) => {
        $.ajax({
          url: 'https://www.eyebuydirect.com/cart?action=redeem_coupon',
          type: 'POST',
          data: {
            'redeem_coupon': code
          },
          success: (response) => {
            const json = response;
            if (json !== null && json.data !== undefined && json.data !== null) {
              var total = json.data.totalAmount;
              if (total !== undefined && total !== null) {
                total = Number.parseFloat(total.replace(/[^0-9.]/g, ''));
              } else {
                total = Number.POSITIVE_INFINITY;
              }
              callback(total);
            } else {
              callback(Number.POSITIVE_INFINITY);
            }
          },
          error: () => {
            callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('input[name="redeem_coupon"]').value = bestCode;
        document.querySelector('input[name="redeem_coupon"]').dispatchEvent(new Event('input', {bubbles: true}));
        document.querySelector('button.btn-apply-code').click();
      }
    },

    eastbay: {
      id: 177, 
      preApplyCodes: (callback) => {
        if (document.querySelector('.OrderSummary-voucher')) {
          document.querySelector('.OrderSummary-voucher button.remove').click();
        } 
         setTimeout(function(){ 
           $.get('https://www.eastbay.com/api/users/carts/current', (data) => {
                    const preValue = data.totalPriceWithTax.value; 
                                callback(preValue);   
            });
          }, 1000);
      },
      applyCode: (code, callback) => {
         var data =  {
            voucherId: code
          };
         
          $.get(' https://www.eastbay.com/api/v3/session', (res) => {
              const csrf_token = res.data.csrfToken;
               $.ajax({
                  url: 'https://www.eastbay.com/api/users/carts/current/vouchers',
                  type: 'POST',
                  data:  JSON.stringify(data),
                  dataType: 'json',
                  contentType: 'application/json',
                  headers: {
                    "x-csrf-token": csrf_token                   
                  },
                   success: function() {
                     $.get('https://www.eastbay.com/api/users/carts/current', (data) => {
                        const value = data.totalPriceWithTax.value; 
                              callback(value);   
                     });
                    },
                     error: function() {
                       $.get('https://www.eastbay.com/api/users/carts/current', (data) => {
                        const value = data.totalPriceWithTax.value; 
                              callback(value);   
                        });
                    }
                  });

                $.ajax({
                  url: 'https://www.eastbay.com/api/users/carts/current/vouchers/'+code,
                  type: 'DELETE',
                  dataType: 'json',
                  contentType: 'application/json',
                  headers: {
                    "x-csrf-token": csrf_token                   
                  },
                  success: () => { }
               });
            });

      },
      applyBestCode: (bestCode) => {
         if (document.querySelector('.c-checkout-promo-code button.Link')) {
            document.querySelector('.c-checkout-promo-code button.Link').click();
        }        
        setTimeout(function(){ 
          document.querySelector('#input_text_voucherId').value = bestCode;
          document.querySelector('#input_text_voucherId').dispatchEvent(new MouseEvent('input', {bubbles: true}));
          document.querySelector('button[aria-label="Apply Promo Code"]').click();
         }, 2000);

        
      },

    },

   farmandfleet: {
      id: 3470,
      preApplyCodes: (callback) => {
        var prevValue = 0;
        const Total = $('.cart-order-total');
        prevValue = Total.length > 0 ? 
                       Number(Total.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
                      console.log(prevValue);
        if(prevValue == 0){
            const elTotal   = $('.cart-order-subtotal');
            prevValue = elTotal.length > 0 ? 
                       Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        }
        
        callback(prevValue);
      },
      applyCode: (code, callback) => {
          var value = 0;
          document.querySelector('#promoCode').value = code;
          document.querySelector('#promoCode').dispatchEvent(new MouseEvent('input', {bubbles: true}));
          document.querySelector('.apply-promo').click();
        setTimeout(function(){              
             const Total = $('.cart-order-total');
              value = Total.length > 0 ? 
                             Number(Total.first().text().replace( /[^0-9.]/g, '').trim()) : 
                            Number.POSITIVE_INFINITY;                           
              if(value == 0){
                  const elTotal   = $('.cart-order-subtotal');
                  value = elTotal.length > 0 ? 
                             Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                            Number.POSITIVE_INFINITY;
              }
            callback(value);

         }, 1500);
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#promoCode').value = bestCode;
        document.querySelector('#promoCode').dispatchEvent(new MouseEvent('input', {bubbles: true}));
        document.querySelector('.apply-promo').click();
      }
    },
  
    fragrancenet: {
      id: 830,
      preApplyCodes: function(callback) {
        const orderValueEl = $('div.total span.subtotalPrice');
        const prevValue = orderValueEl.length > 0 ? 
                          Number(orderValueEl.first().attr('data-price').trim()) : 
                          Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        this.preApplyCodes(() => {
          const formData = getFormFieldsAsJson(document.querySelector('#couponform'));
          formData['gc_coupon_id'] = code;
          $.post('https://www.fragrancenet.com/f/net/ord/basket.html', formData, 
            (response) => {
              const orderValueEl = $(response).find('div.total span.subtotalPrice');
              const value = orderValueEl.length > 0 ? 
                            Number(orderValueEl.first().attr('data-price').trim()) : 
                            Number.POSITIVE_INFINITY;
              callback(value);
            });
        });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#coupon_input').value = bestCode;
        document.querySelector('#coupon_input').dispatchEvent(new Event('input', {bubbles: true}));
        document.querySelector('#couponform').submit();
      }
    },

    gnc: {
      id: 190,
      preApplyCodes: function(callback) {
        const elTotal = $('.checkout-order-totals tr.order-total td.order-value');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {       
            $.get('https://www.gnc.com/on/demandware.store/Sites-GNC2-Site/default/Cart-AddCouponJson?couponCode='+code+'&format=ajax', 
              (response) => {
               const value = response.baskettotal;
               callback(value);
              });         
      },
      applyBestCode: (bestCode) => {
        location.reload();
      }
    },

    hanes: {
      id: 2982,
      preApplyCodes: function(callback) {
        const elTotal = $('#cart-totals .price.bfx-price.bfx-total-grandtotal, tr.grand.totals');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
          const url = $('#discount-coupon-form').attr('action');
          const formData = getFormFieldsAsJson(document.querySelector('#discount-coupon-form'));
          formData['coupon_code_fake'] = code;
          formData['coupon_code'] = code;
          formData['last_code'] = code;
          $.ajax({
            url: url,
            type: 'POST',
            data: formData,
            success: () => {
              $.get('https://'+window.location.hostname+window.location.pathname, (responseGet) => {
                const checkoutconfigindex = responseGet.indexOf("window.checkoutConfig");
                const customerDataindex = responseGet.indexOf("window.isCustomerLoggedIn");
                const finalIndex = customerDataindex-checkoutconfigindex;
                const data = JSON.parse(responseGet.substr(responseGet.indexOf("window.checkoutConfig")+23, finalIndex-107));
                const value = data.totalsData.base_grand_total;
                const formData2 = getFormFieldsAsJson(document.querySelector('#discount-coupon-form'));
                formData2['last_code'] = code;
                formData2['remove_coupon'] = code;
                 $.post(url, formData2, 
                  (response) => {
                   callback(value);
                  });              
              });
            },
            error: (xhr, status, error) => {
               callback(Number.POSITIVE_INFINITY);
            }
          });
      },
        applyBestCode: (bestCode) => {
          document.querySelector('#coupon_code_fake, #discount-code-fake').value = bestCode;
          document.querySelector('#coupon_code_fake, #discount-code-fake').dispatchEvent(new MouseEvent('input', { bubbles: true } ));
          document.querySelector('#coupon_code_fake, #discount-code-fake').dispatchEvent(new Event('change', {bubbles: true}));
          document.querySelector('#coupon_code_fake, #discount-code-fake').dispatchEvent(new Event('blur')); 
          document.querySelector('#coupon_code_fake, #discount-code-fake').dispatchEvent(new Event('focus'));    
          document.querySelector('#discount-coupon-form button.action.apply,#discount-form button.action.action-apply').click();    
        }
    },

  champion: {
      id: 544,
      preApplyCodes: function(callback) {
        const elTotal = $('#cart-totals .price.bfx-price.bfx-total-grandtotal, tr.grand.totals');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
          const url = $('#discount-coupon-form').attr('action');
          const formData = getFormFieldsAsJson(document.querySelector('#discount-coupon-form'));
          formData['coupon_code_fake'] = code;
          formData['coupon_code'] = code;
          formData['last_code'] = code;
          $.ajax({
            url: url,
            type: 'POST',
            data: formData,
            success: () => {
              $.get('https://'+window.location.hostname+window.location.pathname, (responseGet) => {
                const checkoutconfigindex = responseGet.indexOf("window.checkoutConfig");
                const customerDataindex = responseGet.indexOf("window.isCustomerLoggedIn");
                const finalIndex = customerDataindex-checkoutconfigindex;
                const data = JSON.parse(responseGet.substr(responseGet.indexOf("window.checkoutConfig")+23, finalIndex-107));
                const value = data.totalsData.base_grand_total;
                const formData2 = getFormFieldsAsJson(document.querySelector('#discount-coupon-form'));
                formData2['last_code'] = code;
                formData2['remove_coupon'] = code;
                 $.post(url, formData2, 
                  (response) => {
                   callback(value);
                  });              
              });
            },
            error: (xhr, status, error) => {
               callback(Number.POSITIVE_INFINITY);
            }
          });
      },
        applyBestCode: (bestCode) => {
          document.querySelector('#coupon_code_fake, #discount-code-fake').value = bestCode;
          document.querySelector('#coupon_code_fake, #discount-code-fake').dispatchEvent(new MouseEvent('input', { bubbles: true } ));
          document.querySelector('#coupon_code_fake, #discount-code-fake').dispatchEvent(new Event('change', {bubbles: true}));
          document.querySelector('#coupon_code_fake, #discount-code-fake').dispatchEvent(new Event('blur')); 
          document.querySelector('#coupon_code_fake, #discount-code-fake').dispatchEvent(new Event('focus'));    
          document.querySelector('#discount-coupon-form button.action.apply,#discount-form button.action.action-apply').click();    
        }
    },

  justmysize: {
      id: 1046,
      preApplyCodes: function(callback) {
        const elTotal = $('#cart-totals .price.bfx-price.bfx-total-grandtotal, tr.grand.totals');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
          const url = $('#discount-coupon-form').attr('action');
          const formData = getFormFieldsAsJson(document.querySelector('#discount-coupon-form'));
          formData['coupon_code_fake'] = code;
          formData['coupon_code'] = code;
          formData['last_code'] = code;
          $.ajax({
            url: url,
            type: 'POST',
            data: formData,
            success: () => {
              $.get('https://'+window.location.hostname+window.location.pathname, (responseGet) => {
                const checkoutconfigindex = responseGet.indexOf("window.checkoutConfig");
                const customerDataindex = responseGet.indexOf("window.isCustomerLoggedIn");
                const finalIndex = customerDataindex-checkoutconfigindex;
                const data = JSON.parse(responseGet.substr(responseGet.indexOf("window.checkoutConfig")+23, finalIndex-107));
                const value = data.totalsData.base_grand_total;
                const formData2 = getFormFieldsAsJson(document.querySelector('#discount-coupon-form'));
                formData2['last_code'] = code;
                formData2['remove_coupon'] = code;
                 $.post(url, formData2, 
                  (response) => {
                   callback(value);
                  });              
              });
            },
            error: (xhr, status, error) => {
               callback(Number.POSITIVE_INFINITY);
            }
          });
      },
        applyBestCode: (bestCode) => {
          document.querySelector('#coupon_code_fake, #discount-code-fake').value = bestCode;
          document.querySelector('#coupon_code_fake, #discount-code-fake').dispatchEvent(new MouseEvent('input', { bubbles: true } ));
          document.querySelector('#coupon_code_fake, #discount-code-fake').dispatchEvent(new Event('change', {bubbles: true}));
          document.querySelector('#coupon_code_fake, #discount-code-fake').dispatchEvent(new Event('blur')); 
          document.querySelector('#coupon_code_fake, #discount-code-fake').dispatchEvent(new Event('focus'));    
          document.querySelector('#discount-coupon-form button.action.apply,#discount-form button.action.action-apply').click();    
        }
    },
  
    hilton: {
      id: 29321,
      preApplyCodes: (callback) => {
        callback();
      },
      applyCode: (code, callback) => {
        callback(code);
      },
      applyBestCode: (bestCode) => {
      }
    },

    hm: {
      id: 5709,
      preApplyCodes: function(callback) {
        const elTotal = $('[class*="OrderTotals--totals"] tr:last-child td:last-child, #orderSummary [colspan="2"]td:not(:contains(" 0.00")), #total_price_of_basket:not(:contains(" 0.00"))');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace(/[^0-9.]/g, '').replace(',', '').trim()) : 
                      Number.POSITIVE_INFINITY;

        callback(prevValue);
      },
      applyCode: function(code, callback) {
        const url =  'https://www2.hm.com/'+window.location.pathname+'/redeemVoucher';
        $.ajax({
          url: url,
          type: 'POST',
          headers: {
            'Content-Type': 'application/json;charset=UTF-8'
          },
          data: '{"voucherCode":"' + code + '"}',
          success: (response) => {
            var totalPrice = Number.POSITIVE_INFINITY;
            const orderTotals = response.orderTotals;
            if (orderTotals !== null && orderTotals !== undefined) {
              const price = orderTotals.totalPrice;
              if (price !== null && price !== undefined) {
                totalPrice = price.replace( /[^0-9.]/g, '').replace(',', '').trim();
              }
            }
              $.ajax({
                    url: 'https://www2.hm.com/en_us/v1/vouchers/'+code,
                    type: 'DELETE',
                    headers: {
                      'Content-Type': 'application/json;charset=UTF-8'
                    },
                    data: '{}',
                    success: (response) => { callback(totalPrice); },
                    error: (response) => { callback(totalPrice); }
                  });
          },
          error: function() {
            callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: function(bestCode) {
         const url =  'https://www2.hm.com/'+window.location.pathname+'/redeemVoucher';
        $.ajax({
          url: url,
          type: 'POST',
          headers: {
            'Content-Type': 'application/json;charset=UTF-8'
          },
          data: '{"voucherCode":"' + bestCode + '"}',
          success: (response) => { location.reload(); },
          error: (response) => { location.reload(); }
        });
      }
    },

  iherb: {
    id: 5469, 
    preApplyCodes: function(callback) {
      const orderValueEl = $('#cart-grand-total, div:contains("Estimated Total") + div, div:contains("Order Total") + div');
      const prevValue = orderValueEl.length > 0 ? 
                        Number(orderValueEl.first().text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                        Number.POSITIVE_INFINITY;
      callback(prevValue);
    },
    applyCode: function(code, callback) {     
      const url = 'https://'+window.location.hostname+'/api/Carts/0/applyCoupon';
      const data = JSON.parse(document.getElementById('__NEXT_DATA__').innerHTML);
      const customerid = data.props.initialState.server.cartResult.cartId;
      const lang = data.props.initialState.global.pref.language;
      const country = data.props.initialState.global.pref.country;
      const currency = data.props.initialState.global.pref.currency;
      const store = data.props.initialState.global.pref.store;
      const storeId = data.props.initialState.global.pref.storeId;
      $.ajax({
        url: url,
        type: 'POST',
        data: JSON.stringify({couponCode:code}),
        headers: {
            'Content-Type': 'application/json',
            'customerid': customerid,
            'pref': JSON.stringify({"lac":lang,"ctc":country,"crc":currency,"crs":store,"storeid":storeId,"som":"pounds"})
            },
        success: (response) => {
          console.log(response);
          console.log(response.cartTotal);
            const eltotal = response.cartTotal; 
            const value = eltotal ? 
                              Number(eltotal.replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                              Number.POSITIVE_INFINITY;
            callback(value);     
          },
          error: (xhr, status, error) => {
            callback(Number.POSITIVE_INFINITY);
          }
        });     
    },
    applyBestCode: function(bestCode) {
      document.querySelector('#coupon-input, [data-qa-element="input-apply-code"]').value = bestCode;
      document.querySelector('#coupon-input, [data-qa-element="input-apply-code"]').dispatchEvent(new Event('input', { bubbles: true } ));
      document.querySelector('#coupon-apply, [data-qa-element="btn-apply-code"]').click();
    }
  },
  
    jcpenney: {
      id: 199,
      preApplyCodes: function(callback) {
        const localData = JSON.parse(localStorage.getItem('__yoda'));
        this.data = {
          accountId: localData.ACCOUNT_ID,
          accessToken: localData.Access_Token,
        };
        this._removeAllCodes(callback);
      },
      applyCode: function(code, callback) {
        this._applyCode(code, function() {
          this._status(function(result) {
            if (result.adjustments && result.adjustments.length > 0) {
              this._removeCode(result.adjustments[0].id, function() {
                callback(result.totals[0].amount);
              }) ;
            } else {
              callback(result.totals[0].amount);
            }
          }.bind(this));
        }.bind(this));
      },
      applyBestCode: function(bestCode) {
        document.querySelector('[data-automationid="manual-apply-coupon-input"]').value = bestCode;
        document.querySelector('[data-automationid="manual-apply-coupon-input"]').dispatchEvent(new MouseEvent('input', { bubbles: true } ));
        document.querySelector('[data-automation-id="manual-apply-coupon-button"]').click();
      },
      _applyCode: function(code, callback) {
        var body = JSON.stringify({
          code: code,
          serialNumber: null,
        });
        this._xhrRequest('POST', '/adjustment/discounts', callback, body);
      },
      _removeAllCodes: function(callback) {
        this._status(function(result) {
          this._syncForEach(result.adjustments, function(adjustment, done) {
            if (adjustment.code === 'COUPON') {
              this._removeCode(adjustment.id, done);
            }
          }.bind(this), callback);
        }.bind(this));
      },
      _removeCode: function(code, callback) {
        this._xhrRequest('DELETE', `/adjustment/discounts/${code}`, callback);
      },
      _status: function(callback) {
        this._xhrRequest('GET', '?expand=status', function(result) {
          callback(JSON.parse(result));
        });
      },
      _xhrRequest: function(method, url, callback, body) {
        var request = {
          headers: {
            'Authorization': `Bearer ${this.data.accessToken}`,
            'Content-Type': 'application/json;'
          },
          method: method,
          url: `https://order-api.jcpenney.com/order-api/v1/accounts/${this.data.accountId}/draft-order${url}`,
          withCredentials: true,
        };
  
        if (body) {
          request.body = body;
        }
  
        sameOriginRequest(request, callback);
      },
      _syncForEach: function(collection, step, end, i) {
        if (i === undefined) {
            i = 0;
        }
    
        if (i >= collection.length) {
            const total = Number($($('div[data-automation-id="at-total-price"]')[0]).text().substr(1));
            end(total);
        } else {
            step(collection[i], this._syncForEach.bind(null, collection, step, end, i+1));
        }
      }
    },
  
    kohls: {
      id: 1070,
      preApplyCodes: function(callback) {
        const elTotal = $('#totalcharges');
        const value   = elTotal.length > 0 ? 
                              Number(elTotal.first().text().trim().substr(1)) : 
                              Number.POSITIVE_INFINITY;
        const elsubtotal = $('#subtotal');
        const elsubtotalValue   = elsubtotal.length > 0 ? 
                              Number(elsubtotal.first().text().trim().substr(1)) : 
                              Number.POSITIVE_INFINITY;
        const shipcharges = $('#shipcharges');
        const shipchargesValue   = shipcharges.length > 0 ? 
                              Number(shipcharges.first().text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 0;
                                                    
        this.totalBefore = value;
        this.elsubtotalValue = elsubtotalValue;
        this.shipchargesValue = shipchargesValue;
        callback(value);
      },
      applyCode: function(code, callback) {
        if (document.querySelector('#promo-kcInput') === null || !document.querySelector('#promo-kcInput')) {
          document.querySelector('.kohlscashapplylink').click();
        }  
               
          document.querySelector('.kohlscashapplylink').click();
          const self = this;
          self._applyCode(code, function(value) {
            if (!self.codes) {
              self.codes = [];
            }
            if (value < self.totalBefore) {
              self.codes.push(code);
            }
            self._removeAppliedCode(code, function() {
              callback(value);
            });
          }); 
      },
      applyBestCode: function(bestCode) {
            const self = this;
            self._applyBestCode(bestCode, function() {
                //callback(value);
            });
      },
      _applyCode: function(code, callback) {
        const self = this;
        $.ajax({
          url: 'https://www.kohls.com/cnc/checkout/applykccoupons',
          type: 'POST',
          contentType: 'application/json',
          data: JSON.stringify({ promoCode: code, couponType: "promo" }),
          success: function(data) {
            let appliedDiscounts = 0;
            const qualifiedItems = data.appliedDiscounts ? 
                              data.appliedDiscounts.qualifiedItems : 
                              [];
            qualifiedItems.forEach((item) => {
              if (item.amount && item.code)  {
                appliedDiscounts += Number(item.amount.replace( /[^0-9.]/g, '').trim());
              }
            });
            var discountedPrice = (self.elsubtotalValue +self.shipchargesValue) - appliedDiscounts;
            var finalPrice = (Math.ceil((discountedPrice*0.06) * 100)/100)+discountedPrice;
            callback(finalPrice.toFixed(2));
          },
          error: function() {
            callback(self.totalBefore);
          }
        });
      },
      _removeAppliedCode: function(code, callback) {
        $.ajax({
          url: 'https://www.kohls.com/cnc/checkout/removekccoupons',
          type: 'POST',
          contentType: 'application/json',
          data: JSON.stringify({ couponCode: code, couponType: "promo" }),
          success: function() {
            callback();
          },
          error: function() {
            callback(0);
          }
        });
      },
       _applyBestCode: function(bestCode, callback) {
        const self = this;
         $.ajax({
          url: 'https://www.kohls.com/cnc/checkout/applykccoupons',
          type: 'POST',
          contentType: 'application/json',
          data: JSON.stringify({ promoCode: bestCode, couponType: "promo" }),
          success: function(data) {
              document.querySelector('#promo-kcInput').value = bestCode;
              document.querySelector('#promo-kcInput').dispatchEvent(new MouseEvent('input', {bubbles: true}));
              document.querySelector('.apply-greenBtn#applyInputButton').click();
              document.querySelector('.promo-close-btn').click();
          },
          error: function() {
            self._applyBestCode(bestCode, function() {
              });
          }
        });
      }
    },
  
    lordandtaylor: {
      id: 1111, 
      preApplyCodes: function(callback) {
        const elTotal = $('#jsVal-grandTotal');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        this.preApplyCodes(() => {
          $.post(
            'https://www.lordandtaylor.com/checkout/checkout.jsp',
            {
              bmForm: 'applyPromoSaksBag',
              promoCode: code
            }, (response) => {
              if (response !== null && !response.errors) {
                  const value = response.cartSummary.grandTotalWithoutFormatting;
                  const price = value.replace( /[^0-9.]/g, '').trim();
                callback(price);
                $.post(
                  'https://www.lordandtaylor.com/checkout/checkout.jsp',
                  {
                    bmForm: 'remove_promo_code_saks_bag_service',
                    promoCode: code
                  }, () => {
                    //callback(0);
                  }
                ); 
              } else {
                callback(Number.POSITIVE_INFINITY);
              }
            }
          );
        });
      },
      applyBestCode: function(bestCode) {
          document.querySelector('#promoCodeEntry').value = bestCode;
          document.querySelector('#promoCodeEntry').dispatchEvent(new Event('input', {bubbles: true}));
          document.querySelector('#promoApply').click();
      },
      _applyBestCodes: function(index) {
        if (index < this.codes.length) {
          const promoCode = this.codes[index];
          document.querySelector('#promoCodeEntry').value = promoCode;
          document.querySelector('#promoCodeEntry').dispatchEvent(new Event('input', {bubbles: true}));
          document.querySelector('#promoApply').click();
          this._applyBestCodes(index + 1);
        } else {
          this.codes = null;
        }
      }
    },

    macys: {
      id: 207, 
      preApplyCodes: function(callback) {
        const elTotal = $('#cx-at-SUM_SUB_TOTAL-value');
        const value = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        const elRemove = $('#promo-remove-button');
        if (elRemove.length > 0) {
          elRemove.click();
          callback(value);
        } else {
          callback(value);
        }
      },
      applyCode: function(code, callback) {
        const macysBagguid = decodeURI(document.cookie.split(';').filter(function(c) { return c.indexOf('macys_bagguid') !== -1 })[0]).trim().split('=')[1];
        this.preApplyCodes(() => {
          $.ajax({
            url: `https://www.macys.com/my-bag/${macysBagguid}/promo?currencyCode=USD&promoCode=${code}`,
            type: 'PUT',
            contentType: 'application/json',
            success: function(data) {
              let value = Number.POSITIVE_INFINITY;
              if (data.bag.sections) {
                const formattedValue = data.bag.sections.summary.price[0].values[0].formattedValue;
                value = Number(formattedValue.replace( /[^0-9.]/g, '').trim());
              }
              callback(value);
            }
          });
        });
      },
      applyBestCode: function(bestCode) {
        document.querySelector('#promo-apply-input').value = bestCode;
        document.querySelector('#promo-apply-input').dispatchEvent(new Event('input', {bubbles: true}));
        $('.promo-apply-button.primaryBlack.expanded').click();
      }
    },
  
    michaels: {
      id: 6121, 
      preApplyCodes: function(callback) {
        const elTotal = $('li.order-total-value span.value');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().trim().substr(1)) : 
                      Number.POSITIVE_INFINITY;
        const url = $('#promo-form').attr('action');
        $.post(url, {
          dwfrm_cart_couponCode: '',
          dwfrm_cart_coupons_i0_deleteCoupon: 'Remove'
        }, (response) => {
          callback(prevValue);
        });
      },
      applyCode: function(code, callback) {
        this.preApplyCodes(() => {
          const url = $('#promo-form').attr('action');
          $.post(url, {
            dwfrm_cart_couponCode: code,
            dwfrm_cart_addCoupon: 'dwfrm_cart_addCoupon'
          }, (response) => {
            const elTotal = $(response).find('li.order-total-value span.value');
            const value = elTotal.length > 0 ? 
                          Number(elTotal.first().text().trim().substr(1)) : 
                          Number.POSITIVE_INFINITY;
            callback(value);
          });
        });
      },
      applyBestCode: function(bestCode) {
        document.querySelector('#dwfrm_cart_couponCode').value = bestCode;
        document.querySelector('#dwfrm_cart_couponCode').dispatchEvent(new Event('input', {bubbles: true}));
        document.querySelector('#add-coupon').click();
      }
    },
    
    nutrisystem: {
      id: 3976, 
      preApplyCodes: function(callback) {
        const elTotal = $('table.order-totals-table tr.totals td.price');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        console.log('Apply Code: ', code);
        const url = 'https://www.nutrisystem.com/checkout/billing.jsp?_DARGS=/jsps_hmr/shop/includes/apply_checkout_promo.jsp';
        const formData = getFormFieldsAsJson(document.querySelector('#checkoutPromo'));
        formData['promo-code'] = code;
        $.ajax({
          url: url,
          type: 'POST',
          data: formData,
          success: (response, status, xhr) => {
            $.get('https://www.nutrisystem.com'+window.location.pathname + window.location.search, (responseGet) => {
              if (responseGet !== null) {
                const elTotal = $(response).find('table.order-totals-table tr.totals td.price');
                const value = elTotal.length > 0 ? 
                              Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                              Number.POSITIVE_INFINITY;
                callback(value);
              } else {
                callback(Number.POSITIVE_INFINITY);
              }
            });
          },
          error: (xhr, status, error) => {
            console.log(error);
            callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#promo-code-input').value = bestCode;
        document.querySelector('#promo-code-input').dispatchEvent(new MouseEvent('input', { bubbles: true } ));
        document.querySelector('form#checkoutPromo').submit();  
      }
    },

    newegg: {
      id: 1, 
      preApplyCodes: function(callback) {
        const elTotal = $('li.summary-content-total span strong');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.last().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
    },
    applyCode: function(code, callback) {
      this._applyCode(code, function(value) {
        callback(value);
      }) ;
    },
    applyBestCode: function(bestCode) {
      this._applyCode(bestCode, function() {
        location.reload();
      }) ;
    },
    _applyCode: (code, callback) => {     
      const url = 'https://secure.newegg.com/shop/api/InitCartApi';
        $.ajax({
          url: url,
          type: 'POST',
          headers: {
            'content-type': 'application/json'
          },
          data: JSON.stringify({"Actions":[{"ActionType":"InputPCode","JsonContent":JSON.stringify({"ActionType":"InputPCode","Append":[{"PCode":code}]})}]}),
          success: (response, status, xhr) => {
           const data = JSON.parse(response);
           const value = data.SummaryInfo.GrandTotal;
           callback(value);
          },
          error: (xhr, status, error) => {
            callback(Number.POSITIVE_INFINITY);
          }
      });   
    }
  },

    orientaltrading: {
      id: 3069, 
      preApplyCodes: function(callback) {
        const elTotal = $('span.amt-grand-total, .u_txtPrice.u_bold.u_uppercase');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.last().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
       if(window.location.href.indexOf("checkout") > -1){
          const ZipCode = $('[name="order.shippingAddress.zipCode"]:visible').val();
          const zip = ZipCode?ZipCode:'0';
          const addCouponUrl = 'https://secure.checkout.orientaltrading.com/checkout/rest/promoCode/'+code+'/zip/'+zip+'/method/ASDARD';
         $.ajax({
          url: addCouponUrl,
          type: 'GET',
          success: (response, status, xhr) => {
            var total = response.total;
            if (total === undefined || total === null) {
              total = Number.POSITIVE_INFINITY;
            }
            callback(total);
          },
          error: (xhr, status, error) => {
            console.log(error);
            callback(Number.POSITIVE_INFINITY);
          }
        });
       }else{         
        var date = new Date();
        var timestamp = date.getTime();
        const url = `https://`+window.location.hostname+`/rest/promocode/${code}/apply/shoppingcart?_=${timestamp}`;
          $.ajax({
          url: url,
          type: 'GET',
          success: (response, status, xhr) => {
            $.get(`https://`+window.location.hostname+`/web/shoppingcart/summary`, (responseGet) => {
            const total = $(responseGet).find('span.amt-grand-total, .u_txtPrice.u_bold.u_uppercase');
            const value = total.length > 0 ? 
                            Number(total.text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                            Number.POSITIVE_INFINITY;                              
            callback(value);
            });
          },
          error: (xhr, status, error) => {
            console.log(error);
            callback(Number.POSITIVE_INFINITY);
          }
        });
       }
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#promoCodeInput, #promo_code').value = bestCode;
        document.querySelector('#promoCodeInput, #promo_code').dispatchEvent(new MouseEvent('input', { bubbles: true } ));
        document.querySelector('#applyPromoShoppingCart, .p_apply_promo').click();  
      }
    },

    papajohns: {
      id: 5657, 
      preApplyCodes: function(callback) {
        const elTotal = $('.estimated-total-amount');
        const value   = elTotal.length > 0 ? 
                              Number(elTotal.first().text().trim().substr(1)) : 
                              Number.POSITIVE_INFINITY;
        const elRemove = $('.remove-product.remove-product-promo');
        if (elRemove.length > 0) {
          const urlRemove = 'https://www.papajohns.com'+elRemove.first().attr('data-freight-href');
          $.get(urlRemove, () => {
            callback(value);
          });
        } else {
          callback(value);
        }
      },
      applyCode: function(code, callback) {
        this.preApplyCodes(() => {
          $.get(`https://www.papajohns.com/order/validate-promo?promo-code=${code}`, () => {
            $.get(`https://www.papajohns.com/order/view-cart?promoNotification=true&promoCode=${code}`, (data) => {
              const elTotal = $(data).find('.estimated-total-amount.amount h3');
              const value = elTotal.length > 0 ? 
                              Number(elTotal.first().html().substr(1)) : 
                              Number.POSITIVE_INFINITY;
              const elRemove = $(data).find('.remove-product.remove-product-promo');
              if (elRemove.length > 0) {
                const urlRemove = 'https://www.papajohns.com'+elRemove.first().attr('data-freight-href');
                $.get(urlRemove, () => {
                  callback(value);
                });
              } else {
                callback(value);
              }
            });
          });
        });
      },
      applyBestCode: function(bestCode) {
        document.querySelector('#sticky-promo-code').value = bestCode;
        document.querySelector('#sticky-promo-code').dispatchEvent(new MouseEvent('input', {bubbles: true}));
        document.querySelector('#sticky-promo-submit').click();
      }
    },

    papamurphys: {
      id: 17340, 
      preApplyCodes: function(callback) {
        const elTotal = $('span#bTotal');
        const prevValue = elTotal.length > 0 ? 
                          Number(elTotal.first().text()) : 
                          Number.POSITIVE_INFINITY;
        const basketId = $('#BasketId').val();
        if (basketId === null || basketId === undefined) {
          callback(prevValue);
        } else {
          $.ajax({
            url: `https://order.papamurphys.com/order/removecoupon?basketId=${basketId}`,
            type: 'POST',
            data: {},
            success: (responseApplyCoupon) => {
              callback(prevValue);
            },
            error: (xhr, status, error) => {
              callback(prevValue);
            }
          });
        }
      },
      applyCode: function(code, callback) {
        const basketId = $('#BasketId').val();
        if (basketId === null || basketId === undefined) {
          basketId = '';
        }

        $.ajax({
          url: `https://order.papamurphys.com/order/applycoupon?basketId=${basketId}`,
          type: 'POST',
          data: {code: code},
          success: (responseApplyCoupon) => {
            if (responseApplyCoupon === null) {
              callback(Number.POSITIVE_INFINITY);
            } else {
              const status = responseApplyCoupon.querySelectorAll('AsyncResult Status')[0].innerHTML;
              if (status === 'OK') {               
                $.ajax({
                  url: `https://order.papamurphys.com/basket/validatepos/${basketId}`,
                  type: 'POST',
                  data: {code: code},
                  success: (responseValidate) => {
                    if (responseValidate === null) {
                      callback(Number.POSITIVE_INFINITY);
                    } else {
                      const status = responseValidate.querySelectorAll('AsyncResult Status')[0].innerHTML;
                      if (status === 'OK') {
                        const total = responseValidate.querySelectorAll('AsyncResult total')[0].innerHTML;
                        callback(total);
                      } else {
                        callback(Number.POSITIVE_INFINITY);
                      }
                    }
                  },
                  error: (xhr, status, error) => {
                    console.log(error);
                    callback(Number.POSITIVE_INFINITY);
                  }
                });
              } else {
                        callback(Number.POSITIVE_INFINITY);
                      }
            }
          },
          error: (xhr, status, error) => {
            console.log(error);
            callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: function(bestCode) {
        document.querySelector('#CouponCodeText').value = bestCode;
        document.querySelector('#CouponCodeText').dispatchEvent(new MouseEvent('input', {bubbles: true}));
        document.querySelector('#EnterCouponCodeBtn').click();
      }
    },

  partycity: {
    id: 5689, 
      preApplyCodes: function(callback) {
        const elTotal = $('li.order-total').children().last();
        const prevValue = elTotal.text().replace( /[^0-9.]/g, '').replace(',', '').trim();
        if(window.location.href.indexOf("cart") > -1){
          const url = $('#cart-items-form').attr('action');
          const formData = getFormFieldsAsJson(document.querySelector('#cart-items-form'));
          formData['dwfrm_cart_coupons_i0_deleteCoupon'] = 'Remove';
          $.post(url, formData, 
            (response) => {
              callback(prevValue);
          });
        }else{
          const prevCode = $('[name="summary-couponCode"]').val();
          const windowVariables = retrieveWindowVariables(["window.Urls"]);
          const removeCouponUrl = windowVariables["window.Urls"].removeCoupon;
          if(prevCode){
            $.get('https://'+window.location.hostname+removeCouponUrl+'?couponCode='+prevCode+'&format=ajax', 
              () => {                                          
                callback(prevValue,prevCode);
            });
          }else{
             callback(prevValue);
          }
        }
      },
      applyCode: function(code, callback) {  
       if(window.location.href.indexOf("cart") > -1){
        this.preApplyCodes(() => {
          const url = $('#cart-items-form').attr('action');
          const formData = getFormFieldsAsJson(document.querySelector('#cart-items-form'));
          formData['dwfrm_cart_couponCode'] = code;
          formData['dwfrm_cart_addCoupon'] = 'dwfrm_cart_addCoupon';
          $.post(url, formData, 
            (responsePost) => {
              $.get('https://www.partycity.com/cart', (response) => {
                const elTotal = $(response).find('li.order-total').children().last();
                const value = elTotal.text().replace( /[^0-9.]/g, '').replace(',', '').trim();
                callback(value);
              });
            });
        });
       }else{
        const checkoutStep = $('.checkoutstep').val();
        const windowVariables = retrieveWindowVariables(["window.Urls"]);
        const addCouponUrl = windowVariables["window.Urls"].addCoupon;
        const removeCouponUrl = windowVariables["window.Urls"].removeCoupon;
        const summaryRefreshURL = windowVariables["window.Urls"].summaryRefreshURL;      
        $.get(addCouponUrl+'?couponCode='+code+'&format=ajax', 
          () => {
            $.get('https://'+window.location.hostname+summaryRefreshURL+'?format=ajax&checkoutstep='+checkoutStep, 
              (response) => {
                const orderValueEl = $(response).find('li.order-total').children().last();
                const value = orderValueEl.text().replace( /[^0-9.]/g, '').replace(',', '').trim();
                  $.get('https://'+window.location.hostname+removeCouponUrl+'?couponCode='+code+'&format=ajax', 
                  () => {                                          
                    callback(value);
                });
              });
          });
       }
      },
      applyBestCode: (bestCode) => {
        if(window.location.href.indexOf("cart") > -1){
          const url = $('#cart-items-form').attr('action');
          const formData = getFormFieldsAsJson(document.querySelector('#cart-items-form'));
          formData['dwfrm_cart_couponCode'] = bestCode;
          formData['dwfrm_cart_addCoupon'] = 'dwfrm_cart_addCoupon';
          $.post(url, formData, 
            (responsePost) => { location.reload(); })
        }else{
          const windowVariables = retrieveWindowVariables(["window.Urls"]);
          const addCouponUrl = windowVariables["window.Urls"].addCoupon;     
          $.get(addCouponUrl+'?couponCode='+bestCode+'&format=ajax', 
            () => { location.reload(); })
        }
      }
    },

    pharmaca: {
      id: 5795, 
      coupon_input_selector: '#coupon_code',
      total_price_selector: 'tr.grand.totals span.price',
      preApplyCodes: function(callback) {
        const elTotal = $('tr.grand.totals span.price');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        this.pharmacaPrevCode = code;
        $.ajax({
          url: 'https://www.pharmaca.com/checkout/cart/couponPost',
          type: 'POST',
          data: {
            remove: 0,
            coupon_code: code
          },
          success: () => {
            $.get('https://www.pharmaca.com'+window.location.pathname, (responseGet) => {
              const elTotal = $(responseGet).find('.cart-price-new .price');
              var value = 0;
              if( elTotal.length > 0 ){
                 $( elTotal ).each(function( index ) {
                  value += Number($( this ).text().replace( /[^0-9.]/g, '').trim());                
                 });
              }else{
                  value = Number.POSITIVE_INFINITY;
              }
              
              callback(value);
            });
          },
          error: (xhr, status, error) => {
             callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#coupon_code').value = bestCode;
        document.querySelector('#coupon_code').dispatchEvent(new MouseEvent('input', { bubbles: true } ));
        document.querySelector('button.apply').click();  
      }
    },
  
    puma: {
      id: 1403, 
      preApplyCodes: function(callback) {
        const elTotal = $('p.grand-total');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        const el = $('a.remove-coupon');
        var url = null;
        if (el !== null && el !== undefined && el.length > 0) {
          const code = el.attr('data-code');
          const uuid = el.attr('data-uuid');
          url = 'https://us.puma.com/on/demandware.store/Sites-NA-Site/en_US/Cart-RemoveCouponLineItem' +
                      '?code=' + code +
                      '&uuid=' + uuid;
        } else if (this.pumaPrevCode !== null && this.pumaPrevCode !== undefined) {
          url = 'https://us.puma.com/on/demandware.store/Sites-NA-Site/en_US/Cart-RemoveCouponLineItem' +
                      '?code=' + this.pumaPrevCode +
                      '&uuid=' + this.pumaPrevUuid;
        }
        if (url !== null) {
          $.ajax({
            url: url,
            type: 'GET',
            data: {},
            success: () => {
              callback(prevValue);
            },
            error: (xhr, status, error) => {
              console.log(error);
              callback(prevValue);
            }
          });
        } else {
          callback(prevValue);
        }
      },
      applyCode: function(code, callback) {
        this.preApplyCodes(() => {
          this.pumaPrevCode = code;
          console.log('Apply Code: ', code);
          const csrf_token = $('input[name*="csrf_token"]').first().val();
          const url = 'https://us.puma.com/on/demandware.store/Sites-NA-Site/en_US/Cart-AddCoupon' +
                      '?couponCode=' + code + 
                      '&csrf_token=' + csrf_token;
          $.ajax({
            url: url,
            type: 'GET',
            data: {},
            success: (response, status, xhr) => {
              if (response !== null) {
                const totals = response.totals;
                if (totals !== null && totals !== undefined) {
                  const value = totals.grandTotal !== null ? 
                            Number(totals.grandTotal.replace( /[^0-9.]/g, '').trim()) : 
                            Number.POSITIVE_INFINITY;
                  $.get('https://us.puma.com'+window.location.pathname, (responseGet) => {
                    const el = $(responseGet).find('a.remove-coupon');
                    if (el !== null && el !== undefined && el.length > 0) {
                      this.pumaPrevUuid = el.attr('data-uuid');
                    }
                    callback(value);
                  });
                  return;
                }
              }
              callback(Number.POSITIVE_INFINITY);
            },
            error: (xhr, status, error) => {
              console.log(error);
            }
          });
        });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#couponCode').value = bestCode;
        document.querySelector('#couponCode').dispatchEvent(new MouseEvent('input', { bubbles: true } ));
        document.querySelector('.promo-code-submit button').disabled = false;  
        document.querySelector('.promo-code-submit button').click();  
      }
    },

    rakuten: {
      id: 7, 
      preApplyCodes: (callback) => {
        const elTotal = $('.r-product__price-text.r-checkout-cart-summary__is-red span');
        const value   = elTotal.length > 0 ? 
                              Number(elTotal.first().text().trim().substr(1)) : 
                              Number.POSITIVE_INFINITY;
        const csrf = $('meta[name="csrf-token"]').attr('content');  
        $.ajax({
          url: 'https://www.rakuten.com/buy/coupon_discount.json',
          type: 'POST',
          headers: {
            'x-csrf-token': csrf
          },
          data: {},
          success: () => {
            callback(value);
          }
        });
      },
      applyCode: (code, callback) => {
        const csrf = $('meta[name="csrf-token"]').attr('content');
        $.ajax({
          url: 'https://www.rakuten.com/buy/coupon_discount.json',
          type: 'POST',
          headers: {
            'x-csrf-token': csrf
          },
          data: { code_no: code},
          success: () => {
            $.ajax({
              url: 'https://www.rakuten.com/buy/amounts_calculate.json',
              type: 'POST',
              headers: {
                'x-csrf-token': csrf
              },
              data: { coupon_code_no: code },
              success: (data) => {
                const value = Number(data.cash_amount) || Number.POSITIVE_INFINITY;
                callback(value);
              }
            });
          }
        });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('.r-payment-page__coupon-input').value = bestCode;
        document.querySelector('.r-payment-page__coupon-input').dispatchEvent(new MouseEvent('input', {bubbles: true}));
        document.querySelector('.apply-btn').click();
      }
    },
  
    sallybeauty: {
      id: 1455, 
      preApplyCodes: function(callback) {       
        const elTotal = $('p.grand-total');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        const el = $('button.remove-coupon');
        var url = null;
        if (el !== null && el !== undefined && el.length > 0) {
          const code = el.attr('data-code');
          const uuid = el.attr('data-uuid');
          url = 'https://www.sallybeauty.com/on/demandware.store/Sites-SA-Site/default/Cart-RemoveCouponLineItem' +
                      '?code=' + code +
                      '&uuid=' + uuid;
        } else if (this.sallybeautyPrevCode !== null && this.sallybeautyPrevCode !== undefined) {
          const uuid = $('div.save-for-later > a').attr('data-uuid');
          url = 'https://www.sallybeauty.com/on/demandware.store/Sites-SA-Site/default/Cart-RemoveCouponLineItem' +
                      '?code=' + this.sallybeautyPrevCode +
                      '&uuid=' + uuid;

        }
        if (url !== null) {
          $.ajax({
            url: url,
            type: 'GET',
            success: (data) => {
              callback(prevValue);
            },
            error: (xhr, status, error) => {
              callback(prevValue);
            }
          });
        } else {
          callback(prevValue);
        }
      },
      applyCode: function(code, callback) {
        this.preApplyCodes(() => {
          this.sallybeautyPrevCode = code;
          console.log('Apply Code: ', code);
          const loyaltyreward = $('input[name*="loyaltyreward"]').first().val();
          const csrf_token = $('input[name*="csrf_token"]').first().val();
          const url = 'https://www.sallybeauty.com/on/demandware.store/Sites-SA-Site/default/Cart-AddCoupon' +
                      '?couponCode=' + code + 
                      '&loyaltyreward=' + loyaltyreward +
                      '&csrf_token=' + csrf_token;
          $.ajax({
            url: url,
            type: 'GET',
            success: (response) => {
              if (response !== null) {
                const totals = response.totals;
                if (totals !== null && totals !== undefined) {
                  const value = totals.grandTotal !== null ? 
                            Number(totals.grandTotal.trim().substr(1)) : 
                            Number.POSITIVE_INFINITY;
                  callback(value);
                  this.sallybeautyUUID =  response.totals.discounts[0].UUID;
                  this._removeAppliedCode(() => { });
                  return;
                }
              }
              callback(Number.POSITIVE_INFINITY);
            },
            error: (xhr, status, error) => {
              callback(Number.POSITIVE_INFINITY);
            }
          });           
        });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#couponCode').value = bestCode;
        document.querySelector('#couponCode').dispatchEvent(new MouseEvent('input', { bubbles: true } ));
        document.querySelector('.promo-code-submit button').click();  
      },
      _removeAppliedCode: function(callback) {
         const uuid = $('div.save-for-later > a').attr('data-uuid');
          url = 'https://www.sallybeauty.com/on/demandware.store/Sites-SA-Site/default/Cart-RemoveCouponLineItem' +
                      '?code=' + this.sallybeautyPrevCode +
                      '&uuid=' + this.sallybeautyUUID;
          $.ajax({
            url: url,
            type: 'GET',
            success: (data) => {              
            },
            error: (xhr, status, error) => {             
            }
          });        
      }
    },

    shoes: {
      id: 235, 
      preApplyCodes: (callback) => {
        const elTotal = $('.crt-summary-total-price');
        const value   = elTotal.length > 0 ? 
                              Number(elTotal.first().text().trim().substr(1)) : 
                              Number.POSITIVE_INFINITY;
        const userIdCookie = decodeURI(document.cookie.split(';').filter(function(c) { return c.indexOf('user') !== -1 })[0]).trim().split('=')[1];
        const userId = userIdCookie.split('|')[0];
        $.ajax({
          url: `https://www.shoes.com/api/users/${userId}/orders/open/default/promotion`,
          type: 'DELETE',
          success: () => {
            callback(value);
          }
        });
      },
      applyCode: (code, callback) => {
        const userIdCookie = getCookie('user');
        const userId = userIdCookie.split('|')[0];
        $.ajax({
          url: `https://www.shoes.com/cart-checkout/api/users/${userId}/orders/open/default/promotion`,
          type: 'PUT',
          data: JSON.stringify({ promotionId: code }),
          headers: {
            'accept': 'application/vnd.com.shoebuy.v1+json',
            'content-type': 'application/vnd.com.shoebuy.v1+json'
          },
          success: () => {
            $.ajax({
              url: `https://www.shoes.com/cart-checkout/api/users/${userId}/orders/open/default?_=${Date.now()}`,
              type: 'GET',
              success: (data) => {
                const value = data.orderSummary ? Number(data.orderSummary.paymentIntegrationConfig.paymentIntegrations.Paypal.amount) : Number.POSITIVE_INFINITY;
                callback(value);
              },
               error: () => {
                callback(Number.POSITIVE_INFINITY);
              }
            });
          },
          error: () => {
            callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#crt-promoCode').value = bestCode;
        document.querySelector('#crt-promoCode').dispatchEvent(new Event('input', {bubbles: true}));
        document.querySelector('.crt-submit-promo').click();
      }
    },

    shein: {
      id: 7754, 
      preApplyCodes: function(callback) {
        const elTotal = $('div.total-item span.total');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        const windowVariables = retrieveWindowVariables(["gbCoSsrData"]);
        const gbCoSsrData = windowVariables.gbCoSsrData;
        const address_id = gbCoSsrData.checkout.default_address.addressId;
        var use_insurance;
        var shipping_method_id;
        if($('.j-insurance-checkbox').prop("checked") == true){
            use_insurance = '1';
         }
         else {
            use_insurance = '0';
         }          
          const shipping_method = $('.shipping-selected').attr('type');
          const shipping_method_length = gbCoSsrData.checkout.results.shippingMethods.length;
          for(i=0;i<shipping_method_length;i++){
              if(gbCoSsrData.checkout.results.shippingMethods[i].type==shipping_method){
                   shipping_method_id =gbCoSsrData.checkout.results.shippingMethods[i].id;
              }
          }
         const points = gbCoSsrData.checkout.caculate_info.points;
         $.ajax({
              url: 'https://us.shein.com/checkout/cacu_total',
              type: 'POST',
              data: {
                address_id: address_id,
                coupon: code,
                shipping_method_id: shipping_method_id,
                points: points,
                use_insurance: use_insurance,
                use_wallet:0,
                is_shop_transit: 0,
                shop_transit_country_id: 226,
                payment_id: '',
                use_wallet_amount: '',
                comment: '',
                payment_code_unique: '',

              },
              success: (data) => {
                if(data.msg == 'ok'){
                    callback(data.info.grandTotalPrice.amount);
                }else{
                    callback(Number.POSITIVE_INFINITY);
                }
              },
              error: (xhr, status, error) => {
                console.log(error);
                callback(Number.POSITIVE_INFINITY);
              }
            });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('.check-coupon .c-input input[type=text]').value = bestCode;
        document.querySelector('.check-coupon .c-input input[type=text]').dispatchEvent(new MouseEvent('input', {bubbles: true}));
        document.querySelector('.check-coupon .apply-box a span').click();       
      }
    },

    shopdisney: {
      id: 173,
      preApplyCodes: function(callback) {
        const elTotal = $('div.grand-total');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        const csrfToken = $('form#promoCodeForm input[name="csrf_token"]').first().val();
        const url = 'https://www.shopdisney.com/on/demandware.store/Sites-shopDisney-Site/default/Cart-AddCoupon' +
                    `?couponCode=${code}&csrf_token=${csrfToken}`;
        $.ajax({
          url: url,
          type: 'GET',
          success: (response) => {
            if (response.totals !== undefined && response.totals !== null) {
              const totals = response.totals;
              const value = totals.grandTotalValue.value;
              callback(value);
            } else {
              callback(Number.POSITIVE_INFINITY);
            }
          },
          error: (xhr, status, error) => {
            console.log(error);
            callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: (bestCode) => {
        location.reload();
      }
    },

    shutterfly: {
      id: 3699, 
      preApplyCodes: function(callback) {
        const elTotal = $('div#cartSummaryArea tr.table-summary td').last();
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.last().text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
         const apigeeApiKey = 'uWrM911sdIvHivflYxyiHlGgmlgoaV0m';
         const bundleCreationPath =  JSON.parse(sessionStorage.getItem("BundleCreationPath"));
         const cartId = bundleCreationPath.projectModel.metadata.cartId;
         
          $.ajax({
            url: 'https://accounts.shutterfly.com/sso/v2/tokens',
            type: 'GET',
            success: (responseget) => {
              const accesstoken = responseget[6].value;
              $.ajax({
                  url: 'https://api2.shutterfly.com/v1/web-cart-orch/v1/codes/claim',
                  type: 'post',
                  data: JSON.stringify({code: code, cartId: cartId}),
                  contentType: 'application/json; charset=utf-8',         
                  headers: {
                    "Authorization": "Bearer " + accesstoken,
                    "SFLY-Apikey": apigeeApiKey
                  },
                  success: (responseget) => {
                    // Todo: Get total price after applying coupon

                    var value = responseget.cart.summary.prices.total.renderedPrice;
                    if(value){
                      var elTotal = value.replace(/[^0-9\.]+/g, "");
                      callback(elTotal);
                    }else{
                      callback(Number.POSITIVE_INFINITY);
                    }
                  },
                    error: (xhr, status, error) => {
                      console.log(error);
                      callback(Number.POSITIVE_INFINITY);
                    }
                });
            },
              error: (xhr, status, error) => {
                console.log(error);
                callback(Number.POSITIVE_INFINITY);
            }
        });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('.omnibox-code').value = bestCode;
        document.querySelector('.omnibox-code').dispatchEvent(new Event('input', {bubbles: true}));
        document.querySelector('.omnibox-claim').click();
        
      }
    },


    snapfish: {
      id: 1527, 
      preApplyCodes: function(callback) {
        const elTotal = $('td#total_to_pay_now');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').replace(',','').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
          const csrf_token = document.querySelector("meta[name='csrf-token']").getAttribute("content");
          const orderId = $('#orders').val();
          const data = {
            promotionName: code,
            order_id: orderId,
            entered_coupons: code
          }
           $.ajax({
                  url: 'https://www.snapfish.com/cart/updatecart',
                  type: 'POST',
                  data: data,        
                  headers: {
                    "x-csrf-token": csrf_token
                  },
                  success: (response) => {
            const productTotal = response.productTotal ? response.productTotal : 0;
            const shippingTotal = response.shippingTotal ? response.shippingTotal : 0;
            const shippingTax = response.shippingTax ? response.shippingTax : 0;
            const productTax = response.productTax ? response.productTax : 0;
            var discount = 0;
            if (response.productDiscount) {
              discount = response.productDiscount.totalDiscount ? 
                         response.productDiscount.totalDiscount : 0;
            }
            const total = (productTotal + shippingTotal - discount) + shippingTax + productTax; 
            callback(total);
            const body = {
              promotionName: '',
              order_id: orderId,
              isCouponRemoved: true
            }
                   $.ajax({
                        url: 'https://www.snapfish.com/cart/updatecart',
                        type: 'POST',
                        data: body,        
                        headers: {
                          "x-csrf-token": csrf_token
                        },
                        success: (responseget) => {
                           // callback(prevValue);
                        }
                      });
          },error: (xhr, status, error) => {
                console.log(error);
                callback(Number.POSITIVE_INFINITY);
            }
          });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#coupon_id').value = bestCode;
        document.querySelector('#coupon_id').dispatchEvent(new Event('input', {bubbles: true}));
        document.querySelector('#apply_coupon_btn').click();
      }
    },

    sportsmansguide: {
      id: 3123,
      preApplyCodes: (callback) => {
        const Total = $('.grandTotal');
        const prevValue = Total.length > 0 ? 
                       Number(Total.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;        
        callback(prevValue);
      },
      applyCode: (code, callback) => { 
      $.ajax({
          url: 'https://www.sportsmansguide.com/Checkout/CouponSubmit',
          type: 'POST',
          data: {couponCode: code},
          success: (responseget) => {
              $.ajax({
                  url: 'https://www.sportsmansguide.com/Checkout/GetOrderSummary',
                  type: 'POST',
                  data: {hasFirearm: 'false', autoSetPackageProtection: 'true'},
                  success: (responseget) => {
                    // Todo: Get total price after applying coupon
                    var value = responseget.orderSummary.GrandTotal;                                   
                    callback(value);
                  }
                });
          },
              error: (xhr, status, error) => {
                console.log(error);
                callback(Number.POSITIVE_INFINITY);
            }
        });

      },
      applyBestCode: (bestCode) => {
        document.querySelector('input[name="sCoupon"]').value = bestCode;
        document.querySelector('input[name="sCoupon"]').dispatchEvent(new MouseEvent('input', {bubbles: true}));
        document.querySelector('#coupon-entry .black-btn.md-button.md-sg-material-theme').click();
      }
    },

    swansonvitamins: {
      id: 1587,
      removePrevCode: function(code, callback) {
        const csrf = $('meta[name="_csrf"]').attr('content');
        if(window.location.href.indexOf("cart") > -1){
          callback();
        }else{         
          const prevCodeSelector = $('.SourceCodeForm__x');
          if(prevCodeSelector){
            try{  $('.SourceCodeForm__x').click(); }catch(e){}
             setTimeout(function(){
              callback(); 
            }, 2000);   
           }else{
             callback();
          } 
        }
      },
      preApplyCodes: function(callback) {
        const elTotal = $('.cart-total-price, b:contains("order total") +b');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
         this.removePrevCode('prevCode', () => callback(prevValue));
      },
      applyCode: function(code, callback) {
        this._applyCode(code, function(value) {
         this.removePrevCode(code, () => callback(value));
       }.bind(this));
      },
      applyBestCode: function(bestCode) {
         this._applyCode(bestCode, function(value) {
          location.reload();
        }); 
      },
     _applyCode: (code, callback) => {
       const csrf = $('meta[name="_csrf"]').attr('content');
        if(window.location.href.indexOf("cart") > -1){
          $.ajax({
              url: 'https://www.swansonvitamins.com/cart',
              type: 'POST',
              data: {action:'promocode', promoCode: code},
               headers: {
                        'x-csrf-token': csrf
                      },
              success: (response) => {
                const value = response.shoppingBag.totalRoundedCost;
                callback(value);
              },
              error: (xhr, status, error) => {
                callback(Number.POSITIVE_INFINITY);
              }
            });
        }else{
          document.querySelector('[name="sourceCode"]').value = code;
          document.querySelector('[name="sourceCode"]').dispatchEvent(new Event('input', {bubbles: true}));
          document.querySelector('[name="sourceCode"]').dispatchEvent(new Event('change'));
          $('button:contains("apply")').click();          
          setTimeout(function(){
             const elTotal = $('b:contains("order total") +b');
             const value = elTotal.length > 0 ? 
                        Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                        Number.POSITIVE_INFINITY; 
             callback(value);             
          }, 3000);
        }
     },
    },

    target: {
      id: 26, 
      preApplyCodes: (callback) => {
         const elTotal = $('[data-test="cart-summary-total"] > p:last-child');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().trim().substr(1)) : 
                      Number.POSITIVE_INFINITY;        
        callback(prevValue);
      },
      applyCode: (code, callback) => {
        document.querySelector('#promoCodeEntry').value = code;
        document.querySelector('#promoCodeEntry').dispatchEvent(new MouseEvent('input', {bubbles: true}));
         $('[data-test="apply-promo-code-button"]').click();
         setTimeout(function(){ 
             const elTotal_ac = $('[data-test="cart-summary-total"] > p:last-child');
             const value = elTotal_ac.length > 0 ? 
                      Number(elTotal_ac.first().text().trim().substr(1)) : 
                      Number.POSITIVE_INFINITY;
              callback(value);

         }, 1500);
      },
      applyBestCode: (bestCode) => {
         document.querySelector('#promoCodeEntry').value = bestCode;
         document.querySelector('#promoCodeEntry').dispatchEvent(new MouseEvent('input', {bubbles: true}));
         $('[data-test="apply-promo-code-button"]').click();
      }
    },
  
    thriftbooks: {
      id: 24523, 
      preApplyCodes: (callback) => {
        const elTotal = $('div.OrderSummary-Total div.OrderSummary-ItemPad');
        const prevValue = elTotal.text().replace( /[^0-9.]/g, '').trim();
        callback(prevValue);
      },
      applyCode: (code, callback) => {
        $.post('https://www.thriftbooks.com/api/coupon/post/', {
          CouponCode: code,
          IdCheckoutPage: 1
        }, (response) => {
          const value = response.OrderTotal !== null && response.OrderTotal !== undefined ? 
                            Number(response.OrderTotal) : 
                            Number.POSITIVE_INFINITY;
          callback(value);
        });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('input.CartCoupon-input').value = bestCode;
        document.querySelector('input.CartCoupon-input').dispatchEvent(new MouseEvent('input', {bubbles: true}));
        document.querySelector('div.CartCoupon-inputArea div button').click();
      }
    },

    ulta: {
      id: 1696, 
      preApplyCodes: function(callback) {
        const elTotal = $(".OrderSummaryRow__value .Text--bold");
        const value   = elTotal.length > 0 ? 
                              Number(elTotal.first().text().trim().substr(1)) : 
                              Number.POSITIVE_INFINITY;
        callback(value);
      },
      applyCode: function(code, callback) {
        const sessiondata = JSON.parse(localStorage.getItem('sessionData'));
        $.ajax({
          url: 'https://www.ulta.com/services/v5/cart/coupon/add?couponCode=' + code,
          type: 'POST',
          dataType: 'json',
          contentType: 'application/json; charset=utf-8',         
          headers: {
            "api-access-control": "dyn_session_conf=" + sessiondata.secureToken
          },
          success: function(data) {
            var response = data;
            var cartSummary = response.data.cartSummary;
            var value = cartSummary.estimatedTotal;
            callback(value);  
                  $.ajax({
                    url: 'https://www.ulta.com/services/v5/cart/coupon/remove',
                    type: 'POST',
                    dataType: 'json',
                    contentType: 'application/json; charset=utf-8',         
                    headers: {
                      "api-access-control": "dyn_session_conf=" + sessiondata.secureToken
                    },
                    success: function(data) {
                        //
                    },
                    error: function() {
                       //
                    }
                  });  
           
          },
          error: function() {
            callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: function(bestCode) {
        document.querySelector('#couponID').value = bestCode;
        document.querySelector('#couponID').dispatchEvent(new MouseEvent('input', {bubbles: true}));
        document.querySelector('.Coupons button[type="submit"]').click();
      }
    },
  
    vistaprint: {
      preApplyCodes: (callback) => {
        const elTotal = $(".totals .discount-price:first-child");
        const value   = elTotal.length > 0 ? 
                      Number(elTotal.first().text().trim().substr(1)) : 
                      Number.POSITIVE_INFINITY;
        const elPromoInfo = $('.promo-info');
        if (elPromoInfo.length > 0) {
          $.ajax({
            url: 'https://'+window.location.hostname+'/services/api/v1/cart/setCouponCartJson/',
            type: 'POST',
            data: {couponCode: ''},
            success: () => {
              callback(value);
            }
          });
        } else {
          callback(value);
        }
      },
      applyCode: (code, callback) => {
        $.ajax({
          url: 'https://'+window.location.hostname+'/services/api/v1/cart/setCouponCartJson/',
          type: 'POST',
          data: {couponCode: code},
          success: (responseget) => {
            var value = responseget.cart.summary.prices.total.renderedPrice;
            var elTotal = value.replace(/[^0-9\.]+/g, "");                           
            callback(elTotal);
          }
        });
      },
      applyBestCode: (bestCode) => {
          $.ajax({
          url: 'https://'+window.location.hostname+'/services/api/v1/cart/setCouponCartJson/',
          type: 'POST',
          data: {couponCode: bestCode},
          success: () => {location.reload(); },
          error: () => {location.reload(); }
        });
      }
    },
  
    vitacost: {
      id: 5346, 
      preApplyCodes: function(callback) {
        const elTotal = document.querySelector("#orderSummary dd.total");
        const value   = elTotal ? 
                      Number(elTotal.textContent.trim().substr(1)) : 
                      Number.POSITIVE_INFINITY;
        this.requestData = extractFormValues('#Form1');
        callback(value);
      },
      applyCode: function(code, callback) {
        this.requestData.set('IamMasterFrameYesIam$ctl02$txtPromotion', code);
        this.requestData.set('IamMasterFrameYesIam$ctl02$btnPromoUpdate', 'Apply');
        var xhr = new XMLHttpRequest();
        xhr.onreadystatechange = function () {
          if (xhr.readyState == 4) {
            var d = document.implementation.createHTMLDocument('');
            d.documentElement.innerHTML = DOMPurify.sanitize(xhr.response);
            const elTotal = d.querySelector('#orderSummary dd.total');
            const value   = elTotal ? 
                              Number(elTotal.textContent.trim().substr(1)) : 
                              Number.POSITIVE_INFINITY;
            callback(value);
          }
        };
        xhr.open('POST', this.requestData.action);
        xhr.withCredentials = true;
        xhr.setRequestHeader('Accept', 'text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,image/apng,*/*;q=0.8');
        xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
        xhr.send(this.requestData);
      },
      applyBestCode: function(bestCode) {
        document.querySelector('[id*=Promo] input[name*=IamMasterFrame][type=text]').value = bestCode;
        document.querySelector('[id*=Promo] input[type=submit]').click();
      }
    },
  
    walgreens: {
      id: 1915, 
      preApplyCodes: function(callback) {        
           if(window.location.href.indexOf("view-ui") > -1){
            const elTotal = $(".wag-cart-order-summary-items .product__price");
            const value   = elTotal.length > 0 ? 
                            Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) / 100 : 
                            Number.POSITIVE_INFINITY;
             const elCouponCode = $('#wag-cart-code-0');
            if (elCouponCode.length > 0) {
              const csrf = $('meta[name="_csrf"]').attr('content');
              $.ajax({
                url: 'https://www.walgreens.com/cart/v1/promos',
                type: 'POST',
                headers: {
                  'X-XSRF-TOKEN': csrf
                },
                data: { action: 'delete', couponCode: elCouponCode.text().trim() },
                success: () => {
                  callback(value);
                }
              });
            } else {
              callback(value);
            }
        }else{
           const elTotal = $("#totalAmount");
           const value   = elTotal.length > 0 ? 
                              Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                              Number.POSITIVE_INFINITY;
          callback(value);
        }
      },
      applyCode: function(code, callback) {
         if(window.location.href.indexOf("view-ui") > -1){
            const csrf = $('meta[name="_csrf"]').attr('content');
            const self = this;
            $.ajax({
              url: 'https://www.walgreens.com/cart/v1/promos',
              type: 'POST',
              headers: {
                'X-XSRF-TOKEN': csrf
              },
              data: { action: 'add', couponCode: code },
              success: function(data) {
                const value = data.orderPriceInfo ? data.orderPriceInfo.finalOrderPrice / 100 : Number.POSITIVE_INFINITY;
                self.lastAppliedCode = code;
                
                if (self.lastAppliedCode) {
                  self._removeAppliedCode(() => {
                    callback(value);
                  });
                } else {
                  callback(value);
                }
              }
            });
        }else{
            const csrf = $('meta[name="csrf-token"]').attr('content');
            const windowVariables = retrieveWindowVariables(["cartDataInfo"]);
            const order_id = windowVariables.cartDataInfo._id;
            $.ajax({
              url: 'https://photo.walgreens.com/cart/updateorder',
              type: 'POST',
              headers: {
                'x-csrf-token': csrf
              },
              data: { 'promotions[promotionName]': code , page: 'cart', order_id: order_id },
              success: function(data) {
                const total = data.response[0].resource.productTotal;
                const totalDiscount = data.response[0].resource.productDiscount.totalDiscount;
                const value = total - totalDiscount;
                callback(value);                
              }
            });
        }
      },
      applyBestCode: function(bestCode) {
        document.querySelector('#wag-cart-enter-code, #couponField').value = bestCode;
        document.querySelector('#wag-cart-enter-code, #couponField').dispatchEvent(new MouseEvent('input', {bubbles: true}));
        document.querySelector('#wag-cart-apply-code, #applyCoupon').click();
      },
      _removeAppliedCode: function(callback) {
        const csrf = $('meta[name="_csrf"]').attr('content');
        $.ajax({
          url: 'https://www.walgreens.com/cart/v1/promos',
          type: 'POST',
          headers: {
            'X-XSRF-TOKEN': csrf
          },
          data: { action: 'delete', couponCode: this.lastAppliedCode },
          success: function() {
            callback();
          }
        });
      }
    },

    worldmarket: {
      id: 4308, 
      preApplyCodes: (callback) => {
        const elTotal = $('#EstTaxShipItemTable_estBasketTotal');
        const prevValue = elTotal.length > 0 ? 
                      Number(parseFloat(elTotal.first().text().trim().substr(1).replace(/,/g, ''))) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: (code, callback) => {
        $.ajax({
          url: 'https://www.worldmarket.com/basket.do?method=applySourceCode&r=0.6955568034725697',
          type: 'POST',
          data: { sourceCode: code },
          success: function() {
            $.ajax({
              url: 'https://www.worldmarket.com/basket.do',
              type: 'GET',
              success: function(data) {
                const elTotal = $(data).find('#EstTaxShipItemTable_estBasketTotal');
                const value = elTotal.length > 0 ? 
                      Number(parseFloat(elTotal.first().text().trim().substr(1).replace(/,/g, ''))) : 
                      Number.POSITIVE_INFINITY;
                $.ajax({
                  url: 'https://www.worldmarket.com/wmBasket.do?method=removeSourceCode&r=0.6576311557150023',
                  type: 'POST',
                  data: { sourceCode: code },
                  success: function() {
                    callback(value);
                  }
                });
              }
            });
          }
        });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#sourceCode').value = bestCode;
        document.querySelector('#sourceCode').dispatchEvent(new Event('input', { bubbles: true } ));
        document.querySelector('.form_but.sourceCodeApplyBtn.ml-secondary-button').click();
      }
    },

    zazzle: {
      id: 1813,
      preApplyCodes: function(callback) {
        const elTotal = $('.Cart-subtotal.small-6.large-5.column');
        const prevValue = elTotal.length > 0 ? 
                        Number(elTotal.first().text().trim().substr(1)) : 
                        Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        this.getCSRF(function(csrf) {
          $.ajax({
            url: 'https://www.zazzle.com/svc/z3/promotion/applyPromo',
            type: 'POST',
            data: JSON.stringify({ client: "js", csrf: csrf, promoCode: code, returnCart: 'true', returnOrderTotal: 'false' }),
            contentType: 'application/json',
            headers: {
                'x-csrf-token': csrf
              },
            success: function(data) {
              const value = data.data && data.data.cart ? data.data.cart.orderTotal : Number.POSITIVE_INFINITY;
              $.ajax({
                url: 'https://www.zazzle.com/svc/z3/promotion/removePromo',
                type: 'POST',
                data: JSON.stringify({ client: "js", csrf: csrf, promoCode: code, returnCart: 'true', returnOrderTotal: 'false' }),
                contentType: 'application/json',
                headers: {
                  'x-csrf-token': csrf
                  },
                success: function() {
                  callback(value);
                }
              });
            },
              error: (xhr, status, error) => {
                console.log(error);
                callback(Number.POSITIVE_INFINITY);
              }
          });
        });
      },
      applyBestCode: function(bestCode) {
        document.querySelector('.PromoCode .Input.Input--marketplaceTheme .Input-inputWrapper .Input-input').value = bestCode;
        document.querySelector('.PromoCode .Input.Input--marketplaceTheme .Input-inputWrapper .Input-input').dispatchEvent(new MouseEvent('input', {bubbles: true}));
        document.querySelector('.PromoCode button.Button.Button_root__marketplaceTheme').click();
      },
      getCSRF: function(callback) {
        $.ajax({
          url: 'https://www.zazzle.com/co/cart',
          type: 'GET',
          success: function(data) {
            callback(data.substr(data.indexOf("csrf") + 7, 16));
          }
        });
      }
    },

     vitaminshoppe: {
      id: 1637,
      preApplyCodes: function(callback) {
        const elTotal = $('.estimated-order-total-data, .estimate-total span:last');
        const prevValue = elTotal.length > 0 ? 
                        Number(elTotal.first().text().trim().substr(1)) : 
                        Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        if(window.location.href.indexOf("cart") > -1){
        const url = 'https://www.vitaminshoppe.com/rest/model/vitaminshoppe/web/actor/VSIWebShoppingCartActor/redeemDiscount';
         $.ajax({
              url: url,
              type: 'POST',
              data: {action: "apply" ,channel: "web" ,page: "cart" ,rewardCode: code ,source: "summary"},
              success: (response) => {
                const value = response.estimatedCartSummaryPrice;
                $.post(url, {action: "remove" ,channel: "web" ,page: "cart" ,rewardCode: code ,source: "summary"}, 
                  () => {
                        callback(value);
                      });
              },
              error: (xhr, status, error) => {
                console.log(error);
                callback(Number.POSITIVE_INFINITY);
              }
            });
       }else{
        const formData = getFormFieldsAsJson(document.querySelector('.promo-code-fields form'));
        formData['/atg/commerce/order/purchase/CommitOrderFormHandler.couponCode'] = code;
        formData['/atg/commerce/order/purchase/CommitOrderFormHandler.redeemCoupon'] = 'Apply';
        const promoUrl = $('.promo-code-block form').attr('action');
        $.post('https://www.vitaminshoppe.com'+promoUrl, formData, 
          (data, textStatus, request1) => {
           const locationUrl = request1.getResponseHeader('location');
            $.get(locationUrl, 
              (data, textStatus, request2) => {
                 const getUrl = request2.getResponseHeader('location');
                 $.get(getUrl, 
                    (responseget) => {
                      const elTotal = $(responseget).find('.estimate-total span:last');
                      const value = elTotal.length > 0 ? 
                                    Number(elTotal.first().text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                                    Number.POSITIVE_INFINITY; 
                      callback(value);
                 });
              });
          });
       }
      },
      applyBestCode: function(bestCode) {
        document.querySelector('#promocd, #promo-input').value = bestCode;
        document.querySelector('#promocd, #promo-input').dispatchEvent(new MouseEvent('input', {bubbles: true}));
        document.querySelector('.fm-submit input, #checkout-left .promo-apply input[type=submit]').click();
      }
    },

    bodenusa: {
      id: 463, 
      preApplyCodes: function(callback) {
        const elTotal = $('#shoppingBagTotalPrice');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.last().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        var ts = Math.round(new Date().getTime());
        $.ajax({
          url: 'https://checkout.bodenusa.com/en-US/Offer-Code?code='+code+'&emptyCodeInvalid=true&_='+ts,
          type: 'GET',
          success: () => {
            var ts2 = Math.round(new Date().getTime());
            $.ajax({
              url: `https://checkout.bodenusa.com/en-US/ShoppingBag/Index?_=`+ts2,
              type: 'GET',
              success: (response) => {
                const elTotal = $(response).find('#shoppingBagTotalPrice');
                const value = elTotal.length > 0 ? 
                              Number(elTotal.last().text().replace( /[^0-9.]/g, '').trim()) : 
                              Number.POSITIVE_INFINITY;
                callback(value);
              },
              error: (xhr, status, error) => {
                console.log(error);
                callback(Number.POSITIVE_INFINITY);
              }
            })
          },
          error: (xhr, status, error) => {
            console.log(error);
            callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#code').value = bestCode;
        document.querySelector('#code').dispatchEvent(new Event('input', {bubbles: true}));
        document.querySelector('#btnApplyCode').click();
      }
    },

    thompsoncigar: {
      id: 5068, 
      preApplyCodes: function(callback) {
        const elTotal = $('.cart-ordertotal .price-amount').data('value');
        callback(elTotal);
      },
      applyCode: function(code, callback) {
        const formData = getFormFieldsAsJson(document.querySelector('#cart-form'));
        formData['PromoCode'] = code;
        formData['PayPromoSubmit'] = '';        
         $.post('https://www.thompsoncigar.com/cart/', formData, 
          () => {
            const url = 'https://www.thompsoncigar.com/cart/';
            $.get(url, 
              (response) => {
                const value = $(response).find('.cart-ordertotal .price-amount').data('value');                
                callback(value);
                formData2 = formData;
                delete formData2['PayPromoSubmit'];
                formData2['PromoCode'] = '';
                formData2['PromoCode-Remove'] = code;
                   $.post('https://www.thompsoncigar.com/cart/', formData2, 
                    () => { });
              });
          });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#PayPromoCode').value = bestCode;
        document.querySelector('#PayPromoCode').dispatchEvent(new MouseEvent('input', {bubbles: true}));
        document.querySelector('#payment-promo-code').click();
      }
    },

    c21stores: {
      id: 26984, 
      preApplyCodes: function(callback) {
         const elTotal = $('.grand-total-sum');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {        
        const csrf_token = $('input[name="csrf_token"]').val();
         $.get('https://www.c21stores.com/on/demandware.store/Sites-C21-Site/default/Cart-AddCoupon?csrf_token='+csrf_token+'&couponCode='+code, 
          (response) => {
            if(response.totals){
                const value = response.totals.grandTotal;
                const totalValue = Number(value.replace( /[^0-9.]/g, '').trim());                
                const uuid =  response.totals.discounts[0].UUID;
                $.get('https://www.c21stores.com/on/demandware.store/Sites-C21-Site/default/Cart-RemoveCouponLineItem?code='+code+'&uuid='+uuid, 
                  (response) => { });
                callback(totalValue);
            }else{
              callback(Number.POSITIVE_INFINITY);
            }
          });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#couponCode').value = bestCode;
        document.querySelector('#couponCode').dispatchEvent(new Event('input', {bubbles: true}));
        document.querySelector('.promo-code-btn').click();
      }
    },

  jomashop: {
    id: 1034,
    removePrevCode: function(code, callback) {
     const cartId = JSON.parse(localStorage.getItem('M2_VENIA_BROWSER_PERSISTENCE__cartId')).value.replace(/"/g,'');
     $.ajax({
        url: 'https://www.jomashop.com/graphql',
        type: 'POST',
        contentType: 'application/json',
        data: JSON.stringify({
          operationName: 'removeSingleCouponFromCart',
          query: 'mutation removeSingleCouponFromCart($cartId: String!, $couponCode: String!) { applyCouponToCart(input: { cart_id: $cartId,  coupon_code: $couponCode }) { cart { prices { grand_total { value currency __typename } }  __typename } __typename } }',
          variables : {cartId : cartId, couponCode: code }
        }),
        success: (response) => {
          callback();
        },
        error: (xhr, status, error) => {
           callback();
        }
      });
    },
    preApplyCodes: function(callback) {
    console.log('jomashop'); 
      const elTotal = $('div:contains("Grand Total") +div:first, .cart-grand-total .cart-discount-value');
      const prevValue = elTotal.length > 0 ? 
                        Number(elTotal.text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                        Number.POSITIVE_INFINITY;
      if(document.querySelector('.rmv-coupon')){
        const prevCode = $('.rmv-coupon').get(0).childNodes[0].nodeValue.replace(/"/g,'');
        this.removePrevCode(prevCode, () => callback(prevValue,prevCode));
      }else{
        callback(prevValue);
      }      
    },
    applyCode: function(code, callback) {
      this._applyCode(code, function(value) {
       this.removePrevCode(code, () => callback(value));
     }.bind(this));
    },
    applyBestCode: function(bestCode) {
      this._applyCode(bestCode, function(value) {
        location.href= 'https://www.jomashop.com/checkout';
      });   
    },
    _applyCode: (code, callback) => {
      const cartId = JSON.parse(localStorage.getItem('M2_VENIA_BROWSER_PERSISTENCE__cartId')).value.replace(/"/g,'');
       $.ajax({
          url: 'https://www.jomashop.com/graphql',
          type: 'POST',
          contentType: 'application/json',
          data: JSON.stringify({
            operationName: 'applyCouponToCart',
            query: 'mutation applyCouponToCart($cartId: String!, $couponCode: String!) { applyCouponToCart(input: { cart_id: $cartId,  coupon_code: $couponCode }) { cart { prices { grand_total { value currency __typename } }  __typename } __typename } }',
            variables : {cartId : cartId, couponCode: code }
          }),
          success: (response) => {
            if(response.data.applyCouponToCart){
              const value = response.data.applyCouponToCart.cart.prices.grand_total.value;
              callback(value);
            }else{
              callback(Number.POSITIVE_INFINITY);
            }
          },
          error: (xhr, status, error) => {
             callback(Number.POSITIVE_INFINITY);
          }
        });
    },
  },

     opticsplanet: {
      id: 2758, 
      preApplyCodes: function(callback) {
         const elTotal = $('#order-summary-right-panel .e-order-summary .e-order-summary-heading__new');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
         $.get('https://www.opticsplanet.com/checkout/apply-coupon?code='+code, 
          (response) => {
            if(response.totals){
                const value = response.totals.total_grandtotal;               
                $.get('https://www.opticsplanet.com/checkout/apply-coupon?code=', 
                  (response) => { });
                callback(value);
            }else{
              callback(Number.POSITIVE_INFINITY);
            }
          });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#op_order_couponCode').value = bestCode;
        document.querySelector('#op_order_couponCode').dispatchEvent(new MouseEvent('input', {bubbles: true}));
       setTimeout(function(){
        document.querySelector('#coupon-block-container .checkout-apply-button-container .checkout-apply-button').click();
      }, 1000);
      }
    },

    officedepot: {
      id: 30, 
      preApplyCodes: (callback) => {
         const elTotal = $('.od-cart-summary-total .od-cart-summary-field-value');
        const prevValue = elTotal.length > 0 ? 
                     Number(elTotal.text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                    Number.POSITIVE_INFINITY;        
        callback(prevValue);
      },
      applyCode: (code, callback) => {
        setTimeout(function(){ 
          document.querySelector('input[name="couponCode"]').value = code;
          document.querySelector('input[name="couponCode"]').dispatchEvent(new MouseEvent('input', {bubbles: true}));
           $('button[data-auid="OdCart_OdButton_ApplyCoupon"]').click();
           setTimeout(function(){ 
            if(document.querySelector('.od-callout-error')){
               document.querySelector('.od-coupon-list-item button.od-coupon-list-item-remove').click();
               callback(Number.POSITIVE_INFINITY);
            }else if(document.querySelector('.od-coupon-list-item button.od-coupon-list-item-remove')){
               document.querySelector('.od-coupon-list-item button.od-coupon-list-item-remove').click();
               const elTotal = $('.od-cart-summary-total .od-cart-summary-field-value');
               const value = elTotal.length > 0 ? 
                         Number(elTotal.text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                        Number.POSITIVE_INFINITY;
                callback(value);
            }else{
               const elTotal = $('.od-cart-summary-total .od-cart-summary-field-value');
               const value = elTotal.length > 0 ? 
                         Number(elTotal.text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                        Number.POSITIVE_INFINITY;
                callback(value);
            }

           }, 3000);
         }, 6000);
      },
      applyBestCode: (bestCode) => {
         document.querySelector('input[name="couponCode"]').value = bestCode;
         document.querySelector('input[name="couponCode"]').dispatchEvent(new MouseEvent('input', {bubbles: true}));
         $('button[data-auid="OdCart_OdButton_ApplyCoupon"]').click();
      }
    },

    sears: {
      id: 20, 
      preApplyCodes: function(callback) {
        const elTotal = $('.est-total-bottom strong');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        var ts = Math.round(new Date().getTime());
        const body = {
          couponRequest: {couponCode: code },
        };
        $.ajax({
          url: 'https://www.sears.com/crsp/api/cart/v1/coupon/add?ts='+ts,
          type: 'POST',
          data: JSON.stringify(body),
          contentType: 'application/json;charset=UTF-8',
          success: () => {
            var ts2 = Math.round(new Date().getTime());
            $.ajax({
              url: `https://www.sears.com/crsp/api/cart/v1/view?ts=`+ts2,
              type: 'GET',
              success: (data) => {               
                const value = data.response.cartSummary.mrchSubTot;                
                var ts3 = Math.round(new Date().getTime());
                $.ajax({
                  url: 'https://www.sears.com/crsp/api/cart/v1/coupon/remove?ts='+ts3,
                  type: 'POST',
                  data: JSON.stringify(body),
                  contentType: 'application/json;charset=UTF-8',
                  success: () => { callback(value); },
                  error: () => { callback(value); }
                });
              },
              error: (xhr, status, error) => {
                callback(Number.POSITIVE_INFINITY);
              }
            })
          },
          error: (xhr, status, error) => {
            callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('[ng-model=couponCode]').value = bestCode;
        document.querySelector('[ng-model=couponCode]').dispatchEvent(new MouseEvent('input', {bubbles: true}));
         setTimeout(function(){
          document.querySelector('.cc-add').click();
          location.reload();
        }, 1000);
      }
    },

    fromyouflowers: {
      id: 2287, 
      preApplyCodes: function(callback) {
        const elTotal = $('.cartSubtotal .grid_2.alpha.rightJustify');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        $.ajax({
          url: 'https://www.fromyouflowers.com/cart.htm',
          type: 'POST',
          data: {
            cmd: 'Apply Discount',
            disc_code: code
          },
          success: () => {
            $.get('https://www.fromyouflowers.com/cart.htm', (responseGet) => {
              const elTotal = $(responseGet).find('.cartSubtotal .grid_2.alpha.rightJustify');
              var value = 0;
              if( elTotal.length > 0 ){
                 $( elTotal ).each(function( index ) {
                  value += Number($( this ).text().replace( /[^0-9.]/g, '').trim());                
                 });
              }else{
                  value = Number.POSITIVE_INFINITY;
              }
              
              callback(value);
            });
          },
          error: (xhr, status, error) => {
             callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#refcode').value = bestCode;
        $('#refcode').removeAttr("disabled");
        document.querySelector('#refcode').dispatchEvent(new MouseEvent('input', { bubbles: true } ));
        $('.applyDiscount').removeAttr("disabled");
        document.querySelector('.applyDiscount').click();  
      }
    },

  staples: {
      id: 4, 
      preApplyCodes: function(callback) {
        const elTotal = $('.cart__total_price.cart__textAlignRight');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                      Number.POSITIVE_INFINITY;        
        callback(prevValue);
      },
      applyCode: function(code, callback) {      
         const body = {
                coupons: [code]
              };
          $.ajax({
              url: 'https://www.staples.com/cc/api/checkout/default/coupon?responseType=WHOLE&mmx=true&dp=Coupon',
              type: 'POST',
              data: JSON.stringify(body),
              contentType: 'application/json;charset=UTF-8',
              success: (response) => {
                   if(response.cartInfo.cartSummary){
                      const orderValueEl = response.cartInfo.cartSummary.ordTotal;            
                      callback(orderValueEl);
                    }else{
                      callback(Number.POSITIVE_INFINITY);
                    }
              },
              error: (xhr, status, error) => {
                 callback(Number.POSITIVE_INFINITY);
              }
            });       
      },
      applyBestCode: (bestCode) => {
        location.reload();  
      }
    },

    gap: {
      id: 189, 
      preApplyCodes: function(callback) {
        console.log('gap');
        const elTotal = $('.total-price:last:not(:contains("$0.00"))');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                      Number.POSITIVE_INFINITY;        
        callback(prevValue);
      },
      applyCode: function(code, callback) {      
          const windowVariables = retrieveWindowVariables(["window.__SHOPPING_BAG_STATE__"]);
          const shopperId = windowVariables["window.__SHOPPING_BAG_STATE__"].shopperId;
          const locale = windowVariables["window.__SHOPPING_BAG_STATE__"].locale;
          const market = windowVariables["window.__SHOPPING_BAG_STATE__"].market;
          const brand = windowVariables["window.__SHOPPING_BAG_STATE__"].brandAbbr;
          $.ajax({
              url: 'https://'+window.location.hostname+'/shopping-bag/xapi/apply-bag-promo-action/'+shopperId,
              type: 'POST',
              data: JSON.stringify({promoCode:code}),
              contentType: 'application/json;charset=UTF-8',
                headers: {
                'accept': 'application/json, text/plain, */*',
                'guest': 'true',
                'shoppingbagid': '',
                'locale': locale,
                'market': market.toUpperCase(),
                'bag-ui-leapfrog': false,
                'brand': brand,
                'channel': 'WEB'
              },
              success: (response) => {
                if(response.summaryOfCharges){
                  const value = response.summaryOfCharges.myTotal;           
                  callback(value);
                }else{
                  callback(Number.POSITIVE_INFINITY);
                }
              },
              error: (xhr, status, error) => {
                 callback(Number.POSITIVE_INFINITY);
              }
            });       
      },
      applyBestCode: (bestCode) => {
        location.reload();
      }
    },

    gapfactory: {
      id: 23967, 
      preApplyCodes: function(callback) {
        const elTotal = $('.total-price, .sds_tx_right.orderSummary__totalText');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                      Number.POSITIVE_INFINITY;        
        callback(prevValue);
      },
      applyCode: function(code, callback) {      
        const windowVariables = retrieveWindowVariables(["window.__SHOPPING_BAG_STATE__"]);
        const shopperId = windowVariables["window.__SHOPPING_BAG_STATE__"].shopperId;
        const locale = windowVariables["window.__SHOPPING_BAG_STATE__"].locale;
        const market = windowVariables["window.__SHOPPING_BAG_STATE__"].market;
        const brand = windowVariables["window.__SHOPPING_BAG_STATE__"].brandAbbr;
        $.ajax({
            url: 'https://'+window.location.hostname+'/shopping-bag/xapi/apply-bag-promo-action/'+shopperId,
            type: 'POST',
            data: JSON.stringify({promoCode:code}),
            contentType: 'application/json;charset=UTF-8',
              headers: {
              'accept': 'application/json, text/plain, */*',
              'guest': 'true',
              'shoppingbagid': '',
              'locale': locale,
              'market': market.toUpperCase(),
              'bag-ui-leapfrog': false,
              'brand': brand,
              'channel': 'WEB'
            },
            success: (response) => {
              if(response.summaryOfCharges){
                const value = response.summaryOfCharges.myTotal;           
                callback(value);
              }else{
                callback(Number.POSITIVE_INFINITY);
              }
            },
            error: (xhr, status, error) => {
               callback(Number.POSITIVE_INFINITY);
            }
        });  
      },
      applyBestCode: (bestCode) => {
        location.reload();
      }
    },


    puritan: {
      id: 1406, 
      preApplyCodes: function(callback) {
        const elTotal = $('.total-amount.grand-total');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                      Number.POSITIVE_INFINITY;        
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        const formData = getFormFieldsAsJson(document.querySelector('#applyCouponForm'));        
        formData['CouponCode'] = code;
          $.ajax({
              url: 'https://www.puritan.com/shoppingcart/applyCoupon',
              type: 'POST',
              data: formData,
              contentType: 'application/x-www-form-urlencoded; charset=UTF-8',
              success: (responseGet) => {
                  const elTotal = $(responseGet).find('.total-amount.grand-total');
                  var value = 0;
                  if( elTotal.length > 0 ){
                     $( elTotal ).each(function( index ) {
                      value += Number($( this ).text().replace( /[^0-9.]/g, '').trim());                
                     });
                  }else{
                      value = Number.POSITIVE_INFINITY;
                  }
                   callback(value);
              },
              error: (xhr, status, error) => {
                 callback(Number.POSITIVE_INFINITY);
              }
            });
       
      },
      applyBestCode: (bestCode) => {
        document.querySelector('input[name="CouponCode"]').value = bestCode;
        document.querySelector('input[name="CouponCode"]').dispatchEvent(new Event('input', {bubbles: true}));
        document.querySelector('input[name="ApplyCoupon"]').click(); 
      }
    },

    parkseed: {
      id: 4683, 
      preApplyCodes: function(callback) {
        const elTotal = $('.cart-total');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        $.ajax({
          url: 'https://parkseed.com/cart.aspx',
          type: 'POST',
          data: {
            formName: 'dmiformCouponKeycodeHandler',
            pageURL: 'cart.aspx',
            keycode: code
          },
          success: () => {
            $.get('https://parkseed.com/cart.aspx', (responseGet) => {
              const elTotal = $(responseGet).find('.cart-total');
              var value = 0;
              if( elTotal.length > 0 ){
                 $( elTotal ).each(function( index ) {
                  value += Number($( this ).text().replace( /[^0-9.]/g, '').trim());                
                 });
              }else{
                  value = Number.POSITIVE_INFINITY;
              }
              
              callback(value);
            });
          },
          error: (xhr, status, error) => {
             callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('input[name="keycode"]').value = bestCode;
        document.querySelector('input[name="keycode"]').dispatchEvent(new MouseEvent('input', { bubbles: true } ));
        document.querySelector('.apply-promo-btn').click();  
      }
    },

    glassesusa: {
      id: 865, 
      preApplyCodes: function(callback) {
        const elTotal = $('#summary_grand_total');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                      Number.POSITIVE_INFINITY;        
        callback(prevValue);
      },
      applyCode: function(code, callback) {      
          const visitorId = JSON.parse(localStorage.getItem('visitorId'));
          $.ajax({
              url: 'https://www.glassesusa.com/backend/optimaxcart/react/applyCoupon?couponCode='+code,
              type: 'POST',
              headers: {
                'x-visitor-id': visitorId
              },
              success: (response) => {
                   if(response.total){
                      const orderValueEl = response.total; 
                      const value = Number(orderValueEl.replace( /[^0-9.]/g, '').trim());           
                      callback(value);
                    }else{
                      callback(Number.POSITIVE_INFINITY);
                    }
                       $.ajax({
                          url: 'https://www.glassesusa.com/backend/optimaxcart/react/removeCoupon?couponCode='+code,
                          type: 'POST',
                          headers: {
                            'x-visitor-id': visitorId
                          },
                          success: (response) => { }
                        })
              },
              error: (xhr, status, error) => {
                 callback(Number.POSITIVE_INFINITY);
              }
            });       
      },
      applyBestCode: (bestCode) => {
        document.querySelector('input[name="couponField"]').value = bestCode;
        document.querySelector('input[name="couponField"]').dispatchEvent(new Event('input', {bubbles: true}));
        document.querySelector('[data-test-name="couponSubmitButton"]').click();
      }
    },

  overstock: {
      id: 6,
      preApplyCodes: function(callback) {
        const elTotal = $('.total-details .your-total span:last-child');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                      Number.POSITIVE_INFINITY;        
        callback(prevValue);
      },
      applyCode: function(code, callback) {      
        const formData = getFormFieldsAsJson(document.querySelector('#checkoutForm'));
        formData['UsePromoCode'] = 'on';
        formData['PromoCode'] = code;
        $.post('https://www.overstock.com/processorder?json=true&reqType=node-promoCode', formData, 
          (response) => {
           const value = response.checkoutWithMeta.totals.totalAmount.numericValue;
           callback(value);
          });
      },
      applyBestCode: (bestCode) => {
        try {document.querySelector('#promo-trigger').click()} catch (e) {document.querySelector('.payment-option-label [type="checkbox"]').click()}
        document.querySelector('[name="PromoCode"]').value = bestCode;
        document.querySelector('[name="PromoCode"]').dispatchEvent(new Event('input', { bubbles: true } ));
       document.querySelector('.promo-code-submit-container [aria-label="promo code apply button"]').click();
      }
    },

    blinds: {
      id: 3783, 
      preApplyCodes: function(callback) {  
        const elTotal = $('[data-testid="gcc-cart-summary-totalsubtotal"]');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
       const windowVariables = retrieveWindowVariables(["window.NREUM"]);
       const xpid = windowVariables["window.NREUM"].loader_config.xpid;
       $.ajax({
          url: 'https://www.blinds.com/Ordering/Promo/Apply',
          type: 'POST',
          headers: {
          'Content-Type': 'application/x-www-form-urlencoded; charset=UTF-8',
          'x-newrelic-id': xpid
          },
          data: {
            promoCode: code,
          },
          success: (data) => {
           const elTotal = $(data).find('[data-testid="gcc-cart-summary-totalsubtotal"]');
           const value = elTotal.length > 0 ? 
                  Number(elTotal.text().replace( /[^0-9.]/g, '').trim()) : 
                  Number.POSITIVE_INFINITY;                
            $.ajax({
              url: 'https://www.blinds.com/Ordering/Promo/Remove',
              type: 'POST',
              headers: {
              'Content-Type': 'application/x-www-form-urlencoded; charset=UTF-8',
              'x-newrelic-id': xpid
              },
              data: {
                promoCode: code,
              },
              success: (data) => { callback(value); },
              error: (data) => { callback(value); }
            });
          },
          error: (xhr, status, error) => {
            console.log(error);
            callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#apply-promo-input').value = bestCode;
        document.querySelector('#apply-promo-input').dispatchEvent(new MouseEvent('input', {bubbles: true}));
        document.querySelector('#apply-promo-button').click();       
      }
    },

    bulkapothecary: {
      id: 24704, 
      preApplyCodes: function(callback) {         
        const elTotal = $('.cart-total-value.cart-total-grandTotal span');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                      Number.POSITIVE_INFINITY;        
        callback(prevValue);
      },
      applyCode: function(code, callback) {      
         const windowVariables = retrieveWindowVariables(["BCData"]);
         const csrf_token = windowVariables.BCData.csrf_token;
          $.ajax({
              url: 'https://www.bulkapothecary.com/remote/v1/apply-code',
              type: 'POST',
              headers: {
                'X-XSRF-TOKEN': csrf_token,
                 'Content-Type': 'application/x-www-form-urlencoded; charset=UTF-8',
              },
              data: {
                code: code,
              },
              success: (response) => {
                   $.ajax({
                          url: 'https://www.bulkapothecary.com/cart.php',
                          type: 'GET',
                          headers: {
                            'X-XSRF-TOKEN': csrf_token,
                             'Content-Type': 'application/json',
                          },
                          success: (data) => { 
                            const total = $(data).find('.cart-total-value.cart-total-grandTotal span');
                            const value = total.length > 0 ? 
                                            Number(total.text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                                            Number.POSITIVE_INFINITY;                              
                              callback(value);
                          }
                        })
              },
              error: (xhr, status, error) => {
                 callback(Number.POSITIVE_INFINITY);
              }
            })
      },
      applyBestCode: (bestCode) => {
        document.querySelector('input[name="couponcode"]').value = bestCode;
        document.querySelector('input[name="couponcode"]').dispatchEvent(new Event('input', {bubbles: true}));
        document.querySelector('.coupon-form input[type="submit"]').click();
      }
    },


    burpee: {
      id: 3790, 
      preApplyCodes: function(callback) {
        const elTotal = $('.b-order_totals-total .b-order_totals-total_value');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.text().trim().substr(1)) : 
                      Number.POSITIVE_INFINITY;
        const url = $('form[name="dwfrm_cart"]').attr('action');
        const formData = getFormFieldsAsJson(document.querySelector('form[name="dwfrm_cart"]'));
        formData['dwfrm_cart_coupons_i0_deleteCoupon'] = 'Remove';
        $.post(url, formData, 
          (response) => {
            callback(prevValue);
        });
      },
      applyCode: function(code, callback) {      
        this.preApplyCodes(() => {
          const url = $('form[name="dwfrm_cart"]').attr('action');
          const formData = getFormFieldsAsJson(document.querySelector('form[name="dwfrm_cart"]'));
          formData['dwfrm_cart_couponCode'] = code;
          formData['dwfrm_cart_addCoupon'] = 'dwfrm_cart_addCoupon';
            $.post(url, formData, 
            (response) => {
                const formData2 = getFormFieldsAsJson(document.querySelector('form[name="dwfrm_cart"]'));
                  formData2['dwfrm_cart_coupons_i0_deleteCoupon'] = 'Remove';
                   const orderValueEl = $(response).find('.b-order_totals-total .b-order_totals-total_value');
                   const value = orderValueEl.length > 0 ? 
                                  Number(orderValueEl.text().trim().substr(1)) : 
                                  Number.POSITIVE_INFINITY; 
                  $.post(url, formData2, 
                    (response) => {
                     callback(value);
                  });             
            });   
        });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#dwfrm_cart_couponCode').value = bestCode;
        document.querySelector('#dwfrm_cart_couponCode').dispatchEvent(new Event('input', { bubbles: true } ));
        document.querySelector('#add-coupon').click();
      }
    },

    build: {
      id: 3215, 
      preApplyCodes: function(callback) {         
        const elTotal = $('#cart-grand-total');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                      Number.POSITIVE_INFINITY;        
        callback(prevValue);
      },
      applyCode: function(code, callback) {    
        setTimeout(function(){
          $.ajax({
              url: 'https://www.build.com/app/api/cart/coupon/'+code,
              type: 'PUT',
              headers: {
                 'Content-Type': 'application/json',
              },
              data: JSON.stringify({  coupon: code }),
              success: (response) => {
                if(response.status == '1'){
                    $.ajax({
                          url: 'https://www.build.com/app/api/cart?includeItems=true',
                          type: 'GET',
                          success: (data) => { 
                            const value = data.grandTotal;                          
                            callback(value);
                          }
                        });
                    setTimeout(function(){ 
                      $.ajax({
                          url: 'https://www.build.com/app/api/cart/coupon/'+code,
                          type: 'DELETE',
                          headers: {
                             'Content-Type': 'application/json',
                          },
                          data: JSON.stringify({  coupon: code }),
                          success: (response) => {}
                        });
                    }, 1000);

                }else{
                  callback(Number.POSITIVE_INFINITY);
                }
                   
              },
              error: (xhr, status, error) => {
                 callback(Number.POSITIVE_INFINITY);
              }
            });
        }, 2000);
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#coupon-number').value = bestCode;
        document.querySelector('#coupon-number').dispatchEvent(new Event('input', {bubbles: true}));
        document.querySelector('#apply-coupon').click();
      }
    },

    adameve: {
      id: 4994, 
      preApplyCodes: function(callback) {
        const elTotal = $('#cart-summary tr:nth-child(3) td:nth-child(2)');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        const url = 'https://www.adameve.com/shoppingcart.aspx';
        const formData = getFormFieldsAsJson(document.querySelector('#source-code-form'));
         formData['sourceCode'] = code;
         $.post(url, formData, 
            (responsePost) => {
              $.get('https://www.adameve.com/shoppingcart.aspx', (response) => {
                const total = $(response).find('#cart-summary tr:nth-child(3) td:nth-child(2)'); 
                const value = total.length > 0 ? 
                      Number(total.text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
                callback(value);                      
                  });
            });       
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#source-code-form input[name="sourceCode"]').value = bestCode;
        document.querySelector('#source-code-form input[name="sourceCode"]').dispatchEvent(new Event('input', { bubbles: true } ));
        document.querySelector('#sourceCode-button').click();  
      }
    },


    'lenovo' : {
      id: 203,
      preApplyCodes: function(callback) {
        const elTotal = $('#orderSummaryPart .cart-summary-pricingTotal .price-calculator-cart-summary-totalPriceWithTax');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
         callback(prevValue);
      },
      applyCode: function(code, callback) {
        const form = document.querySelector('form#ecouponForm');
        const url = $('form#ecouponForm').attr('action');
        const formData = getFormFieldsAsJson(form);
        formData['couponCode'] = code;
        formData['voucherCode'] = code;
        $.ajax({
          url: 'https://www.lenovo.com'+url,
          type: 'POST',
          data: formData,
          success: (data, textStatus, request) => {
            const locationUrl = request.getResponseHeader('location');
             $.get(locationUrl, 
              (response) => {
                    const elTotal = $(response).find('#orderSummaryPart .cart-summary-pricingTotal .price-calculator-cart-summary-totalPriceWithTax');
                    const value = elTotal.length > 0 ? 
                          Number(elTotal.text().replace( /[^0-9.]/g, '').trim()) : 
                          Number.POSITIVE_INFINITY;
                    callback(value);
              });
          },
          error: (xhr, status, error) => {
            console.log(error);
            callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: function(bestCode) {
        document.querySelector('#couponCode').value = bestCode;
        document.querySelector('#couponCode').dispatchEvent(new Event('input', {bubbles: true}));
        document.querySelector('#couponCode').dispatchEvent(new Event('keyup'));
        document.querySelector('#couponCode').dispatchEvent(new Event('blur')); 
        document.querySelector('#couponCode').dispatchEvent(new Event('focus'));        
        document.querySelector('#cart-summary-ecouponForm-button').click();
      }
    },


    'onepeloton' : {
      id: 39222,
      preApplyCodes: function(callback) {
        const elTotal = $('[data-test-id="orderTotal"]');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
         document.querySelector('[data-test-id="revealCouponCodeInput"]').click();
         callback(prevValue);
      },
      applyCode: function(code, callback) {
        $.ajax({
          url: 'https://api.onepeloton.com/ecomm/add_coupon/'+code,
          type: 'POST',
          headers: {
                 'Content-Type': 'application/json',
              },
          data: JSON.stringify({  coupons_v_2: 'true', renders_light_cart: 'true' }),
          success: (response) => {
            const value = (response.data.cart.total.totalInCents)/100;
            callback(value.toFixed(2));
                $.post('https://api.onepeloton.com/ecomm/remove_coupon/'+code,
                   (responsePost) => {
                   });
          },
          error: (xhr, status, error) => {
            console.log(error);
            callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: function(bestCode) {        
        document.querySelector('#promoCode').value = bestCode;
        document.querySelector('#promoCode').dispatchEvent(new Event('input', {bubbles: true}));
        document.querySelector('[data-test-id="applyCouponCode"]').click();
      }
    },

    keurig: {
      id: 5545, 
      preApplyCodes: function(callback) {
        const elTotal = $('.order-total span.right');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                      Number.POSITIVE_INFINITY;        
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        const formData = getFormFieldsAsJson(document.querySelector('#applyCouponForm'));        
        formData['couponCode'] = code;
          $.ajax({
            url: 'https://www.keurig.com/coupons/applyCoupon',
            type: 'POST',
            data: formData,
            contentType: 'application/x-www-form-urlencoded; charset=UTF-8',
            success: (responseGet) => {
                const elTotal = $(responseGet).find('.order-total span.right');
                const value = elTotal.length > 0 ? 
                        Number(elTotal.text().replace( /[^0-9.]/g, '').trim()) : 
                        Number.POSITIVE_INFINITY;
                $.ajax({
                  url: 'https://www.keurig.com/coupons/removeCoupon',
                  type: 'POST',
                  data: formData,
                  contentType: 'application/x-www-form-urlencoded; charset=UTF-8',
                  success: (responseGet) => {  callback(value); },
                  error: (responseGet) => {  callback(value); }
                });
            },
            error: (xhr, status, error) => {
               callback(Number.POSITIVE_INFINITY);
            }
        });       
      },
      applyBestCode: (bestCode) => {
        document.querySelector('input[name="couponCode"]').value = bestCode;
        document.querySelector('input[name="couponCode"]').dispatchEvent(new Event('input', {bubbles: true}));
        document.querySelector('#couponCodeApply').click(); 
      }
    },

    applebees: {
      id: 7867, 
      preApplyCodes: function(callback) {
        const elTotal = $('.c-ordertotal__totalvalue, .c-cart-checkout-cost');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                      Number.POSITIVE_INFINITY;        
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        const basketId = $('#basketId').val();
        const reqToken = $('input[name="__RequestVerificationToken"]').val();
        const body =  {
              basketId: basketId,
              couponcode: code,
              __RequestVerificationToken: reqToken
            };
        $.ajax({
          url: 'https://www.applebees.com/api/dineequity/menu/basket/coupon',
          type: 'PUT',
          data: body,
          contentType: 'application/x-www-form-urlencoded; charset=UTF-8',
          success: (response) => {
            if(response.total != '0'){
              var value;
              if(document.location.pathname.indexOf("/order/cart") === 0){
                 value = response.total-response.salestax;
              }else{
                 value = response.total;
              }                                          
                
              $.ajax({
                url: 'https://www.applebees.com/api/dineequity/menu/basket/coupon',
                type: 'DELETE',
                data: body,
                contentType: 'application/x-www-form-urlencoded; charset=UTF-8',
                success: (response) => { callback(value); },
                error: (response) => { callback(value); }
              });
            }else{
              callback(Number.POSITIVE_INFINITY);
            }
          },
          error: (xhr, status, error) => {
             callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('input[name="txtPromoCode"]').value = bestCode;
        document.querySelector('input[name="txtPromoCode"]').dispatchEvent(new Event('input', {bubbles: true}));
        document.querySelector('#btnPromoApply').click(); 
      }
    },


    redbubble: {
      id: 7249, 
      preApplyCodes: function(callback) {
        const elTotal = $('[class*="Summary_boldRow"] span:last');
        const csrf = $('meta[name="csrf-token"]').attr('content'); 
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                      Number.POSITIVE_INFINITY;
         $.ajax({
          url: 'https://www.redbubble.com/cart/coupon.json',
          type: 'DELETE',
          headers: {
              'x-csrf-token': csrf
            },
          success: () => { callback(prevValue); },
          error: () => { callback(prevValue); }
        });
      },
      applyCode: function(code, callback) {
        const csrf = $('meta[name="csrf-token"]').attr('content');  
        const body =  {
              coupon_code: code
            };
        $.ajax({
          url: 'https://www.redbubble.com/cart/coupon.json',
          type: 'PUT',
          data: body,
           headers: {
            'x-csrf-token': csrf
          },
          success: (response) => {
           $.get('https://www.redbubble.com/cart.json', (responseGet) => {                         
              const value = responseGet.summary.total;              
               $.ajax({
                url: 'https://www.redbubble.com/cart/coupon.json',
                type: 'DELETE',
                headers: {
                    'x-csrf-token': csrf
                  },
                success: (response) => { callback(value); },
                error: (response) => { callback(value); }
              });
            });
          },
          error: (xhr, status, error) => {
             callback(Number.POSITIVE_INFINITY);
          }
        });       
      },
      applyBestCode: (bestCode) => {
        const csrf = $('meta[name="csrf-token"]').attr('content');
        $.ajax({
          url: 'https://www.redbubble.com/cart/coupon.json',
          type: 'PUT',
          data: {
                  coupon_code: bestCode
                },
           headers: {
            'x-csrf-token': csrf
          },
          success: (response) => { 
            location.reload();
          }
        });
      }
    },


    brownells: {
      id: 489, 
      preApplyCodes: function(callback) {
        const elTotal = $('#divTotalAmt');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        const windowVariables = retrieveWindowVariables(["S_T","K_M" ]);
        const S_T = windowVariables['S_T'];
        const K_M = windowVariables['K_M'];
        const ts = Math.round(new Date().getTime());
         $.ajax({
          url: 'https://www.brownells.com/asmx/BrownellsWebService_Checkout.asmx/ApplyPromoCoupon?'+ts,
          type: 'POST',
          data: JSON.stringify({ promoCode: code}),
           headers: {
                    'content-type': 'application/json;charset=UTF-8',
                    'km' : K_M,
                    'securityticket' : S_T
                  },
          success: (response) => {
              const eltotal = JSON.parse(response.d);
              const value = eltotal.OrderTotal;
              const ts2 = Math.round(new Date().getTime());
                $.ajax({
                  url: 'https://www.brownells.com/asmx/BrownellsWebService_Checkout.asmx/RemovePromoCoupon?'+ts2,
                  type: 'POST',
                  data: JSON.stringify({ promoCode: code}),
                   headers: {
                            'content-type': 'application/json;charset=UTF-8',
                            'km' : K_M,
                            'securityticket' : S_T
                          },
                  success: (response) => { callback(value); },
                  error: (response) => { callback(value); }
                });
          },
          error: (xhr, status, error) => {
             callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#txtCouponPromo').value = bestCode;
        document.querySelector('#txtCouponPromo').dispatchEvent(new MouseEvent('input', {bubbles: true}));
        document.querySelector('#btnCouponPromo').click();       
      }
    },

    lifeextension: {
      id: 32064,   
      preApplyCodes: (callback) => {  
        const elTotal = $('span[data-bind="text: TotalOrder"]'); 
        const prevValue = elTotal.length > 0 ?  
                      Number(elTotal.text().trim().substr(1)) :   
                      Number.POSITIVE_INFINITY;
          callback(prevValue);  
      },  
      applyCode: (code, callback) => {
      setTimeout(function(){  
          document.querySelector('#inputDiscountCode1').value = code; 
          document.querySelector('#inputDiscountCode1').dispatchEvent(new Event('input', {bubbles: true}));
          document.querySelector('#inputDiscountCode1').dispatchEvent(new Event('change')); 
          document.querySelector('#DiscountButton').click(); 
           setTimeout(function(){
          $('#ApplyDisCountModal #MarketingModalOkButton').click(); 
           setTimeout(function(){
               const Total =  $('span[data-bind="text: TotalOrder"]'); 
               const value = Total.length > 0 ?   
                        Number(Total.text().trim().substr(1)) :   
                        Number.POSITIVE_INFINITY; 
                callback(value);
                  }, 2000);
               }, 3000);  
         }, 4000);  
      },  
      applyBestCode: (bestCode) => { 
        setTimeout(function(){  
         document.querySelector('#inputDiscountCode1').value = bestCode;  
         document.querySelector('#inputDiscountCode1').dispatchEvent(new Event('input', {bubbles: true})); 
         document.querySelector('#inputDiscountCode1').dispatchEvent(new Event('change')); 
         document.querySelector('#DiscountButton').click();
           setTimeout(function(){
              $('#ApplyDisCountModal #MarketingModalOkButton').click();
           }, 1000); 
        }, 2000); 
      } 
    },

  coldwatercreek: {
      id: 3587,
      preApplyCodes: function(callback) {
        const elTotal = $('#secondary .bag-summary .order-totals-row.order-total .order-totals-value');
        const prevValue = elTotal.length > 0 ? 
                        Number(elTotal.text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                        Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        $.get('https://www.coldwatercreek.com/on/demandware.store/Sites-coldwater_us-Site/default/Cart-AddCouponJson?couponCode='+code+'&format=ajax', 
          (response) => {
           const value = response.baskettotal;
           callback(value);                      
          });
      },
      applyBestCode: function(bestCode) {
        document.querySelector('input[name="dwfrm_cart_couponCode"]').value = bestCode;
        document.querySelector('input[name="dwfrm_cart_couponCode"]').dispatchEvent(new Event('input', {bubbles: true}));
        document.querySelector('#add-coupon').click();
      }
    },

    collectionsetc: {
      id: 583,
      preApplyCodes: function(callback) {
        const elTotal = $('div.row.order-summary-totals-total, div#cart-summary-order-total');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
         $.post('https://www.collectionsetc.com/api/Cart/ApplyPromoCode/'+code , (data) => {
         var ts = Math.round(new Date().getTime());
             $.get('https://www.collectionsetc.com/api/Cart/?_='+ts, (response) => {
              var elTotal;
              if(document.location.pathname.indexOf("/shopping/cart/") === 0){
                 elTotal = response.OrderSummary.CartOrderTotal;
              }else{
                 elTotal = response.OrderSummary.OrderTotal;
              }                
                callback(elTotal);
                 $.post('https://www.collectionsetc.com/api/Cart/ApplyPromoCode/undefined' , (data) => {
                          //
                    });
              });
          });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#promo-code, #coupon-code').value = bestCode;
        document.querySelector('#promo-code, #coupon-code').dispatchEvent(new Event('input', {bubbles: true}));
        document.querySelector('#btn-apply-promo-code, #promo-code-apply').click();
      }
    },

  luckyvitamin: {
      id: 6117,
      preApplyCodes: function(callback) {
        const elTotal = $('.cart__grand-total .cart__grand-total-value');
        const prevValue = elTotal.length > 0 ? 
                        Number(elTotal.text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                        Number.POSITIVE_INFINITY;
       const ts = Math.round(new Date().getTime());
       $.ajax({
          url: 'https://www.luckyvitamin.com/api/Cart/RemovePromoCodeValue?promoCode=remove&isVoucher=false&_='+ts,
          type: 'GET',
          success: () => {callback(prevValue);  },
          error: () => {  callback(prevValue); }
        });       
      },
      applyCode: function(code, callback) {
        this.preApplyCodes(() => {
         const ts = Math.round(new Date().getTime());
          $.ajax({
            url: 'https://www.luckyvitamin.com/api/Cart/AddPromoCodeValue?promoCode='+code+'&optimoveEmail=&_='+ts,
            type: 'GET',
            success: (response) => {
              const elTotal = response.grandTotal;
              const value = elTotal.length > 0 ? 
                    Number(elTotal.replace( /[^0-9.]/g, '').trim()) : 
                    Number.POSITIVE_INFINITY;
              callback(value);
            },
            error: () => {
              callback(Number.POSITIVE_INFINITY);
            }
          });
        });
      },
      applyBestCode: function(bestCode) {
        const ts = Math.round(new Date().getTime());
        $.ajax({
          url: 'https://www.luckyvitamin.com/api/Cart/AddPromoCodeValue?promoCode='+bestCode+'&optimoveEmail=&_='+ts,
          type: 'GET',
          success: () => { location.reload(); },
          error: () => { location.reload(); }
        });  
      }
    },

   revolve: {
      id: 1432, 
      preApplyCodes: function(callback) {
        const elTotal = $('.cart-summary-total');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                      Number.POSITIVE_INFINITY;        
        callback(prevValue);
      },
      applyCode: function(code, callback) {         
        $.ajax({
          url: 'https://www.revolve.com/r/ajax/ApplyPromoCode.jsp',
          type: 'POST',
          data: {promo: code, scope: ''},
          contentType: 'application/x-www-form-urlencoded; charset=UTF-8',
          success: (responsepost) => {
             $.ajax({
                url: 'https://www.revolve.com/r/ipadApp/checkout/CartItemSummary.jsp',
                type: 'POST',
                success: (response) => {
                  const value = response.totalAmount;                    
                  $.ajax({
                      url: 'https://www.revolve.com/r/ajax/ApplyPromoCode.jsp',
                      type: 'POST',
                       data: {promo: '', scope: ''},
                      contentType: 'application/x-www-form-urlencoded; charset=UTF-8',
                      success: (responseGet) => { callback(value); },
                      error: (responseGet) => { callback(value); }
                    });
              }
            });
          },
          error: (xhr, status, error) => {
             callback(Number.POSITIVE_INFINITY);
          }
        });       
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#edit_promo').click()
        setTimeout(function(){
          document.querySelector('#coupon_code').value = bestCode;
          document.querySelector('#coupon_code').dispatchEvent(new Event('input', {bubbles: true}));
          document.querySelector('#coupon_code_button').click(); 
         }, 1500);  
      }
    },

    orvis: {
      id: 217, 
      preApplyCodes: (callback) => {
        const elTotal = $('.order-total p:first');
        const prevValue = elTotal.text().replace( /[^0-9.]/g, '').trim();
        callback(prevValue);
      },
      applyCode: (code, callback) => {
        const cartData =JSON.parse(sessionStorage.getItem("cartData"));
        const shopperId = cartData.shopperId;
         $.ajax({
              url: 'https://deporder.orvis.com/api/v4/Order/'+shopperId+'/promotion?ce=true',
              type: 'POST',
              data: {promotionCode: code},
              success: (response) => {
                  const value = response.orderTotals !== null && response.orderTotals !== undefined ? 
                        Number(response.orderTotals.orderTotal) : 
                        Number.POSITIVE_INFINITY;
                  callback(value);
              },
              error: (xhr, status, error) => {
                 callback(Number.POSITIVE_INFINITY);
              }
            });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('input[placeholder="Enter Promo Code"]').value = bestCode;
        document.querySelector('input[placeholder="Enter Promo Code"]').dispatchEvent(new MouseEvent('input', {bubbles: true}));
        document.querySelector('button[name="Apply"]').click();
      }
    },

    bouqs: {
      id: 8393,
      preApplyCodes: function(callback) {
        const elTotal = $('.table__total td');
        const prevValue = elTotal.length > 0 ? 
                        Number(elTotal.text().trim().substr(1)) : 
                        Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        const formData = getFormFieldsAsJson(document.querySelector('form#promo_code_form'));       
        formData['promo_code'] = code;
        $.ajax({
          url: 'https://bouqs.com/cart/add_promo_code',
          type: 'POST',
          data: formData,
          success: (data, textStatus, request) => {
            const locationUrl = request.getResponseHeader('location');
            $.get(locationUrl, 
              (response) => {
                const elTotal = $(response).find('.table__total td');
                const value = elTotal.length > 0 ? 
                              Number(elTotal.text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                              Number.POSITIVE_INFINITY;
                callback(value);
              });
            },
              error: (xhr, status, error) => {
                 callback(Number.POSITIVE_INFINITY);
              }
          });
      },
      applyBestCode: function(bestCode) {
        document.querySelector('#promo_code').value = bestCode;
        document.querySelector('#promo_code').dispatchEvent(new MouseEvent('input', {bubbles: true}));
        document.querySelector('button[value="add_promo_code"]').click()
      }
    },

    teleflora: {
      id: 1602,
      preApplyCodes: function(callback) {
        const elTotal = $('span.m-billing-review-grand-total');
        const prevValue = elTotal.length > 0 ? 
                        Number(elTotal.text().trim().substr(1)) : 
                        Number.POSITIVE_INFINITY;
        const prevCode = $('[class*="m-billing-promo-code-individual-entry"]').text();        
        if(prevCode){
          this._removeCode(prevCode, function() {
           callback(prevValue,prevCode);
          });
        }else{
          callback(prevValue);
        }
        
      },
      applyCode: function(code, callback) {
        const formData = getFormFieldsAsJson(document.querySelector('form[name="couponCodeForm"]'));
        formData['couponCode'] = code;
        formData['orgCouponCode'] = code;
        formData['couponCodeBtn'] = 'Submit';
        formData['_D:couponCodeBtn'] = '';
        $.ajax({
          url: 'https://www.teleflora.com/checkout/billing_review.jsp?_DARGS=/checkout/billing_review.jsp.couponCodeForm',
          type: 'POST',
          data: formData,
          contentType: 'application/x-www-form-urlencoded',
          success: (response) => {           
                const elTotal = $(response).find('span.m-billing-review-grand-total');
                const value = elTotal.length > 0 ? 
                              Number(elTotal.text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                              Number.POSITIVE_INFINITY;
           this._removeCode(code, function() {
             callback(value);
            });           
          },
          error: (xhr, status, error) => {
            console.log(error);
            callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: function(bestCode) {
        document.querySelector('#promotionalCode').value = bestCode;
        document.querySelector('#promotionalCode').dispatchEvent(new MouseEvent('input', {bubbles: true}));
        document.querySelector('#coupnApply').click();
      },
    _removeCode: (code, callback) => {
      const formData2 = getFormFieldsAsJson(document.querySelector('form[name="couponCodeRemoveForm"]'));
      formData2['couponCode'] = code;
      formData2['orgCouponCode'] = code;
      formData2['couponCodeRemoveBtn'] = 'Submit';
      formData2['_D:couponCodeRemoveBtn'] = '';
      $.ajax({
        url: 'https://www.teleflora.com/checkout/billing_review.jsp?_DARGS=/checkout/billing_review.jsp.couponCodeRemoveForm',
        type: 'POST',
        data: formData2,
        contentType: 'application/x-www-form-urlencoded',
         success: () => { callback();  },
         error: () => { callback(); }
       }); 
    }
  },

    'dsw' : {
      id: 3836,
      preApplyCodes: function(callback) {
        const elTotal = $('div.checkout-order-summary__line-item__total div span:last-child');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
         callback(prevValue);
      },
      applyCode: function(code, callback) {       
        $.ajax({
          url: 'https://www.dsw.com/api/v1/coupons/claim?locale=en_US&pushSite=DSW',
          type: 'POST',
          data: JSON.stringify({couponClaimCode: code, cart: "shoppingcart" }),
          contentType: 'application/json;charset=UTF-8',
          success: (data, textStatus, request) => {
            const locationUrl = 'https://www.dsw.com/api/v1/cart/details?locale=en_US&pushSite=DSW';
             $.get(locationUrl, 
              (response) => {
                    const value = response.order.priceInfo.total;
                      $.ajax({
                          url: 'https://www.dsw.com/api/v1/coupons/'+code+'?locale=en_US&pushSite=DSW',
                          type: 'DELETE',
                          success: (data, textStatus, request) => {
                             callback(value);
                          },
                          error: (xhr, status, error) => {
                             callback(value);                        
                          }
                        });
                });
          },
          error: (xhr, status, error) => {
            console.log(error);
            callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: function(bestCode) {
        document.querySelector('#promoCode').value = bestCode;
        document.querySelector('#promoCode').dispatchEvent(new Event('input', {bubbles: true}));      
        document.querySelector('form > button').click();
      }
    },


   logitech: {
      id: 1107,
      preApplyCodes: function(callback) {
        const elTotal = $('.dr_price.dr_totals, #qb-cart-summary .cs-subtotal .sub-value:last-child');        
        const prevValue = elTotal.length > 0 ? 
                        Number(elTotal.text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                        Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        const formData = getFormFieldsAsJson(document.querySelector('form[name="ShoppingCartForm"]'));
        formData['couponCode'] = code;
        $.ajax({
          url: 'https://buy.logitech.com/store/',
          type: 'POST',
          data: formData,
          contentType: 'application/x-www-form-urlencoded; charset=UTF-8',
          success: (response) => {           
                const elTotal = $(response).find('.dr_price.dr_totals, #qb-cart-summary .cs-subtotal .sub-value:last-child');
                const value = elTotal.length > 0 ? 
                              Number(elTotal.text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                              Number.POSITIVE_INFINITY;   
                callback(value);             
                        
          },
          error: (xhr, status, error) => {
            console.log(error);
            callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: function(bestCode) {
        document.querySelector('#promoCode').value = bestCode;
        document.querySelector('#promoCode').dispatchEvent(new MouseEvent('input', {bubbles: true}));
        document.querySelector('.dr_couponCode .dr_button, #promoCode + input.dr_button').click();
      }
    },


    easeus: {
      id: 25519,
      preApplyCodes: function(callback) {
        const elTotal = $('.cbCartTotal .cbTtotal');        
        const prevValue = elTotal.length > 0 ? 
                        Number(elTotal.text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                        Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        $('.cbProductAdd').find('input:checkbox').val('0');
        const formData = getFormFieldsAsJson(document.querySelector('form[name="cleverForm"]'));
        const url = $('form[name="cleverForm"]').attr('action');
        formData['purchaseCouponCode'] = code;
        formData['buttonaddCoupon'] = 'Apply'; 
        $.ajax({
          url:  url,
          type: 'POST',
          data: formData,
          contentType: 'application/x-www-form-urlencoded; charset=UTF-8',
          success: (response) => {
                $('.cbProductAdd').find('input:checkbox').val('1');         
                const elTotal = $(response).find('.cbCartTotal .cbTtotal');
                const value = elTotal.length > 0 ? 
                              Number(elTotal.text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                              Number.POSITIVE_INFINITY;   
                callback(value);                        
          },
          error: (xhr, status, error) => {
            $('.cbProductAdd').find('input:checkbox').val('1');   
            console.log(error);
            callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: function(bestCode) {
        document.querySelector('input[name="purchaseCouponCode"]').value = bestCode;
        document.querySelector('input[name="purchaseCouponCode"]').dispatchEvent(new MouseEvent('input', {bubbles: true}));
        document.querySelector('input[name="buttonaddCoupon"]').click();
      }
    },

    jrcigars: {
      id: 16693,
      preApplyCodes: function(callback) {
        const elTotal = $('.products-subtotal .totals__value');        
        const prevValue = elTotal.length > 0 ? 
                        Number(elTotal.text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                        Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        $.ajax({
          url:  'https://www.jrcigars.com/on/demandware.store/Sites-JRCigars-Site/en_US/OnePageCheckout-AddCoupon',
          type: 'POST',
          data: JSON.stringify({couponCode: code}),
          contentType: 'application/json; charset=UTF-8',
          success: (response) => {           
                const value = response.totals.orderTotalValue;
                callback(value); 
          },
          error: (xhr, status, error) => {
            console.log(error);
            callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: function(bestCode) {
        document.querySelector('.coupon-redeem__code-input input[type="text"]').value = bestCode;
        document.querySelector('.coupon-redeem__code-input input[type="text"]').dispatchEvent(new MouseEvent('input', {bubbles: true}));
        document.querySelector('.coupon-redeem__cta').click();
      }
    },


    fossil: {
      id: 1956, 
      preApplyCodes: function(callback) {
         const elTotal = $('.grand-total-wrapper .grand-total');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
         const url = $('form[name="promo-code-form"]').attr('action');
        const csrf_token = $('.promo-code-form input[name="csrf_token"]').val();
         $.get('https://www.fossil.com'+url+'/?csrf_token='+csrf_token+'&couponCode='+code, 
          (response) => {
            if(response.totals){
                const value = response.totals.grandTotal;
                const totalValue = Number(value.replace( /[^0-9.]/g, '').trim())
                const locale = response.locale;
                const uuid =  response.totals.discounts[0].UUID;
                $.get('https://www.fossil.com/on/demandware.store/Sites-fossil-na-Site/'+locale+'/Cart-RemoveCouponLineItem?code='+code+'&uuid='+uuid, 
                  (response) => {
              });
                callback(totalValue);
            }else{
              callback(Number.POSITIVE_INFINITY);
            }
          });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#couponCode').value = bestCode;
        document.querySelector('#couponCode').dispatchEvent(new Event('input', {bubbles: true}));
        document.querySelector('button.promo-code-btn').click();
      }
    },

    keh: {
      id: 24891, 
      preApplyCodes: function(callback) {
        const elTotal = $('#shopping-cart-totals-table tfoot tr:last-child td:last-child .price, #checkout-review-table tfoot tr.last td.last .price');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        $.ajax({
          url: 'https://www.keh.com/shop/checkout/cart/couponPost',
          type: 'POST',
          data: {
            remove: 0,
            coupon_code: code
          },
          success: (data, textStatus, request) => {
            const locationUrl = request.getResponseHeader('location');
            $.get(locationUrl , (responseGet) => {
              const elTotal = $(responseGet).find('#shopping-cart-totals-table tfoot tr:last-child td:last-child .price, #checkout-review-table tfoot tr.last td.last .price');
              var value = 0;
              if( elTotal.length > 0 ){
                 $( elTotal ).each(function( index ) {
                  value += Number($( this ).text().replace( /[^0-9.]/g, '').trim());                
                 });
              }else{
                  value = Number.POSITIVE_INFINITY;
              }
              
              callback(value);
            });
          },
          error: (xhr, status, error) => {
             callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#coupon_code, #checkout-coupon').value = bestCode;
        document.querySelector('#coupon_code, #checkout-coupon').dispatchEvent(new MouseEvent('input', { bubbles: true } ));
        document.querySelector('button[value="Apply"], input[value="Apply Coupon"]').click();  
      }
    },

    boscovs: {
      id: 24891, 
      preApplyCodes: function(callback) {
        const elTotal = $('#order_total');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        $.ajax({
          url: 'https://www.boscovs.com/shop/add-coupon.do?couponCode='+code,
          type: 'GET',
          success: (data, textStatus, request) => {
            const locationUrl = 'https://www.boscovs.com/shop/cart.do';
            $.get(locationUrl , (responseGet) => {
              const elTotal = $(responseGet).find('#order_total');
               const value = elTotal.length > 0 ? 
                      Number(elTotal.text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
              
              callback(value);
            });
          },
          error: (xhr, status, error) => {
             callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#couponCode').value = bestCode;
        document.querySelector('#couponCode').dispatchEvent(new MouseEvent('input', { bubbles: true } ));
        document.querySelector('#coupon-button').click();  
      }
    },

    raise: {
      id: 9797,
      preApplyCodes: function(callback) {
        const elTotal = $('#checkout-total .summary .right');        
        const prevValue = elTotal.length > 0 ? 
                        Number(elTotal.text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                        Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        const formData = getFormFieldsAsJson(document.querySelector('form#checkout_apply_coupon_code'));
        const url = 'https://www.raise.com/promotion_applications.json';
        formData['order[coupon_code]'] = code;
        $.ajax({
          url:  url,
          type: 'POST',
          data: formData,
          contentType: 'application/x-www-form-urlencoded; charset=UTF-8',
          success: (response) => {           
                const locationUrl = 'https://www.raise.com/receipt-summary-totals';
                $.get(locationUrl , (responseGet) => {
                  const elTotal = $(responseGet).find('.summary td.right');
                   const value = elTotal.length > 0 ? 
                          Number(elTotal.text().replace( /[^0-9.]/g, '').trim()) : 
                          Number.POSITIVE_INFINITY; 
                          const removeurl = $(responseGet).find('.remote-delete').attr('href');
                          $.ajax({
                            url:  removeurl,
                            type: 'DELETE',
                            success: (response) => { 
                               callback(value);    
                            }, error: (xhr, status, error) => {
                               callback(value);
                            }
                          });
                });  
          },
          error: (xhr, status, error) => {
            console.log(error);
            callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: function(bestCode) {
        document.querySelector('#order_coupon_code').value = bestCode;
        document.querySelector('#order_coupon_code').dispatchEvent(new MouseEvent('input', {bubbles: true}));
        document.querySelector('#checkout_apply_coupon_code input[name="commit"]').click();
      }
    },

    finishline: {
      id: 805,
      preApplyCodes: function(callback) {
        const elTotal = $('#orderSummaryOrderTotal');
        const prevValue = elTotal.length > 0 ? 
                        Number(elTotal.text().trim().substr(1)) : 
                        Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        const formData = getFormFieldsAsJson(document.querySelector('form#coupon_form'));       
        formData['/atg/commerce/promotion/CouponFormHandler.couponClaimCode'] = code;
        formData['/atg/commerce/promotion/CouponFormHandler.claimCoupon'] = 'claimCoupon';
        $.ajax({
          url: 'https://www.finishline.com/store/checkout/applyCouponJsonResponse.jsp?_DARGS=/store/cart/cartInner.jsp',
          type: 'GET',
          data: formData,
          success: (data, textStatus, request) => {
             if(document.location.pathname.indexOf("/store/cart/") === 0){
               const locationUrl = 'https://www.finishline.com/store/checkout/gadgets/checkoutOrderSummary.jsp?currentStage=cart&cartType=page';
                $.get(locationUrl, 
                  (response) => {
                    const elTotal = $(response).find('#orderSummaryOrderTotal');
                    const value = elTotal.length > 0 ? 
                                  Number(elTotal.text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                                  Number.POSITIVE_INFINITY;
                    callback(value);
                  });
                       
            }else{
              const locationUrl = request.getResponseHeader('location');
              $.get(locationUrl, 
                (response) => {
                  const elTotal = $(response).find('#orderSummaryOrderTotal');
                  const value = elTotal.length > 0 ? 
                                Number(elTotal.text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                                Number.POSITIVE_INFINITY;
                  callback(value);
                });
              }            
            }
          });
      },
      applyBestCode: function(bestCode) {
        document.querySelector('.couponCodeInput ').value = bestCode;
        document.querySelector('.couponCodeInput ').dispatchEvent(new MouseEvent('input', {bubbles: true}));
        document.querySelector('.applyCouponCode').click();
      }
    },

    campsaver: {
      id: 4249,
      preApplyCodes: function(callback) {
        const elTotal = $('#order-summary-right-panel .e-order-summary-heading__sum span:last-child');
        var prevValue = elTotal.length > 0 ? 
                        Number(elTotal.text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                        Number.POSITIVE_INFINITY; 
         if(document.querySelector('#shipping_total_subtotal')){
            const shipping_total_subtotal_select = $('#shipping_total_subtotal');
            var prevValue_subtotal = shipping_total_subtotal_select.length > 0 ? 
                        Number(shipping_total_subtotal_select.text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                        Number.POSITIVE_INFINITY;
               
           const shipping_total_shipping_select = $('#shipping_total_shipping');
           var prevValue_shipping = shipping_total_shipping_select.length > 0 ? 
                Number(shipping_total_shipping_select.text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                0;
                prevValue = (prevValue_subtotal+prevValue_shipping).toFixed(2);
         }        
         $.get('https://www.campsaver.com/checkout/apply-coupon?code=', 
            (response) => {
             callback(prevValue);  
          });
      },
      applyCode: function(code, callback) {
        $.get('https://www.campsaver.com/checkout/apply-coupon?code='+code, 
          (response) => {
           const value = response.totals.total_grandtotal;
             $.get('https://www.campsaver.com/checkout/apply-coupon?code=', 
                (response) => {
                 callback(value);  
                  });                    
          });
      },
      applyBestCode: function(bestCode) {
        if(document.querySelector('.remove-coupon-link span')){
          document.querySelector('.remove-coupon-link span').click();
        } 
        setTimeout(function(){
          $.get('https://www.campsaver.com/checkout/apply-coupon?code='+bestCode, 
          (response) => {
            location.reload();
             });
        }, 1000);
      }
    },

    smarthome: {
      id: 1517,
      preApplyCodes: function(callback) {
        var elTotal; var prevValue;
         if(document.location.pathname.indexOf("/checkout/cart/") === 0){
            elTotal = $('#shopping-cart-totals-table tfoot tr:last-child td:last-child .price');
            prevValue = elTotal.length > 0 ? 
                          Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY; 
        }else{
            elTotal = $('.onestepcheckout-totals td:contains("Grand Total")').next();     
            prevValue = elTotal.length > 0 ? 
                            Number(elTotal.text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                        Number.POSITIVE_INFINITY;               
       }
        callback(prevValue);
      },
      applyCode: function(code, callback) {
         if(document.location.pathname.indexOf("/checkout/cart/") === 0){
             $.ajax({
              url: 'https://www.smarthome.com/checkout/cart/couponPost/',
              type: 'POST',
              data: {
                remove: 0,
                coupon_code: code
              },
              success: (data, textStatus, request) => {
                const locationUrl = request.getResponseHeader('location');
                $.get(locationUrl , (responseGet) => {
                  const elTotal = $(responseGet).find('#shopping-cart-totals-table tfoot tr:last-child td:last-child .price');
                  var value = 0;
                  if( elTotal.length > 0 ){
                     $( elTotal ).each(function( index ) {
                      value += Number($( this ).text().replace( /[^0-9.]/g, '').trim());                
                     });
                  }else{
                      value = Number.POSITIVE_INFINITY;
                  }
                  
                  callback(value);
                });
              },
              error: (xhr, status, error) => {
                 callback(Number.POSITIVE_INFINITY);
              }
            });
       }else{
          $.ajax({
            url:  'https://www.smarthome.com/onestepcheckout/ajax/add_coupon/',
            type: 'POST',
            data: {code: code},
            contentType: 'application/x-www-form-urlencoded; charset=UTF-8',
            success: (response) => {           
                  $.get('https://www.smarthome.com/onestepcheckout/', 
                  (response) => {
                          const total = $(response).find('.onestepcheckout-totals td:contains("Grand Total")').next();     
                          const value = total.length > 0 ? 
                                          Number(total.text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                                          Number.POSITIVE_INFINITY;
                          callback(value); 
                    }); 
            },
            error: (xhr, status, error) => {
              console.log(error);
              callback(Number.POSITIVE_INFINITY);
            }
          });
        }
      },
      applyBestCode: function(bestCode) {
        document.querySelector('#coupon_code, #id_couponcode').value = bestCode;
        document.querySelector('#coupon_code, #id_couponcode').dispatchEvent(new MouseEvent('input', {bubbles: true}));
        document.querySelector('#discount-coupon-form button[value="Apply Coupon"], #onestepcheckout-coupon-add').click();
      }
    },

    inkjets: {
      id: 18514,
      preApplyCodes: function(callback) {
        var elTotal; var prevValue;
         if(document.location.pathname.indexOf("/checkout/cart/") === 0){
            elTotal = $('.tr-total span.price');
            prevValue = elTotal.length > 0 ? 
                          Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY; 
        }else{
            elTotal = $('.tr-total span.price');     
            prevValue = elTotal.length > 0 ? 
                            Number(elTotal.text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                        Number.POSITIVE_INFINITY;               
       }
        callback(prevValue);
      },
      applyCode: function(code, callback) {
         if(document.location.pathname.indexOf("/checkout/cart/") === 0){
             $.ajax({
              url: 'https://www.inkjets.com/checkout/cart/couponPost/',
              type: 'POST',
              data: {
                remove: 0,
                coupon_code: code
              },
              success: (data, textStatus, request) => {
                const locationUrl = request.getResponseHeader('location');
                $.get(locationUrl , (responseGet) => {
                  const elTotal = $(responseGet).find('.tr-total span.price');
                  var value = 0;
                  if( elTotal.length > 0 ){
                     $( elTotal ).each(function( index ) {
                      value += Number($( this ).text().replace( /[^0-9.]/g, '').trim());                
                     });
                  }else{
                      value = Number.POSITIVE_INFINITY;
                  }
                  
                  callback(value);
                });
              },
              error: (xhr, status, error) => {
                 callback(Number.POSITIVE_INFINITY);
              }
            });
       }else{
          const formData = getFormFieldsAsJson(document.querySelector('#discount_form'));
          formData['coupon[code]'] = code;
          $.ajax({
            url:  'https://www.inkjets.com/firecheckout/index/saveCoupon/',
            type: 'POST',
            data: formData,
            contentType: 'application/x-www-form-urlencoded; charset=UTF-8',
            success: (response) => {           
                  $.get('https://www.inkjets.com/firecheckout/', 
                  (response) => {
                          const total = $(response).find('.tr-total span.price');     
                          const value = total.length > 0 ? 
                                          Number(total.text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                                          Number.POSITIVE_INFINITY;
                          callback(value); 
                    }); 
            },
            error: (xhr, status, error) => {
              console.log(error);
              callback(Number.POSITIVE_INFINITY);
            }
          });
        }
      },
      applyBestCode: function(bestCode) {
        document.querySelector('#coupon_code, #coupon-code').value = bestCode;
        document.querySelector('#coupon_code, #coupon-code').dispatchEvent(new MouseEvent('input', {bubbles: true}));
        document.querySelector('.discount-form button[value="Apply"], #coupon-apply').click();
      }
    },

    weightwatchers: {
      id: 246,
      preApplyCodes: (callback) => {
        const Total = $('#priceDetails_priceTotalContainerItem span:last-child');
        const prevValue = Total.length > 0 ? 
                       Number(Total.text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;        
        callback(prevValue);
      },
      applyCode: (code, callback) => { 
        const cartId = $('.cartItem.cartItemCheckout').attr('data-cartid');
        const guestSession =decodeURI(document.cookie.split(';').filter(function(c) { return c.indexOf('guestSession') !== -1 })[0]).trim().split('=')[1];
          
      $.ajax({
          url: 'https://commerce.weightwatchers.com/us/en/api/order/v1/cart/'+cartId+'/offer/'+code+'?channel=E_COMMERCE',
          type: 'POST',
          data: JSON.stringify({market: 'en-US'}),
          headers: {
            'guest-session': guestSession,
            'content-type': 'application/json'
          },
          success: (response) => {
            const value = response.total;
               $.ajax({
                  url: 'https://commerce.weightwatchers.com/us/en/api/order/v1/cart/'+cartId+'/offer/'+code+'?channel=E_COMMERCE',
                  type: 'DELETE',
                  headers: {
                    'guest-session': guestSession,
                    'content-type': 'application/json'
                  },
                    success: () => { callback(value);
                    },
                    error: ()  => { callback(value);
                    }
                });
            },
            error: (xhr, status, error) => {
              console.log(error);
              callback(Number.POSITIVE_INFINITY);
            }
        });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#couponCodeInputText').value = bestCode;
        document.querySelector('#couponCodeInputText').dispatchEvent(new MouseEvent('input', {bubbles: true}));
        document.querySelector('#couponButtonSubmit').click();
      }
    },

  yliving: {
      id: 16014,
      preApplyCodes: (callback) => {
        const orderValueEl = $('.checkoutordertotals .ordertotals .ordertotal span.value, .cartordertotals .ordertotals .ordertotal span.value');
        const prevValue = orderValueEl.length > 0 ? 
                          Number(orderValueEl.text().replace( /[^0-9.]/g, '').trim()) : 
                          Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: (code, callback) => {
         if(document.location.pathname.indexOf("/cart") === 0){
            const url = $('#dwfrm_cart').attr('action');
            const formData = getFormFieldsAsJson(document.querySelector('#dwfrm_cart'));
            formData['dwfrm_cart_couponCode'] = code;
            formData['dwfrm_cart_addCoupon'] = 'Apply';
            $.post(url, formData, 
              (response) => {
                const orderValueEl = $(response).find('.ordertotals .ordertotal .value');
                const value = orderValueEl.length > 0 ? 
                                  Number(orderValueEl.text().replace( /[^0-9.]/g, '').trim()) : 
                                  Number.POSITIVE_INFINITY;
                callback(value);
              });
        }else{
              $.get('https://www.yliving.com/on/demandware.store/Sites-YLiving-Site/default/COBilling-ApplyCoupon?couponCode='+code, 
              (response) => {
                 $.get('https://www.yliving.com/on/demandware.store/Sites-YLiving-Site/default/COOnePage-UpdateSummary', 
                  (response) => {
                    const orderValueEl = $(response).find('.ordertotals .ordertotal .value');
                    const value = orderValueEl.length > 0 ? 
                                      Number(orderValueEl.text().replace( /[^0-9.]/g, '').trim()) : 
                                      Number.POSITIVE_INFINITY;
                    callback(value);
                  });
              });
        }
      },
      applyBestCode: (bestCode) => {
          location.reload();      
      }
    },

    ylighting: {
      id: 1803,
      preApplyCodes: (callback) => {
        const orderValueEl = $('.checkoutordertotals .ordertotals .ordertotal span.value, .cartordertotals .ordertotals .ordertotal span.value');
        const prevValue = orderValueEl.length > 0 ? 
                          Number(orderValueEl.text().replace( /[^0-9.]/g, '').trim()) : 
                          Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: (code, callback) => {
         if(document.location.pathname.indexOf("/cart") === 0){
            const url = $('#dwfrm_cart').attr('action');
            const formData = getFormFieldsAsJson(document.querySelector('#dwfrm_cart'));
            formData['dwfrm_cart_couponCode'] = code;
            formData['dwfrm_cart_addCoupon'] = 'Apply';
            $.post(url, formData, 
              (response) => {
                const orderValueEl = $(response).find('.ordertotals .ordertotal .value');
                const value = orderValueEl.length > 0 ? 
                                  Number(orderValueEl.text().replace( /[^0-9.]/g, '').trim()) : 
                                  Number.POSITIVE_INFINITY;
                callback(value);
              });
        }else{
              $.get('https://www.ylighting.com/on/demandware.store/Sites-YLighting-Site/default/COBilling-ApplyCoupon?couponCode='+code, 
              (response) => {
                 $.get('https://www.ylighting.com/on/demandware.store/Sites-YLighting-Site/default/COOnePage-UpdateSummary', 
                  (response) => {
                    const orderValueEl = $(response).find('.ordertotals .ordertotal .value');
                    const value = orderValueEl.length > 0 ? 
                                      Number(orderValueEl.text().replace( /[^0-9.]/g, '').trim()) : 
                                      Number.POSITIVE_INFINITY;
                    callback(value);
                  });
              });
        }
      },
      applyBestCode: (bestCode) => {
          location.reload();      
      }
    },

    tommy: {
      id: 4901,
      preApplyCodes: (callback) => {
        const elTotal = $('.cart-total .total_figures.order_total_figures');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: (code, callback) => {      
        const url = 'https://'+window.location.hostname+'/AjaxRESTPromotionCodeApply';
        const formData = getFormFieldsAsJson(document.querySelector('form[name="PromotionCodeForm"]'));
          formData['promoCode'] = code; 
          formData['requesttype'] = 'ajax';
        $.ajax({
          url: url,
          type: 'POST',
          data: formData,
          success: (response) => {
            const catalogId = $('#PromotionCodeForm input[name="catalogId"]').val();
            var storeId = $('#PromotionCodeForm input[name="storeId"]').val();
            var langId = $('input[name="langId"]').val();
            var getUrl = 'https://'+window.location.hostname+'/ShopCartDisplayView?shipmentType=single&catalogId='+catalogId+'&langId='+langId+'&storeId='+storeId;
             $.ajax({
              url: getUrl,
              type: 'POST',
              data: {
                'objectId': '',
                'requesttype': 'ajax'
              },
              success: (response) => {                    
                const elTotal =  $(response).find('.cart-total .total_figures.order_total_figures');                   
                const value = elTotal.length > 0 ? 
                              Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                              Number.POSITIVE_INFINITY;
              const formData2 = formData;
              formData2['taskType'] = 'R';                    
              var removeUrl = 'https://'+window.location.hostname+'/AjaxRESTPromotionCodeRemove';
               $.ajax({
                url: removeUrl,
                type: 'POST',
                data: formData2,
                success: () => { callback(value); },
                error: () => { callback(value); }
              });
              }
            });
          },
          error: (xhr, status, error) => {
            console.log(error);
            callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: (bestCode) => {
         document.querySelector('#promoCode').value = bestCode;
         document.querySelector('#promoCode').dispatchEvent(new Event('input', {bubbles: true}));
         document.querySelector('#WC_PromotionCodeDisplay_links_1').click();
      }
    },

    partnerbrands: {
      id: 37273,
      preApplyCodes: (callback) => {
        const elTotal = $('.cart-total .total_figures.order_total_figures');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: (code, callback) => {        
        const url = 'https://'+window.location.hostname+'/AjaxRESTPromotionCodeApply';
        const formData = getFormFieldsAsJson(document.querySelector('form[name="PromotionCodeForm"]'));
          formData['promoCode'] = code; 
          formData['requesttype'] = 'ajax';              

        $.ajax({
          url: url,
          type: 'POST',
          data: formData,
          success: (response) => {
            const catalogId = $('#PromotionCodeForm input[name="catalogId"]').val();
            var storeId = $('#PromotionCodeForm input[name="storeId"]').val();
            var langId = $('input[name="langId"]').val();
            var getUrl = 'https://'+window.location.hostname+'/ShopCartDisplayView?shipmentType=single&catalogId='+catalogId+'&langId='+langId+'&storeId='+storeId;
             $.ajax({
                  url: getUrl,
                  type: 'POST',
                  data: {
                    'objectId': '',
                    'requesttype': 'ajax'
                  },
                  success: (response) => {                    
                    const elTotal =  $(response).find('.cart-total .total_figures.order_total_figures');                   
                    const value = elTotal.length > 0 ? 
                                  Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                                  Number.POSITIVE_INFINITY;
                    const formData2 = formData;
                    formData2['taskType'] = 'R';                    
                    var removeUrl = 'https://'+window.location.hostname+'/AjaxRESTPromotionCodeRemove';
                     $.ajax({
                      url: removeUrl,
                      type: 'POST',
                      data: formData2,
                      success: (response) => { callback(value); },
                      error: (response) => { callback(value); }
                    });
                  }
            });
          },
          error: (xhr, status, error) => {
            console.log(error);
            callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: (bestCode) => {
         document.querySelector('#promoCode').value = bestCode;
         document.querySelector('#promoCode').dispatchEvent(new Event('input', {bubbles: true}));
         document.querySelector('#WC_PromotionCodeDisplay_links_1').click();
      }
    },

   calvinklein: {
      id: 4248,
      preApplyCodes: (callback) => {
        const elTotal = $('.cart-total .total_figures.order_total_figures');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: (code, callback) => {       
        const url = 'https://'+window.location.hostname+'/AjaxRESTPromotionCodeApply';
        const formData = getFormFieldsAsJson(document.querySelector('form[name="PromotionCodeForm"]'));
          formData['promoCode'] = code; 
          formData['requesttype'] = 'ajax';
        $.ajax({
          url: url,
          type: 'POST',
          data: formData,
          success: (response) => {
            const catalogId = $('#PromotionCodeForm input[name="catalogId"]').val();
            var storeId = $('#PromotionCodeForm input[name="storeId"]').val();
            var langId = $('input[name="langId"]').val();
            var getUrl = 'https://'+window.location.hostname+'/ShopCartDisplayView?shipmentType=single&catalogId='+catalogId+'&langId='+langId+'&storeId='+storeId;
             $.ajax({
                  url: getUrl,
                  type: 'POST',
                  data: {
                    'objectId': '',
                    'requesttype': 'ajax'
                  },
                  success: (response) => {                    
                    const elTotal =  $(response).find('.cart-total .total_figures.order_total_figures');                   
                    const value = elTotal.length > 0 ? 
                                  Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                                  Number.POSITIVE_INFINITY;
                    const formData2 = formData;
                    formData2['taskType'] = 'R';                    
                    var removeUrl = 'https://'+window.location.hostname+'/AjaxRESTPromotionCodeRemove';
                      $.ajax({
                        url: removeUrl,
                        type: 'POST',
                        data: formData2,
                        success: (response) => { callback(value); },
                        error: (response) => { callback(value); }
                      });
                  }
            });
          },
          error: (xhr, status, error) => {
            console.log(error);
            callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: (bestCode) => {
         document.querySelector('#promoCode').value = bestCode;
         document.querySelector('#promoCode').dispatchEvent(new Event('input', {bubbles: true}));
         document.querySelector('#WC_PromotionCodeDisplay_links_1').click();
      }
    },

   kendrascott: {
      preApplyCodes: function(callback) {
        const elTotal = $('.bfx-total-grandtotal');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        if(window.location.href.indexOf("cart") > -1){
          if(document.querySelector('#cart-items-form')){
            const url = $('#cart-items-form').attr('action');
            const formData = getFormFieldsAsJson(document.querySelector('#cart-items-form'));
            formData['dwfrm_cart_coupons_i0_deleteCoupon'] = 'Remove';
            $.post(url, formData, 
              (response) => {
                callback(prevValue);
            });
          }else{
            callback(prevValue);
          }
        }else{
          if(document.querySelector('.remove-coupon')){
            $.get('https://'+window.location.hostname+'/on/demandware.store/Sites-KendraScott-Site/en_US/COBilling-AddCouponCodeJson?couponCode=empty&couponAction=0&format=ajax', 
              (response) => {
                callback(prevValue);
              });
          }else{
            callback(prevValue);
          }          
        }
      },
      applyCode: function(code, callback) {
        if(window.location.href.indexOf("cart") > -1){    
          this.preApplyCodes(() => {
            const url = $('#cart-coupon-form').attr('action');
            const formData = getFormFieldsAsJson(document.querySelector('#cart-coupon-form'));
            formData['dwfrm_cart_couponCode'] = code;
            formData['dwfrm_cart_addCoupon'] = 'dwfrm_cart_addCoupon';
              $.post(url, formData, 
              (responsePost) => {
                $.get('https://'+window.location.hostname+'/cart', (response) => {
                    const orderValueEl = $(response).find('.bfx-total-grandtotal');
                    const value = orderValueEl.length > 0 ? 
                                    Number(orderValueEl.text().replace( /[^0-9.]/g, '').trim()) : 
                                    Number.POSITIVE_INFINITY;  
                     callback(value);                 
                });
              }); 
          });
        }else{
          $.get('https://'+window.location.hostname+'/on/demandware.store/Sites-KendraScott-Site/en_US/COBilling-AddCouponCodeJson?couponCode='+code+'&couponAction=add&format=ajax', 
              (responseGet) => {
                const checkout_value = responseGet.baskettotal;
                  $.get('https://'+window.location.hostname+'/on/demandware.store/Sites-KendraScott-Site/en_US/COBilling-AddCouponCodeJson?couponCode=empty&couponAction=0&format=ajax', 
                    (response) => {
                     callback(checkout_value);
                  });
              });
        }
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#dwfrm_cart_couponCode').value = bestCode;
        document.querySelector('#dwfrm_cart_couponCode').dispatchEvent(new Event('input', { bubbles: true } ));
        document.querySelector('#add-coupon').click();
      }
    },

  autoanything: {
      preApplyCodes: function(callback) {
         const orderValueEl = $('.cartTotals li span.b');
         const prevValue = orderValueEl.length > 0 ? 
                          Number(orderValueEl.first().text().replace( /[^0-9.]/g, '').trim()) : 
                          Number.POSITIVE_INFINITY;
                          console.log(prevValue);
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        this._applyCode(code, function(value) {
             callback(value);
          }); 
      },
      applyBestCode: function(bestCode) {
        document.querySelector('#txtPromotionalCode').value = bestCode;
        document.querySelector('#txtPromotionalCode').dispatchEvent(new MouseEvent('input', {bubbles: true}));
        document.querySelector('#btnRedeem').click();
      },
      _applyCode: function(code, callback) {
        const windowVariables = retrieveWindowVariables(["window.CART_ID","window.VISIT_ID","window.VISITOR_ID" ]);
        const cartId = windowVariables['window.CART_ID'];
        const visitId = windowVariables['window.VISIT_ID'];
        const visitorId = windowVariables['window.VISITOR_ID'];       
      $.ajax({
          url: 'https://www.autoanything.com/services/CartService.svc/ApplyPromoCode',
          type: 'POST',
          data: JSON.stringify({cartId:cartId, promoCode: code, visitId:visitId, visitorId:visitorId}),
           headers: {
                    'content-type': 'application/json;charset=UTF-8'
                  },
          success: (response) => {
              const value = (response.d.Payload.GrandtotalAmount.Amount).toFixed(2);
              callback(value);
          },
          error: (xhr, status, error) => {
             callback(Number.POSITIVE_INFINITY);
          }
        });
      },
    },

    trueandco: {
      id: 27177,
      preApplyCodes: (callback) => {
        const elTotal = $('.summary_price-total p:last-child');       
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);         
      },
      applyCode: (code, callback) => {
        var ts = Math.round(new Date().getTime());
        const cart_token = decodeURI(document.cookie.split(';').filter(function(c) { return c.indexOf('cartToken') !== -1 })[0]).trim().split('=')[1];
        const url = 'https://trueandco.com/api/v1/carts/'+cart_token+'?timestamp='+ts;
        $.ajax({
          url: url,
          type: 'PATCH',
          data: JSON.stringify({cart: { promo_code: code }}),
           headers: {
                    'content-type': 'application/json;charset=UTF-8'
                  },
          success: (response) => {
              const total = response.data.attributes.purchase_total;
               const value = total ? 
                          Number(total.replace( /[^0-9.]/g, '').trim()) : 
                          Number.POSITIVE_INFINITY;
                            callback(value);
          },
          error: (xhr, status, error) => {
            console.log(error);
            callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: (bestCode) => {
         document.querySelector('.input_discount #input-with-label').removeAttribute('disabled');
         document.querySelector('.input_discount .button.button_secondary').removeAttribute('disabled');
         document.querySelector('.input_discount #input-with-label').value = bestCode;
         document.querySelector('#input-with-label').dispatchEvent(new Event('input', {bubbles: true})); 
         document.querySelector('#input-with-label').dispatchEvent(new Event('change', {bubbles: true}));
         document.querySelector('#input-with-label').dispatchEvent(new Event('blur')); 
         document.querySelector('#input-with-label').dispatchEvent(new Event('focus'));
         setTimeout(() => {
          document.querySelector('.input_discount .button.button_secondary').click();
        }, 250);
      }
    },

    crocs: {
      id: 27177,
      preApplyCodes: (callback) => {
        const elTotal = $('#estimatedTotal');       
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);         
      },
      applyCode: (code, callback) => {
       const url = 'https://www.crocs.com/on/demandware.store/Sites-crocs_us-Site/default/Cart-API';
        $.ajax({
          url: url,
          type: 'POST',
          data: {action:'addcoupon', updates: 'approaching|promos|shipping|delivery', coupon: code },
           headers: {
                    'content-type': 'application/x-www-form-urlencoded; charset=UTF-8'
                  },
          success: (response) => {
              const value = response.data.cartEstimatedTotal;
              callback(value);
          },
          error: (xhr, status, error) => {
            console.log(error);
            callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: (bestCode) => {
         document.querySelector('#couponFld').value = bestCode;
         document.querySelector('#couponFld').dispatchEvent(new Event('input', {bubbles: true})); 
         document.querySelector('#addcoup').click();
      }
    },

    callawaygolfpreowned: {
      preApplyCodes: function(callback) {
        const elTotal = $('#basket-total .text-value');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        $.ajax({
          url: 'https://www.callawaygolfpreowned.com/on/demandware.store/Sites-CGPO5-Site/default/Cart-AddCouponToBasket',
          type: 'POST',
          data: {
            couponCode: code
          },
          success: () => {
            $.get('https://www.callawaygolfpreowned.com/cart', (responseGet) => {
              const elTotal = $(responseGet).find('#basket-total .text-value');
              const value = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
                      $.ajax({
                        url: 'https://www.callawaygolfpreowned.com/on/demandware.store/Sites-CGPO5-Site/default/Cart-DeleteCoupon',
                        type: 'POST',
                        data: {
                          couponCode: code
                        },
                        success: () => {  callback(value);  },
                        error: (xhr, status, error) => { callback(value); }
                      });
            });
          },
          error: (xhr, status, error) => {
             callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('input[name="couponCode"]').value = bestCode;
        document.querySelector('input[name="couponCode"]').dispatchEvent(new MouseEvent('input', { bubbles: true } ));
        document.querySelector('.couponAddBtn span').click();  
      }
    },


   olympiasports: {
      id: 3429, 
      preApplyCodes: function(callback) {
        const elTotal = $('[data-totals-component="grandTotal"] dd strong');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        const url = $('.promo-code-form ').attr('data-action-url');
        const csrf_token = $('.promo-code-form input[name="csrf_token"]').val();
        $.get('https://www.olympiasports.net'+url+'/?csrf_token='+csrf_token+'&couponCode='+code, 
          (response) => {
          if(response.totals){
            const value = response.totals.grandTotal;
            const totalValue = Number(value.replace( /[^0-9.]/g, '').trim())
            const locale = response.locale;
            const uuid =  response.totals.discounts[0].UUID;
            $.ajax({
              url: 'https://www.olympiasports.net/on/demandware.store/Sites-OlympiaSports-Site/'+locale+'/Cart-RemoveCouponLineItem?code='+code+'&uuid='+uuid,
              type: 'GET',
              success: () => { callback(totalValue); },
              error: () => { callback(totalValue); }
            });                 
          }else{
            callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#couponCode').value = bestCode;
        document.querySelector('#couponCode').dispatchEvent(new Event('input', {bubbles: true}));
        document.querySelector('button.promo-code-btn').click();
      }
    },

    edenbrothers: {
      id: 26537,
      preApplyCodes: (callback) => {
        const orderValueEl = $('.totals_all.cart-totals-value.cart-ordertotal-value');
        const prevValue = orderValueEl.length > 0 ? 
                          Number(orderValueEl.first().text().replace( /[^0-9.]/g, '').trim()) : 
                          Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: (code, callback) => {
        const url = $('form[name="order"]').attr('action');
        const formData = getFormFieldsAsJson(document.querySelector('form[name="order"]'));
        formData['coupon_code'] = code;
        formData['function'] = 'Apply Coupon';        
        $.post(url, formData, 
          (response) => {
            const orderValueEl = $(response).find('.totals_all.cart-totals-value.cart-ordertotal-value');
            const value = orderValueEl.length > 0 ? 
                              Number(orderValueEl.first().text().replace( /[^0-9.]/g, '').trim()) : 
                              Number.POSITIVE_INFINITY;
                              callback(value);
          });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#coupon_code').value = bestCode;
        document.querySelector('#coupon_code').dispatchEvent(new Event('input', { bubbles: true } ));
        document.querySelector('[data-id="Apply Coupon"]').click();
      }
    },


   webstaurantstore: {
      id: 2653, 
      preApplyCodes: function(callback) {
         const elTotal = $('.subtotal.cartpromo-subtotal');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {        
         $.post('https://www.webstaurantstore.com/shoppingcart:cart/applydiscountcode/', {discountCode: code }, 
          (response) => {
            if(response.cart){
                const value = response.cart.subtotal;                
                callback(value);
            }else{
              callback(Number.POSITIVE_INFINITY);
            }
          });
      },
      applyBestCode: (bestCode) => {
        location.reload();
      }
    },

    ezvacuum: {
      id: 3598, 
      preApplyCodes: function(callback) {
        const elTotal = $('#shopping-cart-totals-table tfoot tr:last-child td:last-child .price');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        $.ajax({
          url: 'https://www.ezvacuum.com/checkout/cart/couponPost',
          type: 'POST',
          data: {
            remove: 0,
            coupon_code: code
          },
          success: (data, textStatus, request) => {
            const locationUrl = request.getResponseHeader('location');
            $.get(locationUrl , (responseGet) => {
              const elTotal = $(responseGet).find('#shopping-cart-totals-table tfoot tr:last-child td:last-child .price');
              var value = 0;
              if( elTotal.length > 0 ){
                 $( elTotal ).each(function( index ) {
                  value += Number($( this ).text().replace( /[^0-9.]/g, '').trim());                
                 });
              }else{
                  value = Number.POSITIVE_INFINITY;
              }
              
              callback(value);
            });
          },
          error: (xhr, status, error) => {
             callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#coupon_code').value = bestCode;
        document.querySelector('#coupon_code').dispatchEvent(new MouseEvent('input', { bubbles: true } ));
        document.querySelector('button[value="Apply Coupon"]').click();  
      }
    },

  wondershare: {
      id: 6867, 
      preApplyCodes: function(callback) {
         const elTotal = $('.total .price, #total, #main .order_amount.success.font-muli, .span_total, .now-total');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {    
      const url = document.URL.split("/");
      const shopId = url[3];
      const order_id = getParam('order_id');
         $.post('https://store.wondershare.com/'+shopId+'/sdk/Bootstrap/Sdk.php', {order_id: order_id, operation: 'apply_coupon_code' , coupon_code: code }, 
          (response) => {
            if(response.data){
                const value = response.data.orderInfo.order_amount;                
                callback(value);
            }else{
              callback(Number.POSITIVE_INFINITY);
            }
          });
      },
      applyBestCode: (bestCode) => {
        const url = document.URL.split("/");
        const shopId = url[3];
        const order_id = getParam('order_id');
        $.post('https://store.wondershare.com/'+shopId+'/sdk/Bootstrap/Sdk.php', {order_id: order_id, operation: 'apply_coupon_code' , coupon_code: bestCode }, 
          (response) => { location.reload(); });
      }
    },

    lakeside: {
      id: 3921, 
      preApplyCodes: function(callback) {
         const elTotal = $('aside.order-sum__tab span');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        var ajaxurl = '';
         if(window.location.href.indexOf("shopping_cart") > -1){
           ajaxurl = $('#couponCodeForm').attr('action');           
         }else{
           ajaxurl = '/checkout/order_summary_container_acap.jsp';
         }
        const formData = getFormFieldsAsJson(document.querySelector('#couponCodeForm'));
        formData['/atg/commerce/promotion/CouponFormHandler.couponClaimCode'] = code;
        $.ajax({
          url: 'https://www.lakeside.com'+ajaxurl,
          type: 'POST',
          data: formData,
          success: (response) => { 
            const orderValueEl = $(response).find('aside.order-sum__tab span');
            const value = orderValueEl.length > 0 ? 
                              Number(orderValueEl.first().text().replace( /[^0-9.]/g, '').trim()) : 
                              Number.POSITIVE_INFINITY;
                              callback(value);     
          },
          error: (xhr, status, error) => {
             callback(Number.POSITIVE_INFINITY);
          }
        }); 
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#applyCouponInput').value = bestCode;
        document.querySelector('#applyCouponInput').dispatchEvent(new MouseEvent('input', { bubbles: true } ));
        document.querySelector('#applyCouponCode, #applyButton').click();  
      }
    },

    mattressfirm: {
      id: 15959,
      preApplyCodes: function(callback) {
        const elTotal = $('tr.order-total td.order-value');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
         if(window.location.href.indexOf("shopping_cart") > -1){
          const url = $('form[name="dwfrm_cart"]').attr('action');
          const formData = getFormFieldsAsJson(document.querySelector('form[name="dwfrm_cart"]'));
          formData['dwfrm_cart_couponCode'] = code;
          formData['dwfrm_cart_addCoupon'] = 'true';
          $.ajax({
            url: url+'?format=ajax',
            type: 'POST',
            data: formData,
            success: (response, status, xhr) => {
              if (response !== null) {
                const elTotal = $(response).find('tr.order-total td.order-value');
                const value = elTotal.length > 0 ? 
                              Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                              Number.POSITIVE_INFINITY;                
                callback(value);
              } else {
                callback(Number.POSITIVE_INFINITY);
              }
            },
            error: (xhr, status, error) => {
              console.log(error);
              callback(Number.POSITIVE_INFINITY);
            }
          });
        }else{
           $.get('https://www.mattressfirm.com/on/demandware.store/Sites-Mattress-Firm-Site/default/Cart-AddCouponCheckoutJson?couponCode='+code+'&format=ajax', (response) => {             
              $.get(window.location.href, (responseGet) => {             
                const elTotal = $(responseGet).find('tr.order-total td.order-value');
                  const value = elTotal.length > 0 ? 
                                Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                                Number.POSITIVE_INFINITY;
                  callback(value);
                  });
            });
        }
      },
      applyBestCode: (bestCode) => {
        location.reload();  
      }
    },


    kirklands: {
      id: 6474,
      preApplyCodes: function(callback) {
        const elTotal = $('#estimated-grand-total, #grandTotalData');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        var url, formMethod, formData;
         if(window.location.href.indexOf("basket") > -1){
          url = $('form[name="basket_body"]').attr('action');
          formData = getFormFieldsAsJson(document.querySelector('form[name="basket_body"]'));
          formData['checkoutAction'] = '4';
          formData['promoCode'] = code;
          formData['submitPromotionCode'] = 'Submit';
          formMethod = 'GET';
        }else{
          url = '/checkout/update_award_in_order.cmd';
          formData = getFormFieldsAsJson(document.querySelector('form[name="paymentForm"]'));
          formData['awardAction'] = '1';
          formData['awardCode'] = code;
          formData['promoCode'] = code;
          formMethod = 'POST';
        }
          $.ajax({
            url: 'https://www.kirklands.com'+url,
            type: formMethod,
            data: formData,
            success: (response, status, xhr) => {
                const elTotal = $(response).find('#estimated-grand-total, #grandTotalData');
                const value = elTotal.length > 0 ? 
                              Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                              Number.POSITIVE_INFINITY;                
                callback(value);
            },
            error: (xhr, status, error) => {
              console.log(error);
              callback(Number.POSITIVE_INFINITY);
            }
          });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#promoCode').value = bestCode;
        document.querySelector('#promoCode').dispatchEvent(new MouseEvent('input', { bubbles: true } ));
        document.querySelector('input[name="submitPromotionCode"], #submitPromotionCode').click();  
      }
    },

    lens: {
      id: 1088,
      preApplyCodes: function(callback) {
        const elTotal = $('#orderTotal-cell');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
          const url = $('form[name="frm"]').attr('action');
          const formData = getFormFieldsAsJson(document.querySelector('form[name="frm"]'));
          formData['coupcode'] = code;
          $.ajax({
            url: url,
            type: 'POST',
            data: formData,
            success: (response, status, xhr) => {
                const elTotal = $(response).find('#orderTotal-cell');
                const value = elTotal.length > 0 ? 
                              Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                              Number.POSITIVE_INFINITY;   
                const formData2 = formData;
                formData2['coupcode'] = '';
                formData2['typed_coupcode'] = code;
                formData2['dodelcoup'] = 'yes';
                  $.ajax({
                    url: url,
                    type: 'POST',
                    data: formData2,
                    success: (response, status, xhr) => { callback(value); },
                    error: (xhr, status, error) => { callback(value); }
                  });
            },
            error: (xhr, status, error) => {
              console.log(error);
              callback(Number.POSITIVE_INFINITY);
            }
          });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#coupcode').value = bestCode;
        document.querySelector('#coupcode').dispatchEvent(new MouseEvent('input', { bubbles: true } ));
        document.querySelector('#coupapply').click(); 
      }
    },


    fragrancex: {
      id: 831,
      preApplyCodes: function(callback) {
        const elTotal = $('.cartsubtotal.ptn10 p.h4.ptn:last, .order-summary tfoot td');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        var url, formMethod, formData;
         if(window.location.href.indexOf("cart") > -1){
          const ts = Math.round(new Date().getTime());
          url = $('form#CardTableAsyncForm').attr('data-ajax-url');
          formData = getFormFieldsAsJson(document.querySelector('form#CardTableAsyncForm'));          
          formData['code'] = code;
          formData['X-Requested-With'] = 'XMLHttpRequest';
          formData['_'] = ts;
           $.ajax({
            url: 'https://www.fragrancex.com'+url,
            type: 'GET',
            data: formData,
            success: (response, status, xhr) => {
                const elTotal = $(response).find('.cartsubtotal.ptn10 p.h4.ptn:last, .order-summary tfoot td');
                const value = elTotal.length > 0 ? 
                              Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                              Number.POSITIVE_INFINITY;                
                callback(value);
            },
            error: (xhr, status, error) => {
              console.log(error);
              callback(Number.POSITIVE_INFINITY);
            }
          });
        }else{
          formData = getFormFieldsAsJson(document.querySelector('form#OrderInfoForm'));
          formData['CoupongGiftCertCode'] = code;
           $.ajax({
            url: 'https://www.fragrancex.com/Widgets/CheckoutCouponGiftCert/AjaxCheckoutCouponGiftCert',
            type: 'POST',
            data: formData,
            success: (response, status, xhr) => {
                 $.ajax({
                  url: 'https://www.fragrancex.com/Widgets/SideOrderSummary/AjaxSideOrderSummary',
                  type: 'POST',
                  data: formData,
                  success: (response, status, xhr) => {
                      const elTotal = $(response).find('.cartsubtotal.ptn10 p.h4.ptn:last, .order-summary tfoot td');
                      const value = elTotal.length > 0 ? 
                                    Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                                    Number.POSITIVE_INFINITY;                
                      callback(value);
                  },
                  error: (xhr, status, error) => {
                    console.log(error);
                    callback(Number.POSITIVE_INFINITY);
                  }
                });
             },
            error: (xhr, status, error) => {
              console.log(error);
              callback(Number.POSITIVE_INFINITY);
            }
          });
        }         
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#CartTableAsyncSection #name, #CoupongGiftCertCode').value = bestCode;
        document.querySelector('#CartTableAsyncSection #name, #CoupongGiftCertCode').dispatchEvent(new MouseEvent('input', { bubbles: true } ));
        document.querySelector('#CardTableAsyncForm .ga-submit-coupon, #ApplyCouponGiftCert').click();  
      }
    },


    katespade: {
      id: 4540,
      preApplyCodes: (callback) => {
        const orderValueEl = $('.cart-order-totals .order-total .order-value');
        const prevValue = orderValueEl.length > 0 ? 
                          Number(orderValueEl.first().text().trim().substr(1)) : 
                          Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: (code, callback) => {
      if(window.location.href.indexOf("shopping-bag") > -1){ 
        const url = $('#cart-items-form').attr('action');
        const formData = getFormFieldsAsJson(document.querySelector('#cart-items-form'));
        formData['dwfrm_cart_couponCode'] = code;
        formData['dwfrm_cart_addCoupon'] = 'dwfrm_cart_addCoupon';
        $.post(url, formData, 
          (response) => {
            const orderValueEl = $(response).find('.cart-order-totals .order-total .order-value');
            const value = orderValueEl.length > 0 ? 
                              Number(orderValueEl.first().text().trim().substr(1)) : 
                              Number.POSITIVE_INFINITY;
            callback(value);
          });
      }else{
         $.get('https://'+window.location.hostname+'/on/demandware.store/Sites-Shop-Site/en_US/Cart-AddCouponJson?couponCode='+code+'&format=ajax', 
              (responseGet) => {
                  $.get('https://'+window.location.hostname+'/on/demandware.store/Sites-Shop-Site/en_US/COBilling-UpdateSummary?format=ajax', 
                    (response) => {
                      const orderValueEl = $(response).find('.order-total .order-value');
                      const value = orderValueEl.length > 0 ? 
                                    Number(orderValueEl.first().text().trim().substr(1)) : 
                                    Number.POSITIVE_INFINITY;
                          $.get('https://'+window.location.hostname+'/on/demandware.store/Sites-Shop-Site/en_US/Cart-DeleteCouponJson?couponCode='+code+'&format=ajax', 
                          (response) => {                                          
                            callback(value);
                        });
                  });
              });
          }
      },
      applyBestCode: (bestCode) => {
        try{ document.querySelector('#dwfrm_billing_usegiftorpromo').click(); } catch(e){ } 
        document.querySelector('#dwfrm_cart_couponCode, #dwfrm_billing_couponCode').value = bestCode;
        document.querySelector('#dwfrm_cart_couponCode, #dwfrm_billing_couponCode').dispatchEvent(new Event('input', { bubbles: true } ));
        document.querySelector('#add-coupon').click();
      }
    },


    'softsurroundings': {
      id: 1891,
      preApplyCodes: function(callback) {
        const elTotal = $('#totals .prices b');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;        
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        $.post('https://'+window.location.hostname+'/itemoptions/', {promoCode: code, action: '1', pageType: 'promoCode'}, 
          () => {
            const url = window.location.href;
            $.get(url, 
              (response) => {
                const elTotal = $(response).find('#totals .prices b');
                const value = elTotal.length > 0 ? 
                              Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                              Number.POSITIVE_INFINITY;
                callback(value);
              });
          });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('.promoCodeGenInput').value = bestCode;
        document.querySelector('.promoCodeGenInput').dispatchEvent(new Event('input', { bubbles: true } ));
        document.querySelector('#ajaxPromoCode').click();
      }
    },

    haband: {
      id: 905, 
      preApplyCodes: function(callback) {
        const elTotal = $('#checkoutOrderSummaryOrderTotal');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        var url;
        if(window.location.href.indexOf("guest") > -1){
          url = 'https://www.haband.com/guest/order/promoCode';          
        }else{
          url = 'https://www.haband.com/order/promoCode';
        }
        $.ajax({
          url: url,
          type: 'PUT',
          data: JSON.stringify({ promoCodes: [code] }),
          headers: { 'content-type': 'application/json' },
          success: (data, textStatus, request) => {
            const value = data.orderSummary.orderTotal;
            callback(value);
          },
          error: (xhr, status, error) => {
             callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#promoCodeViewPromoCodeField').value = bestCode;
        document.querySelector('#promoCodeViewPromoCodeField').dispatchEvent(new MouseEvent('input', { bubbles: true } ));
        document.querySelector('#promoCodeViewPromoCodeApply').click();  
      }
    },

    venus: {
      id: 7719, 
      preApplyCodes: function(callback) {  
        const elTotal = $('#ctl00_Body1_lblTotal, #OrderTotal, #orderSummaryOrderTotalSpan');
        const windowVariables = retrieveWindowVariables(["window.NREUM"]);
        const xpid = windowVariables["window.NREUM"].loader_config.xpid;
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
      $.ajax({
          url: 'https://www.venus.com/api/Promotions',
          type: 'DELETE',
          headers: {
          'x-newrelic-id': xpid
          },
          success: () => { callback(prevValue); },
          error: () => { callback(prevValue); }
        });        
      },
      applyCode: function(code, callback) {
       this.preApplyCodes(() => {       
        this._applyCode(code, function(value) {
          callback(value);
        }); 
       });
      },
      applyBestCode: function(bestCode) {
        this._applyCode(bestCode, function() {
            location.reload();
        }) ;
      },
      _applyCode: (code, callback) => {
        const windowVariables = retrieveWindowVariables(["window.NREUM"]);
        const xpid = windowVariables["window.NREUM"].loader_config.xpid;
       $.ajax({
            url: 'https://www.venus.com/api/Promotions',
            type: 'POST',
            headers: {
            'x-newrelic-id': xpid
            },
            data: {
              PromotionCode: code,
            },
            success: (data) => {
              $.ajax({
                  url: 'https://www.venus.com/api/order',
                  type: 'GET',
                  headers: {
                  'x-newrelic-id': xpid
                  },
                  success: (response) => {                  
                     const value = response.Pricing.Total;
                     callback(value);  
                  },error: () => {
                    callback(Number.POSITIVE_INFINITY);
                  }
              });
            },
            error: () => {
              callback(Number.POSITIVE_INFINITY);
            }
        });
      }
    },

    personalizationmall: {
      id: 3991,
      preApplyCodes: (callback) => {
        const orderValueEl = $('.table__order-checkout tr:last-child td:nth-child(2)');
        console.log(orderValueEl);
        const prevValue = orderValueEl.length > 0 ? 
                          Number(orderValueEl.first().text().replace( /[^0-9.]/g, '').trim()) :
                          Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: (code, callback) => {
        const url = 'https://www.personalizationmall.com/checkout.aspx';
        const formData = getFormFieldsAsJson(document.querySelector('#aspnetForm'));
        formData['ctl00$mainContent$txtCouponCode'] = code;
        formData['ctl00$mainContent$cmdReviseDiscout'] = 'Apply Coupon';
        $.post(url, formData, 
          (response) => {
            const orderValueEl = $(response).find('.table__order-checkout tr:last-child td:nth-child(2)');
            const value = orderValueEl.length > 0 ? 
                              Number(orderValueEl.first().text().replace( /[^0-9.]/g, '').trim()) : 
                              Number.POSITIVE_INFINITY;
            callback(value);
          });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('input[name="ctl00$mainContent$txtCouponCode"]').value = bestCode;
        document.querySelector('input[name="ctl00$mainContent$txtCouponCode"]').dispatchEvent(new Event('input', { bubbles: true } ));
        document.querySelector('input[name="ctl00$mainContent$cmdReviseDiscout"]').click();
      }
    },

    mypillow: {
      id: 24862, 
      preApplyCodes: function(callback) {  
        const elTotal = $('tr.grand.totals span.price');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
           const windowVariables = retrieveWindowVariables(["window.checkoutConfig","window.NREUM"]);
           const quoteId = windowVariables["window.checkoutConfig"].quoteId;
           const xpid = windowVariables["window.NREUM"].loader_config.xpid;
           $.ajax({
                url: 'https://www.mypillow.com/rest/default/V1/guest-carts/'+quoteId+'/coupons/'+code,
                type: 'PUT',
                headers: {
                'x-newrelic-id': xpid
                },
                success: (data) => {
                  const ts = Math.round(new Date().getTime());
                      $.ajax({
                          url: 'https://www.mypillow.com/rest/default/V1/guest-carts/'+quoteId+'/payment-information?_='+ts,
                          type: 'GET',
                          headers: {
                          'x-newrelic-id': xpid
                          },
                          success: (response) => {                  
                             const value = response.totals.base_grand_total;
                              $.ajax({
                                  url: 'https://www.mypillow.com/rest/default/V1/guest-carts/'+quoteId+'/coupons',
                                  type: 'DELETE',
                                  headers: {
                                  'x-newrelic-id': xpid
                                  },
                                  success: (response) => {
                                       callback(value.toFixed(2));
                                  }
                                });
                          }
                        });
                },
                error: (xhr, status, error) => {
                  console.log(error);
                  callback(Number.POSITIVE_INFINITY);
                }
              });
      },
      applyBestCode: (bestCode) => {
           const windowVariables = retrieveWindowVariables(["window.checkoutConfig","window.NREUM"]);
           const quoteId = windowVariables["window.checkoutConfig"].quoteId;
           const xpid = windowVariables["window.NREUM"].loader_config.xpid;
           $.ajax({
                url: 'https://www.mypillow.com/rest/default/V1/guest-carts/'+quoteId+'/coupons/'+bestCode,
                type: 'PUT',
                headers: {
                'x-newrelic-id': xpid
                },
                success: (data) => {location.reload();}
            });       
      }
    },

     torrid: {
      id: 1670,
      preApplyCodes: function(callback) {
        const elTotal = $('.orderTotal');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
         if(window.location.href.indexOf("cart") > -1){
          const url = $('form[name="dwfrm_cart"]').attr('action');
          const formData = getFormFieldsAsJson(document.querySelector('form[name="dwfrm_cart"]'));
          formData['dwfrm_cart_couponCode'] = code;
          formData['dwfrm_cart_addCoupon'] = 'dwfrm_cart_addCoupon';
          $.ajax({
            url: url,
            type: 'POST',
            data: formData,
            success: (response, status, xhr) => {
                const elTotal = $(response).find('.orderTotal');
                const value = elTotal.length > 0 ? 
                              Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                              Number.POSITIVE_INFINITY; 
                const formData2 = getFormFieldsAsJson(document.querySelector('form[name="dwfrm_cart"]'));
                  formData2['dwfrm_cart_coupons_i0_deleteCoupon'] = '';
                  formData2['dwfrm_cart_couponCode'] = '';
                  $.post(url, formData2, 
                    (response) => {
                     callback(value);
                  });
            },
            error: (xhr, status, error) => {
              console.log(error);
              callback(Number.POSITIVE_INFINITY);
            }
          });
        }else{
           $.get('https://www.torrid.com/on/demandware.store/Sites-torrid-Site/default/Cart-AddCouponJson?couponCode='+code+'&format=ajax', (response) => {             
                const value = response.baskettotal;
                $.get('https://www.torrid.com/on/demandware.store/Sites-torrid-Site/default/COBilling-RemoveCouponJson?couponCode='+code+'&format=ajax', (responseremove) => {             
                  callback(value);
                });
            });
        }
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#dwfrm_cart_couponCode, #dwfrm_billing_couponCode').value = bestCode;
        document.querySelector('#dwfrm_cart_couponCode, #dwfrm_billing_couponCode').dispatchEvent(new Event('input', { bubbles: true } ));
        document.querySelector('#add-coupon, #apply-coupon').click();
      }
    },

    bissell: {
      id: 26844, 
      preApplyCodes: function(callback) {
        const elTotal = $('p.grand-total');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        const el = $('button.remove-coupon');
        var url = null;
        if (el !== null && el !== undefined && el.length > 0) {
          const code = el.attr('data-code');
          const uuid = el.attr('data-uuid');
          url = 'https://www.bissell.com/on/demandware.store/Sites-bissell-Site/en_US/Cart-RemoveCouponLineItem' +
                      '?code=' + code +
                      '&uuid=' + uuid;
        } else if (this.pumaPrevCode !== null && this.pumaPrevCode !== undefined) {
          url = 'https://www.bissell.com/on/demandware.store/Sites-bissell-Site/en_US/Cart-RemoveCouponLineItem' +
                      '?code=' + this.pumaPrevCode +
                      '&uuid=' + this.pumaPrevUuid;
        }
        if (url !== null) {
          $.ajax({
            url: url,
            type: 'GET',
            data: {},
            success: () => {
              callback(prevValue);
            },
            error: (xhr, status, error) => {
              console.log(error);
              callback(prevValue);
            }
          });
        } else {
          callback(prevValue);
        }
      },
      applyCode: function(code, callback) {
        this.preApplyCodes(() => {
          this.pumaPrevCode = code;
          console.log('Apply Code: ', code);
          const csrf_token = $('input[name*="csrf_token"]').first().val();
          const url = 'https://www.bissell.com/on/demandware.store/Sites-bissell-Site/en_US/Cart-AddCoupon' +
                      '?couponCode=' + code + 
                      '&csrf_token=' + csrf_token;
          $.ajax({
            url: url,
            type: 'GET',
            data: {},
            success: (response, status, xhr) => {
              if (response !== null) {
                const totals = response.totals;
                if (totals !== null && totals !== undefined) {
                  const value = totals.grandTotal !== null ? 
                            Number(totals.grandTotal.replace( /[^0-9.]/g, '').trim()) : 
                            Number.POSITIVE_INFINITY;
                  $.get('https://www.bissell.com'+window.location.pathname, (responseGet) => {
                    const el = $(responseGet).find('button.remove-coupon');
                    if (el !== null && el !== undefined && el.length > 0) {
                      this.pumaPrevUuid = el.attr('data-uuid');                      
                    }
                    callback(value);
                  });
                  return;
                }
              }
              callback(Number.POSITIVE_INFINITY);
            },
            error: (xhr, status, error) => {
              console.log(error);
            }
          });
        });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#couponCode').value = bestCode;
        document.querySelector('#couponCode').dispatchEvent(new MouseEvent('input', { bubbles: true } ));
        document.querySelector('.promo-code-submit button').disabled = false;  
        document.querySelector('.promo-code-submit button').click();  
        setTimeout(function(){
          try {document.querySelector('#couponInterceptModal .btn-coupon-intercept-delete').click(); } catch (e) {}
        }, 1000);
      }
    },

    statelinetack: {
      id: 1557,
      preApplyCodes: (callback) => {
        const orderValueEl = $('.cart-checkout-subtotal-price');
        console.log(orderValueEl);
        const prevValue = orderValueEl.length > 0 ? 
                          Number(orderValueEl.first().text().replace( /[^0-9.]/g, '').trim()) :
                          Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: (code, callback) => {
        var url, formData;
      if(window.location.href.indexOf("cart") > -1){
        url = 'https://www.statelinetack.com/cart.aspx';
        formData = getFormFieldsAsJson(document.querySelector('#aspnetForm'));
        formData['ctl00$ctl00$CenterContentArea$MainContent$ctl00$txtPromoCode'] = code;
        formData['ctl00$ctl00$CenterContentArea$MainContent$ctl00$btnPromoCode'] = 'Apply';
      }else{
        url = 'https://www.statelinetack.com/BillingShipping.aspx';
        formData = getFormFieldsAsJson(document.querySelector('#aspnetForm'));
        formData['ctl00$MainContent$billingShipping$txtPromoCode'] = code;
        formData['ctl00$MainContent$billingShipping$btnPromoCode'] = 'Apply';
      }
        $.post(url, formData, 
          (response) => {
            const orderValueEl = $(response).find('.cart-checkout-subtotal-price');
            const value = orderValueEl.length > 0 ? 
                              Number(orderValueEl.first().text().replace( /[^0-9.]/g, '').trim()) : 
                              Number.POSITIVE_INFINITY;
            callback(value);
          });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#ctl00_ctl00_CenterContentArea_MainContent_ctl00_txtPromoCode, #ctl00_MainContent_billingShipping_txtPromoCode').value = bestCode;
        document.querySelector('#ctl00_ctl00_CenterContentArea_MainContent_ctl00_txtPromoCode, #ctl00_MainContent_billingShipping_txtPromoCode').dispatchEvent(new Event('input', { bubbles: true } ));
        document.querySelector('#ctl00_ctl00_CenterContentArea_MainContent_ctl00_btnPromoCode, #ctl00_MainContent_billingShipping_btnPromoCode').click();
      }
    },

    pier1: {
      id: 8283, 
      preApplyCodes: function(callback) {
         const elTotal = $('.order-row.order-total .orderdetails-pricing');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        const ts = Math.round(new Date().getTime());
        const url = 'https://www.pier1.com/on/demandware.store/Sites-pier1_us-Site/default/Cart-AddCoupon?couponCode='+code+'&imgrole=productLine&isAppliedByFeaturedCode=false&_='+ts;
         $.ajax({
            url: url,
            type: 'GET',
              headers: {
                    'accept': 'application/json, text/javascript, */*; q=0.01'
                  },
            success: (response, status, xhr) => {
            if(response.order_total){
                const value = response.order_total.value;
                const ts2 = Math.round(new Date().getTime());
                $.get('https://www.pier1.com/on/demandware.store/Sites-pier1_us-Site/default/Cart-RemoveCoupon?couponCode='+code+'&_='+ts2, 
                  (response) => {
                    callback(value);
              });
            }else{
              callback(Number.POSITIVE_INFINITY);
            }
          }
        });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('input[name="coupon_code"]').value = bestCode;  
        document.querySelector('input[name="coupon_code"]').dispatchEvent(new Event('input', {bubbles: true})); 
        document.querySelector('input[name="coupon_code"]').dispatchEvent(new Event('change', {bubbles: true}));
        document.querySelector('input[name="coupon_code"]').dispatchEvent(new Event('blur')); 
        document.querySelector('input[name="coupon_code"]').dispatchEvent(new Event('focus'));      
        document.querySelector('button.submit-coupon').click();
      }
    },

  rockbottomgolf: {
      id: 1439, 
      preApplyCodes: function(callback) {
         const elTotal = $('.cart-total-value.cart-total-grandTotal span, .cart-priceItem--total [data-test="cart-price-value"]');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        const windowVariables = retrieveWindowVariables(["BCData"]);
        const csrf_token = windowVariables.BCData.csrf_token;
        var url;
         if(window.location.href.indexOf("cart") > -1){
          url = 'https://www.rockbottomgolf.com/remote/v1/apply-code';
           $.ajax({
              url: url,
              type: 'POST',
              data: {code: code},
              headers: {
                    'x-xsrf-token': csrf_token
                  },
              success: (response, status, xhr) => {
              if(response.data && response.data.status=='success'){
                   $.ajax({
                          url: 'https://www.rockbottomgolf.com/api/storefront/cart',
                          type: 'GET',
                          headers: {
                                'x-xsrf-token': csrf_token
                              },
                          success: (responseget, status, xhr) => {
                            const value = responseget[0].cartAmount;
                            callback(value);
                          }
                        });
              }else{
                callback(Number.POSITIVE_INFINITY);
              }
            },
              error: (xhr, status, error) => {
                console.log(error);
                callback(Number.POSITIVE_INFINITY);
            }
          });
       }else{
           $.ajax({
              url: 'https://www.rockbottomgolf.com/api/storefront/checkout-settings',
              type: 'GET',
              headers: {
                    'x-xsrf-token': csrf_token,
                     'x-api-internal': 'This API endpoint is for internal use only and may change in the future'
                  },
              success: (responseGet, status, xhr) => {
                const checkoutId = responseGet.context.checkoutId; 
                 url = 'https://www.rockbottomgolf.com/api/storefront/checkouts/'+checkoutId+'/coupons?include=cart.lineItems.physicalItems.options%2Ccart.lineItems.digitalItems.options%2Ccustomer%2Ccustomer.customerGroup%2Cpayments%2Cpromotions.banners%2Cconsignments.availableShippingOptions';
                 $.ajax({
                      url: url,
                      type: 'POST',
                      data: JSON.stringify({couponCode: code}),
                      headers: {
                            'x-xsrf-token': csrf_token,
                            'content-type': 'application/json'
                          },
                      success: (response, status, xhr) => {
                          const value = response.cart.cartAmount;
                          callback(value);
                    },
                      error: (xhr, status, error) => {
                        console.log(error);
                        callback(Number.POSITIVE_INFINITY);
                    }
                  });
            }
          });           
       }
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#couponcode, input[name="redeemableCode"]').value = bestCode;  
        document.querySelector('#couponcode, input[name="redeemableCode"]').dispatchEvent(new Event('input', {bubbles: true}));     
        document.querySelector('.coupon input[type="submit"], #applyRedeemableButton').click();
      }
    },


    eyeconic: {
      id: 4540,
      preApplyCodes: (callback) => {
        const orderValueEl = $('#orderSummary-orderTotal, .order-total td:last-child');
        const prevValue = orderValueEl.length > 0 ? 
                          Number(orderValueEl.first().text().trim().substr(1)) : 
                          Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: (code, callback) => {
         if(window.location.href.indexOf("shoppingbag") > -1){ 
         $.get('https://'+window.location.hostname+'/on/demandware.store/Sites-eyeconic-Site/default/Cart-AddCouponJson?format=ajax&couponCode='+code+'&source=cart', 
          (responseGet) => {
            $.get('https://'+window.location.hostname+'/on/demandware.store/Sites-eyeconic-Site/default/Cart-UpdateSummary', 
              (response) => {
              const orderValueEl = $(response).find('#orderSummary-orderTotal');
              const value = orderValueEl.length > 0 ? 
                            Number(orderValueEl.first().text().trim().substr(1)) : 
                            Number.POSITIVE_INFINITY;
                $.get('https://'+window.location.hostname+'/on/demandware.store/Sites-eyeconic-Site/default/Cart-RemoveCoupon?couponCode='+code, 
                (response) => {                                          
                  callback(value);
              }).fail(function() {
               callback(Number.POSITIVE_INFINITY);
              }); 
            }).fail(function() {
              callback(Number.POSITIVE_INFINITY);
            }); 
          }).fail(function() {
            callback(Number.POSITIVE_INFINITY);
          }); 
       }else{
        $.get('https://'+window.location.hostname+'/on/demandware.store/Sites-eyeconic-Site/default/Cart-AddCouponJson?format=ajax&couponCode='+code, 
        (responseGet) => {
          const value = responseGet.baskettotal;
          $.get('https://'+window.location.hostname+'/on/demandware.store/Sites-eyeconic-Site/default/Cart-RemoveCoupon?couponCode='+code, 
            (response) => {                                          
              callback(value);
          }).fail(function() {
            callback(Number.POSITIVE_INFINITY);
          }); 
        }).fail(function() {
         callback(Number.POSITIVE_INFINITY);
        }); 
       }
      },
      applyBestCode: (bestCode) => {
        try {document.querySelector('#dwfrm_billing_showGCAndPromoSection').click()} catch (e) {}
        document.querySelector('#promo-code-entry, #dwfrm_billing_couponCode').value = bestCode;
        document.querySelector('#promo-code-entry, #dwfrm_billing_couponCode').dispatchEvent(new Event('input', { bubbles: true } ));
        document.querySelector('#promo-apply-button, #add-coupon').click();
      }
    },

    russellstover: {
      id: 2982,
      preApplyCodes: (callback) => {
        const elTotal = $('#order_total tr:last-child td:last-child');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: (code, callback) => {        
        const url = 'https://www.russellstover.com/AjaxRESTPromotionCodeApply';
        const formData = getFormFieldsAsJson(document.querySelector('form[name="PromotionCodeFormorderSummary"]'));
        formData['promoCode'] = code;
        $.ajax({
          url: url,
          type: 'POST',
          data: formData,
          success: (response) => {
            var getUrl = '';
            const catalogId = $('#PromotionCodeFormorderSummary input[name="catalogId"]').val();
            var storeId = $('#PromotionCodeFormorderSummary input[name="storeId"]').val();
            var langId = $('input[name="langId"]').val();
            const orderId = $('#PromotionCodeFormorderSummary input[name="orderId"]').val();
            if(window.location.href.indexOf("AjaxOrderItemDisplayView") > -1){
              getUrl = 'https://www.russellstover.com/ShopCartDisplayView?shipmentType=single&catalogId='+catalogId+'&langId='+langId+'&storeId='+storeId;
            }else{
              getUrl = 'https://www.russellstover.com/CurrentOrderInformationView?catalogId='+catalogId+'&langId='+langId+'&storeId='+storeId+'&orderId='+orderId+'&fromPage=shippingBillingPage&shipmentTypeId=1&fromPage=shippingBillingPage';
            }
             $.ajax({
                  url: getUrl,
                  type: 'POST',
                  data: {
                    'objectId': '',
                    'requesttype': 'ajax'
                  },
                  success: (response) => {                    
                    const elTotal =  $(response).find('#order_total tr:last-child td:last-child');                   
                    const value = elTotal.length > 0 ? 
                                  Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                                  Number.POSITIVE_INFINITY;              

                    const formData2 = formData;
                    formData2['taskType'] = 'R';                    
                    var removeUrl = 'https://www.russellstover.com/AjaxRESTPromotionCodeRemove';
                       $.ajax({
                            url: removeUrl,
                            type: 'POST',
                            data: formData2,
                            success: (response) => { callback(value); },
                            error: (xhr, status, error) => {callback(value); }
                          });
                  }
                });
          },
          error: (xhr, status, error) => {
            console.log(error);
            callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: (bestCode) => {
         document.querySelector('#promoCodeorderSummary').value = bestCode;
         document.querySelector('#promoCodeorderSummary').dispatchEvent(new Event('input', {bubbles: true}));
         document.querySelector('#PromotionCodeFormorderSummary #WC_PromotionCodeDisplay_links_1').click();
      }
    },

    hp: {
      id: 198, 
      preApplyCodes: function(callback) {
        const elTotal = $('#cartSliderTotal, #rOrderTotal');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        const windowVariables = retrieveWindowVariables(["absoluteURL"]);
        const url = windowVariables.absoluteURL;
        const orderID = $('#orderId').val();
        var refreshUrl;
        if(window.location.href.indexOf("AjaxOrderItemDisplayView") > -1){
          refreshUrl = 'RefreshCart';
        }else{
          refreshUrl = 'RefreshCheckoutCart';
        }
        $.ajax({
          url: url+'AjaxPromotionCodeManage',
          type: 'POST',
          data: {promoCode:code,taskType:'A',orderId:orderID },
          success: (response, status, xhr) => {
            $.ajax({
              url: url+'AjaxOrderChangeServiceItemUpdate',
              type: 'POST',
              data: {promoCode:code,taskType:'A',orderId:orderID },
              success: (response, status, xhr) => {
                const geturl = url+refreshUrl+'?ajax=true';
                $.ajax({
                  url: geturl,
                  type: 'GET',
                  success: (response, status, xhr) => {
                    const total = $(response).find('#cartSliderTotal, #rOrderTotal'); 
                    const value = total.length > 0 ? 
                      Number(total.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
                      $.ajax({
                        url: url+'AjaxPromotionCodeManage',
                        type: 'POST',
                        data: {promoCode:code,taskType:'R',orderId:orderID },
                        success: (response, status, xhr) => { callback(value); },
                        error: (xhr, status, error) => { callback(value); }
                      });                    
                  },
                  error: (xhr, status, error) => {
                    callback(Number.POSITIVE_INFINITY);
                  }
                });
              },
              error: (xhr, status, error) => {
                callback(Number.POSITIVE_INFINITY);
              }
            });
          },
          error: (xhr, status, error) => {
            callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: (bestCode) => {
        const windowVariables = retrieveWindowVariables(["absoluteURL"]);
        const url = windowVariables.absoluteURL;
        const orderID = $('#orderId').val();
         $.ajax({
          url: url+'AjaxPromotionCodeManage',
          type: 'POST',
          data: {promoCode:bestCode,taskType:'A',orderId:orderID },
          success: (response) => {
             $.ajax({
              url: url+'AjaxOrderChangeServiceItemUpdate',
              type: 'POST',
              data: {promoCode:bestCode,taskType:'A',orderId:orderID },
              success: (response) => {
                location.reload();
              }
            });
          }
        });
      }
    },

    kinguin: {
      id: 3598, 
      preApplyCodes: function(callback) {
        const elTotal = $('tr.grand_total td:last-child');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        $.ajax({
          url: 'https://www.kinguin.net/checkout/cart/couponPostAjax',
          type: 'POST',
          data: {
            remove: 0,
            coupon_code: code
          },
          success: (data, textStatus, request) => {
            const html = data.html;
              const elTotal = $(html).find('tr.grand_total td:last-child');
              const value = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
                $.ajax({
                    url: 'https://www.kinguin.net/checkout/cart/couponPostAjax',
                    type: 'POST',
                    data: {
                      remove: 1,
                      coupon_code: code
                    },
                    success: (data, textStatus, request) => {callback(value);},
                    error: (xhr, status, error) => {callback(value);}
                });
          },
          error: (xhr, status, error) => {
             callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#coupon_code').value = bestCode;
        document.querySelector('#coupon_code').dispatchEvent(new MouseEvent('input', { bubbles: true } ));
        document.querySelector('button.c-button--apply').click();  
      }
    },

    petcarerx: {
      id: 1349, 
      preApplyCodes: function(callback) {
        const elTotal = $('#summary_total span');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        $.ajax({
          url: 'https://www.petcarerx.com/ajax/cart_page.ashx',
          type: 'POST',
          data: {
            cmd: 'submit_new_coupon',
            coupon: code
          },
          success: (data, textStatus, request) => {
            const ts = Math.round(new Date().getTime());
                $.ajax({
                    url: 'https://www.petcarerx.com/ajax/cart_page.ashx?cmd=getcartsummary&_='+ts,
                    type: 'GET',
                    success: (data, textStatus, request) => {
                      const total = data.total;
                      const value = total ? 
                            Number(total.replace( /[^0-9.]/g, '').trim()) : 
                            Number.POSITIVE_INFINITY;
                      callback(value);
                    },
                    error: (xhr, status, error) => { callback(Number.POSITIVE_INFINITY); }
                });
          },
          error: (xhr, status, error) => {
             callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#newcoupon_textbox').value = bestCode;
        document.querySelector('#newcoupon_textbox').dispatchEvent(new MouseEvent('input', { bubbles: true } ));
        document.querySelector('.saveForm input.formBtn').click();  
      }
    },

  justformen: {
      id: 37404, 
      preApplyCodes: function(callback) {  
        const elTotal = $('tr.grand.totals span.price');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
           const windowVariables = retrieveWindowVariables(["window.checkoutConfig","window.NREUM"]);
           const quoteId = windowVariables["window.checkoutConfig"].quoteId;
           const xpid = windowVariables["window.NREUM"].loader_config.xpid;
           $.ajax({
                url: 'https://www.justformen.com/rest/default/V1/guest-carts/'+quoteId+'/coupons/'+code,
                type: 'PUT',
                headers: {
                'x-newrelic-id': xpid
                },
                success: (data) => {
                  const ts = Math.round(new Date().getTime());
                      $.ajax({
                          url: 'https://www.justformen.com/rest/default/V1/guest-carts/'+quoteId+'/payment-information?_='+ts,
                          type: 'GET',
                          headers: {
                          'x-newrelic-id': xpid
                          },
                          success: (response) => {                  
                             const value = response.totals.base_grand_total;
                              $.ajax({
                                  url: 'https://www.justformen.com/rest/default/V1/guest-carts/'+quoteId+'/coupons',
                                  type: 'DELETE',
                                  headers: {
                                  'x-newrelic-id': xpid
                                  },
                                  success: (response) => {
                                       callback(value.toFixed(2));
                                  }
                                });
                          }
                        });
                },
                error: (xhr, status, error) => {
                  console.log(error);
                  callback(Number.POSITIVE_INFINITY);
                }
              });
      },
      applyBestCode: (bestCode) => {
           const windowVariables = retrieveWindowVariables(["window.checkoutConfig","window.NREUM"]);
           const quoteId = windowVariables["window.checkoutConfig"].quoteId;
           const xpid = windowVariables["window.NREUM"].loader_config.xpid;
           $.ajax({
                url: 'https://www.justformen.com/rest/default/V1/guest-carts/'+quoteId+'/coupons/'+bestCode,
                type: 'PUT',
                headers: {
                'x-newrelic-id': xpid
                },
                success: (data) => {location.reload();}
            });       
      }
    },

    nolo: {
      id: 10218, 
      preApplyCodes: function(callback) {
        const elTotal = $('.tax-checkout-grandtotal .cart-totals-price');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        $.ajax({
          url: 'https://store.nolo.com/products/checkout/cart/couponPost/',
          type: 'POST',
          data: {
            remove: 0,
            coupon_code: code
          },
          success: () => {
            $.get('https://store.nolo.com'+window.location.pathname, (responseGet) => {
              const elTotal = $(responseGet).find('.tax-checkout-grandtotal .cart-totals-price');
              var value = 0;
              if( elTotal.length > 0 ){
                 $( elTotal ).each(function( index ) {
                  value += Number($( this ).text().replace( /[^0-9.]/g, '').trim());                
                 });
              }else{
                  value = Number.POSITIVE_INFINITY;
              }              
              callback(value);
            });
          },
          error: (xhr, status, error) => {
             callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#coupon_code').value = bestCode;
        document.querySelector('#coupon_code').dispatchEvent(new MouseEvent('input', { bubbles: true } ));
        document.querySelector('button.btn-apply-coupon').click();  
      }
    },

  planttherapy: {
      id: 28559,
      preApplyCodes: function(callback) {
        const elTotal = $('.cart-summary div :contains("Estimated Total:"), .basket-total-row .basket-total-amount');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        const url = $('#js_coupon_form, #osel-coupon-form').attr('action');
        const formData = getFormFieldsAsJson(document.querySelector('#js_coupon_form, #osel-coupon-form'));
        formData['Coupon_Code'] = code;
        $.ajax({
          url: url,
          type: 'POST',
          data: formData,
          success: (responseGet) => {
              const elTotal = $(responseGet).find('.cart-summary div :contains("Estimated Total:"), .basket-total-row .basket-total-amount');
              const value = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;              
              callback(value);
          },
          error: (xhr, status, error) => {
             callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#l-coupon-code').value = bestCode;
        document.querySelector('#l-coupon-code').dispatchEvent(new MouseEvent('input', { bubbles: true } ));
        document.querySelector('#l-coupon-code-button, #osel-coupon-form button').click();  
      }
    },

    zagg: {
      id: 1812,
      preApplyCodes: function(callback) {
        const elTotal = $('#cart-totals .amount[data-th="Total"] .price, .grand.totals .amount .price, strong .price');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        const url = $('.discount-coupon-form').attr('action');
        $.ajax({
          url: url,
          type: 'POST',
          data: {
            remove: 0,
            coupon_code: code
          },
          success: () => {
            $.get('https://www.zagg.com'+window.location.pathname, (responseGet) => {
              const checkoutconfigindex = responseGet.indexOf("window.checkoutConfig");
              const customerDataindex = responseGet.indexOf("window.customerData");
              const finalIndex = customerDataindex-checkoutconfigindex;
              const data = JSON.parse(responseGet.substr(responseGet.indexOf("window.checkoutConfig")+23, finalIndex-29));
              const value = data.totalsData.base_grand_total;
               $.post(url, { remove: 1 }, 
                (response) => {
                 callback(value);
                });              
            });
          },
          error: (xhr, status, error) => {
             callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: (bestCode) => {
        const url = $('.discount-coupon-form').attr('action');
        $.post(url, { remove: 0, coupon_code: bestCode }, 
          (response) => {
            location.reload();
          });
      }
    },

    pipingrock: {
      id: 11541,
      preApplyCodes: function(callback) {
        const elTotal = $('.cart-value-g_subtotal_after_discounts');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                      Number.POSITIVE_INFINITY;        
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        $.ajax({
          url: 'https://www.pipingrock.com/cart',
          xhr: function() {
              var xhr = jQuery.ajaxSettings.xhr();
              var setRequestHeader = xhr.setRequestHeader;
              xhr.setRequestHeader = function(name, value) {
                  if (name == 'X-Requested-With') return;
                  setRequestHeader.call(this, name, value);
              }
              return xhr;
          },
          type: 'POST',
          data: {
            prcc: code
          },
          success: (response) => {
                const elTotal = $(response).find('.cart-value-g_subtotal_after_discounts');
                const value = elTotal.length > 0 ? 
                              Number(elTotal.text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                              Number.POSITIVE_INFINITY;
                callback(value);
              }
          });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#prcc').value = bestCode;
        document.querySelector('#prcc').dispatchEvent(new Event('input', { bubbles: true } ));
        document.querySelector('.rewards-code input[value="Apply"]').click();
      }
    },

    tillys: {
      id: 1655,
      preApplyCodes: (callback) => {
        const orderValueEl = $('.order-total .order-value');
        const prevValue = orderValueEl.length > 0 ? 
                          Number(orderValueEl.first().text().trim().substr(1)) : 
                          Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: (code, callback) => {
      if(window.location.href.indexOf("cart") > -1){ 
        $.get('https://'+window.location.hostname+'/on/demandware.store/Sites-tillys-Site/default/Cart-AddCouponJson?couponCode='+code+'&format=ajax&page=cart', 
              (responseGet) => {
                  $.get('https://'+window.location.hostname+'/cart', 
                    (response) => {
                      const orderValueEl = $(response).find('.order-total .order-value');
                      const value = orderValueEl.length > 0 ? 
                                    Number(orderValueEl.first().text().trim().substr(1)) : 
                                    Number.POSITIVE_INFINITY;
                      callback(value);
                  });
              });
      }else{
         $.get('https://'+window.location.hostname+'/on/demandware.store/Sites-tillys-Site/default/Cart-AddCouponJson?couponCode='+code+'&format=ajax', 
              (responseGet) => {
                  $.get('https://'+window.location.hostname+'/on/demandware.store/Sites-tillys-Site/default/COBilling-UpdateSummary?checkoutStep=3', 
                    (response) => {
                      const orderValueEl = $(response).find('.order-total .order-value');
                      const value = orderValueEl.length > 0 ? 
                                    Number(orderValueEl.first().text().trim().substr(1)) : 
                                    Number.POSITIVE_INFINITY;
                          $.get('https://'+window.location.hostname+'/on/demandware.store/Sites-tillys-Site/default/COBilling-RemoveCouponCode?couponCode='+code+'&format=ajax', 
                          (response) => {                                          
                            callback(value);
                        });
                  });
              });
          }
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#dwfrm_cart_couponCode').value = bestCode;
        document.querySelector('#dwfrm_cart_couponCode').dispatchEvent(new Event('input', { bubbles: true } ));
        document.querySelector('#add-coupon').click();
      }
    },


    jockey: {
      id: 1029,
      preApplyCodes: function(callback) {
        const elTotal = $('div.flex-row.sb.total span:contains("$")');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        const url = 'https://www.jockey.com/api/basket/default/coupon/'+code+'?runTotals=true';
        $.ajax({
          url: url,
          type: 'PUT',
          success: (responseGet) => {
              const value = responseGet.Total;  
                    $.ajax({
                      url: url,
                      type: 'DELETE',
                      success: () => {  callback(value); },
                      error: () => {  callback(value); }
                });
          },
          error: (xhr, status, error) => {
             callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#couponCode').value = bestCode;
        document.querySelector('#couponCode').dispatchEvent(new MouseEvent('input', { bubbles: true } ));
        document.querySelector('button[aria-label="Apply coupon"]').click();  
      }
    },

    charlottesweb: {
      id: 41356,
      preApplyCodes: function(callback) {
        const elTotal = $('#cart-totals .amount[data-th="Total"] .price, .grand.totals .amount .price, strong .price');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
         if(window.location.href.indexOf("cart") > -1){
            const url = $('#discount-coupon-form').attr('action');
            const form_key = $('input[name="form_key"]').val();
            $.post(url, { remove: 1,form_key: form_key }, 
            (response) => {
                 callback(prevValue);
            });
        }else{
           const windowVariables = retrieveWindowVariables(["window.checkoutConfig","window.NREUM"]);
           const quoteId = windowVariables["window.checkoutConfig"].quoteId;
           const xpid = windowVariables["window.NREUM"].loader_config.xpid;
           $.ajax({
            url: 'https://www.charlottesweb.com/rest/default/V1/guest-carts/'+quoteId+'/coupons',
            type: 'DELETE',
             headers: {
                'x-newrelic-id': xpid
                },
            success: () => { callback(prevValue); },
            error: () => { callback(prevValue); }
          });
        }
      },
      applyCode: function(code, callback) {
       this.preApplyCodes(() => {
        if(window.location.href.indexOf("cart") > -1){
          const url = $('#discount-coupon-form').attr('action');
          const form_key = $('input[name="form_key"]').val();
          $.ajax({
            url: url,
            type: 'POST',
            data: {
              remove: 0,
              form_key: form_key,
              coupon_code: code
            },
            success: () => {
              $.get('https://www.charlottesweb.com'+window.location.pathname, (responseGet) => {
                const checkoutconfigindex = responseGet.indexOf("window.checkoutConfig");
                const customerDataindex = responseGet.indexOf("window.customerData");
                const finalIndex = customerDataindex-checkoutconfigindex;
                const data = JSON.parse(responseGet.substr(responseGet.indexOf("window.checkoutConfig")+23, finalIndex-37));
                const value = data.totalsData.base_grand_total;
                callback(value);             
              });
            },error: (xhr, status, error) => {
               callback(Number.POSITIVE_INFINITY);
            }
          });
        }else{
          const windowVariables = retrieveWindowVariables(["window.checkoutConfig","window.NREUM"]);
           const quoteId = windowVariables["window.checkoutConfig"].quoteId;
           const xpid = windowVariables["window.NREUM"].loader_config.xpid;
           $.ajax({
                url: 'https://www.charlottesweb.com/rest/default/V1/guest-carts/'+quoteId+'/coupons/'+code,
                type: 'PUT',
                headers: {
                'x-newrelic-id': xpid
                },
                success: (data) => {
                  const ts = Math.round(new Date().getTime());
                      $.ajax({
                          url: 'https://www.charlottesweb.com/rest/default/V1/guest-carts/'+quoteId+'/payment-information?_='+ts,
                          type: 'GET',
                          headers: {
                          'x-newrelic-id': xpid
                          },
                          success: (response) => {                  
                             const value = response.totals.base_grand_total;
                             callback(value.toFixed(2));
                          }
                        });
                },error: (xhr, status, error) => {
                  console.log(error);
                  callback(Number.POSITIVE_INFINITY);
                }
              });
        }
       });
      },
      applyBestCode: (bestCode) => {
        if(window.location.href.indexOf("cart") > -1){
          const url = $('#discount-coupon-form').attr('action');
          const form_key = $('input[name="form_key"]').val();
          $.post(url, { remove: 0, coupon_code: bestCode,form_key: form_key }, 
            (response) => {
              location.reload();
            });
         }else{
           const windowVariables = retrieveWindowVariables(["window.checkoutConfig","window.NREUM"]);
           const quoteId = windowVariables["window.checkoutConfig"].quoteId;
           const xpid = windowVariables["window.NREUM"].loader_config.xpid;
           $.ajax({
                url: 'https://www.charlottesweb.com/rest/default/V1/guest-carts/'+quoteId+'/coupons/'+bestCode,
                type: 'PUT',
                headers: {
                'x-newrelic-id': xpid
                },
                success: () => {location.reload();}
              });
        }
      }
    },

    dollargeneral: {
      id: 5738,
      preApplyCodes: function(callback) {
        const elTotal = $('#cart-totals .amount[data-th="Order Total"] .price, .grand.totals .amount .price, strong .price');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        if(window.location.href.indexOf("cart") > -1){
          const url = $('#discount-coupon-form').attr('action');
          const formData = getFormFieldsAsJson(document.querySelector('#discount-coupon-form'));
          formData['coupon_code_fake'] = code;
          formData['coupon_code'] = code;
          formData['last_code'] = code;
          $.ajax({
            url: url,
            type: 'POST',
            data: formData,
            success: () => {
              $.get('https://www.dollargeneral.com'+window.location.pathname, (responseGet) => {
                const checkoutconfigindex = responseGet.indexOf("window.checkoutConfig");
                const customerDataindex = responseGet.indexOf("window.customerData");
                const finalIndex = customerDataindex-checkoutconfigindex;
                const data = JSON.parse(responseGet.substr(responseGet.indexOf("window.checkoutConfig")+23, finalIndex-37));
                const value = data.totalsData.base_grand_total;
                const formData2 = getFormFieldsAsJson(document.querySelector('#discount-coupon-form'));
                formData2['last_code'] = code;
                formData2['remove_coupon'] = code;
                 $.post(url, formData2, 
                  (response) => {
                   callback(value);
                  });              
              });
            },
            error: (xhr, status, error) => {
               callback(Number.POSITIVE_INFINITY);
            }
          });
      }else{
         const windowVariables = retrieveWindowVariables(["window.checkoutConfig"]);
         const quoteId = windowVariables["window.checkoutConfig"].quoteData.entity_id;
         $.ajax({
              url: 'https://www.dollargeneral.com/rest/default/V1/guest-carts/'+quoteId+'/coupons/'+code,
              type: 'PUT',
              success: (data) => {
                const ts = Math.round(new Date().getTime());
                    $.ajax({
                        url: 'https://www.dollargeneral.com/rest/default/V1/guest-carts/'+quoteId+'/payment-information?_='+ts,
                        type: 'GET',
                        success: (response) => {                  
                           const value = response.totals.base_grand_total;
                            $.ajax({
                                url: 'https://www.dollargeneral.com/rest/default/V1/guest-carts/'+quoteId+'/coupons',
                                type: 'DELETE',
                                success: (response) => {
                                     callback(value.toFixed(2));
                                }
                              });
                          }
                      });
              },
              error: (xhr, status, error) => {
                console.log(error);
                callback(Number.POSITIVE_INFINITY);
              }
            });
         }
      },
        applyBestCode: (bestCode) => {
          document.querySelector('#coupon_code_fake, #discount-code-fake').value = bestCode;
          document.querySelector('#coupon_code_fake, #discount-code-fake').dispatchEvent(new MouseEvent('input', { bubbles: true } ));
          document.querySelector('#coupon_code_fake, #discount-code-fake').dispatchEvent(new Event('change', {bubbles: true}));
          document.querySelector('#coupon_code_fake, #discount-code-fake').dispatchEvent(new Event('blur')); 
          document.querySelector('#coupon_code_fake, #discount-code-fake').dispatchEvent(new Event('focus'));    
          document.querySelector('#discount-coupon-form .actions-toolbar button, .primary .action.action-apply').click();    
        }
    },

    freshdirect: {
      id: 6174,
      preApplyCodes: function(callback) {
        const elTotal = $('.st_val_ssOrderTotal');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        const url = 'https://www.freshdirect.com/api/expresscheckout/promotion';
        $.ajax({
          url: url,
          type: 'POST',
          data: {data:JSON.stringify({"fdform":"promotion","formdata":{"promotionCode":code,"action":"applyPromotion"}})},
          success: (responseGet) => {
            if(responseGet.submitForm.result.cartData){
              const elTotal = responseGet.submitForm.result.cartData.estimatedTotal;  
              const value = elTotal ? 
                            Number(elTotal.replace( /[^0-9.]/g, '').trim()) : 
                            Number.POSITIVE_INFINITY;
                $.ajax({
                  url: url,
                  type: 'POST',
                  data: {data:JSON.stringify({"fdform":"promotion","formdata":{"action":"removePromotion"}})},
                  success: () => {  callback(value); },
                  error: () => {  callback(value); }
                }); 
            }else{
              callback(Number.POSITIVE_INFINITY);
            }              
          },
          error: (xhr, status, error) => {
             callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#promotional-code').value = bestCode;
        document.querySelector('#promotional-code').dispatchEvent(new MouseEvent('input', { bubbles: true } ));
        document.querySelector('#promotional-code-applybtn').click();  
      }
    },

    batteriesplus: {
      id: 397, 
      preApplyCodes: function(callback) {
        const elTotal = $('.order-summary strong.pull-right');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        $.ajax({
          url: 'https://www.batteriesplus.com/ShoppingCart/AddDiscount',
          type: 'POST',
          data: {
            couponCode: code
          },
          success: () => {
            $.get('https://www.batteriesplus.com'+window.location.pathname, (responseGet) => {
              const elTotal = $(responseGet).find('.order-summary strong.pull-right');
              const value = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
                $.ajax({
                  url: 'https://www.batteriesplus.com/ShoppingCart/RemoveDiscount',
                  type: 'POST',
                  data: {
                    couponCode: code
                  },
                  success: () => { callback(value); },
                  errror: () => { callback(value); },
                })
            });
          },
          error: (xhr, status, error) => {
             callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('input[name="couponCode"]').value = bestCode;
        document.querySelector('input[name="couponCode"]').dispatchEvent(new MouseEvent('input', { bubbles: true } ));
        document.querySelector('.add-discount').click();  
      }
    },

  'lancome-usa': {
      id: 3922, 
      preApplyCodes: function(callback) {
        const elTotal = $('.cart_order_totals.secondary_totals .text_right.order-total__cell, #js_checkout_app .text_right.order-total__cell');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        $.ajax({
          url: 'https://www.lancome-usa.com/on/demandware.store/Sites-lancome-us-Site/default/Cart-AddRemoveCoupon?type=add&couponCode='+code+'&format=ajax',
          type: 'GET',
          success: (responseGet) => {
              const elTotal = $(responseGet).find('.order_total.js_order_total td:last-child');
              const value = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
                $.ajax({
                  url: 'https://www.lancome-usa.com/on/demandware.store/Sites-lancome-us-Site/default/Cart-AddRemoveCoupon?type=remove&couponCode='+code+'&format=ajax',
                  type: 'GET',
                  data: {
                    couponCode: code
                  },
                  success: () => { callback(value); },
                  errror: () => { callback(value); },
                })
          },
          error: (xhr, status, error) => {
             callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#dwfrm_cart_couponCode, #dwfrm_couponcode_couponCode').value = bestCode;
        document.querySelector('#dwfrm_cart_couponCode, #dwfrm_couponcode_couponCode').dispatchEvent(new MouseEvent('input', { bubbles: true } ));
        document.querySelector('#add-coupon, button[name="dwfrm_couponcode_applyCoupon"]').click();  
      }
    },

  itcosmetics: {
    removePrevCode: function(code, callback) {
      var formData = {};
      formData['coupon_remove_'+code] = code
      const url = $('.c-form.m-reset.c-cart-coupon__form').attr('action');
      $.ajax({
        url: url+'?ajax=true',
        type: 'POST',
        data: formData,
        success: () => { callback(); },
        error: () => { callback(); }
      });   
    },
    preApplyCodes: function(callback) { 
      const elTotal = document.querySelector('.c-cart-summary-table .m-total .m-value').innerText;
      const prevValue = elTotal.replace(/[^0-9.]/g, '').trim();
      const prevCodeSelector = document.querySelector('.c-cart-coupon__list-remove');
      if(prevCodeSelector){
        const prevCode = prevCodeSelector.value;
        const prevCodeName = prevCodeSelector.getAttribute('name');
        this.removePrevCode(prevCode, () => callback(prevValue, prevCode));
      }else{
        callback(prevValue);
      }      
    },
    applyCode: function(code, callback) {
      this._applyCode(code, function(value) {
      this.removePrevCode(code, () => callback(value));
     }.bind(this));
    },
    applyBestCode: function(bestCode) {
      this._applyCode(bestCode, function(value) {
        location.reload();
      });   
    },
    _applyCode: (code, callback) => { 
      const url = $('.c-form.m-reset.c-cart-coupon__form').attr('action');
      const formData = getFormFieldsAsJson(document.querySelector('.c-form.m-reset.c-cart-coupon__form'));
      formData['couponcode'] = code;
      $.post(url+'?ajax=true', formData, 
      (responsePost) => {
        const orderValueEl = $(responsePost).find('.c-cart-summary-table .m-total .m-value');
        const value = orderValueEl.length > 0 ? 
                    Number(orderValueEl.first().text().replace( /[^0-9.]/g, '').trim()) : 
                    Number.POSITIVE_INFINITY; 
        callback(value);
      });
    },
  },

    musicnotes: {
      id: 1225, 
      preApplyCodes: function(callback) {
        const elTotal = $('.total, h4.total-price');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
       const windowVariables = retrieveWindowVariables(["window.NREUM"]);
           const xpid = windowVariables["window.NREUM"].loader_config.xpid;
           $.ajax({
                url: 'https://www.musicnotes.com/checkout/ApplyVoucherCode',
                type: 'POST',
                headers: {
                'Content-Type': 'application/x-www-form-urlencoded; charset=UTF-8',
                'x-newrelic-id': xpid
                },
                data: {
                  voucherCode: code,
                },
                success: (data) => {
                  const ts = Math.round(new Date().getTime());              
                  $.ajax({
                      url: 'https://www.musicnotes.com/checkout/OrderSummarySection?_='+ts,
                      type: 'GET',
                      headers: {
                        'x-newrelic-id': xpid
                      },
                    success: (responseGet) => { 
                        const elTotal = $(responseGet).find('.total, h4.total-price');
                        const value = elTotal.length > 0 ? 
                          Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                          Number.POSITIVE_INFINITY; 
                          callback(value);
                    },errror: () => { callback(Number.POSITIVE_INFINITY); },
                  })
          },
          error: (xhr, status, error) => {
             callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#DiscountID, #voucherCodeInput').value = bestCode;
        document.querySelector('#DiscountID, #voucherCodeInput').dispatchEvent(new MouseEvent('input', { bubbles: true } ));
        document.querySelector('#applyDisc, #applyVoucherCodeButton').click();  
      }
    },

    readers: {
      id: 6174,
      preApplyCodes: function(callback) {
        const elTotal = $('.cart-total span, tr.total span');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        const url = 'https://www.readers.com/cart.php';
        var formData,getUrl,method,getformData,ts;
        ts = Math.round(new Date().getTime());
        if(window.location.href.indexOf("checkout") > -1){
          formData = {coupon:code, mode:'add_coupon'};
          getUrl = 'https://www.readers.com/get_block.php?block=opc_totals';
          getformData = {t:ts};
          method = 'GET';
        }else{
          formData = getFormFieldsAsJson(document.querySelector('#js_coupon_form, #osel-coupon-form'));
          formData['coupon'] = code;
          formData['mode'] = 'add_coupon';
          getUrl = 'https://www.readers.com/cart.php';
          method = 'POSt';
        }
        $.ajax({
          url: url,
          type: 'POST',
          data: formData,
          success: () => {
             $.ajax({
                url: getUrl,
                type: method,
                data: getformData,
                success: (responseGet) => {
                  const elTotal = $(responseGet).find('.cart-total span, tr.total span');
                  const value = elTotal.length > 0 ? 
                                Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                                Number.POSITIVE_INFINITY;
                  $.ajax({
                    url: 'https://www.readers.com/cart.php?mode=unset_coupons',
                    type: 'GET',
                    success: () => {  callback(value); },
                    error: () => {  callback(value); }
                  });
                }
              });
          },
          error: (xhr, status, error) => {
             callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#coupon').value = bestCode;
        document.querySelector('#coupon').dispatchEvent(new Event('input', { bubbles: true } ));
        document.querySelector('#coupon').dispatchEvent(new Event('change', {bubbles: true}));
        document.querySelector('#coupon').dispatchEvent(new Event('blur')); 
        document.querySelector('#coupon').dispatchEvent(new Event('focus'));
        setTimeout(function(){
           document.querySelector('[aria-label="apply coupon"], #apply_coupon').click();   
        }, 1000);        
      }
    },

  selectblinds: {
      id: 3693, 
      preApplyCodes: function(callback) {
        const elTotal = $('#totalAmt');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
         if(window.location.href.indexOf("Checkout") > -1){
           $.ajax({
              url: 'https://www.selectblinds.com/ShoppingCart/SetDiscount?fromCart=False&DiscountCode='+code,
              type: 'POST',
              data: {'X-Requested-With':'XMLHttpRequest'},
              success: () => {
                  $.ajax({
                    url: 'https://www.selectblinds.com/ShoppingCart/Totals?ShipAddress=&ShipCity=&ShipState=0&ShipZip=',
                    type: 'POST',
                    data: {'X-Requested-With':'XMLHttpRequest'},
                    success: (response) => {
                        const elTotal = $(response).find('#totalAmt');
                        const value = elTotal.length > 0 ? 
                                Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                                Number.POSITIVE_INFINITY;
                          callback(value); 
                        },
                    error: (xhr, status, error) => {
                       callback(Number.POSITIVE_INFINITY);
                    }
                  });
              },
              error: (xhr, status, error) => {
                 callback(Number.POSITIVE_INFINITY);
              }
            });
        }else{
            $.ajax({
              url: 'https://www.selectblinds.com/ShoppingCart/SetDiscount?fromCart=True&DiscountCode='+code,
              type: 'POST',
              data: {'X-Requested-With':'XMLHttpRequest'},
              success: (response) => {
                  const elTotal = $(response).find('#totalAmt');
                  const value = elTotal.length > 0 ? 
                          Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                          Number.POSITIVE_INFINITY;
                    callback(value); 
              },
              error: (xhr, status, error) => {
                 callback(Number.POSITIVE_INFINITY);
              }
            });
        }
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#DiscountCode').value = bestCode;
        document.querySelector('#DiscountCode').dispatchEvent(new MouseEvent('input', { bubbles: true } ));
        document.querySelector('.applyDiscountCode').click();  
      }
    },

    paulaschoice: {
      id: 10036, 
      preApplyCodes: function(callback) {
        const elTotal = $('div[class*=BagOrderTotals__Subtotal].medium1 div:contains($)');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        const csrfToken = decodeURI(document.cookie.split(';').filter(function(c) { return c.indexOf('sid') !== -1 })[1]).trim().split('=')[1];
      $.ajax({
          url: 'https://www.paulaschoice.com/on/demandware.store/Sites-paulaschoice_us-Site/en_US/Bag-AddCoupon',
          type: 'POST',
          data: JSON.stringify({couponCode:code, csrfToken:csrfToken+'='}),
          headers: {
                'content-type': 'application/json;charset=UTF-8'
          },
          success: (response) => {
              const value = response.data.amountDue.value;
                $.ajax({
                  url: 'https://www.paulaschoice.com/on/demandware.store/Sites-paulaschoice_us-Site/en_US/Bag-RemoveCoupon',
                  type: 'POST',
                  data: JSON.stringify({couponCode:code, csrfToken:csrfToken+'='}),
                  headers: {
                        'content-type': 'application/json;charset=UTF-8'
                  },
                  success: () => { callback(value); },
                  errror: () => { callback(value); },
                })
          },
          error: (xhr, status, error) => {
             callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('[class*="CouponInput"]').value = bestCode;
        document.querySelector('[class*="CouponInput"]').dispatchEvent(new MouseEvent('input', { bubbles: true } ));
        document.querySelector('[class*="CouponInput"] + [value="Apply"]').click();  
      }
    },

    arttoframe: {
      id: 25484, 
      preApplyCodes: function(callback) {
        const elTotal = $('#cart_total_div tbody tr td:contains(Total) + td');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
       $.ajax({
          url: 'https://www.arttoframe.com/cartmanager.php',
          type: 'POST',
          data: {coupon_code:code},
          xhr: function() {
              var xhr = jQuery.ajaxSettings.xhr();
              var setRequestHeader = xhr.setRequestHeader;
              xhr.setRequestHeader = function(name, value) {
                  if (name == 'X-Requested-With') return;
                  setRequestHeader.call(this, name, value);
              }
              return xhr;
          },
          success:  (data, textStatus, request) => {
                $.get('https://www.arttoframe.com'+window.location.pathname, 
                    (responseget) => {
                      const elTotal = $(responseget).find('#cart_total_div tbody tr td:contains(Total) + td');
                      const value = elTotal.length > 0 ? 
                                    Number(elTotal.first().text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                                    Number.POSITIVE_INFINITY; 
                      callback(value);
                 });
          },
          error: (xhr, status, error) => {
             callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#coupon_code').value = bestCode;
        document.querySelector('#coupon_code').dispatchEvent(new MouseEvent('input', { bubbles: true } ));
        document.querySelector('.clsApplyNew').click();  
      }
    },

    shopbop: {
      id: 1492, 
      preApplyCodes: function(callback) {
        const elTotal = $('[data-at="subtotal"]');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
       const locale = $('body').attr("data-locale");
       const currency = $('body').attr("data-currency");
       const siteId = $('#site-id').attr("data-site-id");
       const csrfToken = $('#csrfToken').attr("data-csrf-token");
       const cartId = $('[data-at="ShoppingCart"]').attr('data-cart-id');
       const url = 'https://api.shopbop.com/carts/'+cartId+'?siteId='+siteId+'&lang='+locale+'&currency='+currency;
      $.ajax({
          url: url,
          type: 'POST',
          data: JSON.stringify({promotionCode:code}),
          headers: {
                'content-type': 'application/json;charset=UTF-8',
                'csrf-token': csrfToken
          },
          success: (response) => {
              const elTotal = response.total;
              const value = elTotal ? 
                            Number(elTotal.replace( /[^0-9.]/g, '').trim()) : 
                            Number.POSITIVE_INFINITY;
                $.ajax({
                  url: url,
                  type: 'POST',
                  data: JSON.stringify({promotionCode:''}),
                  headers: {
                        'content-type': 'application/json;charset=UTF-8',
                        'csrf-token': csrfToken
                  },
                  success: () => { callback(value); },
                  errror: () => { callback(value); },
                })
          },
          error: (xhr, status, error) => {
             callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('[data-at="PromotionInput"]').value = bestCode;
        document.querySelector('[data-at="PromotionInput"]').dispatchEvent(new MouseEvent('input', { bubbles: true } ));
        document.querySelector('[data-at="DesktopPromotionApplyButton"]').click();  
      }
    },

    bluenile: {
      id: 23657, 
      preApplyCodes: function(callback) {
        const elTotal = $('.total .right');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        const userstate  = $('body').attr('data-userstate');
        const userData = JSON.parse(userstate);
        const url = 'https://secure.bluenile.com/api/secure/basket/source-code?country='+userData.countryCode+'&language='+userData.languageCode+'&productSet='+userData.productSet+'&currency='+userData.currencyCode;
        $.ajax({
              url: url,
              type: 'DELETE',
              success: () => { callback(prevValue); },
              errror: () => { callback(prevValue); },
            })
      },
      applyCode: function(code, callback) {
         this.preApplyCodes(() => {
          this._applyCode(code, function(value) {
            callback(value);
          }); 
        });       
      },
      applyBestCode: function(bestCode) {
         this._applyCode(bestCode, function() {
            location.reload();
          }) ; 
      },
       _applyCode: (code, callback) => {
        const formData = getFormFieldsAsJson(document.querySelector('#pf-form'));
        const userstate  = $('body').attr('data-userstate');
        const userData = JSON.parse(userstate);
        const url = 'https://secure.bluenile.com/api/secure/basket/source-code?country='+userData.countryCode+'&language='+userData.languageCode+'&productSet='+userData.productSet+'&currency='+userData.currencyCode;
        formData['sourceCode'] = code;
        $.ajax({
          url: url,
          type: 'POST',
          data: formData,
          success: (response) => {
            const value = response.orderTotalNum;
            callback(value);
          },
          error: (xhr, status, error) => {
            callback(Number.POSITIVE_INFINITY);
          }
        });
       }
    },

    insomniacookies: {
      id: 30060, 
      preApplyCodes: function(callback) {
        const elTotal = $('.cart-total-item:last-child .pull-right b');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        var ts1 = Math.round(new Date().getTime());
         $.get('https://insomniacookies.com/shop/addCoupon/'+code+'/website?_='+ts1, 
              (response) => {
                if(response.success == true){
                  var ts2 = Math.round(new Date().getTime());
                  $.get('https://insomniacookies.com/shop/getCart?_='+ts2, 
                  (responseget) => {
                      var ts3 = Math.round(new Date().getTime());
                      const value=responseget.totals.total;
                       $.get('https://insomniacookies.com/shop/deleteCoupon?_='+ts3, 
                        () => {
                            callback(value);                            
                        });
                  });
                }else{
                  callback(Number.POSITIVE_INFINITY);
                }
              });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#cart-side-panel-component.active input[aria-label="Enter Coupon Code"], .cart-open [aria-label="Enter Coupon Code"]').value = bestCode;
        document.querySelector('#cart-side-panel-component.active input[aria-label="Enter Coupon Code"], .cart-open [aria-label="Enter Coupon Code"]').dispatchEvent(new MouseEvent('input', {bubbles: true}));
        document.querySelector('#cart-side-panel-component .input-group button.btn.btn-outline-primary.ae-button[data-ae-blurbtype="button"][data-ae-form-field="true"]').click();
      }
    },


    quill: {
      id: 1412, 
      preApplyCodes: function(callback) {
        const elTotal = $('#TotalLabel, #TotalLabelFR');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        const formData = getFormFieldsAsJson(document.querySelector('#CheckoutCartForm'));
        const url = $('#CheckoutCartForm').attr('action');
        formData['CouponViewModel.CouponCode'] = code;
        formData['CouponViewModel.CouponAction'] = '1';
        formData['CouponApply'] = 'True';
        formData['isClickedApplyBtn'] = 'True';
        $.ajax({
          url: 'https://www.quill.com'+url,
          type: 'POST',
          data: formData,
          success: (response) => {
              const elTotal = $(response).find('#ItemPriceLabel');
              const value = elTotal.length > 0 ? 
                            Number(elTotal.first().text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                            Number.POSITIVE_INFINITY; 
              callback(value);
          },
          error: (xhr, status, error) => {
             callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('.couponStackbleInputDiv .scInput, #CouponInput').value = bestCode;
        document.querySelector('.couponStackbleInputDiv .scInput, #CouponInput').dispatchEvent(new MouseEvent('input', { bubbles: true } ));
        document.querySelector('#couponSection [name="CouponApplyButton"]').click();  
      }
    },

    converse: {
      id: 3587,
      preApplyCodes: function(callback) {
        const elTotal = $('div.order-total span.price, .total');
        const prevValue = elTotal.length > 0 ? 
                        Number(elTotal.text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                        Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        const windowVariables = retrieveWindowVariables(["window.Urls"]);
        const addCouponUrl = windowVariables["window.Urls"].addCoupon;
        const removeCouponUrl = windowVariables["window.Urls"].removeCoupon;
        $.get(addCouponUrl+'?format=ajax&couponCode='+code+'&reload=false', 
          (response) => {
           const elTotal = response.couponData.totals.total;
           const value = elTotal ? 
                        Number(elTotal.replace( /[^0-9.]/g, '').trim()) : 
                        Number.POSITIVE_INFINITY;
            $.get(removeCouponUrl+'?format=ajax&couponCode='+code+'&reload=false', 
              () => {
               callback(value);  
            });                    
        });
      },
      applyBestCode: function(bestCode) {
        document.querySelector('input[name="dwfrm_cart_couponCode"]').value = bestCode;
        document.querySelector('input[name="dwfrm_cart_couponCode"]').dispatchEvent(new Event('input', {bubbles: true}));
        document.querySelector('#add-coupon').click();
      }
    },


    'famous-smoke': {
      id: 6316, 
      preApplyCodes: function(callback) {
        const elTotal = $('.pricebox span:last, #ordersummary_grandtotal');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) { 
       if(window.location.href.indexOf("cart") > -1){
        const url = 'https://www.famous-smoke.com/cigars/include/ajax_responder.cfm';
        $.post(url,{task:'activateCoupon', coupon_code:code}, 
            () => {
             var ts1 = Math.round(new Date().getTime());
                $.get('https://'+window.location.hostname+window.location.pathname+'?keyword='+code+'&_='+ts1, 
                  (response) => {
                    const elTotal = $(response).find('.pricebox span:last');
                    const value = elTotal.length > 0 ? 
                                  Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                                  Number.POSITIVE_INFINITY; 
                    $.post(url,{task:'activateCoupon', coupon_code:''}, 
                      () => {
                       callback(value);  
                    });                    
                });
          });
        }else{
          $.post('https://www.famous-smoke.com/checkout/coupon',{coupon_code:code}, 
            () => {
                var ts1 = Math.round(new Date().getTime());
                $.get('https://www.famous-smoke.com/checkout/ordersummary?_='+ts1, 
                  (response) => {
                    const elTotal = $(response).find('#ordersummary_grandtotal');
                    const value = elTotal.length > 0 ? 
                                  Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                                  Number.POSITIVE_INFINITY; 
                    $.post('https://www.famous-smoke.com/checkout/coupon',{ coupon_code:''}, 
                      () => {
                       callback(value);  
                    });                    
                });
            });  
        } 
      },
      applyBestCode: (bestCode) => {
        document.querySelector('[name="coupon_code"], #couponcode').value = bestCode;
        document.querySelector('[name="coupon_code"], #couponcode').dispatchEvent(new MouseEvent('input', { bubbles: true } ));
        setTimeout(function(){ document.querySelector('a.btn_center, [name="coupon_code"] + button, .btn-promo').click(); }, 1000); 
      }
    },

  'ross-simons': {
      id: 1446, 
      preApplyCodes: function(callback) {
        const elTotal = $('.order-value');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
          const url = $('#cart-items-form').attr('action');
          const formData = getFormFieldsAsJson(document.querySelector('#cart-items-form'));
          formData['dwfrm_cart_couponCode'] = code;
          formData['dwfrm_cart_addCoupon'] = 'dwfrm_cart_addCoupon';
          $.post(url, formData, 
            (responsePost) => {
              $.get('https://'+window.location.hostname+'/cart', (response) => {
                const elTotal = $(response).find('.order-value');
                const value = elTotal.length > 0 ? 
                                Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                                Number.POSITIVE_INFINITY; 
                callback(value);
              });
            });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#dwfrm_cart_couponCode').value = bestCode;
        document.querySelector('#dwfrm_cart_couponCode').dispatchEvent(new MouseEvent('input', { bubbles: true } ));
        document.querySelector('#add-coupon').click();
      }
    },

    cleanitsupply: {
      id: 29542, 
      preApplyCodes: function(callback) {
        const elTotal = $('#total-cart-amount');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
          const url = window.location.href;
          $.post(url, {action:'applyCoupon', couponCode:code}, 
            (responsePost) => {
              $.get(url, (response) => {
                const elTotal = $(response).find('#total-cart-amount');
                const value = elTotal.length > 0 ? 
                                Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                                Number.POSITIVE_INFINITY; 
                $.get('https://cleanitsupply.com/smartcheckout3.aspx?action=removeCoupon&couponCode='+code, () => {
                  callback(value);
                });                
              });
            });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#coupon-code').value = bestCode;
        document.querySelector('#coupon-code').dispatchEvent(new MouseEvent('input', { bubbles: true } ));
        document.querySelector('.applyCouponLink').click();
      }
    },

  koleimports: {
      id: 15657,
      preApplyCodes: function(callback) {
        var elTotal; var prevValue;
         if(document.location.pathname.indexOf("/checkout/cart/") === 0){
            elTotal = $('#shopping-cart-totals-table tfoot tr:last-child td:last-child .price');
            prevValue = elTotal.length > 0 ? 
                          Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY; 
        }else{
            elTotal = $('.onestepcheckout-totals tr.grand-total span.price');     
            prevValue = elTotal.length > 0 ? 
                        Number(elTotal.text().replace( /[^0-9.]/g, '').trim()) : 
                        Number.POSITIVE_INFINITY;               
       }
        callback(prevValue);
      },
      applyCode: function(code, callback) {
         if(document.location.pathname.indexOf("/checkout/cart/") === 0){
             $.ajax({
              url: 'https://www.koleimports.com/checkout/cart/couponPost/',
              type: 'POST',
              data: {
                remove: 0,
                coupon_code: code
              },
              success: (data, textStatus, request) => {
                const locationUrl = request.getResponseHeader('location');
                $.get(locationUrl , (responseGet) => {
                  const elTotal = $(responseGet).find('#shopping-cart-totals-table tfoot tr:last-child td:last-child .price');
                  var value = 0;
                  if( elTotal.length > 0 ){
                     $( elTotal ).each(function( index ) {
                      value += Number($( this ).text().replace( /[^0-9.]/g, '').trim());                
                     });
                  }else{
                      value = Number.POSITIVE_INFINITY;
                  }
                  
                  callback(value);
                });
              },
              error: (xhr, status, error) => {
                 callback(Number.POSITIVE_INFINITY);
              }
            });
       }else{
          $.ajax({
            url:  'https://www.koleimports.com/onestepcheckout/ajax/add_coupon/',
            type: 'POST',
            data: {code: code},
            contentType: 'application/x-www-form-urlencoded; charset=UTF-8',
            success: (response) => {           
                  $.get('https://www.koleimports.com/onestepcheckout/', 
                  (response) => {
                          const total = $(response).find('.onestepcheckout-totals tr.grand-total span.price');     
                          const value = total.length > 0 ? 
                                          Number(total.text().replace( /[^0-9.]/g, '').trim()) : 
                                          Number.POSITIVE_INFINITY;
                          callback(value); 
                    }); 
            },
            error: (xhr, status, error) => {
              console.log(error);
              callback(Number.POSITIVE_INFINITY);
            }
          });
        }
      },
      applyBestCode: function(bestCode) {
        document.querySelector('#coupon_code, #id_couponcode').value = bestCode;
        document.querySelector('#coupon_code, #id_couponcode').dispatchEvent(new MouseEvent('input', {bubbles: true}));
        document.querySelector('#discount-coupon-form button[value="Apply Coupon"], #onestepcheckout-coupon-add').click();
      }
    },

  toms: {
      id: 3720, 
      preApplyCodes: function(callback) {
        const elTotal = $('#co-cart-tot');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        const _dynSessConf = $('[name="_dynSessConf"]').val();
        const locale = $('#locale').val();
        const ts1 = Math.round(new Date().getTime());
        const url = 'https://www.toms.com/services/order/applyCoupon';
       $.get(url+'?_dynSessConf='+_dynSessConf+'&locale='+locale+'&couponClaimCode='+code+'&_='+ts1, (response) => {
          const ts2 = Math.round(new Date().getTime());
          if(response.order){
              const elTotal = response.order.tomsOrderDetailMap.orderTotal;
              const value = elTotal ? 
                            Number(elTotal.replace( /[^0-9.]/g, '').trim()) : 
                            Number.POSITIVE_INFINITY;
              $.get(url+'?_dynSessConf='+_dynSessConf+'&locale='+locale+'&_='+ts2, () => {
                callback(value);
              });   
          }else{
             callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#co-pcode-input').value = bestCode;
        document.querySelector('#co-pcode-input').dispatchEvent(new MouseEvent('input', { bubbles: true } ));
        document.querySelector('#co-pcode-submit').click();
      }
    },

  surlatable: {
      id: 1583,
      preApplyCodes: (callback) => {
        const orderValueEl = $('.order-total .order-value');
        const prevValue = orderValueEl.length > 0 ? 
                          Number(orderValueEl.first().text().trim().substr(1)) : 
                          Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: (code, callback) => {
      if(window.location.href.indexOf("cart") > -1){ 
        const url = $('#cart-items-form').attr('action');
        const formData = getFormFieldsAsJson(document.querySelector('#cart-items-form'));
        formData['dwfrm_cart_couponCode'] = code;
        formData['dwfrm_cart_updateCart'] = 'dwfrm_cart_updateCart';
        $.post(url, formData, 
          (response) => {
            const orderValueEl = $(response).find('.order-total .order-value');
            const value = orderValueEl.length > 0 ? 
                              Number(orderValueEl.first().text().trim().substr(1)) : 
                              Number.POSITIVE_INFINITY;
            callback(value);
          });
      }else{
          $.get('https://www.surlatable.com/on/demandware.store/Sites-SLT-Site/default/Cart-AddCouponJson?couponCode='+code+'&format=ajax', 
              (response) => {
               const value = response.baskettotal;
               callback(value);
              }); 
          }
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#dwfrm_cart_couponCode, #dwfrm_billing_couponCode').value = bestCode;
        document.querySelector('#dwfrm_cart_couponCode, #dwfrm_billing_couponCode').dispatchEvent(new Event('input', { bubbles: true } ));
        document.querySelector('#add-coupon').click();
      }
    },

   bbqguys: {
      id: 7998,
      preApplyCodes: (callback) => {
        const orderValueEl = $('#totals-total');
        const prevValue = orderValueEl.length > 0 ? 
                          Number(orderValueEl.first().text().replace( /[^0-9.]/g, '').trim()) : 
                          Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: (code, callback) => {
        const url = 'https://www.bbqguys.com/coupon-code-ajax';
        $.post(url, {for:'cartCheckout',couponCode:code}, 
          (response) => {
            const value = response.total;
            callback(value);
          });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#payment-coupon-input').value = bestCode;
        document.querySelector('#payment-coupon-input').dispatchEvent(new Event('input', { bubbles: true } ));
        document.querySelector('#payment-coupon-input + button').click();
      }
    },

   clarksusa: {
      id: 10105,
      preApplyCodes: (callback) => {
        const orderValueEl = $('.total-incl-vat-amount');
        const prevValue = orderValueEl.length > 0 ? 
                          Number(orderValueEl.first().text().trim().substr(1)) : 
                          Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: (code, callback) => {
        const csrftoken = $('[name="CSRFToken"]').val();
        const url = 'https://www.clarksusa.com/cart/apply-voucher-ajax';
        $.post(url, {CSRFToken:csrftoken,voucherCode:code}, 
          (response) => {
            const value = response.data.remainingTotalPrice;
              $.post('https://www.clarksusa.com/cart/release-voucher-ajax', {CSRFToken:csrftoken,voucherCode:code}, 
                () => {
                  callback(value);
                })
          });
      },
      applyBestCode: (bestCode) => {
          document.querySelector('#vouhcerCode').value = bestCode;
          document.querySelector('#vouhcerCode').dispatchEvent(new Event('input', { bubbles: true } ));
          document.querySelector('.js-apply-promo-code').click(); 
      }
    },

  '4inkjets': {
      id: 281,
      preApplyCodes: (callback) => {
        const orderValueEl = $('.grand-total .price');
        const prevValue = orderValueEl.length > 0 ? 
                          Number(orderValueEl.first().text().trim().substr(1)) : 
                          Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: (code, callback) => {
        const url = 'https://www.4inkjets.com/checkout/cart/couponPost';
        $.post(url, {async:'true',coupon_code:code}, 
          (response) => {
            $.get('https://www.4inkjets.com/checkout/cart/retrieveCartTotals', (responseGet) => {
                  const data = JSON.parse(responseGet);
                  const value = data.grandtotal;
                  callback(value);
                })
          });
      },
      applyBestCode: (bestCode) => {
          document.querySelector('#coupon_code').value = bestCode;
          document.querySelector('#coupon_code').dispatchEvent(new Event('input', { bubbles: true } ));
          document.querySelector('#btn-apply-coupon').click(); 
      }
    },

  'magazines': {
      id: 281,
      preApplyCodes: (callback) => {
        const orderValueEl = $('#storeCheckoutForm[style="display: block;"] #subTotalCont #subTotal__amount--price');
        const prevValue = orderValueEl.length > 0 ? 
                          Number(orderValueEl.first().text().replace( /[^0-9.]/g, '').trim()) : 
                          Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: (code, callback) => {
          document.querySelector('#storeCheckoutForm input#couponCode').value = code;
          document.querySelector('#storeCheckoutForm input#couponCode').dispatchEvent(new MouseEvent('input', {bubbles: true}));
          document.querySelector('#storeCheckoutForm button.coupon-apply').click();
          setTimeout(function(){              
               const elTotal = $('#storeCheckoutForm[style="display: block;"] #subTotalCont #subTotal__amount--adjusted');
               const value = elTotal.length > 0 ? 
                              elTotal.first().text() : 
                              Number.POSITIVE_INFINITY;
                const fvalue = value ? 
                               Number(value.replace( /[^0-9.]/g, '').trim()) : 
                               Number.POSITIVE_INFINITY;
               callback(fvalue);
           }, 3000);
      },
      applyBestCode: (bestCode) => {
          document.querySelector('#storeCheckoutForm input#couponCode').value = bestCode;
          document.querySelector('#storeCheckoutForm input#couponCode').dispatchEvent(new Event('input', { bubbles: true } ));
          document.querySelector('#storeCheckoutForm button.coupon-apply').click(); 
      }
    },

  myprotein: {
      id: 13721, 
      preApplyCodes: function(callback) {
        const elTotal = $('.athenaBasket_totalValue');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
         $.post('https://'+window.location.hostname+'/my.basket', {
            discountCode: code
          }, (response) => {
            const elTotal = $(response).find('.athenaBasket_totalValue');
            const value = elTotal.length > 0 ? 
                          Number(elTotal.first().text().trim().substr(1)) : 
                          Number.POSITIVE_INFINITY;
            callback(value);
          });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#discountcode').value = bestCode;
        document.querySelector('#discountcode').dispatchEvent(new Event('input', {bubbles: true}));
        document.querySelector('#add-discount-code').click();
      }
    },

    ganderoutdoors: {
      id: 33333, 
      preApplyCodes: function(callback) {
        const elTotal = $('.estimated-price');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.text().trim().substr(1)) : 
                      Number.POSITIVE_INFINITY;
         callback(prevValue);
      },
      applyCode: function(code, callback) {
        if(window.location.href.indexOf("cart") > -1){ 
          const url = $('form[name="dwfrm_cart"]').attr('action');
          const formData = getFormFieldsAsJson(document.querySelector('form[name="dwfrm_cart"]'));
          formData['dwfrm_cart_couponCode'] = code;
          formData['dwfrm_cart_addCoupon'] = 'dwfrm_cart_addCoupon';
          $.post(url, formData, 
            (response) => {
               const orderValueEl = $(response).find('.estimated-price');
               const value = orderValueEl.length > 0 ? 
                                  Number(orderValueEl.text().trim().substr(1)) : 
                                  Number.POSITIVE_INFINITY;               
               callback(value);
          });
        }else{
          $.get('https://www.ganderoutdoors.com/on/demandware.store/Sites-GanderOutdoors-Site/default/Cart-AddCouponJson?couponCode='+code+'&format=ajax&fromCheckout=true', 
          (response) => {
             $.get('https://www.ganderoutdoors.com'+window.location.pathname, 
                (responseget) => {
                   const orderValueEl = $(responseget).find('.estimated-price');
                   const value = orderValueEl.length > 0 ? 
                                      Number(orderValueEl.text().trim().substr(1)) : 
                                      Number.POSITIVE_INFINITY;               
                   callback(value); 
              });                  
          });
        }
      },
      applyBestCode: (bestCode) => {
        location.reload();
      }
    },

    carid: {
      id: 5779,
      preApplyCodes: function(callback) {
        const elTotal = $('.cart-order-list li:last span.price');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        const url = 'https://www.carid.com/cart.php';
        var formData,getUrl,method,getformData,ts;
          formData = {coupon:code, mode:'add_coupon'};
          formData['mode'] = 'add_coupon';
          getUrl = 'https://www.carid.com/cart.php';
          method = 'GET';
        $.ajax({
          url: url,
          type: 'POST',
          data: formData,
          success: () => {
             $.ajax({
                url: getUrl,
                type: method,
                data: getformData,
                success: (responseGet) => {
                  const elTotal = $(responseGet).find('.cart-order-list li:last span.price');
                  const value = elTotal.length > 0 ? 
                                Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                                Number.POSITIVE_INFINITY;
                  $.ajax({
                    url: 'https://www.carid.com/cart.php?mode=unset_coupons',
                    type: 'GET',
                    success: () => {  callback(value); },
                    error: () => {  callback(value); }
                  });
                }
              });
          },
          error: (xhr, status, error) => {
             callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: (bestCode) => {
         const formData = {coupon:bestCode, mode:'add_coupon'};
        $.ajax({
          url: 'https://www.carid.com/cart.php',
          type: 'POST',
          data: formData,
          success: () => {location.reload(); },
          error: () => {location.reload(); }
        });
      }
    },


   'mileskimball': {
      id: 1176,
      preApplyCodes: (callback) => {
        const orderValueEl = $('[data-calc-co1="total"]');
        const prevValue = orderValueEl.length > 0 ? 
                          Number(orderValueEl.first().text().trim().substr(1)) : 
                          Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: (code, callback) => {
        const url = 'https://www.mileskimball.com/api/v1/CartPromotionCodes?sourcecode='+code;
        var formData,getUrl;
        formData = {sourcecode:code};
        getUrl = 'https://www.mileskimball.com/api/v1/ShoppingCart?forceValidateCart=false';
        $.ajax({
          url: url,
          type: 'POST',
          data: JSON.stringify(formData),
          contentType: 'application/json;charset=UTF-8',
          success: () => {
               $.get(getUrl, 
                (responseget) => {
                   const value = responseget.Totals.Total._amount; 
                    $.ajax({
                      url: url,
                      type: 'DELETE',
                      success: () => { callback(value); },
                      error: () => { callback(value); }
                    });
              }); 
          },
          error: (xhr, status, error) => {
             callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: (bestCode) => {
          document.querySelector('#sourceCode').value = bestCode;
          document.querySelector('#sourceCode').dispatchEvent(new Event('input', { bubbles: true } ));
          document.querySelector('#SourceCodeButton1').click(); 
      }
    },

    scholastic: {
      id: 1466,
      preApplyCodes: function(callback) {
        const elTotal = $('#order_total, .list-cart-total li:first span, .order_total, #lblGrandTotal');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) { 
        const windowVariables = retrieveWindowVariables(["window.Urls"]);
        const addCouponUrl = windowVariables["window.Urls"].addCoupon;      
            $.get(addCouponUrl+'?couponCode='+code+'&format=ajax', 
              (response) => {
               const value = response.baskettotal;
               callback(value);
              });         
      },
      applyBestCode: (bestCode) => {
        location.reload();
      }
    },

   'theclassyhome': {
      id: 7033,
      preApplyCodes: (callback) => {
        const orderValueEl = $('#grandtotal');
        const prevValue = orderValueEl.length > 0 ? 
                          Number(orderValueEl.first().text().trim().substr(1)) : 
                          Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: (code, callback) => {
        const url = 'https://www.theclassyhome.com/cartProcessor.php';
        const formData = {discountCode:code, command:'applyDiscountCode'};
        $.ajax({
          url: url,
          type: 'POST',
          data: formData,
          success: () => {
               $.post(url, {command:'getCartData'},
                (response) => {
                  const elTotal = $(response).find('#grandtotal');
                  const value = elTotal.length > 0 ? 
                                Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                                Number.POSITIVE_INFINITY;
                  callback(value);  
              }); 
          },
          error: (xhr, status, error) => {
             callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: (bestCode) => {
          document.querySelector('#discount-code').value = bestCode;
          document.querySelector('#discount-code').dispatchEvent(new Event('input', { bubbles: true } ));
          document.querySelector('#applyDiscountCode').click(); 
      }
    },

    thecpapshop: {
      id: 18467, 
      preApplyCodes: function(callback) {
        const elTotal = $('#shopping-cart-totals-table tfoot tr:last-child td:last-child .price');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        $.ajax({
          url: 'https://www.thecpapshop.com/checkout/cart/couponPost/',
          type: 'POST',
          data: {
            remove: 0,
            coupon_code: code
          },
          success: (data, textStatus, request) => {
            const locationUrl = request.getResponseHeader('location');
            $.get(locationUrl , (responseGet) => {
              const elTotal = $(responseGet).find('#shopping-cart-totals-table tfoot tr:last-child td:last-child .price');
              var value = 0;
              if( elTotal.length > 0 ){
                 $( elTotal ).each(function( index ) {
                  value += Number($( this ).text().replace( /[^0-9.]/g, '').trim());                
                 });
              }else{
                  value = Number.POSITIVE_INFINITY;
              }              
              callback(value);
            });
          },
          error: (xhr, status, error) => {
             callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#coupon_code').value = bestCode;
        document.querySelector('#coupon_code').dispatchEvent(new MouseEvent('input', { bubbles: true } ));
        document.querySelector('button[value="Apply Coupon"]').click();  
      }
    },

  amerimark: {
      id: 2825, 
      preApplyCodes: function(callback) {
        const elTotal = $('.orderSummaryCartTotalValue');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
         $.get('https://www.amerimark.com/ajax/setCouponCode.html?couponCode='+code, () => {
           $.get('https://www.amerimark.com/'+window.location.pathname, (response) => {
            const elTotal = $(response).find('.orderSummaryCartTotalValue');
            const value = elTotal.length > 0 ? 
                          Number(elTotal.first().text().trim().substr(1)) : 
                          Number.POSITIVE_INFINITY;
            callback(value);
             });
          });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#promo_code').value = bestCode;
        document.querySelector('#promo_code').dispatchEvent(new Event('input', {bubbles: true}));
        document.querySelector('#coupon_code_button').click();
      }
    },

  contactsdirect: {
      id: 24477,
      preApplyCodes: function(callback) {
        const elTotal = $('.cart_amount.price-align.insurance_amount.total');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        const csrfToken = $('[name="csrfToken"]').val();
       $.ajax({
          url: 'https://www.contactsdirect.com/cart/promo',
          type: 'POST',
          data: {promoCode:code, csrfToken:csrfToken },
          success: (response) => {
                const elTotal = $(response).find('.cart_amount.price-align.insurance_amount.total');
                const value = elTotal.length > 0 ? 
                              Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                              Number.POSITIVE_INFINITY;
                const removeUrl = $(response).find('.remove_promo').attr('href');
                if(removeUrl){
                  $.get('https://www.contactsdirect.com'+removeUrl, () => {
                   callback(value);
                 });
                }else{
                   callback(value);
                }                                 
          },
          error: (xhr, status, error) => {
             callback(Number.POSITIVE_INFINITY);
          }
        });         
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#promoCode').value = bestCode;
        document.querySelector('#promoCode').dispatchEvent(new MouseEvent('input', { bubbles: true } ));
        document.querySelector('#addPromo').click();  
      }
    },

  lapolicegear: {
      id: 5789,
      preApplyCodes: function(callback) {
        const elTotal = $('.cart-total-grandTotal');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
         const windowVariables = retrieveWindowVariables(["BCData"]);
         const csrf_token = windowVariables.BCData.csrf_token;
        $.ajax({
          url: 'https://lapolicegear.com/remote/v1/apply-code',
          type: 'POST',
          data: {code:code},
          headers: {
            'x-xsrf-token': csrf_token
          },
          success: (response) => {
            if(response.data.status == 'success'){
              $.ajax({
                url: 'https://lapolicegear.com/api/storefront/cart',
                type: 'GET',
                data: {code:code},
                headers: {
                  'x-xsrf-token': csrf_token
                },
                success: (response) => {
                  const value = response[0].cartAmount;
                  callback(value);
                },
                error: (xhr, status, error) => {
                   callback(Number.POSITIVE_INFINITY);
                }
              });
            }else{
              callback(Number.POSITIVE_INFINITY);
            }                                
          },
          error: (xhr, status, error) => {
             callback(Number.POSITIVE_INFINITY);
          }
        });         
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#couponcode').value = bestCode;
        document.querySelector('#couponcode').dispatchEvent(new MouseEvent('input', { bubbles: true } ));
        document.querySelector('.coupon-form input[value="Apply"]').click();  
      }
    },

    keenfootwear: {
      id: 15959,
      preApplyCodes: function(callback) {
        const elTotal = $('.price.total');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
         if(window.location.href.indexOf("cart") > -1){
          const url = $('form[name="dwfrm_cart"]').attr('action');
          const formData = getFormFieldsAsJson(document.querySelector('form[name="dwfrm_cart"]'));
          formData['dwfrm_cart_couponCode'] = code;
          formData['dwfrm_cart_addCoupon'] = 'dwfrm_cart_addCoupon';
          $.ajax({
            url: url,
            type: 'POST',
            data: formData,
            success: (response, status, xhr) => {
                const elTotal = $(response).find('.price.total');
                const value = elTotal.length > 0 ? 
                              Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                              Number.POSITIVE_INFINITY;                
                callback(value);
            },
            error: (xhr, status, error) => {
              callback(Number.POSITIVE_INFINITY);
            }
          });
        }else{
           $.get('https://www.keenfootwear.com/on/demandware.store/Sites-keen_us-Site/en_US/Cart-AddCouponJson?couponCode='+code+'&format=ajax', (responseGet) => {             
              const value = responseGet.baskettotal;
              callback(value);                  
            });
        }
      },
      applyBestCode: (bestCode) => {
        location.reload();  
      }
    },

  honest: {
      id: 14224,
      preApplyCodes: function(callback) {
        const elTotal = $('.grand-total');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {   
        const url = $('.promo-code-form').attr('action'); 
        const csrf_token = $('[name="csrf_token"]').val();   
          $.ajax({
            url: 'https://'+window.location.hostname+url+'?couponCode='+code+'&csrf_token='+csrf_token,
            type: 'GET',
            success: (response, status, xhr) => {
              if(response.totals){
                const elTotal = response.totals.grandTotal;
                const value = elTotal ? 
                        Number(elTotal.replace( /[^0-9.]/g, '').trim()) : 
                        Number.POSITIVE_INFINITY;
               callback(value);
              }else{
                callback(Number.POSITIVE_INFINITY);
              }              
            },error: (xhr, status, error) => {
              callback(Number.POSITIVE_INFINITY);
            }
          });       
      },
      applyBestCode: (bestCode) => {
        location.reload();
      }
    },

  campingworld: {
    id: 516, 
    preApplyCodes: function(callback) {
      const elTotal = $('.estimated-price');
      const prevValue = elTotal.length > 0 ? 
                    Number(elTotal.text().trim().substr(1)) : 
                    Number.POSITIVE_INFINITY;
       callback(prevValue);
    },
    applyCode: function(code, callback) {
      if(window.location.href.indexOf("cart") > -1){ 
        const url = $('form[name="dwfrm_cart"]').attr('action');
        const formData = getFormFieldsAsJson(document.querySelector('form[name="dwfrm_cart"]'));
        formData['dwfrm_cart_couponCode'] = code;
        formData['dwfrm_cart_addCoupon'] = 'dwfrm_cart_addCoupon';
        $.post(url, formData, 
          (response) => {
             const orderValueEl = $(response).find('.estimated-price');
             const value = orderValueEl.length > 0 ? 
                                Number(orderValueEl.text().trim().substr(1)) : 
                                Number.POSITIVE_INFINITY;               
             callback(value);
        });
      }else{
       const windowVariables = retrieveWindowVariables(["window.Urls"]);
       const addCouponUrl = windowVariables["window.Urls"].addCoupon;
        $.get(addCouponUrl+'?couponCode='+code+'&format=ajax&fromCheckout=true', 
        (response) => {
           $.get('https://'+window.location.hostname+window.location.pathname, 
              (responseget) => {
                 const orderValueEl = $(responseget).find('.estimated-price');
                 const value = orderValueEl.length > 0 ? 
                                    Number(orderValueEl.text().trim().substr(1)) : 
                                    Number.POSITIVE_INFINITY;               
                 callback(value); 
            });                  
        });
      }
    },
    applyBestCode: (bestCode) => {
      location.reload();
    }
  },

  overtons: {
    id: 1309, 
    preApplyCodes: function(callback) {
      const elTotal = $('.estimated-price');
      const prevValue = elTotal.length > 0 ? 
                    Number(elTotal.text().trim().substr(1)) : 
                    Number.POSITIVE_INFINITY;
       callback(prevValue);
    },
    applyCode: function(code, callback) {
      if(window.location.href.indexOf("cart") > -1){ 
        const url = $('form[name="dwfrm_cart"]').attr('action');
        const formData = getFormFieldsAsJson(document.querySelector('form[name="dwfrm_cart"]'));
        formData['dwfrm_cart_couponCode'] = code;
        formData['dwfrm_cart_addCoupon'] = 'dwfrm_cart_addCoupon';
        $.post(url, formData, 
          (response) => {
             const orderValueEl = $(response).find('.estimated-price');
             const value = orderValueEl.length > 0 ? 
                                Number(orderValueEl.text().trim().substr(1)) : 
                                Number.POSITIVE_INFINITY;               
             callback(value);
        });
      }else{
       const windowVariables = retrieveWindowVariables(["window.Urls"]);
       const addCouponUrl = windowVariables["window.Urls"].addCoupon;
        $.get(addCouponUrl+'?couponCode='+code+'&format=ajax&fromCheckout=true', 
        (response) => {
           $.get('https://'+window.location.hostname+window.location.pathname, 
              (responseget) => {
                 const orderValueEl = $(responseget).find('.estimated-price');
                 const value = orderValueEl.length > 0 ? 
                                    Number(orderValueEl.text().trim().substr(1)) : 
                                    Number.POSITIVE_INFINITY;               
                 callback(value); 
            });                  
        });
      }
    },
    applyBestCode: (bestCode) => {
      location.reload();
    }
  },

  allheart: {
      id: 15603, 
      preApplyCodes: function(callback) {
        const elTotal = $('#cart_value_total');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        var ts1 = Math.round(new Date().getTime());
        const Email = $('#Email').val();
         $.get('https://www.allheart.com/AppApplyCoupon.aspx?couponCode='+code+'&email='+encodeURIComponent(Email)+'&extra='+ts1+'&d=1', () => {
           setTimeout(function(){
            var ts2 = Math.round(new Date().getTime());        
             $.get('https://www.allheart.com/AppCartView.aspx?extra='+ts2, (responseGet) => {
                const data = JSON.parse(responseGet);
                const elTotal = data.subTotal;
                const value = elTotal ? 
                            Number(elTotal.replace( /[^0-9.]/g, '').trim()) : 
                            Number.POSITIVE_INFINITY;
                callback(value);
               }); 
            }, 1000);
          });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#coupon_code').value = bestCode;
        document.querySelector('#coupon_code').dispatchEvent(new Event('input', {bubbles: true}));
        document.querySelector('.apply_code.coupon').click();
      }
    },

    saatchiart: {
      id: 14427, 
      preApplyCodes: function(callback) {
        const elTotal = $('.cart__total .cart__total__inner .cart__total__row div span');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
       $.ajax({
            url: 'https://www.saatchiart.com/cart-api/coupon',
            type: 'PUT',
            data: {
              code: code,
            },
            success: (response) => {
              $.get('https://www.saatchiart.com/cart-api/cart', (responseGet) => {
                const value = responseGet.total_order_price_to_pay/100;
                callback(value);
               }); 
          },
          error: (xhr, status, error) => {
             callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: (bestCode) => {
         $.ajax({
            url: 'https://www.saatchiart.com/cart-api/coupon',
            type: 'PUT',
            data: {
              code: bestCode,
            },
            success: (response) => { location.reload(); }
          });
      }
    },

  newchic: {
      id: 26165, 
      preApplyCodes: function(callback) {
        const elTotal = $('.summary-subtotal-container-js div:last-child div');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
         $.post('https://www.newchic.com/api/shopcart/useCoupon/', {coupon_code: code}, (response) => {
          if(response.result.cartSumary){
            const elTotal = response.result.cartSumary.formatFinalTotal.amount;
            const value =  elTotal ? 
                          Number(elTotal.replace( /[^0-9.]/g, '').trim()) : 
                          Number.POSITIVE_INFINITY;
            callback(value);
          }else{
            callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('.coupon-select-input-js').value = bestCode;
        document.querySelector('.coupon-select-input-js').dispatchEvent(new Event('input', {bubbles: true}));
        document.querySelector('.coupon-discount-apply-btn-js').click();
      }
    },

    sonos: {
      id: 4840,
      preApplyCodes: function(callback) {
        const elTotal = $('.order-total .order-value');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        const windowVariables = retrieveWindowVariables(["window.Urls"]);
        const addCouponUrl = windowVariables["window.Urls"].addCartCoupon;      
            $.get(addCouponUrl+'?couponCode='+code+'&format=ajax', 
              (response) => {
               const value = response.baskettotal;
               callback(value);
              });         
      },
      applyBestCode: (bestCode) => {
        location.reload();
      }
    },

    swarovski: {
      id: 3712, 
      preApplyCodes: (callback) => {
        const elTotal = $('#cartSummary div:nth-child(4) div:nth-child(2) div');
        const prevValue = elTotal.text().replace( /[^0-9.]/g, '').trim();
        callback(prevValue);
      },
      applyCode: (code, callback) => {
        const CSRFTokenInfo =JSON.parse(sessionStorage.getItem("CSRFTokenInfo"));
        const csrf = CSRFTokenInfo.token;
        const url = 'https://www.swarovski.com/'+window.location.pathname;
         $.ajax({
              url: url+'voucher/apply/',
              type: 'POST',
              data: {voucherCode: code, CSRFToken:csrf},
              success: (response) => {
                $.get(url, (responseGet) => {
                  const orderValueEl = $(responseGet).find('#cartSummary div:nth-child(4) div:nth-child(2) div');
                  const value = orderValueEl.length > 0 ? 
                                    Number(orderValueEl.first().text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                                    Number.POSITIVE_INFINITY;
                   $.post(url+'voucher/remove/', {voucherCode: code, CSRFToken:csrf},
                    () => {
                      callback(value);
                    }).fail(function() {
                     callback(Number.POSITIVE_INFINITY);
                    }); 
                 }).fail(function() {
                 callback(Number.POSITIVE_INFINITY);
                });  
              },
              error: (xhr, status, error) => {
                 callback(Number.POSITIVE_INFINITY);
              }
            });
      },
      applyBestCode: (bestCode) => {
       const CSRFTokenInfo =JSON.parse(sessionStorage.getItem("CSRFTokenInfo"));
        const csrf = CSRFTokenInfo.token;
        const url = 'https://www.swarovski.com/en-US/cart/';
         $.ajax({
          url: url+'voucher/apply/',
          type: 'POST',
          data: {voucherCode: bestCode, CSRFToken:csrf},
          success: (response) => { location.reload(); },
          error: (response) => { location.reload(); },
        })
      }
    },

   dwr: {
      id: 3827,
      preApplyCodes: function(callback) {
        const elTotal = $('.order-total td:last-child');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
         if(window.location.href.indexOf("cart") > -1){
          const url = $('form[name="dwfrm_cart"]').attr('action');
          const formData = getFormFieldsAsJson(document.querySelector('form[name="dwfrm_cart"]'));
          formData['dwfrm_cart_couponCode'] = code;
          formData['dwfrm_cart_addCoupon'] = 'dwfrm_cart_addCoupon';
          $.ajax({
            url: url,
            type: 'POST',
            data: formData,
            success: (response, status, xhr) => {
                const elTotal = $(response).find('.order-total td:last-child');
                const value = elTotal.length > 0 ? 
                              Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                              Number.POSITIVE_INFINITY; 
                callback(value);
            },
            error: (xhr, status, error) => {
              console.log(error);
              callback(Number.POSITIVE_INFINITY);
            }
          });
        }else{
           const windowVariables = retrieveWindowVariables(["window.Urls"]);
           const addCouponUrl = windowVariables["window.Urls"].addCoupon;
           $.get(addCouponUrl+'?couponCode='+code+'&format=ajax', (response) => {             
                const value = response.baskettotal;
                callback(value);
            });
        }
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#dwfrm_cart_couponCode, #dwfrm_billing_couponCode').value = bestCode;
        document.querySelector('#dwfrm_cart_couponCode, #dwfrm_billing_couponCode').dispatchEvent(new Event('input', { bubbles: true } ));
        document.querySelector('#add-coupon, #apply-coupon').click();
      }
    },

  bodybuilding: {
    id: 160,
    preApplyCodes: function(callback) {
      const elTotal = $('#ShoppingCartTopBanner .order-total.order-total--highlight .order-total__price');
      const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
      callback(prevValue);
    },
    applyCode: function(code, callback) {
      const url = $('form#cartForm').attr('action');
      const formData = getFormFieldsAsJson(document.querySelector('form#cartForm'));       
      formData['promoCode'] = code;
      $.ajax({
        url: 'https://www.bodybuilding.com'+url,
        type: 'POST',
        data: formData,
        success: (data, textStatus, request) => {
            const locationUrl = request.getResponseHeader('location');
            $.get(locationUrl, 
              (response) => {
                const elTotal = $(response).find('#ShoppingCartTopBanner .order-total.order-total--highlight .order-total__price');
                const value = elTotal.length > 0 ? 
                              Number(elTotal.text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                              Number.POSITIVE_INFINITY;
                callback(value);
              });            
          },
          error: (xhr, status, error) => {
            callback(Number.POSITIVE_INFINITY);
          }
        });
    },
    applyBestCode: function(bestCode) {
      document.querySelector('#promoCode').value = bestCode;
      document.querySelector('#promoCode').dispatchEvent(new MouseEvent('input', {bubbles: true}));
      document.querySelector('.claim-coupon-btn').click();
    }
  },

  airportparkingreservations: {
    id: 4137,
    preApplyCodes: function(callback) {
      const elTotal = $('div:contains("Total")+div');
      const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
      callback(prevValue);
    },
    applyCode: function(code, callback) {
     const windowVariables = retrieveWindowVariables(["apr.add_coupon_link","window.Laravel"]);
     const url = windowVariables["apr.add_coupon_link"];
     const csrfToken = windowVariables["window.Laravel"].csrfToken;
      $.ajax({
        url: url,
        type: 'POST',
        data: JSON.stringify({code:code,coupon:code}),
        headers: {
            'Content-Type': 'application/json;charset=UTF-8',
            'x-csrf-token': csrfToken
            },
        success: (response) => {
           if(window.location.href.indexOf("psf_checkout") > -1){
            if(response.data){
              const value = (response.data.pricing.total).toFixed(2);
              callback(value);  
            }else{
              callback(Number.POSITIVE_INFINITY);
            }              
           }else{
             const value = (response.pricing.total).toFixed(2);
             callback(value);
           }                        
          },
          error: (xhr, status, error) => {
            callback(Number.POSITIVE_INFINITY);
          }
        });
    },
    applyBestCode: function(bestCode) {
       const windowVariables = retrieveWindowVariables(["apr.add_coupon_link","window.Laravel"]);
       const url = windowVariables["apr.add_coupon_link"];
       const csrfToken = windowVariables["window.Laravel"].csrfToken;
        $.ajax({
          url:  url,
          type: 'POST',
          data: JSON.stringify({code:bestCode,coupon:bestCode}),
          headers: {
              'Content-Type': 'application/json;charset=UTF-8',
              'x-csrf-token': csrfToken
              },
          success: () => { location.reload(); },
          error: () => { location.reload(); }
        });
     }
  },

  modcloth: {
    id: 1182,
    preApplyCodes: function(callback) {
      const elTotal = $('.order-value, tfoot .orderCost');
      const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
      callback(prevValue);
    },
    applyCode: function(code, callback) {
      const addCouponUrl = 'https://www.modcloth.com/on/demandware.store/Sites-modcloth-Site/default/CheckoutCart-AddCoupon';
      const removeCouponUrl = 'https://www.modcloth.com/on/demandware.store/Sites-modcloth-Site/default/CheckoutCart-RemoveCoupon';
      $.ajax({
        url: addCouponUrl,
        type: 'POST',
        data: JSON.stringify({CouponCode:code}),
        headers: {
            'Content-Type': 'application/json;charset=UTF-8',
          },
        success: (response) => {
            const data = JSON.parse(response);
            const value = data.adjustedMerchandizeCost;
            if(data.status == 'APPLIED'){
                $.ajax({
                url: removeCouponUrl,
                type: 'POST',
                data: JSON.stringify({CouponCode:code}),
                headers: {
                    'Content-Type': 'application/json;charset=UTF-8',
                    },
                 success: () => { callback(value); },
                 error: () => { callback(value); }
              });
            }else{
              callback(Number.POSITIVE_INFINITY);
            }                     
          },
          error: (xhr, status, error) => {
            callback(Number.POSITIVE_INFINITY);
          }
      });
    },
    applyBestCode: function(bestCode) {
      const addCouponUrl = 'https://www.modcloth.com/on/demandware.store/Sites-modcloth-Site/default/CheckoutCart-AddCoupon';
      $.ajax({
        url: addCouponUrl,
        type: 'POST',
        data: JSON.stringify({CouponCode:bestCode}),
        headers: {
            'Content-Type': 'application/json;charset=UTF-8',
          },
        success: () => { location.reload(); },
        error: () => { location.reload(); }
      });
    }
  },

  partswarehouse: {
     id: 27065,
      preApplyCodes: (callback) => {
        const elTotal = $("td#v65-cart-total-estimate-cell font b");
        const value   = elTotal.length > 0 ? 
                         Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) :
                         Number.POSITIVE_INFINITY;
        callback(value);
      },
      applyCode: (code, callback) => {
        const formData = getFormFieldsAsJson(document.querySelector('form[name="form"]'));
        formData['CouponCode'] = code;
        $.ajax({
          url: 'https://'+window.location.hostname+'/ShoppingCart.asp',
          type: 'POST',
          data: formData,
          success: (response) => {
             $.get('https://'+window.location.hostname+window.location.pathname, 
              (responseGet) => {
               const elTotal = $(responseGet).find('td#v65-cart-total-estimate-cell font b');
               const value = elTotal.length > 0 ? 
                            Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                            Number.POSITIVE_INFINITY;
              $.ajax({
                url: 'https://'+window.location.hostname+'/ShoppingCart.asp?RemoveCouponCode='+code,
                type: 'GET',
                success: () => { callback(value); },error: ()=>{callback(value); }
              });
            })
          },
          error: (xhr, status, error) => {
            callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#v65-cart-coupon-entry-details-input').value = bestCode;
        document.querySelector('#v65-cart-coupon-entry-details-input').dispatchEvent(new MouseEvent('input', {bubbles: true}));
        document.querySelector('#v65-cart-coupon-entry-details-button').click();
      }
    },

  pensketruckrental: {
      id: 17758,
      preApplyCodes: (callback) => {
        const elTotal = $(".price.total");
        const value   = elTotal.length > 0 ? 
                         Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) :
                         Number.POSITIVE_INFINITY;
        callback(value);
      },
      applyCode: (code, callback) => {
        var ts1 = Math.round(new Date().getTime());
        const window_name =  sessionStorage.getItem("window_name");
        const business = sessionStorage.getItem("Personal");
        var businessType,rentalType;
        if(business && business == 'TRUE'){
          businessType = 'personal';
        }else{
          businessType = 'commercial';
        }
        const rental = document.querySelector('truck').getAttribute('ng-reflect-is-round-trip');
        if(rental == 'true'){
          rentalType = 'local';
        }else{
          rentalType = 'oneway';
        }
        $.ajax({
          url: 'https://www.pensketruckrental.com/erental2/api/shoppingcart/add-promo?cache='+ts1+'&window_name='+window_name,
          type: 'POST',
          data: JSON.stringify({promoCode: code, businessType:businessType, country:"US", rentalType:rentalType}),
          headers: {
            'Content-Type': 'application/json',
          },
          success: (response) => {
            if(response.data.cartTotal){
              const value = response.data.cartTotal;
              var ts2 = Math.round(new Date().getTime());
             $.ajax({
                url: 'https://www.pensketruckrental.com/erental2/api/shoppingcart/remove-promo?cache='+ts2+'&window_name='+window_name,
                type: 'POST',
                data: JSON.stringify({promoCode: code, businessType:businessType, country:"US", rentalType:rentalType}),
                headers: {
                  'Content-Type': 'application/json',
                },
                success: () => { callback(value); },
                error: () => { callback(value);  }
              })
            }else{
              callback(Number.POSITIVE_INFINITY);
            }            
          },
          error: (xhr, status, error) => {
            callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: (bestCode) => {
        var ts1 = Math.round(new Date().getTime());
        const window_name =  sessionStorage.getItem("window_name");
        const business = sessionStorage.getItem("Personal");
        var businessType,rentalType;
        if(business && business == 'TRUE'){
          businessType = 'personal';
        }else{
          businessType = 'commercial';
        }
        const rental = document.querySelector('truck').getAttribute('ng-reflect-is-round-trip');
        if(rental == 'true'){
          rentalType = 'local';
        }else{
          rentalType = 'oneway';
        }
        $.ajax({
          url: 'https://www.pensketruckrental.com/erental2/api/shoppingcart/add-promo?cache='+ts1+'&window_name='+window_name,
          type: 'POST',
          data: JSON.stringify({promoCode: bestCode, businessType:businessType, country:"US", rentalType:rentalType}),
          headers: {
            'Content-Type': 'application/json',
          },
          success: (response) => { location.reload(); },
          error: (xhr, status, error) => {location.reload(); }
        });
      }
    },

  madewell: {
      id: 7579,
      preApplyCodes: (callback) => {
        const orderValueEl = $('.order-total .order-value');
        const prevValue = orderValueEl.length > 0 ? 
                          Number(orderValueEl.first().text().trim().substr(1)) : 
                          Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: (code, callback) => {
      if(window.location.href.indexOf("cart") > -1){ 
        const url = $('#cart-items-form').attr('action');
        const formData = getFormFieldsAsJson(document.querySelector('#cart-items-form'));
        formData['dwfrm_cart_couponCode'] = code;
        formData['dwfrm_cart_updateCart'] = 'dwfrm_cart_updateCart';
        formData['dwfrm_cart_addCoupon'] = 'true';
        $.post(url, formData, 
          (response) => {
            $.get('https://'+window.location.hostname+window.location.pathname, 
              (responseGet) => {
                const orderValueEl = $(responseGet).find('.order-total .order-value');
                const value = orderValueEl.length > 0 ? 
                                  Number(orderValueEl.first().text().trim().substr(1)) : 
                                  Number.POSITIVE_INFINITY;
                callback(value);
              });            
          });
      }else{
        const windowVariables = retrieveWindowVariables(["window.Urls"]);
        const addCouponUrl = windowVariables["window.Urls"].addCoupon;
          $.get(addCouponUrl+'?couponCode='+code+'&format=ajax', 
              (response) => { 
                $.get('https://'+window.location.hostname+window.location.pathname, 
                  (responseGet) => {
                    const orderValueEl = $(responseGet).find('.order-total .order-value');
                    const value = orderValueEl.length > 0 ? 
                                      Number(orderValueEl.first().text().trim().substr(1)) : 
                                      Number.POSITIVE_INFINITY;
                    callback(value);
                  });        
              }); 
          }
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#dwfrm_cart_couponCode, #dwfrm_billing_couponCode').value = bestCode;
        document.querySelector('#dwfrm_cart_couponCode, #dwfrm_billing_couponCode').dispatchEvent(new Event('input', { bubbles: true } ));
        document.querySelector('#add-coupon').click();
      }
    },

  nautica: {
     id: 3970,
      preApplyCodes: function(callback) {
        const elTotal = $('.bfx-total-grandtotal');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().trim().substr(1)) : 
                      Number.POSITIVE_INFINITY;     
          const url = $('form[name="dwfrm_cart"]').attr('action');
          const formData = getFormFieldsAsJson(document.querySelector('form[name="dwfrm_cart"]'));
          formData['dwfrm_cart_coupons_i0_deleteCoupon'] = 'Remove';
          $.post(url, formData, 
            (response) => {
               callback(prevValue);
          });       
      },
      applyCode: function(code, callback) {  
          this.preApplyCodes(() => {
            const url = $('form[name="dwfrm_cart"]').attr('action');
            const formData = getFormFieldsAsJson(document.querySelector('form[name="dwfrm_cart"]'));
            formData['dwfrm_cart_couponCode'] = code;
            formData['dwfrm_cart_addCoupon'] = 'dwfrm_cart_addCoupon';
              $.post(url, formData, 
              (responsePost) => {               
                    const orderValueEl = $(responsePost).find('.bfx-total-grandtotal');
                    const value = orderValueEl.length > 0 ? 
                                    Number(orderValueEl.first().text().trim().substr(1)) : 
                                    Number.POSITIVE_INFINITY;  
                    callback(value); 
              }); 
          });        
      },
      applyBestCode: (bestCode) => {
        document.querySelector('[name="dwfrm_cart_couponCode"]').value = bestCode;
        document.querySelector('[name="dwfrm_cart_couponCode"]').dispatchEvent(new Event('input', { bubbles: true } ));
        document.querySelector('#add-coupon').click();
      }
    },

    jackrabbit: {
      id: 26640, 
      preApplyCodes: function(callback) {
         const elTotal = $('div[data-totals-component="grandTotal"] dd');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {        
        const csrf_token = $('input[name="csrf_token"]').val();
        const windowVariables = retrieveWindowVariables(["window.SFRA.Urls"]);
        const digitalbasketurl = windowVariables["window.SFRA.Urls"].dotdigitalBasket;
        const url = $('.promo-code-form ').attr('data-action-url');
         $.get('https://www.jackrabbit.com'+url+'?csrf_token='+csrf_token+'&couponCode='+code, 
          (response) => {
            if(response.dotdigitalCartData){
              const value = response.dotdigitalCartData.grandTotal;
              callback(value);
            }else{
              callback(Number.POSITIVE_INFINITY);
            }
          });
      },
      applyBestCode: (bestCode) => {
        location.reload();
      }
    },


  kiehls: {
    removePrevCode: function(code, callback) {
      var formData = {};
      formData['coupon_remove_'+code] = code
      const url = $('.c-form.m-reset.c-cart-coupon__form').attr('action');
      $.ajax({
        url: url+'?ajax=true',
        type: 'POST',
        data: formData,
        success: () => { callback(); },
        error: () => { callback(); }
      });   
    },
    preApplyCodes: function(callback) { 
      const elTotal = document.querySelector('.c-cart-summary-table .m-total .m-value').innerText;
      const prevValue = elTotal.replace(/[^0-9.]/g, '').trim();
      const prevCodeSelector = document.querySelector('.c-cart-coupon__list-remove');
      if(prevCodeSelector){
        const prevCode = prevCodeSelector.value;
        const prevCodeName = prevCodeSelector.getAttribute('name');
        this.removePrevCode(prevCode, () => callback(prevValue, prevCode));
      }else{
        callback(prevValue);
      }      
    },
    applyCode: function(code, callback) {
      this._applyCode(code, function(value) {
      this.removePrevCode(code, () => callback(value));
     }.bind(this));
    },
    applyBestCode: function(bestCode) {
      this._applyCode(bestCode, function(value) {
        location.reload();
      });   
    },
    _applyCode: (code, callback) => { 
      const url = $('.c-form.m-reset.c-cart-coupon__form').attr('action');
      const formData = getFormFieldsAsJson(document.querySelector('.c-form.m-reset.c-cart-coupon__form'));
      formData['couponcode'] = code;
      $.ajax({
        url: url+'?ajax=true',
        type: 'POST',
        data: formData,
        success: (responsePost) => { 
          const orderValueEl = $(responsePost).find('.c-cart-summary-table .m-total .m-value');
          const value = orderValueEl.length > 0 ? 
                      Number(orderValueEl.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY; 
          callback(value);
        },error: () => { callback(Number.POSITIVE_INFINITY); }
      });
    },
  },

    lovelyskin: {
      id: 1114, 
      preApplyCodes: function(callback) {
        const elTotal = $('.row.margin-bottom :last-child strong, #order-summary tbody tr:last-child td:last-child');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        const prevCode = $("a.modalTrigger .underline, #promo-code-form a.lsu-c-promo.lsu-td-u[data-toggle='modal'][data-log-id='SpecialOfferDetails:PromoCode:Summary']").text();
        callback(prevValue,prevCode);
      },
      applyCode: function(code, callback) {
         var url,formData,getUrl,ts,data;
         if(window.location.href.indexOf("cart") > -1){ 
            url = 'https://www.lovelyskin.com/cart/applypromocode';
            getUrl = 'https://www.lovelyskin.com/cart';
            formData = getFormFieldsAsJson(document.querySelector('form#form0'));
            formData['Value'] = code;
         }else{
            ts = Math.round(new Date().getTime());
            url = 'https://www.lovelyskin.com/securecheckout/promocode/add';
            getUrl = 'https://www.lovelyskin.com/securecheckout/payment/layout?_='+ts;
            formData = getFormFieldsAsJson(document.querySelector('#promo-code-form form'));
            formData['PromoCode'] = code;
            formData['promoCodeToggle'] = 'true'; 
         }
         $.ajax({
            url: url,
            type: 'POST',
            data: formData,
            success: (response) => {
             $.get(getUrl, 
               (responseGet) => { 
                  if(window.location.href.indexOf("cart") > -1){ 
                    data = responseGet;
                  }else{
                    data = responseGet.layout.html;
                  }
                  const elTotal = $(data).find('.row.margin-bottom :last-child strong, #order-summary tbody tr:last-child td:last-child');
                  const value = elTotal.length > 0 ? 
                  Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                  Number.POSITIVE_INFINITY;
                  callback(value);    
               });
            },
            error: (xhr, status, error) => {
               callback(Number.POSITIVE_INFINITY);
            }
          }); 
      },
      applyBestCode: (bestCode) => {
        var url,formData;
         if(window.location.href.indexOf("cart") > -1){ 
            url = 'https://www.lovelyskin.com/cart/applypromocode';
            formData = getFormFieldsAsJson(document.querySelector('form#form0'));
            formData['Value'] = bestCode;
         }else{
            url = 'https://www.lovelyskin.com/securecheckout/promocode/add';
            formData = getFormFieldsAsJson(document.querySelector('#promo-code-form form'));
            formData['PromoCode'] = bestCode;
            formData['promoCodeToggle'] = 'true';  
         } 
            $.ajax({
              url: url,
              type: 'POST',
              data: formData,
              success: () => { location.reload(); },
              error: () => { location.reload(); }
            });
      }
    },

   acmetools: {
      id: 17544,
      preApplyCodes: (callback) => {
        const elTotal = $('#order_total tr:last-child td:last-child');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: (code, callback) => {    
        const url = 'https://www.acmetools.com/shop/AjaxRESTPromotionCodeApply';
        const formData = getFormFieldsAsJson(document.querySelector('form[name="PromotionCodeForm"]'));
          formData['promoCode'] = code; 
          formData['requesttype'] = 'ajax';
        $.ajax({
          url: url,
          type: 'POST',
          data: formData,
          success: (response) => {
            const catalogId = $('#PromotionCodeForm input[name="catalogId"]').val();
            var storeId = $('#PromotionCodeForm input[name="storeId"]').val();
            var langId = $('input[name="langId"]').val();
            var getUrl = 'https://www.acmetools.com/shop/ShopCartDisplayView?shipmentType=single&catalogId='+catalogId+'&langId='+langId+'&storeId='+storeId;
             $.ajax({
                  url: getUrl,
                  type: 'POST',
                  data: {
                    'objectId': '',
                    'requesttype': 'ajax'
                  },
                  success: (response) => {                    
                    const elTotal =  $(response).find('#order_total tr:last-child td:last-child');                   
                    const value = elTotal.length > 0 ? 
                                  Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                                  Number.POSITIVE_INFINITY;                   
                    const formData2 = formData;
                     formData2['taskType'] = 'R';                    
                      var removeUrl = 'https://www.acmetools.com/shop/AjaxRESTPromotionCodeRemove';
                       $.ajax({
                            url: removeUrl,
                            type: 'POST',
                            data: formData2,
                            success: (response) => {   callback(value); },
                            error: (response) => {   callback(value); }
                          });
                  },
                    error: (xhr, status, error) => {
                      callback(Number.POSITIVE_INFINITY);
                    }
                });
          },
          error: (xhr, status, error) => {
            callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: (bestCode) => {
         document.querySelector('#promoCode').value = bestCode;
         document.querySelector('#promoCode').dispatchEvent(new Event('input', {bubbles: true}));
         document.querySelector('#WC_PromotionCodeDisplay_links_1').click();
      }
    },

  tjx: {
      id: 9798,
      preApplyCodes: function(callback) {
        const elTotal = $('span.order-total-price, #totalPrice');
        const prevValue = elTotal.length > 0 ? 
                        Number(elTotal.text().trim().substr(1)) : 
                        Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        const formData = getFormFieldsAsJson(document.querySelector('form[name="promoForm"]'));       
        formData['/atg/commerce/promotion/CouponFormHandler.couponClaimCode'] = code;
        formData['/atg/commerce/promotion/CouponFormHandler.claimCoupon'] = 'APPLY';
        $.ajax({
          url: 'https://tjmaxx.tjx.com/store/checkout/cart.jsp?_DARGS=/store/checkout/views/cart.jsp.promo',
          type: 'POST',
          data: formData,
          success: (data, textStatus, request) => {
             const locationUrl = request.getResponseHeader('Location');
              $.ajax({
                  url: locationUrl,
                  type: 'GET',
                  success: (response) => {
                          const elTotal = $(response).find('span.order-total-price, #totalPrice');
                          const value = elTotal.length > 0 ? 
                                        Number(elTotal.text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                                        Number.POSITIVE_INFINITY;
                          callback(value);
                  }, error: (xhr, status, error) => {
                  callback(Number.POSITIVE_INFINITY);
                 }
                })           
            },
           error: (xhr, status, error) => {
            callback(Number.POSITIVE_INFINITY);
           }
          });
      },
      applyBestCode: function(bestCode) {
        document.querySelector('#promo-code').value = bestCode;
        document.querySelector('#promo-code').dispatchEvent(new MouseEvent('input', {bubbles: true}));
        document.querySelector('#accept-promotion').click();
      }
    },

    paulfredrick: {
      id: 3072,
      preApplyCodes: (callback) => {
        const orderValueEl = $('.order-total span:last-child, .column-inner .order-summary div .span-total');
        console.log(orderValueEl);
        const prevValue = orderValueEl.length > 0 ? 
                          Number(orderValueEl.first().text().replace( /[^0-9.]/g, '').trim()) :
                          Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: (code, callback) => {
        const url = 'https://www.paulfredrick.com/checkout/cart.aspx?mn=expandablebag';
        const formData = getFormFieldsAsJson(document.querySelector('#form1'));
        formData['ctl00$MainContent$PromoCodes$PromoCodeTextBox'] = code;
        formData['ctl00$MainContent$PromoCodes$ApplyPromoButton.x'] = '0';
        formData['ctl00$MainContent$PromoCodes$ApplyPromoButton.y'] = '0';
        formData['ctl00$MainContent$PromoCodes$PromoCodeTextBox_edit'] = code;
        formData['ctl00$MainContent$PromoCodes$CouponReset.x'] = '0';
        formData['ctl00$MainContent$PromoCodes$CouponReset.y'] = '0';
         $.ajax({
          url: url,
          type: 'POST',
          data: formData,
          success: (data, textStatus, request) => {
            const locationUrl = request.getResponseHeader('location');
            $.get(locationUrl, 
            (response) => {
              const orderValueEl = $(response).find('.order-total span:last-child, .column-inner .order-summary div .span-total');
              const value = orderValueEl.length > 0 ? 
                                Number(orderValueEl.first().text().replace( /[^0-9.]/g, '').trim()) : 
                                Number.POSITIVE_INFINITY;
              callback(value);
            }) 
          },
           error: (xhr, status, error) => {
            callback(Number.POSITIVE_INFINITY);
           }
        })
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#ctl00_MainContent_PromoCodes_PromoCodeTextBox, #PromoCodeTextBox_edit, #txtPromoCode').value = bestCode;
        document.querySelector('#ctl00_MainContent_PromoCodes_PromoCodeTextBox, #PromoCodeTextBox_edit, #txtPromoCode').dispatchEvent(new Event('input', { bubbles: true } ));
        document.querySelector('#ApplyPromoButton, .btn-promo-apply, #btnApplyPromo').click();
      }
    },

    casper: {
      id: 22995, 
      preApplyCodes: function(callback) {
        const elTotal = $('#order-summary [data-summary-item="total"] span:last-child');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
         var ts = Math.round(new Date().getTime());
         $.get('https://casper.com/japi/order?include=&ts='+ts, 
          (response) => {
            const orderId = response.data.attributes.number;
            const removeurl = 'https://casper.com/japi/order/remove_promos?include=&order='+orderId;
             $.post(removeurl, 
              () => {               
                   callback(prevValue); 
              }); 
          });        
      },
      applyCode: function(code, callback) {
        var ts = Math.round(new Date().getTime());
         $.get('https://casper.com/japi/order?include=&ts='+ts, 
          (response) => {
            const orderId = response.data.attributes.number;
            const applyurl = 'https://casper.com/japi/order/apply_promo?include=&order='+orderId+'&coupon_code='+code;
            const removeurl = 'https://casper.com/japi/order/remove_promos?include=&order='+orderId;
             $.post(applyurl, 
              (responsePost) => {               
                    const value = responsePost.included['1'].attributes.order;
                    $.post(removeurl, () => {  callback(value);  }); 
              }); 
          });
      },
      applyBestCode: (bestCode) => {
         var ts = Math.round(new Date().getTime());
         $.get('https://casper.com/japi/order?include=&ts='+ts, 
          (response) => {
            const orderId = response.data.attributes.number;
            const applyurl = 'https://casper.com/japi/order/apply_promo?include=&order='+orderId+'&coupon_code='+bestCode;
              $.post(applyurl, 
              () => {               
                    location.reload(); 
              }); 
          });
      }
    },

    mintmobile: {
      id: 34839,
      preApplyCodes: function(callback) {
        const elTotal = $('.total + .total-value .currency, #opc_totals .total-value.nowrap .currency, .Order-total [data-title="Total"]');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        var url,formData,getUrl,method,getformData,ts,mainMethod,priceSelector;
        ts = Math.round(new Date().getTime());
        if(window.location.href.indexOf("checkout") > -1 && window.location.href.indexOf("phones") > -1){
          url = 'https://phones.mintmobile.com/cart.php';
          formData = {coupon:code, mode:'add_coupon'};
          getUrl = 'https://phones.mintmobile.com/get_block.php?block=opc_totals';
          priceSelector = '.total + .total-value .currency, .total-value.nowrap .currency'
          getformData = {t:ts};
          mainMethod = 'POST';
          method = 'GET';
        }else if(window.location.href.indexOf("cart.php") > -1 && window.location.href.indexOf("phones") > -1){
          url = 'https://phones.mintmobile.com/cart.php';
          formData = getFormFieldsAsJson(document.querySelector('[name="couponform"]'));
          formData['coupon'] = code;
          formData['mode'] = 'add_coupon';
          getUrl = 'https://phones.mintmobile.com/cart.php';
          priceSelector = '.total + .total-value .currency, #opc_totals .total-value.nowrap .currency'
          method = 'GET';
          mainMethod = 'GET';
        }else{
          url = 'https://www.mintmobile.com/cart/';
          formData = getFormFieldsAsJson(document.querySelector('form.Order-form'));
          formData['coupon_code'] = code;
          formData['apply_coupon'] = 'Apply coupon';
          getUrl = 'https://www.mintmobile.com/cart/';
          priceSelector = '.Order-total [data-title="Total"]'
          method = 'GET';
          mainMethod = 'POST';
        }
        $.ajax({
          url: url,
          type: mainMethod,
          data: formData,
          success: () => {
             $.ajax({
                url: getUrl,
                type: method,
                data: getformData,
                success: (responseGet) => {
                  const elTotal = $(responseGet).find(priceSelector);
                  const value = elTotal.length > 0 ? 
                                Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                                Number.POSITIVE_INFINITY;
                  callback(value);
                }
              });
          },
          error: (xhr, status, error) => {
             callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: (bestCode) => {
       location.reload();
      }
    },

 rockler: {
      id: 2550, 
      preApplyCodes: function(callback) {  
        const elTotal = $('tr.grand.totals span.price');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;        

        if(window.location.href.indexOf("cart") > -1){
          const url = $('#discount-coupon-form').attr('action');
          $.post(url, {  remove: 1  }, 
            (response) => {
             callback(prevValue);
            });
         }else{
           const windowVariables = retrieveWindowVariables(["window.checkoutConfig","window.NREUM"]);
           const quoteId = windowVariables["window.checkoutConfig"].quoteId;
           const xpid = windowVariables["window.NREUM"].loader_config.xpid;
           $.ajax({
              url: 'https://www.rockler.com/rest/default/V1/guest-carts/'+quoteId+'/coupons',
              type: 'DELETE',
              headers: {
              'x-newrelic-id': xpid
              },
              success: () => { callback(prevValue); },
              error: () => { callback(prevValue); }
          });
        }
      },
      applyCode: function(code, callback) {
       this.preApplyCodes(() => {
        if(window.location.href.indexOf("cart") > -1){
          const url = $('#discount-coupon-form').attr('action');
          $.ajax({
            url: url,
            type: 'POST',
            data: {
              remove: 0,
              coupon_code: code
            },
            success:  (data, textStatus, request1) => {                
             const locationUrl = request1.getResponseHeader('location');
              $.get(locationUrl, (responseGet) => {
                const checkoutconfigindex = responseGet.indexOf("window.checkoutConfig");
                const customerDataindex = responseGet.indexOf("window.customerData");
                const finalIndex = customerDataindex-checkoutconfigindex;
                const data = JSON.parse(responseGet.substr(responseGet.indexOf("window.checkoutConfig")+23, finalIndex-37));
                const value = data.totalsData.base_grand_total;
                callback(value);             
              });
            },error: (xhr, status, error) => {
               callback(Number.POSITIVE_INFINITY);
            }
          });
        }else{
         const windowVariables = retrieveWindowVariables(["window.checkoutConfig","window.NREUM"]);
         const quoteId = windowVariables["window.checkoutConfig"].quoteId;
         const xpid = windowVariables["window.NREUM"].loader_config.xpid;
         $.ajax({
          url: 'https://www.rockler.com/rest/default/V1/guest-carts/'+quoteId+'/coupons/'+code,
          type: 'PUT',
          headers: {
          'x-newrelic-id': xpid
          },
          success: (data) => {
            const ts = Math.round(new Date().getTime());
                $.ajax({
                  url: 'https://www.rockler.com/rest/default/V1/guest-carts/'+quoteId+'/payment-information?_='+ts,
                  type: 'GET',
                  headers: {
                  'x-newrelic-id': xpid
                  },
                  success: (response) => {
                    const value = response.totals.base_grand_total;
                    callback(value.toFixed(2));
                  }
                });
              },
              error: (xhr, status, error) => {
                console.log(error);
                callback(Number.POSITIVE_INFINITY);
              }
            })
         }
       });
      },
      applyBestCode: (bestCode) => {
       if(window.location.href.indexOf("cart") > -1){
         const url = $('#discount-coupon-form').attr('action');
         $.post(url, { remove: 0, coupon_code: bestCode }, 
          (response) => {
            location.reload();
          });
       }else{
         const windowVariables = retrieveWindowVariables(["window.checkoutConfig","window.NREUM"]);
         const quoteId = windowVariables["window.checkoutConfig"].quoteId;
         const xpid = windowVariables["window.NREUM"].loader_config.xpid;
         $.ajax({
              url: 'https://www.rockler.com/rest/default/V1/guest-carts/'+quoteId+'/coupons/'+bestCode,
              type: 'PUT',
              headers: {
              'x-newrelic-id': xpid
              },
              success: (data) => {location.reload();}
          });     
        }  
      }
    },

    kaspersky: {
      id: 264,
      preApplyCodes: function(callback) {
        const elTotal = $('.dr_priceVAT.dr_totals.dr_totalAmountWithVat, #dr_priceTotal .dr_totals span');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                      Number.POSITIVE_INFINITY;        
        callback(prevValue);
      },
      applyCode: function(code, callback) {      
        const formData = getFormFieldsAsJson(document.querySelector('form[name="ShoppingCartForm"]'));
        formData['couponCode'] = code;
        const url = $('form[name="ShoppingCartForm"]').attr('action');
        $.post('https://'+window.location.hostname+url, formData, 
          (data, textStatus, request1) => {
           const locationUrl = request1.getResponseHeader('location');
            $.get(locationUrl, 
              (responseGet) => {
                const elTotal = $(responseGet).find('.dr_priceVAT.dr_totals.dr_totalAmountWithVat, #dr_priceTotal .dr_totals span');
                const value = elTotal.length > 0 ? 
                              Number(elTotal.first().text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                              Number.POSITIVE_INFINITY;
                callback(value);
              });
          });
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#promoCode').value = bestCode;
        document.querySelector('#promoCode').dispatchEvent(new Event('input', { bubbles: true } ));
        document.querySelector('.couponCodeContent .dr_button').click();
      }
    },

    riteaid: {
      id: 7355, 
      preApplyCodes: function(callback) {  
        const elTotal = $('tr.grand.totals span.price');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY; 
        if(window.location.href.indexOf("cart") > -1){
          const url = $('#discount-coupon-form').attr('action');
          const form_key = $('input[name="form_key"]').val();
          $.post(url, {  remove: 1,form_key:form_key  }, 
            (response) => {
             callback(prevValue);
            });
         }else{
           const windowVariables = retrieveWindowVariables(["window.checkoutConfig","window.NREUM"]);
           const quoteId = windowVariables["window.checkoutConfig"].quoteId;
           const xpid = windowVariables["window.NREUM"].loader_config.xpid;
           $.ajax({
              url: 'https://www.riteaid.com/shop/rest/default/V1/guest-carts/'+quoteId+'/coupons',
              type: 'DELETE',
              headers: {
              'x-newrelic-id': xpid
              },
              success: () => { callback(prevValue); },
              error: () => { callback(prevValue); }
          });
        }
      },
      applyCode: function(code, callback) {
       this.preApplyCodes(() => {
        if(window.location.href.indexOf("cart") > -1){
          const url = $('#discount-coupon-form').attr('action');
          const form_key = $('input[name="form_key"]').val();
          $.ajax({
            url: url,
            type: 'POST',
            data: {
              remove: 0,
              coupon_code: code,
              form_key:form_key
            },
            success:  (data, textStatus, request1) => {                
             const locationUrl = request1.getResponseHeader('location');
              $.get(locationUrl, (responseGet) => {
                const checkoutconfigindex = responseGet.indexOf("window.checkoutConfig");
                const customerDataindex = responseGet.indexOf("window.customerData");
                const finalIndex = customerDataindex-checkoutconfigindex;
                const data = JSON.parse(responseGet.substr(responseGet.indexOf("window.checkoutConfig")+23, finalIndex-37));
                const value = data.totalsData.base_grand_total;
                 callback(value);             
              });
            },error: (xhr, status, error) => {
               callback(Number.POSITIVE_INFINITY);
            }
          });
        }else{
         const windowVariables = retrieveWindowVariables(["window.checkoutConfig","window.NREUM"]);
         const quoteId = windowVariables["window.checkoutConfig"].quoteId;
         const xpid = windowVariables["window.NREUM"].loader_config.xpid;
         $.ajax({
          url: 'https://www.riteaid.com/shop/rest/default/V1/guest-carts/'+quoteId+'/coupons/'+code,
          type: 'PUT',
          headers: {
          'x-newrelic-id': xpid
          },
          success: (data) => {
            const ts = Math.round(new Date().getTime());
                $.ajax({
                  url: 'https://www.riteaid.com/shop/rest/default/V1/guest-carts/'+quoteId+'/payment-information?_='+ts,
                  type: 'GET',
                  headers: {
                  'x-newrelic-id': xpid
                  },
                  success: (response) => {
                    const value = response.totals.base_grand_total;
                    callback(value.toFixed(2));
                  }
                });
              },
              error: (xhr, status, error) => {
                callback(Number.POSITIVE_INFINITY);
              }
            })
         }
       });
      },
      applyBestCode: (bestCode) => {
       if(window.location.href.indexOf("cart") > -1){
         const url = $('#discount-coupon-form').attr('action');
         const form_key = $('input[name="form_key"]').val();
         $.post(url, { remove: 0, coupon_code: bestCode,form_key:form_key }, 
          (response) => {
            location.reload();
          });
       }else{
         const windowVariables = retrieveWindowVariables(["window.checkoutConfig","window.NREUM"]);
         const quoteId = windowVariables["window.checkoutConfig"].quoteId;
         const xpid = windowVariables["window.NREUM"].loader_config.xpid;
         $.ajax({
              url: 'https://www.riteaid.com/shop/rest/default/V1/guest-carts/'+quoteId+'/coupons/'+bestCode,
              type: 'PUT',
              headers: {
              'x-newrelic-id': xpid
              },
              success: (data) => {location.reload();}
          });     
        }  
      }
    },

  dealgenius: {
      id: 6394,
      preApplyCodes: function(callback) {
        const elTotal = $('#cart-totals .amount[data-th="Total"] .price, .grand.totals .amount .price, strong .price');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        if(window.location.href.indexOf("cart") > -1){
            const url = $('#discount-coupon-form').attr('action');
            const form_key = $('input[name="form_key"]').val();
            $.post(url, { remove: 1,form_key: form_key }, 
            (response) => {
                 callback(prevValue);
            });
        }else{
           const windowVariables = retrieveWindowVariables(["window.checkoutConfig"]);
           const quoteId = windowVariables["window.checkoutConfig"].quoteId;
           $.ajax({
            url: 'https://www.dealgenius.com/rest/default/V1/guest-carts/'+quoteId+'/coupons',
            type: 'DELETE',
            success: () => { callback(prevValue); },
            error: () => { callback(prevValue); }
          });
        }
      },
      applyCode: function(code, callback) {
        this.preApplyCodes(() => {
        if(window.location.href.indexOf("cart") > -1){
          const url = $('#discount-coupon-form').attr('action');
          const form_key = $('input[name="form_key"]').val();
          $.ajax({
            url: url,
            type: 'POST',
            data: {
              remove: 0,
              form_key: form_key,
              coupon_code: code
            },
            success: () => {
              $.get('https://www.dealgenius.com'+window.location.pathname, (responseGet) => {
                const checkoutconfigindex = responseGet.indexOf("window.checkoutConfig");
                const customerDataindex = responseGet.indexOf("window.customerData");
                const finalIndex = customerDataindex-checkoutconfigindex;
                const data = JSON.parse(responseGet.substr(responseGet.indexOf("window.checkoutConfig")+23, finalIndex-37));
                const value = data.totalsData.base_grand_total;
                callback(value);
              });
            },error: (xhr, status, error) => {
               callback(Number.POSITIVE_INFINITY);
            }
          });
        }else{
          const windowVariables = retrieveWindowVariables(["window.checkoutConfig"]);
           const quoteId = windowVariables["window.checkoutConfig"].quoteId;
           $.ajax({
                url: 'https://www.dealgenius.com/rest/default/V1/guest-carts/'+quoteId+'/coupons/'+code,
                type: 'PUT',
                success: (data) => {
                  const ts = Math.round(new Date().getTime());
                      $.ajax({
                          url: 'https://www.dealgenius.com/rest/default/V1/guest-carts/'+quoteId+'/payment-information?_='+ts,
                          type: 'GET',
                          success: (response) => {                  
                             const value = response.totals.base_grand_total;
                             callback(value.toFixed(2));                             
                          }
                        });
                },error: (xhr, status, error) => {
                  console.log(error);
                  callback(Number.POSITIVE_INFINITY);
                }
              });
        }
       });
      },
      applyBestCode: (bestCode) => {
        if(window.location.href.indexOf("cart") > -1){
          const url = $('#discount-coupon-form').attr('action');
          const form_key = $('input[name="form_key"]').val();
          $.post(url, { remove: 0, coupon_code: bestCode,form_key: form_key }, 
            (response) => {
              location.reload();
            });
         }else{
           const windowVariables = retrieveWindowVariables(["window.checkoutConfig"]);
           const quoteId = windowVariables["window.checkoutConfig"].quoteId;
           $.ajax({
                url: 'https://www.dealgenius.com/rest/default/V1/guest-carts/'+quoteId+'/coupons/'+bestCode,
                type: 'PUT',
                success: () => {location.reload();}
              });
        }
      }
    },

    tracfone: {
      id: 242, 
      preApplyCodes: function(callback) {
        const elTotal = $('.subtotal_desktop > li:last-child > div:last-child');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        const form = document.querySelector('#PromotionCodeForm_desktop');
        const formData = getFormFieldsAsJson(form);
        formData['promoCode'] = code;
        formData['requesttype'] = 'ajax';
        $.ajax({
          url: 'https://shop.tracfone.com/webapp/wcs/stores/servlet/AjaxPromotionCodeManage',
          type: 'POST',
          data: formData,
          success: (response, status, xhr) => {
            $.ajax({
              url: 'https://shop.tracfone.com/webapp/wcs/stores/servlet/AjaxOrderChangeServiceItemUpdate',
              type: 'POST',
              data: {
                orderId: '.',
                calculationUsage: '-1,-3,-4',
                requesttype: 'ajax'
              },
              success: (response, status, xhr) => {
                const url = `https://shop.tracfone.com/shop/ShopCartDisplayView?` + 
                  `catalogId=${formData['catalogId']}&langId=${formData['langId']}&storeId=${formData['storeId']}`
                $.ajax({
                  url: url,
                  type: 'POST',
                  data: {
                    objectId: '',
                    requesttype: 'ajax',
                    from_section: 'promocode'
                  },
                  success: (response, status, xhr) => {
                    const elTotal = $(response).find('.js-totalplanprice');
                    const value = elTotal.length > 0 ? 
                                  Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                                  Number.POSITIVE_INFINITY;
                    const formData2 = formData;
                    formData2['taskType'] = 'R';
                      $.ajax({
                        url: 'https://shop.tracfone.com/webapp/wcs/stores/servlet/AjaxPromotionCodeManage',
                        type: 'POST',
                        data: formData2,
                        success: () => { callback(value.toFixed(2)); },
                        error: () => { callback(value.toFixed(2)); }
                      });                    
                  },
                  error: (xhr, status, error) => {
                    callback(Number.POSITIVE_INFINITY);
                  }
                });
              },
              error: (xhr, status, error) => {
                callback(Number.POSITIVE_INFINITY);
              }
            });
          },
          error: (xhr, status, error) => {
            callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: (bestCode) => {
       document.querySelector('#cartOrderTotals_Div #expandPromoCode').click();
        setTimeout(function(){
          const coupon = document.querySelector('#PromotionCodeForm_desktop [name="promoCode"]');
          coupon.value = bestCode;
          coupon.dispatchEvent(new Event('input', { bubbles: true } ));          
          coupon.dispatchEvent(new Event('keyup'));
          coupon.dispatchEvent(new Event('blur'));
          coupon.dispatchEvent(new Event('focus'));
          document.querySelector('#WC_PromotionCodeDisplay_div_3_desktop').click();
        }, 500);
        
      }
    },

   joesnewbalanceoutlet: {
      id: 1030, 
      preApplyCodes: function(callback) {
        const elTotal = $('#OrderTotal');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
       $.ajax({
          url: 'https://www.joesnewbalanceoutlet.com/cart/removeDiscountCode',
          type: 'POST',
           success: () => { callback(prevValue); },
            error: () => { callback(prevValue); }
         })        
      },
      applyCode: function(code, callback) { 
       this.preApplyCodes(() => { 
        const orderId = $('[name="OrderNumber"]').val();
        const verificationToken = $('[name="__RequestVerificationToken"]').val();
         $.ajax({
            url: 'https://www.joesnewbalanceoutlet.com/cart/applyDiscountCode',
            type: 'POST',
            data: JSON.stringify({CustomerDiscountCode: code, OrderNumber: orderId}),
             headers: {
                    'Content-Type': 'application/json; charset=UTF-8',
                    '__RequestVerificationToken' : verificationToken
                    },
            success: (response) => {
              $.get('https://www.joesnewbalanceoutlet.com/'+window.location.pathname, 
               (responseGet) => {
                  const elTotal = $(responseGet).find('#OrderTotal');
                  const value = elTotal.length > 0 ? 
                                Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                                Number.POSITIVE_INFINITY;
                  callback(value);
              });              
            },
            error: (xhr, status, error) => {
              callback(Number.POSITIVE_INFINITY);
            }
          })
        })
      },
      applyBestCode: (bestCode) => {
        const orderId = $('[name="OrderNumber"]').val();
        const verificationToken = $('[name="__RequestVerificationToken"]').val();
         $.ajax({
          url: 'https://www.joesnewbalanceoutlet.com/cart/applyDiscountCode',
          type: 'POST',
          data: JSON.stringify({CustomerDiscountCode: bestCode, OrderNumber: orderId}),
          headers: {
            'Content-Type': 'application/json; charset=UTF-8',
            '__RequestVerificationToken' : verificationToken
          },
          success: () => { location.reload(); },
          error: () => { location.reload(); }
        })
      }
    },

  avidmax: {
      id: 5514, 
      preApplyCodes: function(callback) {
        const elTotal = $('.cart-total-value.cart-total-grandTotal span, .cart-priceItem--total [data-test="cart-price-value"]');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        const windowVariables = retrieveWindowVariables(["BCData"]);
        const csrf_token = windowVariables.BCData.csrf_token;
        var url;
         if(window.location.href.indexOf("cart") > -1){
          url = 'https://www.avidmax.com/remote/v1/apply-code';
           $.ajax({
              url: url,
              type: 'POST',
              data: {code: code},
              headers: {
                    'x-xsrf-token': csrf_token
                  },
              success: (response, status, xhr) => {
              if(response.data && response.data.status=='success'){
               $.ajax({
                  url: 'https://www.avidmax.com/cart.php',
                  type: 'GET',
                  success: (responseGet, status, xhr) => {
                    const elTotal = $(responseGet).find('.cart-total-value.cart-total-grandTotal span');
                    const value = elTotal.length > 0 ? 
                                  Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                                  Number.POSITIVE_INFINITY;
                    callback(value);
                  }
                });
              }else{
                callback(Number.POSITIVE_INFINITY);
              }
            },
            error: (xhr, status, error) => {
              console.log(error);
              callback(Number.POSITIVE_INFINITY);
            }
          });
       }else{
           $.ajax({
              url: 'https://www.avidmax.com/api/storefront/checkout-settings',
              type: 'GET',
              headers: {
                    'x-xsrf-token': csrf_token,
                     'x-api-internal': 'This API endpoint is for internal use only and may change in the future'
                  },
              success: (responseGet, status, xhr) => {
                const checkoutId = responseGet.context.checkoutId; 
                 url = 'https://www.avidmax.com/api/storefront/checkouts/'+checkoutId+'/coupons?include=cart.lineItems.physicalItems.options%2Ccart.lineItems.digitalItems.options%2Ccustomer%2Ccustomer.customerGroup%2Cpayments%2Cpromotions.banners%2Cconsignments.availableShippingOptions';
                 $.ajax({
                      url: url,
                      type: 'POST',
                      data: JSON.stringify({couponCode: code}),
                      headers: {
                            'x-xsrf-token': csrf_token,
                            'content-type': 'application/json'
                          },
                      success: (response, status, xhr) => {
                          const value = response.outstandingBalance;
                          callback(value);
                    },
                      error: (xhr, status, error) => {
                        console.log(error);
                        callback(Number.POSITIVE_INFINITY);
                    }
                  });
            }
          });           
       }
      },
      applyBestCode: (bestCode) => {
        const windowVariables = retrieveWindowVariables(["BCData"]);
        const csrf_token = windowVariables.BCData.csrf_token;
        var url;
         if(window.location.href.indexOf("cart") > -1){
          url = 'https://www.avidmax.com/remote/v1/apply-code';
           $.ajax({
              url: url,
              type: 'POST',
              data: {code: bestCode},
              headers: {
                    'x-xsrf-token': csrf_token
                  },
              success: () => { location.reload(); },
              error: () => { location.reload(); }
          });
       }else{
         $.ajax({
            url: 'https://www.avidmax.com/api/storefront/checkout-settings',
            type: 'GET',
            headers: {
                  'x-xsrf-token': csrf_token,
                   'x-api-internal': 'This API endpoint is for internal use only and may change in the future'
                },
            success: (responseGet, status, xhr) => {
            const checkoutId = responseGet.context.checkoutId; 
            url = 'https://www.avidmax.com/api/storefront/checkouts/'+checkoutId+'/coupons?include=cart.lineItems.physicalItems.options%2Ccart.lineItems.digitalItems.options%2Ccustomer%2Ccustomer.customerGroup%2Cpayments%2Cpromotions.banners%2Cconsignments.availableShippingOptions';
            $.ajax({
                url: url,
                type: 'POST',
                data: JSON.stringify({couponCode: bestCode}),
                headers: {
                      'x-xsrf-token': csrf_token,
                      'content-type': 'application/json'
                    },
                success: () => { location.reload(); },
                error: () => { location.reload(); }
            });
          }
        });           
       }
      }
    },

   cheaptickets: {
      id: 3803, 
      preApplyCodes: function(callback) {
        const elTotal = $('.summary-total.amount-value, .prod-total, .trip-total [data-price-update="total"], #creditcard-expanded-payment-cart-container .cart-total.order-grand-total-value, #cart-breakdown .cart-total.order-grand-total-value.cart-highlight[data-total-name="cart-price-total-value"] span');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);    
      },
      applyCode: function(code, callback) { 
        const tripid = $('body').attr('data-tripid');
        const productType = $('body').attr('data-producttype');
         $.ajax({
            url: 'https://www.cheaptickets.com/Checkout/applyCoupon',
            type: 'POST',
            data: {couponCode: code, tripid: tripid, tlCouponAttach:'1',tlCouponCode:code,productType:productType,binPrefix:''},
            success: (response) => {
                var newdata =response.updatedPriceModel;
                var price;
                Object.values(newdata).forEach(val => {
                 if(val.description == 'affirmTotalInCent'){
                  price = val.value/100;
                 }
                });  
              $.ajax({
                url: 'https://www.cheaptickets.com/Checkout/removeCoupon',
                type: 'POST',
                data: {tripid: tripid, tlCouponRemove:'1',tlCouponCode:code,productType:productType,binPrefix:''},
                success: () => { callback(price); },
                error: () => { callback(price); }
              })        
            },
            error: (xhr, status, error) => {
              callback(Number.POSITIVE_INFINITY);
            }
          })
      },
      applyBestCode: (bestCode) => {
       if(window.location.href.indexOf("MultiItemCheckout") > -1){ 
         document.querySelector('#couponId, #PromoCode').value = bestCode;
         document.querySelector('#couponId, #PromoCode').dispatchEvent(new Event('input', {bubbles: true}));
         document.querySelector('#couponId, #PromoCode').dispatchEvent(new Event('change'));
         document.querySelector('#apply_coupon_button, #add-promo-code-button').click();
       }else{
        const tripid = $('body').attr('data-tripid');
        const productType = $('body').attr('data-producttype');
         $.ajax({
            url: 'https://www.cheaptickets.com/Checkout/applyCoupon',
            type: 'POST',
            data: {couponCode: bestCode, tripid: tripid, tlCouponAttach:'1',tlCouponCode:bestCode,productType:productType,binPrefix:''},
            success: () => { location.reload(); },
            error: () => { location.reload(); }
          })
       }
      }
    },

  designbyhumans: {
      id: 6961,
      preApplyCodes: function(callback) {
        const elTotal = $('#totals-totalPrice .currency-amount');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {   
        const url = 'https://www.designbyhumans.com/a/CartTotals'; 
         var ts = Math.round(new Date().getTime());   
          $.ajax({
            url: url+'?discount_code='+code+'&outputType=AJAX&_'+ts,
            type: 'GET',
            success: (response, status, xhr) => {
              const value = response.totals.totalPrice;
              callback(value);
            },error: (xhr, status, error) => {
              callback(Number.POSITIVE_INFINITY);
            }
          });       
      },
      applyBestCode: (bestCode) => {
        document.querySelector('#promotion_promo_code').value = bestCode;
        document.querySelector('#promotion_promo_code').dispatchEvent(new Event('input', { bubbles: true } ));
        document.querySelector('#promotion_promo_code_btn').click();
      }
    },

   zappos: {
      id: 2046, 
      preApplyCodes: function(callback) {
        const elTotal = $('tbody tr:nth-child(5) td:last, div:nth-child(3) div div:contains("Order Total:") + div');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);           
      },
      applyCode: function(code, callback) { 
       this._applyCode(code, function(value) {
                callback(value); 
              }) ; 
      },
      applyBestCode: function(bestCode) {
        this._applyCode(bestCode, function() {
               location.reload();
              }) ;
      },
      _applyCode: (code, callback) => {
        const purchaseId  = getParam('pid',location.href);
        const ubidMain = getCookie('ubid-main');
        const sessionToken = getCookie('session-token');
        const sessionId = getCookie('session-id');
        const xMmain = getCookie('x-main');
          $.ajax({
                url: 'https://amazon.zappos.com/mobileapi/v1/checkout/configure?includeAddresses=false&includeAssociated=true&includePayments=false&includeShipmentOptions=false&src=melody',
                type: 'POST',
                data: JSON.stringify({coupon: code, purchaseId:purchaseId, useDiscount:true, useGCBalance:true}),
                headers: {
                      'X-Mafia-Auth-Requested': true,
                      'X-Mafia-Client': 'MARTY-DESKTOP-ZAPPOS',
                      'X-Mafia-Recognized-Token': sessionToken,
                      'X-Mafia-Session-Id': sessionId,
                      'X-Mafia-Session-Requested': true,
                      'X-Mafia-Session-Token': sessionToken,
                      'X-Mafia-Ubid-Main': ubidMain,
                      'content-type': 'application/json'
                },
                success: (response) => {
                   const value = response.purchaseStatus.chargeSummary.total;
                   callback(value);
                },
                error: () => {  callback(Number.POSITIVE_INFINITY); }
          });
      }
    },

    hydroflask: {
      id: 29432,
      preApplyCodes: function(callback) {
        const elTotal = $('.grandtotal-price .price, .grand.totals span.price');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
         if(window.location.href.indexOf("cart") > -1){
            const url = $('#discount-coupon-form').attr('action');
            const form_key = $('input[name="form_key"]').val();
            $.post(url, { remove: 1,form_key: form_key }, 
            (response) => {
                 callback(prevValue);
            });
        }else{
           const windowVariables = retrieveWindowVariables(["window.checkoutConfig","window.NREUM"]);
           const quoteId = windowVariables["window.checkoutConfig"].quoteId;
           const xpid = windowVariables["window.NREUM"].loader_config.xpid;
           $.ajax({
            url: 'https://www.hydroflask.com/rest/default/V1/guest-carts/'+quoteId+'/coupons',
            type: 'DELETE',
             headers: {
                'x-newrelic-id': xpid
                },
            success: () => { callback(prevValue); },
            error: () => { callback(prevValue); }
          });
        }
      },
      applyCode: function(code, callback) {
       this.preApplyCodes(() => {
        if(window.location.href.indexOf("cart") > -1){
          const url = $('#discount-coupon-form').attr('action');
          const form_key = $('input[name="form_key"]').val();
          $.ajax({
            url: url,
            type: 'POST',
            data: {
              remove: 0,
              form_key: form_key,
              coupon_code: code
            },
            success: () => {
              $.get('https://www.hydroflask.com'+window.location.pathname, (responseGet) => {
                const checkoutconfigindex = responseGet.indexOf("window.checkoutConfig");
                const customerDataindex = responseGet.indexOf("window.customerData");
                const finalIndex = customerDataindex-checkoutconfigindex;
                const data = JSON.parse(responseGet.substr(responseGet.indexOf("window.checkoutConfig")+23, finalIndex-37));
                const value = data.totalsData.grand_total;
                callback(value);             
              });
            },error: (xhr, status, error) => {
               callback(Number.POSITIVE_INFINITY);
            }
          });
        }else{
           const windowVariables = retrieveWindowVariables(["window.checkoutConfig","window.NREUM"]);
           const quoteId = windowVariables["window.checkoutConfig"].quoteId;
           const xpid = windowVariables["window.NREUM"].loader_config.xpid;
           $.ajax({
                url: 'https://www.hydroflask.com/rest/default/V1/guest-carts/'+quoteId+'/coupons/'+code,
                type: 'PUT',
                headers: {
                'x-newrelic-id': xpid
                },
                success: (data) => {
                  const ts = Math.round(new Date().getTime());
                      $.ajax({
                          url: 'https://www.hydroflask.com/rest/default/V1/guest-carts/'+quoteId+'/payment-information?_='+ts,
                          type: 'GET',
                          headers: {
                          'x-newrelic-id': xpid
                          },
                          success: (response) => {                  
                             const value = response.totals.base_grand_total;
                             callback(value.toFixed(2));
                          }
                        });
                },error: (xhr, status, error) => {
                  console.log(error);
                  callback(Number.POSITIVE_INFINITY);
                }
              });
        }
       });
      },
      applyBestCode: (bestCode) => {
        if(window.location.href.indexOf("cart") > -1){
          const url = $('#discount-coupon-form').attr('action');
          const form_key = $('input[name="form_key"]').val();
          $.post(url, { remove: 0, coupon_code: bestCode,form_key: form_key }, 
            (response) => {
              location.reload();
            });
         }else{
           const windowVariables = retrieveWindowVariables(["window.checkoutConfig","window.NREUM"]);
           const quoteId = windowVariables["window.checkoutConfig"].quoteId;
           const xpid = windowVariables["window.NREUM"].loader_config.xpid;
           $.ajax({
                url: 'https://www.hydroflask.com/rest/default/V1/guest-carts/'+quoteId+'/coupons/'+bestCode,
                type: 'PUT',
                headers: {
                'x-newrelic-id': xpid
                },
                success: () => {location.reload();}
              });
        }
      }
    },

   bedrosians: {
      id: 2046, 
      preApplyCodes: function(callback) {
        const elTotal = $('.order-summary-total span:last-child');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);           
      },
      applyCode: function(code, callback) { 
       this._applyCode(code, function() {
        if(window.location.href.indexOf("cart") > -1){
          const locationUrl = window.location.pathname;
           $.get('https://www.bedrosians.com'+locationUrl, 
            (response) => {
              const elTotal = $(response).find('.order-summary-total span:last-child');
              const value = elTotal.length > 0 ? 
                    Number(elTotal.text().replace( /[^0-9.]/g, '').trim()) : 
                    Number.POSITIVE_INFINITY;
              callback(value);
            });
        }else{
          const locationUrl = '/en/shoppingbag/checkoutitems/';
           $.get('https://www.bedrosians.com'+locationUrl, 
            (response) => {
              const value = response.AmountDue;
              callback(value);
            });
         }        
        }) ; 
      },
      applyBestCode: function(bestCode) {
        this._applyCode(bestCode, function() {
               location.reload();
              }) ;
      },
      _applyCode: (code, callback) => {
        const url = $('[name="promotionalCodeForm"] ').attr('action');
          $.ajax({
                url: 'https://www.bedrosians.com'+url,
                type: 'POST',
                data: {'Promotion.PromotionalCode': code},
                success: (data, textStatus, request) => {
                  callback(data);                
                },
                error: (data) => {  callback(data);  }
          });
      }
    },

   ltdcommodities: {
      id: 3937, 
      preApplyCodes: function(callback) {
        const elTotal = $('aside.order-sum__tab span');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);           
      },
      applyCode: function(code, callback) { 
       this._applyCode(code, function(value) {
        callback(value);
        }) ; 
      },
      applyBestCode: function(bestCode) {
        this._applyCode(bestCode, function() {
               location.reload();
              }) ;
      },
      _applyCode: (code, callback) => {
        const formData = getFormFieldsAsJson(document.querySelector('#couponCodeForm'));
        formData['/atg/commerce/promotion/CouponFormHandler.couponClaimCode'] = code;
        if(window.location.href.indexOf("shopping_cart") > -1){
          var url = $("#couponCodeForm").attr('action');
        }else{
          var url = '/checkout/order_summary_container_acap.jsp';
        }
        $.ajax({
          url: 'https://www.ltdcommodities.com'+url,
          type: 'POST',
          data: formData,
          success: (response) => {
            const elTotal = $(response).find('aside.order-sum__tab span'); 
            const value = elTotal.length > 0 ? 
                          Number(elTotal.text().replace( /[^0-9.]/g, '').trim()) : 
                          Number.POSITIVE_INFINITY;
            callback(value);           
          },
          error: (data) => {  callback(Number.POSITIVE_INFINITY);  }
        });
      }
    },

   columbia: {
      id: 589, 
      preApplyCodes: function(callback) {
        const elTotal = $('#csc-amount-total');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);           
      },
      applyCode: function(code, callback) { 
       this._applyCode(code, function() {
        if(window.location.href.indexOf("cart") > -1){
         const windowVariables = retrieveWindowVariables(["spc.urls"]);          
         const removeCouponUrl = windowVariables["spc.urls"].addCoupon;
         const updateOrderSummaryOnCartUrl = windowVariables["spc.urls"].updateOrderSummaryOnCart;
           $.get(updateOrderSummaryOnCartUrl+'?format=ajax', 
              (responseGet) => {
                const elTotal = $(responseGet).find('#csc-amount-total');
                const value = elTotal.length > 0 ? 
                    Number(elTotal.text().replace( /[^0-9.]/g, '').trim()) : 
                    Number.POSITIVE_INFINITY;
                 $.get(removeCouponUrl+'?format=ajax&removeCoupon='+code, 
                  () => {
                   callback(value);  
                });   
            });
        }else{
         const windowVariables = retrieveWindowVariables(["spc.urls"]);          
         const removeCouponUrl = windowVariables["spc.urls"].addCoupon;
         const updateOrderSummaryOnCartUrl = windowVariables["spc.urls"].updateOrderSummaryOnCart;
         const shippingMethodID = $('#dwfrm_singlepagecheckout_shippingMethodID').val();
         const countryCode = $('#dwfrm_singlepagecheckout_shippingAddress_addressFields_countries_country').val();
         const address1 = $('#dwfrm_singlepagecheckout_shippingAddress_addressFields_address1').val();
         const address2 = $('#dwfrm_singlepagecheckout_shippingAddress_addressFields_address2').val();
         const city = $('#dwfrm_singlepagecheckout_shippingAddress_addressFields_city').val();
         const stateCode = $('#dwfrm_singlepagecheckout_shippingAddress_addressFields_states_'+countryCode).val();
         const postalCode = $('#dwfrm_singlepagecheckout_shippingAddress_addressFields_postcode_'+countryCode).val();         
         const shippingOption = $('#dwfrm_singlepagecheckout_shippingAddress_addressFields_shippingOption').val();
         const formData = {shippingMethodID: shippingMethodID, format: 'ajax', address1: address1, address2: address2, city: city, stateCode: stateCode, postalCode: postalCode, countryCode: countryCode, shippingOption: shippingOption}
         $.post(updateOrderSummaryOnCartUrl, formData,
            (responsePost) => {
              const elTotal = $(responsePost).find('#csc-amount-total');
                const value = elTotal.length > 0 ? 
                    Number(elTotal.text().replace( /[^0-9.]/g, '').trim()) : 
                    Number.POSITIVE_INFINITY;
                 $.get(removeCouponUrl+'?format=ajax&removeCoupon='+code, 
                  () => {
                   callback(value);  
                });   
            });
         }        
        }) ; 
      },
      applyBestCode: function(bestCode) {
        this._applyCode(bestCode, function() {
               location.reload();
              }) ;
      },
      _applyCode: (code, callback) => {
        const windowVariables = retrieveWindowVariables(["spc.urls"]);
        const addCouponUrl = windowVariables["spc.urls"].addCoupon;
        const updateOrderSummaryOnCartUrl = windowVariables["spc.urls"].updateOrderSummaryOnCart;
        $.get(addCouponUrl+'?format=ajax&couponCode='+code, 
          (response) => {
             callback(code);            
        });
      }
    },

    iceland: {
      id: 29940,
      preApplyCodes: function(callback) {
        const elTotal = $('.order-total .order-value');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: function(code, callback) {
        const windowVariables = retrieveWindowVariables(["window.Urls"]);
        const addCouponUrl = windowVariables["window.Urls"].addCoupon;      
            $.get(addCouponUrl+'?couponCode='+code+'&format=ajax', 
              (response) => {
               const value = response.baskettotal;
               callback(value);
              });         
      },
      applyBestCode: (bestCode) => {
        location.reload();
      }
    },

 dickies: {
    id: 682,
    preApplyCodes: (callback) => {
      const orderValueEl = $('.order-total td:last');
      const prevValue = orderValueEl.length > 0 ? 
                        Number(orderValueEl.first().text().trim().substr(1)) : 
                        Number.POSITIVE_INFINITY;
      callback(prevValue);
    },
    applyCode: (code, callback) => {
      const url = $('#cart-items-form').attr('action');
      const formData = getFormFieldsAsJson(document.querySelector('#cart-items-form'));
      formData['dwfrm_cart_couponCode'] = code;
      formData['dwfrm_cart_addCoupon'] = 'dwfrm_cart_addCoupon';
      $.post(url, formData, 
        (response) => {
          const orderValueEl = $(response).find('.order-total td:last');
          const value = orderValueEl.length > 0 ? 
                            Number(orderValueEl.first().text().trim().substr(1)) : 
                            Number.POSITIVE_INFINITY;
          callback(value);
        });
    },
    applyBestCode: (bestCode) => {
      try{ document.querySelector('.cart-coupon-code-note').click(); } catch(e){ } 
      document.querySelector('#dwfrm_cart_couponCode').value = bestCode;
      document.querySelector('#dwfrm_cart_couponCode').dispatchEvent(new Event('input', { bubbles: true } ));
      document.querySelector('#add-coupon').click();
    }
  },

  underarmour: {
    id: 1956, 
    preApplyCodes: function(callback) {
       const elTotal = $('.grand-total.bfx-total-grandtotal');
      const prevValue = elTotal.length > 0 ? 
                    Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                    Number.POSITIVE_INFINITY;
      if(document.querySelector('.js-removecoupon')){
          const prevCode = $('.js-removecoupon').attr('data-code');
          const uuid = $('.js-removecoupon').attr('data-uuid');
           $.get('https://www.underarmour.com/on/demandware.store/Sites-US-Site/en-us/Cart-RemoveCouponLineItem?code='+prevCode+'&uuid='+uuid, 
                () => {
                  callback(prevValue,prevCode);
            });
      }else{
        callback(prevValue);
      }      
    },
    applyCode: function(code, callback) {
       const url = $('form[name="promo-code-form"]').attr('action');
      const csrf_token = $('[name="promo-code-form"] input[name="csrf_token"]').val();
       $.get('https://www.underarmour.com'+url+'/?csrf_token='+csrf_token+'&couponCode='+code, 
        (response) => {
          if(response.totals){
              const value = response.totals.grandTotal;
              const totalValue = Number(value.replace( /[^0-9.]/g, '').trim())
              const locale = response.locale;
              const uuid =  response.totals.discounts[0].UUID;
              $.get('https://www.underarmour.com/on/demandware.store/Sites-US-Site/'+locale+'/Cart-RemoveCouponLineItem?code='+code+'&uuid='+uuid, 
                () => {
                  callback(totalValue);
            });
              
          }else{
            callback(Number.POSITIVE_INFINITY);
          }
        });
    },
    applyBestCode: (bestCode) => {
      document.querySelector('#couponCode').value = bestCode;
      document.querySelector('#couponCode').dispatchEvent(new Event('input', {bubbles: true}));
      document.querySelector('button.promo-code-btn').click();
    }
  },

 shoplet: {
    id: 2578,
    preApplyCodes: (callback) => {
      const orderValueEl = $('#cartSubTotal');
      const prevValue = orderValueEl.length > 0 ? 
                        Number(orderValueEl.first().text().replace( /[^0-9.]/g, '').trim()) : 
                        Number.POSITIVE_INFINITY;
      callback(prevValue);
    },
    applyCode: (code, callback) => {
      const url = 'https://www.shoplet.com/cart/process/mode/add_coupon/coupon_code/'+code+'/express/true';
      $.post(url, 
        () => {
           $.get('https://www.shoplet.com/cart/view', 
              (response) => {
              const cartSubTotal = $(response).find('#cartSubTotal');
              const cartSubTotalValue = cartSubTotal.length > 0 ? 
                                Number(cartSubTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                                Number.POSITIVE_INFINITY;
              const couponTotal = $(response).find('p:contains("Coupon") + p');
              const couponTotalValue = couponTotal.length > 0 ? 
                                Number(couponTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                                0;
              const shipping  = $(response).find('p:contains("Shipping") + p');
              const shippingValue = shipping.length > 0 ? 
                                Number(shipping.first().text().replace( /[^0-9.]/g, '').trim()) : 
                                0;
              const handling = $(response).find('p:contains("Handling") + p');
              const handlingValue = handling.length > 0 ? 
                                Number(handling.first().text().replace( /[^0-9.]/g, '').trim()) : 
                                0;
              const value = (cartSubTotalValue+shippingValue+handlingValue)-couponTotalValue;
              callback(value);
          });
        });
    },
    applyBestCode: (bestCode) => {
      location.reload();
    }
  },

  skechers: {
    id: 1961,
    preApplyCodes: (callback) => {
      const orderValueEl = $('.grand-total-sum');
      const prevValue = orderValueEl.length > 0 ? 
                        Number(orderValueEl.first().text().replace( /[^0-9.]/g, '').trim()) : 
                        Number.POSITIVE_INFINITY;
      callback(prevValue);
    },
    applyCode: (code, callback) => {
      const addCouponUrl = $('.promo-code-form').attr('data-action');
      const csrf_token = $('.promo-code-form [name="csrf_token"]').val();
       $.get(addCouponUrl+'?couponCode='+code+'&dwfrm_billing_givex_cardPin=&csrf_token='+csrf_token, 
          (response) => {
            if(response.totals){
              const value = response.totals.remainingBalance;
              callback(value);
            }else{
              callback(Number.POSITIVE_INFINITY);
            }
      });
    },
    applyBestCode: (bestCode) => {
      location.reload();
    }
  },

  landsend: {
    id: 3924,
    preApplyCodes: (callback) => {
      const orderValueEl = $('#shopping-bag .total-price .price:not(:contains($0)), .total-price.clearfix .price.ng-binding:not(:contains($0)),  .grand .order-totals-value:not(:contains($0))');
      const prevValue = orderValueEl.length > 0 ? 
                        Number(orderValueEl.first().text().replace( /[^0-9.]/g, '').trim()) : 
                        Number.POSITIVE_INFINITY;
      callback(prevValue);
    },
     applyCode: function(code, callback) {
      this._applyCode(code, function(value) {
        callback(value);
      }) ; 
    },
    applyBestCode: function(bestCode) {
      this._applyCode(bestCode, function() {
        location.reload();
      }) ;
    },
    _applyCode: (code, callback) => {
      const csrf_token = getCookie('X-CSRF-TOKEN');
        $.ajax({
          url: 'https://www.landsend.com/co/checkout/applyPromotion',
          type: 'POST',
          headers: {
          'x-csrf-token': csrf_token
          },
          data : {promoCode: code, promoPIN : '', functionName: 'applyPromotion'},
          success: (data) => {
               if(data.basket && data.basket.orderTotals){
                  const value = data.basket.orderTotals.localizedGrandTotal;
                  callback(value);
               }else{
                 callback(Number.POSITIVE_INFINITY);
               }
          },error: (xhr, status, error) => {
            console.log(error);
            callback(Number.POSITIVE_INFINITY);
          }
      });
    }
  },

  deluxe: {
    id: 2227, 
    preApplyCodes: function(callback) {  
      const orderValueEl = $('.total-line div:eq(2)').contents().get(2).textContent;
      const prevValue = orderValueEl ? 
                        Number(orderValueEl.replace( /[^0-9.]/g, '').trim()) : 
                        Number.POSITIVE_INFINITY;
      $.ajax({
          url: 'https://www.deluxe.com/shopdeluxe/common/removeAppliedCoupon.jsp',
          type: 'POST',
          success: () => { callback(prevValue); },
          error: () => { callback(prevValue); }
        });        
    },
    applyCode: function(code, callback) {
     this.preApplyCodes(() => {       
      this._applyCode(code, function(value) {
        callback(value);
      }); 
     });
    },
    applyBestCode: function(bestCode) {
      this._applyCode(bestCode, function() {
          location.reload();
      }) ;
    },
    _applyCode: (code, callback) => {
      $.ajax({
        url: 'https://www.deluxe.com/shopdeluxe/common/promotion_form.jsp',
        type: 'POST',
        data: {
          promoid: code,
        },
        success: (data) => {
          $.ajax({
              url: 'https://www.deluxe.com/shopdeluxe/sd/cart/yourShoppingCart.jsp?message=',
              type: 'GET',
              success: (response) => {        
                 const total = $(response).find('.total-line div:eq(2)').contents().get(2).textContent;
                 const value = total ? 
                      Number(total.replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
                 callback(value);  
              },error: () => {
                callback(Number.POSITIVE_INFINITY);
              }
          });
        },
        error: () => {
          callback(Number.POSITIVE_INFINITY);
        }
      });
    }
  },

  hsamuel: {
    id: 8419, 
    preApplyCodes: function(callback) {  
      const orderValueEl = $('.order-summary__total-value:last');
      const prevValue = orderValueEl.length > 0 ? 
                        Number(orderValueEl.first().text().replace( /[^0-9.]/g, '').trim()) : 
                        Number.POSITIVE_INFINITY;
      const prevCodeSelector = document.querySelector('#couponCodeRemove');
      if(prevCodeSelector){
        const prevCode = $('#couponCodeRemove').val();
         this._removeCode(prevCode, function() {
           callback(prevValue,prevCode);
        });
      }else{
        callback(prevValue);
      }       
    },
    applyCode: function(code, callback) {     
      this._applyCode(code, function() {
       $.get('https://'+window.location.hostname+'/webstore/secure/showbasket.sdo', 
          (response) => {
          const orderValueEl = $(response).find('.order-summary__total-value:last');
          const value = orderValueEl.length > 0 ? 
                        Number(orderValueEl.first().text().replace( /[^0-9.]/g, '').trim()) : 
                        Number.POSITIVE_INFINITY;
          this._removeCode(code, function() {
           callback(value);
        });
       });
     }.bind(this));
    },
    applyBestCode: function(bestCode) {
      this._applyCode(bestCode, function() {
          location.reload();
      }) ;
    },
    _applyCode: (code, callback) => {
     const csrfToken = $('meta[name="_csrf"]').attr('content');
     $.ajax({
      url: 'https://'+window.location.hostname+'/webstore/secure/couponRedemption.sdo',
      type: 'POST',
      data: {
          couponCode: code,  _csrf: csrfToken
      },
      success: () => { callback(code); },
      error: () => { callback(code); }
    });
    },
    _removeCode: (code, callback) => {
     const csrfToken = $('meta[name="_csrf"]').attr('content');
     $.ajax({
      url: 'https://'+window.location.hostname+'/webstore/secure/removeCoupon.sdo',
      type: 'POST',
      data: {
          couponCode: code, remove : '', _csrf: csrfToken
      },
      success: () => { callback(); },
      error: () => { callback(); }
    });
    }
  },

  ernestjones: {
    id: 8899, 
    preApplyCodes: function(callback) {  
      const orderValueEl = $('.order-summary__total-value:last');
      const prevValue = orderValueEl.length > 0 ? 
                        Number(orderValueEl.first().text().replace( /[^0-9.]/g, '').trim()) : 
                        Number.POSITIVE_INFINITY;
      const prevCodeSelector = document.querySelector('#couponCodeRemove');
      if(prevCodeSelector){
        const prevCode = $('#couponCodeRemove').val();
         this._removeCode(prevCode, function() {
           callback(prevValue,prevCode);
        });
      }else{
        callback(prevValue);
      }       
    },
    applyCode: function(code, callback) {     
      this._applyCode(code, function() {
       $.get('https://'+window.location.hostname+'/webstore/secure/showbasket.sdo', 
          (response) => {
          const orderValueEl = $(response).find('.order-summary__total-value:last');
          const value = orderValueEl.length > 0 ? 
                        Number(orderValueEl.first().text().replace( /[^0-9.]/g, '').trim()) : 
                        Number.POSITIVE_INFINITY;
          this._removeCode(code, function() {
           callback(value);
        });
       });
     }.bind(this));
    },
    applyBestCode: function(bestCode) {
      this._applyCode(bestCode, function() {
        location.reload();
      }) ;
    },
    _applyCode: (code, callback) => {
     const csrfToken = $('meta[name="_csrf"]').attr('content');
     $.ajax({
      url: 'https://'+window.location.hostname+'/webstore/secure/couponRedemption.sdo',
      type: 'POST',
      data: {
          couponCode: code,  _csrf: csrfToken
      },
      success: () => { callback(code); },
      error: () => { callback(code); }
      });
    },
    _removeCode: (code, callback) => {
       const csrfToken = $('meta[name="_csrf"]').attr('content');
       $.ajax({
        url: 'https://'+window.location.hostname+'/webstore/secure/removeCoupon.sdo',
        type: 'POST',
        data: {
            couponCode: code, remove : '', _csrf: csrfToken
        },
        success: () => { callback(); },
        error: () => { callback(); }
      });
    }
  },

  basspro: {
      id: 394,
      preApplyCodes: (callback) => {
        const elTotal = $('#cartTotal .total_figures');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        callback(prevValue);
      },
      applyCode: (code, callback) => {    
        const url = $('form[name="PromotionCodeForm"]').attr('action');
        const formData = getFormFieldsAsJson(document.querySelector('form[name="PromotionCodeForm"]'));
          formData['promoCode'] = code; 
          formData['requesttype'] = 'ajax';
        $.ajax({
          url: url,
          type: 'POST',
          data: formData,
          success: (response) => {
            const catalogId = $('#PromotionCodeForm input[name="catalogId"]').val();
            var storeId = $('#PromotionCodeForm input[name="storeId"]').val();
            var langId = $('input[name="langId"]').val();
            var getUrl = 'https://'+window.location.hostname+'/shop/ShopCartDisplayView?shipmentType=single&catalogId='+catalogId+'&langId='+langId+'&storeId='+storeId;
             $.ajax({
              url: getUrl,
              type: 'POST',
              data: {
                'objectId': '',
                'requesttype': 'ajax'
              },
              success: (response) => {                    
                const elTotal =  $(response).find('#cartTotal .total_figures');                   
                const value = elTotal.length > 0 ? 
                              Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                              Number.POSITIVE_INFINITY;
                const formData2 = formData;
                formData2['taskType'] = 'R';                    
                var removeUrl = 'https://'+window.location.hostname+'/shop/AjaxRESTPromotionCodeRemove';
                 $.ajax({
                  url: removeUrl,
                  type: 'POST',
                  data: formData2,
                  success: (response) => {  callback(value); },
                  error: (response) => {  callback(value); }
                });
              }
            });
          },
          error: (xhr, status, error) => {
            console.log(error);
            callback(Number.POSITIVE_INFINITY);
          }
        });
      },
      applyBestCode: (bestCode) => {
         document.querySelector('#promoCode').value = bestCode;
         document.querySelector('#promoCode').dispatchEvent(new Event('input', {bubbles: true}));
         document.querySelector('.promotion_button a').click();
      }
    },

  melissaanddoug: {
    removePrevCode: function(code, callback) {
      if(window.location.href.indexOf("cart") > -1){
          const url = $('#cart-items-form').attr('action');
          const formData = getFormFieldsAsJson(document.querySelector('#cart-items-form'));
          formData['dwfrm_cart_coupons_i0_deleteCoupon'] = 'Remove';
          $.post(url, formData, 
            (response) => {
              callback();
          });
      }else{
          const windowVariables = retrieveWindowVariables(["window.Urls"]);
          const addCouponUrl = windowVariables["window.Urls"].addCoupon;
          $.get(addCouponUrl+'?couponCode=empty&couponAction=0&format=ajax', 
            (response) => {
              callback();
          });         
      }
    },
    preApplyCodes: function(callback) { 
      const elTotal = $('.bfx-total-grandtotal');
      const prevValue = elTotal.length > 0 ? 
                    Number(elTotal.text().replace( /[^0-9.]/g, '').trim()) : 
                    Number.POSITIVE_INFINITY;
      this.removePrevCode('prevCode', () => callback(prevValue));
    },
    applyCode: function(code, callback) {
      if(window.location.href.indexOf("cart") > -1){
          const url = $('#cart-items-form').attr('action');
          const formData = getFormFieldsAsJson(document.querySelector('#cart-items-form'));
          formData['dwfrm_cart_couponCode'] = code;
          formData['dwfrm_cart_addCoupon'] = 'dwfrm_cart_addCoupon';
          formData['dwfrm_cart_updateCart'] = 'dwfrm_cart_updateCart';
            $.post(url, formData, 
            (responsePost) => {
              $.get('https://'+window.location.hostname+'/cart', (response) => {
                  const orderValueEl = $(response).find('.bfx-total-grandtotal');
                  const value = orderValueEl.length > 0 ? 
                                  Number(orderValueEl.text().replace( /[^0-9.]/g, '').trim()) : 
                                  Number.POSITIVE_INFINITY;  
                  this.removePrevCode(code, () => callback(value));
              });
            });
      }else{
        const windowVariables = retrieveWindowVariables(["window.Urls"]);
        const addCouponUrl = windowVariables["window.Urls"].addCoupon;
        $.get(addCouponUrl+'?couponCode='+code+'&couponAction=add&format=ajax', 
            (responseGet) => {
              $.get('https://'+window.location.hostname+window.location.pathname, (response) => {
                  const orderValueEl = $(response).find('.bfx-total-grandtotal');
                  const value = orderValueEl.length > 0 ? 
                                  Number(orderValueEl.text().replace( /[^0-9.]/g, '').trim()) : 
                                  Number.POSITIVE_INFINITY;  
                  this.removePrevCode(code, () => callback(value));         
              });
          });
      }
    },
    applyBestCode: (bestCode) => {
      if(window.location.href.indexOf("cart") > -1){
        document.querySelector('#dwfrm_cart_couponCode, #dwfrm_billing_couponCode').value = bestCode;
        document.querySelector('#dwfrm_cart_couponCode, #dwfrm_billing_couponCode').dispatchEvent(new Event('input', { bubbles: true } ));
        document.querySelector('#add-coupon').click();
      }else{
        location.reload();
      }
    }
  },

  urbanstems: {
    id: 27737, 
     removePrevCode: function(code, uuid, callback) {
      const  url = 'https://urbanstems.com/on/demandware.store/Sites-urbanstems-Site/default/Cart-RemoveCouponLineItem' +
                    '?code=' + code +
                    '&uuid=' + uuid;
       $.ajax({
          url: url,
          type: 'GET',
          data: {},
          success: () => {
            callback();
          },
          error: (xhr, status, error) => {
            callback();
          }
      });
    },
    preApplyCodes: function(callback) {
      const elTotal = $('span.grand-total-sum');
      const prevValue = elTotal.length > 0 ? 
                    Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                    Number.POSITIVE_INFINITY;
      const el = $('button.remove-coupon');
      if (el !== null && el !== undefined && el.length > 0) {
        const code = el.attr('data-code');
        const uuid = el.attr('data-uuid');
        this.removePrevCode(code,uuid, () => callback(prevValue));
      }else {
        callback(prevValue);
      }
    },
    applyCode: function(code, callback) {
        const csrf_token = $('input[name*="csrf_token"]').first().val();
        const url = 'https://urbanstems.com/on/demandware.store/Sites-urbanstems-Site/default/Cart-AddCoupon' +
                    '?couponCode=' + code + 
                    '&csrf_token=' + csrf_token;
        $.ajax({
          url: url,
          type: 'GET',
          data: {},
          success: (response, status, xhr) => {
            if (response !== null) {
              const totals = response.totals;
              if (totals !== null && totals !== undefined) {
                const value = totals.grandTotal !== null ? 
                          Number(totals.grandTotal.replace( /[^0-9.]/g, '').trim()) : 
                          Number.POSITIVE_INFINITY;
                $.get('https://urbanstems.com'+window.location.pathname, (responseGet) => {
                  const el = $(responseGet).find('button.remove-coupon');
                  if (el !== null && el !== undefined && el.length > 0) {
                    const uuid = el.attr('data-uuid');
                    this.removePrevCode(code, uuid, () => callback(value));
                  }else{
                     callback(Number.POSITIVE_INFINITY);
                   }
                });
                return;
              }
            }
            callback(Number.POSITIVE_INFINITY);
          },
          error: (xhr, status, error) => {
            console.log(error);
          }
        });
    },
    applyBestCode: (bestCode) => {
      const csrf_token = $('input[name*="csrf_token"]').first().val();
      const url = 'https://urbanstems.com/on/demandware.store/Sites-urbanstems-Site/default/Cart-AddCoupon' +
                    '?couponCode=' + bestCode + 
                    '&csrf_token=' + csrf_token;
      $.ajax({
        url: url,
        type: 'GET',
        data: {},
        success: () => { location.reload(); },
        error: () => { location.reload(); }
      })
    }
  },

  coachoutlet: {
    removePrevCode: function(code, callback) {
      if(window.location.href.indexOf("checkout") > -1){
        callback();
      }else{
        const url = $('#cart-items-form').attr('action');
        const formData = getFormFieldsAsJson(document.querySelector('#cart-items-form'));
        formData['dwfrm_cart_coupons_i0_deleteCoupon'] = 'Remove';
        $.get(url, formData, 
          (response) => {
            callback();
        }).fail(function() {
         callback();
        });         
      }
    },
    preApplyCodes: function(callback) { 
      const elTotal = $('.subtotal.value');
      const prevValue = elTotal.length > 0 ? 
                    Number(elTotal.text().replace( /[^0-9.]/g, '').trim()) : 
                    Number.POSITIVE_INFINITY;
      this.removePrevCode('prevCode', () => callback(prevValue));
    },
    applyCode: function(code, callback) {
      this._applyCode(code, function(value) {
       this.removePrevCode(code, () => callback(value));
     }.bind(this));
    },
    applyBestCode: function(bestCode) {
      this._applyCode(bestCode, function(value) {
        location.href= 'https://www.coachoutlet.com/checkout';
      });   
    },
    _applyCode: (code, callback) => {
      if(window.location.href.indexOf("checkout") > -1){
        const url = $('#dwfrm_cart').attr('action');
        const formData = getFormFieldsAsJson(document.querySelector('#dwfrm_cart'));
        formData['dwfrm_cart_couponCode-text'] = code;
        formData['dwfrm_cart_couponCode'] = code;
        formData['dwfrm_cart_addCoupon'] = 'dwfrm_cart_addCoupon';
        $.post(url, formData, 
        (responsePost) => {
          const orderValueEl = $(responsePost).find('.subtotal.value');
          const value = orderValueEl.length > 0 ? 
                        Number(orderValueEl.text().replace( /[^0-9.]/g, '').trim()) : 
                        Number.POSITIVE_INFINITY;  
          callback(value);
        }).fail(function(response) {
          callback(Number.POSITIVE_INFINITY)
        });  
      }else{
        const url = $('#cart-items-form').attr('action');
        const formData = getFormFieldsAsJson(document.querySelector('#cart-items-form'));
        formData['dwfrm_cart_couponCode-text'] = code;
        formData['dwfrm_cart_couponCode'] = code;
        formData['dwfrm_cart_addCoupon'] = 'dwfrm_cart_addCoupon';
        formData['dwfrm_cart_updateCart'] = 'dwfrm_cart_updateCart';
        $.get(url, formData, 
        (responsePost) => {
          const orderValueEl = $(responsePost).find('.subtotal.value');
          const value = orderValueEl.length > 0 ? 
                          Number(orderValueEl.text().replace( /[^0-9.]/g, '').trim()) : 
                          Number.POSITIVE_INFINITY;  
          callback(value);
        }).fail(function(response) {
          callback(Number.POSITIVE_INFINITY)
        });
      }
    },
  },

  mpix: {
    id: 6011,
    preApplyCodes: (callback) => {
      const orderValueEl = $('.order-summary div:contains("Total") .col-5.text-right, .order-summary .card-block .total');
      const prevValue = orderValueEl.length > 0 ? 
                        Number(orderValueEl.first().text().replace( /[^0-9.]/g, '').trim()) : 
                        Number.POSITIVE_INFINITY;
      callback(prevValue);
    },
     applyCode: function(code, callback) {
      this._applyCode(code, function(value) {
        callback(value);
      }); 
    },
    applyBestCode: function(bestCode) {
      this._applyCode(bestCode, function() {
        location.reload();
      });
    },
    _applyCode: (code, callback) => {
      $.ajax({
        url: 'https://www.mpix.com/customer/api/Checkout/ApplyPromo',
        type: 'POST',
        headers: {
        'content-type': 'application/json',
        'webapi-version' : 'V2'
        },
        data : JSON.stringify({PromoCode: code}),
        success: (data) => {
         if(data.orderTotal){
            const value = data.orderTotal.total;
            callback(value);
         }else{
           callback(Number.POSITIVE_INFINITY);
         }
        },error: (xhr, status, error) => {
          callback(Number.POSITIVE_INFINITY);
        }
      });
    }
  },

  sierra: {
    id: 236,
    preApplyCodes: (callback) => {
      const orderValueEl = $('#cartSummary #orderTotal, .js-order-details-sub-total');
      const prevValue = orderValueEl.length > 0 ? 
                        Number(orderValueEl.first().text().replace( /[^0-9.]/g, '').trim()) : 
                        Number.POSITIVE_INFINITY;
      callback(prevValue);
    },
     applyCode: function(code, callback) {
      this._applyCode(code, function() {
         $.get(window.location.href, (responseGet) => {             
            const elTotal = $(responseGet).find('#cartSummary #orderTotal, .js-order-details-sub-total');
            const value = elTotal.length > 0 ? 
                          Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                          Number.POSITIVE_INFINITY;
            callback(value);
          });
      }); 
    },
    applyBestCode: function(bestCode) {
      this._applyCode(bestCode, function() {
        location.reload();
      }) ;
    },
    _applyCode: (code, callback) => {
       const formData = getFormFieldsAsJson(document.querySelector('.keycodeFormContainer form'));
       const url = $(".keycodeFormContainer form ").attr('action');
       formData['KeyCode'] = code;
      $.ajax({
        url: 'https://www.sierra.com/'+url,
        type: 'POST',
        data : formData,
        success: (data, textStatus, request) => {
          const locationUrl = request.getResponseHeader('location');
          callback(locationUrl);
        },error: (xhr, status, error) => {
          callback();
        }
      });
    }
  },

  bradfordexchangechecks: {
    id: 478,
    preApplyCodes: function(callback) { 
      const orderValueEl = $('.totals dd strong');
      const prevValue = orderValueEl.length > 0 ? 
                        Number(orderValueEl.first().text().replace( /[^0-9.]/g, '').trim()) : 
                        Number.POSITIVE_INFINITY;
      callback(prevValue);     
    },
    applyCode: function(code, callback) {
      this._applyCode(code, function() {
         $.get(window.location.href, (responseGet) => {
            const elTotal = $(responseGet).find('.totals dd strong');
            const value = elTotal.length > 0 ? 
                          Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                          Number.POSITIVE_INFINITY;
            callback(value);
          });
      });
    },
    applyBestCode: function(bestCode) {
      this._applyCode(bestCode, function() {
        location.reload();
      }) ;
    },
    _applyCode: (code, callback) => {
      $.ajax({
        url: 'https://www.bradfordexchangechecks.com/modals/modalHaveAnAdPostForHome.jsp?ACTION=HAVE_AN_AD_PRDTL&from=home',
        type: 'POST',
        data : {BECT_CODE : code},
        success: (data, textStatus, xhr) => {
          callback();
        },error: (xhr, status, error) => {
          callback();
        }
      });
    }
  },

  nativecos: {
      preApplyCodes: function(callback) {
       if(window.location.href.indexOf("cart") > -1){ 
        const elTotal = $('.price-row__total span.row-value, .cart-header__price-row:contains("Subtotal") span');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        const prevCodeSelector = document.querySelector('.price-row__coupon .row-label');
        if(prevCodeSelector){
          try{  $('.price-row__coupon .price-row__remove').click(); }catch(e){}
          setTimeout(function(){
            const prevCodeData = prevCodeSelector.innerText;
            const prevCode = prevCodeData.replace('Coupon: ','');
            callback(prevValue,prevCode);
           }, 500);
        }else{
          callback(prevValue);
        }        
       }else{
        const elTotal = $('.payment-due__price');
        const prevValue = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
        const prevCode = $('.edit_checkout .reduction-code__text').first().text();
        callback(prevValue,prevCode);
       }
      },
      applyCode: function(code, callback) {
        if(window.location.href.indexOf("cart") > -1){
          setTimeout(function(){
          try{  $('.cart-header__promo-toggle').click(); }catch(e){}
          document.querySelector('.cart-header__promo-input').value = code;
          document.querySelector('.cart-header__promo-input').dispatchEvent(new Event('input', {bubbles: true}));
          document.querySelector('.cart-header__promo-input').dispatchEvent(new Event('change'));
          document.querySelector('.cart-header__promo-btn').click();          
          setTimeout(function(){
           const elTotal = $('.price-row__total span.row-value');
           const value = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY; 
           prevCodeSelector = $('.price-row__coupon .price-row__remove');
           if(prevCodeSelector){
              try{  $('.price-row__coupon .price-row__remove').click(); }catch(e){}
              callback(value); 
             }else{
              callback(value); 
             } 
           }, 2000);
        }, 2000);
        }else{
            const authenticity_token = $('input[name="authenticity_token"]:last').val();
            const url = 'https://'+window.location.hostname+$(".edit_checkout ").attr('action');
            $.ajax({
              url: url,
              type: 'POST',
              data: {
                _method: 'patch',
                authenticity_token: authenticity_token,
                'checkout[reduction_code]': code,
                'checkout[client_details][browser_width]': 1349,
                'checkout[client_details][browser_height]': 657,
                'checkout[client_details][javascript_enabled]': 1
              },
              success: () => {
                $.get('https://'+window.location.hostname+window.location.pathname, (responseGet) => {             
                  const elTotal = $(responseGet).find('.payment-due__price');
                  const value = elTotal.length > 0 ? 
                                Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                                Number.POSITIVE_INFINITY;
                  callback(value);
                });
              },
              error: (xhr, status, error) => {
                console.log(error);
                callback(Number.POSITIVE_INFINITY);
              },
              fail: (xhr, status, error) => {
                console.log(error);
                callback(Number.POSITIVE_INFINITY);
              }
            });
         }
      },
      applyBestCode: (bestCode) => {
       if(window.location.href.indexOf("cart") > -1){
          document.querySelector('.cart-header__promo-input').value = bestCode;
          document.querySelector('.cart-header__promo-input').dispatchEvent(new Event('input', {bubbles: true}));
          document.querySelector('.cart-header__promo-input').dispatchEvent(new Event('change'));
          document.querySelector('.cart-header__promo-btn').click();
       }else{
        document.querySelector('[name="checkout[reduction_code]"], #checkout_discount_code').value = bestCode;
        document.querySelector('[name="checkout[reduction_code]"], #checkout_discount_code').dispatchEvent(new MouseEvent('input', { bubbles: true } ));
        setTimeout(function(){
            document.querySelector('[data-trekkie-id="apply_discount_button"], #apply-discount').click(); 
          }, 500);
       }
      }
    },


  elfcosmetics: {
    id: 722,
    preApplyCodes: (callback) => {
      const orderValueEl = $('.order-total .order-value');
      const prevValue = orderValueEl.length > 0 ? 
                        Number(orderValueEl.first().text().trim().substr(1)) : 
                        Number.POSITIVE_INFINITY;
      callback(prevValue);
    },
    applyCode: (code, callback) => {
    if(document.querySelector('#cart-items-form')){ 
      const url = $('#cart-items-form').attr('action');
      const formData = getFormFieldsAsJson(document.querySelector('#cart-items-form'));
      formData['dwfrm_cart_couponCode'] = code;
      formData['dwfrm_cart_addCoupon'] = 'dwfrm_cart_addCoupon';
      $.post(url, formData, 
        (response) => {
          const orderValueEl = $(response).find('.order-total .order-value');
          const value = orderValueEl.length > 0 ? 
                      Number(orderValueEl.first().text().trim().substr(1)) : 
                      Number.POSITIVE_INFINITY;
          callback(value);
        });
    }else{
      const windowVariables = retrieveWindowVariables(["window.Urls"]);
      const addCouponUrl = windowVariables["window.Urls"].addCoupon;     
      $.get(addCouponUrl+'?couponCode='+code+'&format=ajax', 
        (response) => { const value = response.baskettotal; callback(value); }) 
      }
    },
    applyBestCode: (bestCode) => {
      document.querySelector('#dwfrm_cart_couponCode, #dwfrm_billing_couponCode').value = bestCode;
      document.querySelector('#dwfrm_cart_couponCode, #dwfrm_billing_couponCode').dispatchEvent(new Event('input', { bubbles: true } ));
      document.querySelector('#add-coupon').click();
    }
  },

  acehardware: {
    id: 722,
    preApplyCodes: (callback) => {
      const orderValueEl = $('.cart-footer-pricing-total-container div:last-child .cart-footer-pricing-total');
      const prevValue = orderValueEl.length > 0 ? 
                        Number(orderValueEl.first().text().replace( /[^0-9.]/g, '').trim()) : 
                        Number.POSITIVE_INFINITY;
      callback(prevValue);
    },
    applyCode: (code, callback) => {
      const cartId = $('[name="id"]').val();
      $.ajax({
        url: 'https://www.acehardware.com/api/commerce/carts/'+cartId+'/coupons/'+code,
        type: 'PUT',
        contentType: 'application/json',
        success: (response) => {
          if(response.discountedTotal){
            const value = response.discountedTotal;
            callback(value);
          }else{
            callback(Number.POSITIVE_INFINITY);
          }
        },error: (xhr, status, error) => {
          callback(Number.POSITIVE_INFINITY);
        }
      });
    },
    applyBestCode: (bestCode) => {
      const cartId = $('[name="id"]').val();
      $.ajax({
        url: 'https://www.acehardware.com/api/commerce/carts/'+cartId+'/coupons/'+bestCode,
        type: 'PUT',
        contentType: 'application/json',
        success: () => { location.reload(); },
        error: () => { location.reload(); }
      });
    }
  },

  'ray-ban': {
    id: 198, 
    preApplyCodes: function(callback) {
      const elTotal = $('.wcs-shopping-total-title.wcs-shopping-grandtotal-js');
      const prevValue = elTotal.length > 0 ? 
                    Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                    Number.POSITIVE_INFINITY;
      callback(prevValue);
    },
    applyCode: function(code, callback) {
      this._applyCode(code, function(value) {
        callback(value);
      }) ;
    },
    applyBestCode: function(bestCode) {
      this._applyCode(bestCode, function() {
        location.reload();
      }) ;
    },
    _applyCode: (code, callback) => {      
      const url = 'https://www.ray-ban.com/AjaxPromotionCodeManage';
      const orderID = $('#orderId').val();
      const storeId = $('[name="storeId"]').val();
      $.ajax({
        url: url,
        type: 'POST',
        data: {promoCode: code, orderId: orderID, taskType: 'A', URL: 'ShopCartDisplayView', isCalculateViewRequired: true, promoAjax: true, storeId: storeId },
        success: (response, status, xhr) => {
          const total = $(response).find('.wcs-shopping-total-title.wcs-shopping-grandtotal-js'); 
          const value = total.length > 0 ? 
            Number(total.first().text().replace( /[^0-9.]/g, '').trim()) : 
            Number.POSITIVE_INFINITY;
            callback(value);
        },
        error: (xhr, status, error) => {
          callback(Number.POSITIVE_INFINITY);
        }
      });    
    }
  },

  coach: {
    removePrevCode: function(code, callback) {
      const url = $('form[name="dwfrm_cart"]').attr('action');
      const formData = getFormFieldsAsJson(document.querySelector('form[name="dwfrm_cart"]'));
      formData['dwfrm_cart_coupons_i0_deleteCoupon'] = 'Remove';
      $.post(url, formData, 
        (response) => {
          callback();
      });
    },
    preApplyCodes: function(callback) { 
      const elTotal = $('.order-total .value, .row.order-total span:last');
      const prevValue = elTotal.length > 0 ? 
                    Number(elTotal.text().replace( /[^0-9.]/g, '').trim()) : 
                    Number.POSITIVE_INFINITY;
      this.removePrevCode('prevCode', () => callback(prevValue));     
    },
    applyCode: function(code, callback) {
      const url = $('form[name="dwfrm_cart"]').attr('action');
      const formData = getFormFieldsAsJson(document.querySelector('form[name="dwfrm_cart"]'));
      formData['dwfrm_cart_couponCode'] = code;
      formData['dwfrm_cart_addCoupon'] = 'dwfrm_cart_addCoupon';
      $.post(url, formData, 
      (response) => {
       const orderValueEl = $(response).find('.order-total .value, .row.order-total span:last');
       const value = orderValueEl.length > 0 ? 
                    Number(orderValueEl.text().trim().substr(1)) : 
                    Number.POSITIVE_INFINITY; 
        this.removePrevCode(code, () => callback(value));            
      }); 
    },
    applyBestCode: (bestCode) => {
      document.querySelector('#dwfrm_cart_couponCode').value = bestCode;
      document.querySelector('#dwfrm_cart_couponCode').dispatchEvent(new Event('input', { bubbles: true } ));
      document.querySelector('#add-coupon').click();
    }
  },

  'magazine': {
    id: 33924,
    preApplyCodes: (callback) => {
      const orderValueEl = $('#subTotal__amount--price');
      const prevValue = orderValueEl.length > 0 ? 
                        Number(orderValueEl.first().text().replace( /[^0-9.]/g, '').trim()) : 
                        Number.POSITIVE_INFINITY;
      callback(prevValue);
    },
    applyCode: (code, callback) => {
      const sid = $('.arLanguage__selection.visible').attr('data-selection');
      const cid = $('#containerId').val();
      const url = 'https://www.magazine.store/rest-crt/model/public/com/meredith/commerce/order/coupon/ValidateCouponActor/validate/?sid='+sid+'&cid='+cid+'&cpn='+code;
      $.get(url, 
      (response) => {
        const data = JSON.parse(response.validationResult);
        console.log(data);
        const data2 = JSON.parse(Object.keys(data)[0]);
        const discount = data2.discount;
        const subtotal = $('#subTotal__amount--price');
        const prevValue = subtotal.length > 0 ? 
                  Number(subtotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                  Number.POSITIVE_INFINITY;
                  console.log(prevValue);
        const value = prevValue-discount;
        callback(value);       
      });
    },
    applyBestCode: (bestCode) => {
      document.querySelector('#couponCode').value = bestCode;
      document.querySelector('#couponCode').dispatchEvent(new Event('input', { bubbles: true } ));
      document.querySelector('.coupon-apply').click(); 
    }
  },

  onehanesplace: {
    id: 1289,
    preApplyCodes: function(callback) {
      const elTotal = $('#cart-totals .price.bfx-price.bfx-total-grandtotal, tr.grand.totals');
      const prevValue = elTotal.length > 0 ? 
                    Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                    Number.POSITIVE_INFINITY;
      callback(prevValue);
    },
    applyCode: function(code, callback) {
      const url = $('#discount-coupon-form').attr('action');
      const formData = getFormFieldsAsJson(document.querySelector('#discount-coupon-form'));
      formData['coupon_code_fake'] = code;
      formData['coupon_code'] = code;
      formData['last_code'] = code;
      $.ajax({
        url: url,
        type: 'POST',
        data: formData,
        success: () => {
          $.get('https://'+window.location.hostname+window.location.pathname, (responseGet) => {
            const checkoutconfigindex = responseGet.indexOf("window.checkoutConfig");
            const customerDataindex = responseGet.indexOf("window.isCustomerLoggedIn");
            const finalIndex = customerDataindex-checkoutconfigindex;
            const data = JSON.parse(responseGet.substr(responseGet.indexOf("window.checkoutConfig")+23, finalIndex-107));
            const value = data.totalsData.base_grand_total;
            const formData2 = getFormFieldsAsJson(document.querySelector('#discount-coupon-form'));
            formData2['last_code'] = code;
            formData2['remove_coupon'] = code;
             $.post(url, formData2, 
              (response) => {
               callback(value);
              });              
          });
        },
        error: (xhr, status, error) => {
           callback(Number.POSITIVE_INFINITY);
        }
      });
    },
    applyBestCode: (bestCode) => {
      document.querySelector('#coupon_code_fake, #discount-code-fake').value = bestCode;
      document.querySelector('#coupon_code_fake, #discount-code-fake').dispatchEvent(new MouseEvent('input', { bubbles: true } ));
      document.querySelector('#coupon_code_fake, #discount-code-fake').dispatchEvent(new Event('change', {bubbles: true}));
      document.querySelector('#coupon_code_fake, #discount-code-fake').dispatchEvent(new Event('blur')); 
      document.querySelector('#coupon_code_fake, #discount-code-fake').dispatchEvent(new Event('focus'));    
      document.querySelector('#discount-coupon-form button.action.apply,#discount-form button.action.action-apply').click();    
    }
  },

  trekkinn: {
    preApplyCodes: function(callback) {
      const elTotal = $('#importe_total');
      const prevValue = elTotal.length > 0 ? 
                    Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                    Number.POSITIVE_INFINITY;
      callback(prevValue);
    },
    applyCode: function(code, callback) {
      this._applyCode(code, function(value) {
        callback(value);
      }) ;
    },
    applyBestCode: function(bestCode) {
      this._applyCode(bestCode, function() {
        location.reload();
      }) ;
    },
    _applyCode: (code, callback) => {      
      const url = $('.c-zona-codigo').attr('action');
      const formData = getFormFieldsAsJson(document.querySelector('.c-zona-codigo'));
      formData['codigo_promocional'] = code;      
      $.ajax({
        url: 'https://www.trekkinn.com/'+url,
        type: 'POST',
        data: formData,
        success: (response, status, xhr) => {
          const total = $(response).find('#importe_total'); 
          const value = total.length > 0 ? 
                    Number(total.first().text().replace( /[^0-9.]/g, '').trim()) : 
                    Number.POSITIVE_INFINITY;
            callback(value);
        },
        error: (xhr, status, error) => {
          callback(Number.POSITIVE_INFINITY);
        }
      });    
    }
  },

  modanisa: {
    removePrevCode: function(code, callback) {
      const url = 'https://www.modanisa.com/en/basket/kupon_sil.php?new=1';
      $.get(url, 
        (response) => {
          callback();
      }).fail(function() {
          callback();
      });
    },
    preApplyCodes: function(callback) { 
      const elTotal = $('.basketSummary-value-totalPrice');
      const prevValue = elTotal.length > 0 ? 
                    Number(elTotal.text().replace( /[^0-9.]/g, '').trim()) : 
                    Number.POSITIVE_INFINITY;
      const prevCode = $('div:nth-child(3) > div.basketSummary-couponCodeWrapper > span').text();
      this.removePrevCode(prevCode, () => callback(prevValue, prevCode));
    },
    applyCode: function(code, callback) {
      this._applyCode(code, function(value) {
       this.removePrevCode(code, () => callback(value));
     }.bind(this));
    },
    applyBestCode: function(bestCode) {
      this._applyCode(bestCode, function(value) {
        location.reload();
      });   
    },
    _applyCode: (code, callback) => {      
      const url = 'https://www.modanisa.com/en/api/use_coupon.php';
      $.ajax({
        url: url,
        type: 'POST',
        data: {coupon_code: code},
        success: (response, status, xhr) => {
         $.get('https://www.modanisa.com/en/api/basket_components.php', 
          (responsePost) => {
            const data = JSON.parse(responsePost);
            const basket = data.basketSummary;
            const orderValueEl = $(basket).find('.basketSummary-value-totalPrice');
            const value = orderValueEl.length > 0 ? 
                            Number(orderValueEl.text().replace( /[^0-9.]/g, '').trim()) : 
                            Number.POSITIVE_INFINITY;
            callback(value);
          }).fail(function(response) {
            callback(Number.POSITIVE_INFINITY)
          });
        },
        error: (xhr, status, error) => {
          callback(Number.POSITIVE_INFINITY);
        }
      });    
    },
  },

  manscaped: {
    removePrevCode: function(code, callback) {
      const cart_token = $('[name="cart_token"]').val();
      const url = 'https://checkout.manscaped.com/shippingamount_responsive?store_id=39550&cart_token='+cart_token+'&discount_code=&customer_email=';
      $.get(url, 
        (response) => {
          callback();
      }).fail(function() {
          callback();
      });
    },
    preApplyCodes: function(callback) { 
      const elTotal = $('.payment-due__price');
      const prevValue = elTotal.length > 0 ? 
                    Number(elTotal.text().replace( /[^0-9.]/g, '').trim()) : 
                    Number.POSITIVE_INFINITY;
      const prevCode = $('.applied-discount__code').text();
      this.removePrevCode(prevCode, () => callback(prevValue, prevCode));
    },
    applyCode: function(code, callback) {
      this._applyCode(code, function(value) {
       this.removePrevCode(code, () => callback(value));
     }.bind(this));
    },
    applyBestCode: function(bestCode) {
      this._applyCode(bestCode, function(value) {
        location.reload();
      });   
    },
    _applyCode: (code, callback) => {      
      const cart_token = $('[name="cart_token"]').val();
      const url = 'https://checkout.manscaped.com/shippingamount_responsive?store_id=39550&cart_token='+cart_token+'&discount_code='+code+'&customer_email=';
      $.ajax({
        url: url,
        type: 'GET',
        success: (response, status, xhr) => {
         const value = response.total_amount;
         callback(value);
        },
        error: (xhr, status, error) => {
          callback(Number.POSITIVE_INFINITY);
        }
      });    
    },
  },

  shoecarnival: {
    id: 5851,
    preApplyCodes: (callback) => {
      const orderValueEl = $('.cart-order-totals .order-total .order-value');
      const prevValue = orderValueEl.length > 0 ? 
                        Number(orderValueEl.first().text().trim().substr(1)) : 
                        Number.POSITIVE_INFINITY;
      callback(prevValue);
    },
    applyCode: (code, callback) => {
      const url = $('#cart-items-form').attr('action');
      const formData = getFormFieldsAsJson(document.querySelector('#cart-items-form'));
      formData['dwfrm_cart_couponCode'] = code;
      formData['dwfrm_cart_addCoupon'] = 'dwfrm_cart_addCoupon';
      $.post(url, formData, 
        (response) => {
          const orderValueEl = $(response).find('.cart-order-totals .order-total .order-value');
          const value = orderValueEl.length > 0 ? 
                            Number(orderValueEl.first().text().trim().substr(1)) : 
                            Number.POSITIVE_INFINITY;
          callback(value);
        });
    },
    applyBestCode: (bestCode) => {
      document.querySelector('#dwfrm_cart_couponCode').value = bestCode;
      document.querySelector('#dwfrm_cart_couponCode').dispatchEvent(new Event('input', { bubbles: true } ));
      document.querySelector('#add-coupon').click();
    }
  },

  yesstyle: {
    removePrevCode: function(code, callback) {
      const windowVariables = retrieveWindowVariables(["ysApp.config"]);
      const authorization = windowVariables["ysApp.config"].security['Y-Authorization'];
      const expiration = windowVariables["ysApp.config"].security['Y-Expiration'];
      const string = windowVariables["ysApp.config"].security['Y-String'];
      const url = 'https://www.yesstyle.com/rest/coupon/v1/coupon-reward-code';
      $.ajax({
        url: url,
        type: 'DELETE',
        headers: {
                  'y-authorization': authorization,
                  'y-expiration': expiration,
                  'y-string': string,
                  'content-type': 'text/plain;charset=UTF-8'
                },
        data : JSON.stringify({couponCode : ''}),
        success: () => { callback(); },
        error: () => { callback(); }
      });  
    },
    preApplyCodes: function(callback) { 
      const elTotal = document.querySelector('[ng-bind-html="shoppingBag.orderSummary.grandTotal"]').innerText;
      const prevValue = elTotal.replace(/[^0-9.]/g, '').trim();
      this.removePrevCode('prevCode', () => callback(prevValue));
    },
    applyCode: function(code, callback) {
      this._applyCode(code, function(value) {
       this.removePrevCode(code, () => callback(value));
     }.bind(this));
    },
    applyBestCode: function(bestCode) {
      this._applyCode(bestCode, function(value) {
        location.reload();
      });   
    },
    _applyCode: (code, callback) => {      
      const windowVariables = retrieveWindowVariables(["ysApp.config"]);
      const authorization = windowVariables["ysApp.config"].security['Y-Authorization'];
      const expiration = windowVariables["ysApp.config"].security['Y-Expiration'];
      const string = windowVariables["ysApp.config"].security['Y-String'];
      const url = 'https://www.yesstyle.com/rest/coupon/v1/coupon-reward-code';
      $.ajax({
        url: url,
        type: 'PATCH',
        headers: {
                  'y-authorization': authorization,
                  'y-expiration': expiration,
                  'y-string': string,
                  'content-type': 'text/plain;charset=UTF-8'
                },
        data : JSON.stringify({couponCode : code}),
        success: (response) => {
          if(response.result && response.result.orderSummary){
            const value = response.result.orderSummary.orderTotal
            callback(value);
          }else{
            callback(Number.POSITIVE_INFINITY);
          }
        },
        error: () => {
          callback(Number.POSITIVE_INFINITY);
        }
      });    
    },
  },

  'shoppbs': {
    preApplyCodes: function(callback) {
      const elTotal = $('.total-line .summary-line .price');
      const prevValue = elTotal.length > 0 ? 
                    Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                    Number.POSITIVE_INFINITY;
      callback(prevValue);
    },
    applyCode: function(code, callback) {
      this._applyCode(code, function(value) {
        callback(value);
      }) ;
    },
    applyBestCode: function(bestCode) {
     document.querySelector('input[name="COUPON_CODE"]').value = bestCode;
     try{  
      document.querySelector('input[name="COUPON_CODE"]').dispatchEvent(new Event('input', {bubbles: true}));
      document.querySelector('input[name="COUPON_CODE"]').dispatchEvent(new Event('change', {bubbles: true}));
      document.querySelector('button#cart-promo-button, button#billing-coupon-button').click();
     }catch(e){}
    },
    _applyCode: (code, callback) => {      
      $.ajax({
        url: location.href,
        type: 'POST',
        data: {COUPON_CODE: code},
        success: (response, status, xhr) => {
          const total = $(response).find('.total-line .summary-line .price'); 
          const value = total.length > 0 ? 
                    Number(total.first().text().replace( /[^0-9.]/g, '').trim()) : 
                    Number.POSITIVE_INFINITY;
          callback(value);
        },
        error: (xhr, status, error) => {
          callback(Number.POSITIVE_INFINITY);
        }
      });    
    }
  },

  ctshirts: {
    removePrevCode: function(code, callback) {
      const url = $('#cart-items-form').attr('action');
      const formData = getFormFieldsAsJson(document.querySelector('#cart-items-form'));
      formData['dwfrm_cart_coupons_i0_deleteCoupon'] = 'Remove';
      $.post(url, formData, 
        (response) => {
          callback();
      });
    },
    preApplyCodes: function(callback) { 
      const elTotal = $('.js-summary-desktop .item__price--large:last-child');
      const prevValue = elTotal.length > 0 ? 
                    Number(elTotal.text().replace( /[^0-9.]/g, '').trim()) : 
                    Number.POSITIVE_INFINITY;
      var prevCodeSelector = document.querySelector('#js-coupon-code + .item-list__coupon .coupon-radio label');
      var prevCode;
      if(prevCodeSelector){
        prevCode = prevCodeSelector.innerText;
        this.removePrevCode('prevCode', () => callback(prevValue, prevCode));
      }else{
        callback(prevValue);
      }      
    },
    applyCode: function(code, callback) {
      const url = $('#cart-items-form').attr('action');
      const formData = getFormFieldsAsJson(document.querySelector('#cart-items-form'));
      formData['dwfrm_cart_couponCode'] = code;
      formData['dwfrm_cart_addCoupon'] = 'dwfrm_cart_addCoupon';
      formData['dwfrm_cart_updateCart'] = 'dwfrm_cart_updateCart';
      $.post(url, formData, 
      (responsePost) => {
        const orderValueEl = $(responsePost).find('.js-summary-desktop .item__price--large:last-child');
        const value = orderValueEl.length > 0 ? 
                    Number(orderValueEl.text().replace( /[^0-9.]/g, '').trim()) : 
                    Number.POSITIVE_INFINITY;  
        this.removePrevCode(code, () => callback(value));
      });
    },
    applyBestCode: (bestCode) => {
      document.querySelector('#dwfrm_cart_couponCode').value = bestCode;
      document.querySelector('#dwfrm_cart_couponCode').dispatchEvent(new Event('input', { bubbles: true } ));
      document.querySelector('#add-coupon').click();
    }
  },

  tvstoreonline: {
    removePrevCode: function(url, callback) {
      $.ajax({
        url: url,
        type: 'GET',
        success: () => { callback(); },
        error: () => { callback(); }
      });
    },
    preApplyCodes: function(callback) { 
      const elTotal = document.querySelector('.cart-total-grandTotal').innerText;
      const prevValue = elTotal.replace(/[^0-9.]/g, '').trim();
      const prevCodeSelector = $('a:contains(Remove)');
      if(prevCodeSelector.length > 0 ){
        const prevCodeUrl = $('a:contains(Remove)').attr('href');
        this.removePrevCode(prevCodeUrl, () => callback(prevValue));
      }else{
        callback(prevValue);
      }      
    },
    applyCode: function(code, callback) {
      this._applyCode(code, function(value) {
        $.get('https://www.tvstoreonline.com/cart.php', 
          (response) => {
            const orderValueEl = $(response).find('.cart-total-grandTotal');
            const value = orderValueEl.length > 0 ? 
                    Number(orderValueEl.text().replace( /[^0-9.]/g, '').trim()) : 
                    Number.POSITIVE_INFINITY; 
            const removeUrl = $(response).find('a:contains(Remove)').attr('href');
            this.removePrevCode(removeUrl, () => callback(value));
        }).fail(function() {
            callback(Number.POSITIVE_INFINITY);
        });
     }.bind(this));
    },
    applyBestCode: function(bestCode) {
      this._applyCode(bestCode, function(value) {
        location.reload();
      });   
    },
    _applyCode: (code, callback) => {
      const windowVariables = retrieveWindowVariables(["BCData"]);
      const csrf_token = windowVariables.BCData.csrf_token;
      $.ajax({
        url: 'https://www.tvstoreonline.com/remote/v1/apply-code',
        type: 'POST',
        headers: {
                  'x-xsrf-token': csrf_token,
                },
        data : {code: code},
        success: (response) => { callback(); },
        error: () => { callback(); }
      });
    },
  },

  haggar: {
    removePrevCode: function(code, callback) {
      const windowVariables = retrieveWindowVariables(["window.Urls"]);
      const removeCouponUrl = windowVariables["window.Urls"].deleteCoupon;
      $.ajax({
        url: removeCouponUrl+'?couponCode='+code+'&format=ajax',
        type: 'GET',
        success: () => { callback(); },
        error: () => { callback(); }
      });
    },
    preApplyCodes: function(callback) { 
      const elTotal = document.querySelector('.order-total .order-value').innerText;
      const prevValue = elTotal.replace(/[^0-9.]/g, '').trim();
      const prevCodeSelector = document.querySelector('.cartcoupon');
      if(prevCodeSelector){
        const prevCode = prevCodeSelector.innerText;
        this.removePrevCode(prevCode, () => callback(prevValue));
      }else{
        callback(prevValue);
      }      
    },
    applyCode: function(code, callback) {
      this._applyCode(code, function(value) {
        $.get(location.href, 
          (response) => {
            const orderValueEl = $(response).find('.order-total .order-value');
            const value = orderValueEl.length > 0 ? 
                    Number(orderValueEl.text().replace( /[^0-9.]/g, '').trim()) : 
                    Number.POSITIVE_INFINITY; 
            this.removePrevCode(code, () => callback(value));
        }).fail(function() {
            callback(Number.POSITIVE_INFINITY);
        });
     }.bind(this));
    },
    applyBestCode: function(bestCode) {
      this._applyCode(bestCode, function(value) {
        location.reload();
      });   
    },
    _applyCode: (code, callback) => {
      const windowVariables = retrieveWindowVariables(["window.Urls"]);
      const addCouponUrl = windowVariables["window.Urls"].addCoupon;
      $.ajax({
        url: addCouponUrl+'?couponCode='+code+'&format=ajax',
        type: 'GET',
        success: (response) => { callback(); },
        error: () => { callback(); }
      });
    },
  },

  aeropostale: {
    removePrevCode: function(code, callback) {
      if(window.location.href.indexOf("cart") > -1){
        const url = $('#cart-items-form').attr('action');
        const formData = getFormFieldsAsJson(document.querySelector('#cart-items-form'));
        formData['dwfrm_cart_coupons_i0_deleteCoupon'] = 'Remove';
        $.post(url, formData, 
          (response) => {
             callback();
        });
      }
    },
    preApplyCodes: function(callback) { 
      const elTotal = document.querySelector('.order-total .order-value').innerText;
      const prevValue = elTotal.replace(/[^0-9.]/g, '').trim();
      const prevCodeSelector = document.querySelector('.cartcoupon .value');
      if(prevCodeSelector){
        const prevCode = prevCodeSelector.innerText;
        this.removePrevCode(prevCode, () => callback(prevValue, prevCode));
      }else{
        callback(prevValue);
      }      
    },
    applyCode: function(code, callback) {
      this._applyCode(code, function(value) {
        if(window.location.href.indexOf("cart") > -1){
          $.get('https://'+window.location.hostname+'/cart', (response) => {
              const orderValueEl = $(response).find('.order-total .order-value');
              const value = orderValueEl.length > 0 ? 
                          Number(orderValueEl.first().text().trim().substr(1)) : 
                          Number.POSITIVE_INFINITY;  
              this.removePrevCode(code, () => callback(value));               
            }).fail(function() {
              callback(Number.POSITIVE_INFINITY);
          });
        }else{         
         $.get('https://'+window.location.hostname+'/on/demandware.store/Sites-aeropostale-Site/default/COBilling-UpdateSummary?format=ajax', 
          (response) => {
          const orderValueEl = $(response).find('.order-total .order-value');
          const value = orderValueEl.length > 0 ? 
                        Number(orderValueEl.first().text().trim().substr(1)) : 
                        Number.POSITIVE_INFINITY;
          callback(value);
          });
        }
     }.bind(this));
    },
    applyBestCode: function(bestCode) {
      this._applyCode(bestCode, function(value) {
        location.reload();
      });   
    },
    _applyCode: (code, callback) => {
      if(window.location.href.indexOf("cart") > -1){  
        const url = $('#cart-items-form').attr('action');
        const formData = getFormFieldsAsJson(document.querySelector('#cart-items-form'));
        formData['dwfrm_cart_couponCode'] = code;
        formData['dwfrm_cart_addCoupon'] = 'dwfrm_cart_addCoupon';
        $.post(url, formData, 
        (responsePost) => {
          callback();
        });
      }else{
        $.get('https://'+window.location.hostname+'/on/demandware.store/Sites-aeropostale-Site/default/Cart-AddCouponJson?couponCode='+code+'&format=ajax', 
        (responseGet) => {
          callback();
        });
      }
    },
  },

  hockeymonkey: {
    id: 938,
    removePrevCode: function(code, callback) {
      if(window.location.href.indexOf("cart") > -1){
        const url = $('#discount-coupon-form').attr('action');
        const formData2 = getFormFieldsAsJson(document.querySelector('#discount-coupon-form'));
        formData2['last_code'] = code;
        formData2['remove_coupon'] = code;
        $.post(url, formData2, 
        (response) => {  callback(); }).fail(function() { callback(); });
      }else{
        const windowVariables = retrieveWindowVariables(["window.checkoutConfig"]);
        const quoteId = windowVariables["window.checkoutConfig"].quoteId;
        const customerData = windowVariables["window.checkoutConfig"].customerData;
        const storeCode = windowVariables["window.checkoutConfig"].storeCode
        var url;
        if(customerData.id){
          url = 'https://www.hockeymonkey.com/rest/'+storeCode+'/V1/carts/mine/coupons';
        }else{
          url = 'https://www.hockeymonkey.com/rest/'+storeCode+'/V1/guest-carts/'+quoteId+'/coupons';
        }
        $.ajax({
          url: url,
          type: 'DELETE',
          success: (response) => { callback(); },
          error: (response) => { callback(); }
        });
      }           
    },
    preApplyCodes: function(callback) {
      const elTotal = $('.grand.totals .price');
      const prevValue = elTotal.length > 0 ? 
                    Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                    Number.POSITIVE_INFINITY;
      const prevCode = $('#coupon_code, #discount-code').val();
      if(prevCode != ''){
        this.removePrevCode(prevCode, () => callback(prevValue, prevCode));
      }else{
        callback(prevValue);
      }      
    },
    applyCode: function(code, callback) {
     this._applyCode(code, function(value) {
        const ts = Math.round(new Date().getTime());
        const windowVariables = retrieveWindowVariables(["window.checkoutConfig"]);
        const quoteId = windowVariables["window.checkoutConfig"].quoteId;
        const customerData = windowVariables["window.checkoutConfig"].customerData;
        const storeCode = windowVariables["window.checkoutConfig"].storeCode
        var url;
        if(customerData.id){
          url = 'https://www.hockeymonkey.com/rest/'+storeCode+'/V1/carts/mine/payment-information?_='+ts;
        }else{
          url = 'https://www.hockeymonkey.com/rest/'+storeCode+'/V1/guest-carts/'+quoteId+'/payment-information?_='+ts;
        }
        $.ajax({
            url: url,
            type: 'GET',
            success: (response) => {                  
               const value = response.totals.base_grand_total;
               this.removePrevCode(code, () => callback(value.toFixed(2)));
            },error: () => { this.removePrevCode(code, () => callback(Number.POSITIVE_INFINITY)); }
          });
     }.bind(this));
    },
    applyBestCode: function(bestCode) {
      this._applyCode(bestCode, function() {
        location.reload();
      }) ;
    },
    _applyCode: (code, callback) => {
      if(window.location.href.indexOf("cart") > -1){
        const url = $('#discount-coupon-form').attr('action');
        const formData = getFormFieldsAsJson(document.querySelector('#discount-coupon-form'));
        formData['coupon_code_fake'] = code;
        formData['coupon_code'] = code;
        formData['last_code'] = code;
        $.ajax({
          url: url,
          type: 'POST',
          data: formData,
          success: () => { callback(); },
          error: () => { callback(); }
        });
      }else{
        const windowVariables = retrieveWindowVariables(["window.checkoutConfig"]);
        const quoteId = windowVariables["window.checkoutConfig"].quoteId;
        const customerData = windowVariables["window.checkoutConfig"].customerData;
        const storeCode = windowVariables["window.checkoutConfig"].storeCode
        var url;
        if(customerData.id){
          url = 'https://www.hockeymonkey.com/rest/'+storeCode+'/V1/carts/mine/coupons/'+code;
        }else{
          url = 'https://www.hockeymonkey.com/rest/'+storeCode+'/V1/guest-carts/'+quoteId+'/coupons/'+code;
        }
        $.ajax({
          url: url,
          type: 'PUT',
          success: () => { callback(); },
          error: () => { callback(); }
        });
      }
    },
  },

  shoplc: {
    removePrevCode: function(code, callback) {
      var ts = Math.round(new Date().getTime());
      const url = 'https://www.shoplc.com/cart/releaseajaxpromocode?_='+ts;
      $.get(url, 
        (response) => {
          callback();
      }).fail(function() {
          callback();
      });
    },
    preApplyCodes: function(callback) { 
      const elTotal = $('.d-total-display-price');
      const prevValue = elTotal.length > 0 ? 
                    Number(elTotal.text().replace( /[^0-9.]/g, '').trim()) : 
                    Number.POSITIVE_INFINITY;
      const prevCode = $('#promoCodeRequest').val();
      this.removePrevCode(prevCode, () => callback(prevValue, prevCode));
    },
    applyCode: function(code, callback) {
      this._applyCode(code, function(value) {
       this.removePrevCode(code, () => callback(value));
     }.bind(this));
    },
    applyBestCode: function(bestCode) {
      this._applyCode(bestCode, function(value) {
        location.reload();
      });   
    },
    _applyCode: (code, callback) => {      
      var ts = Math.round(new Date().getTime());
      const url = 'https://www.shoplc.com/cart/ajaxpromocode?promoCode='+code+'&_='+ts;
      $.ajax({
        url: url,
        type: 'GET',
        success: (response, status, xhr) => {
          if(response.cartData && response.cartData.totalPayableAmount){
            const value = response.cartData.totalPayableAmount;
            callback(value);
          }else{
            callback(Number.POSITIVE_INFINITY);
          }
        },
        error: (xhr, status, error) => {
          callback(Number.POSITIVE_INFINITY);
        }
      });    
    },
  },

  stylevana: {
    id: 39514, 
    preApplyCodes: function(callback) {
      const elTotal = $('#shopping-cart-totals-table tfoot tr:last-child td:last-child .price, #order-summary-table tfoot tr:last-child td:last-child .price');
      const prevValue = elTotal.length > 0 ? 
                    Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                    Number.POSITIVE_INFINITY;
      const prevCode = $('#coupon_code').val();
      callback(prevValue,prevCode);
    },
    applyCode: function(code, callback) {
      const url = $('#discount-coupon-form').attr('action');
      $.ajax({
        url: url,
        type: 'POST',
        data: {
          remove: 0,
          coupon_code: code
        },
        success: (data, textStatus, request) => {
          const locationUrl = request.getResponseHeader('location');
          $.get(locationUrl , (responseGet) => {
            const elTotal = $(responseGet).find('#shopping-cart-totals-table tfoot tr:last-child td:last-child .price, #order-summary-table tfoot tr:last-child td:last-child .price');
            var value = 0;
            if( elTotal.length > 0 ){
               $( elTotal ).each(function( index ) {
                value += Number($( this ).text().replace( /[^0-9.]/g, '').trim());                
               });
            }else{
                value = Number.POSITIVE_INFINITY;
            }
            
            callback(value);
          });
        },
        error: (xhr, status, error) => {
           callback(Number.POSITIVE_INFINITY);
        }
      });
    },
    applyBestCode: (bestCode) => {
      document.querySelector('#coupon_code').value = bestCode;
      document.querySelector('#coupon_code').dispatchEvent(new MouseEvent('input', { bubbles: true } ));
      document.querySelector('button[value="Apply Coupon"]').click();  
    }
  },

  '123inkjets': {
    preApplyCodes: function(callback) { 
      const elTotal = $('.grand-total .price');
      const prevValue = elTotal.length > 0 ? 
                    Number(elTotal.text().replace( /[^0-9.]/g, '').trim()) : 
                    Number.POSITIVE_INFINITY;
      callback(prevValue)
    },
    applyCode: function(code, callback) {
      this._applyCode(code, function(value) {
        $.get('https://www.123inkjets.com/checkout/cart/retrieveCartTotals', 
        (response) => {
          const data = JSON.parse(response);
          const value = data.grandtotal;
          callback(value);
      }).fail(function() {
          callback(Number.POSITIVE_INFINITY);
      });
     }.bind(this));
    },
    applyBestCode: function(bestCode) {
      this._applyCode(bestCode, function(value) {
        location.reload();
      });   
    },
    _applyCode: (code, callback) => {
      const url = 'https://www.123inkjets.com/checkout/cart/couponPost';
      $.ajax({
        url: url,
        type: 'POST',
        contentType: 'application/json;charset=UTF-8',
        data: JSON.stringify({coupon_code :code, 'async': true }),
        success: () => { callback(); },
        error: () => { callback(); }
      });    
    },
  },

  'inkcartridges': {
    preApplyCodes: function(callback) { 
      const elTotal = $('.grand-total .price');
      const prevValue = elTotal.length > 0 ? 
                    Number(elTotal.text().replace( /[^0-9.]/g, '').trim()) : 
                    Number.POSITIVE_INFINITY;
      callback(prevValue)
    },
    applyCode: function(code, callback) {
      this._applyCode(code, function(value) {
        $.get('https://www.inkcartridges.com/checkout/cart/retrieveCartTotals', 
        (response) => {
          const data = JSON.parse(response);
          const value = data.grandtotal;
          callback(value);
      }).fail(function() {
          callback(Number.POSITIVE_INFINITY);
      });
     }.bind(this));
    },
    applyBestCode: function(bestCode) {
      this._applyCode(bestCode, function(value) {
        location.reload();
      });   
    },
    _applyCode: (code, callback) => {
      const url = 'https://www.inkcartridges.com/checkout/cart/couponPost';
      $.ajax({
        url: url,
        type: 'POST',
        contentType: 'application/json;charset=UTF-8',
        data: JSON.stringify({coupon_code :code, 'async': true }),
        success: () => { callback(); },
        error: () => { callback(); }
      });    
    },
  },

  'kitchenaid': {
    preApplyCodes: function(callback) { 
      const elTotal = document.querySelector('.summary__row .order-summary-estimated-value strong').innerText;
      const prevValue = elTotal.replace( /[^0-9.]/g, '').trim();
      callback(prevValue);
    },
    applyCode: function(code, callback) {
      this._applyCode(code, function(value) {
        callback(value);
     }.bind(this));
    },
    applyBestCode: function(bestCode) {
      document.querySelector('.mobile-hidden #voucherCode, .shopping-cart-tile-wrapper #voucherCode, #order-promo-code-input').value = bestCode;
      document.querySelector('.mobile-hidden #voucherCode, .shopping-cart-tile-wrapper #voucherCode, #order-promo-code-input').dispatchEvent(new Event('input', {bubbles: true})); 
      document.querySelector('.mobile-hidden #voucherCode, .shopping-cart-tile-wrapper #voucherCode, #order-promo-code-input').dispatchEvent(new Event('change', {bubbles: true})); 
      document.querySelector('.mobile-hidden #voucherCode, .shopping-cart-tile-wrapper #voucherCode, #order-promo-code-input').dispatchEvent(new Event('blur')); 
      document.querySelector('.mobile-hidden #voucherCode, .shopping-cart-tile-wrapper #voucherCode, #order-promo-code-input').dispatchEvent(new Event('keyup')); 
      document.querySelector('.mobile-hidden #voucherCode, .shopping-cart-tile-wrapper #voucherCode, #order-promo-code-input').dispatchEvent(new Event('focus'));  
      document.querySelector('.js-order-summary-promo-apply').click()   
    },
    _applyCode: (code, callback) => {
      const url = $('#voucherForm').attr('action');
      const formData = getFormFieldsAsJson(document.querySelector('#voucherForm'));
      formData['voucherCode'] = code;
      $.ajax({
        url: url,
        type: 'POST',
        data: formData,
        success: (response) => { 
        	const data = $(response).find('#updatedCartData').attr('data-updated-cart-data');
        	const jsonData = JSON.parse(data);
        	const value = jsonData.totalPriceWithTax.value;
        	callback(value);
         },
        error: () => { callback(Number.POSITIVE_INFINITY); }
      });    
    },
  },

  'eaglemoss': {
    preApplyCodes: function(callback) { 
      const elTotal = document.querySelector('[value="vm.basket.subtotalWithDiscount"], [value="total.value"]').textContent;
      const prevValue = elTotal.replace( /[^0-9.]/g, '').trim();
      callback(prevValue);
    },
    applyCode: function(code, callback) {
      this._applyCode(code, function(value) {
        callback(value);
     }.bind(this));
    },
    applyBestCode: function(bestCode) {
      this._applyCode(bestCode, function(value) {
        location.reload();
      });   
    },
    _applyCode: (code, callback) => {
      const basehref = $('base').attr('href');
      const url = 'https://shop.eaglemoss.com'+basehref+'api/basket/coupon/add';
      $.ajax({
        url: url,
        type: 'POST',
        contentType: 'application/json',
        data: JSON.stringify({coupon :code }),
        success: (response) => { 
          if(response.customer && response.customer.cart){
            const value = response.customer.cart.totals.grand_total;
            callback(value); 
          }else{
            callback(Number.POSITIVE_INFINITY); 
          }
        },
        error: () => { callback(Number.POSITIVE_INFINITY); }
      });    
    },
  },

  'hayneedle': {
    preApplyCodes: function(callback) { 
      const elTotal = document.querySelector('[class*="cart-subtotal__cartRowTotal"].txt-black.txt-right, [class*="order-summary__cartRowTotal"].txt-black.txt-right').innerText;
      const prevValue = elTotal.replace( /[^0-9.]/g, '').trim();
      callback(prevValue);
    },
    applyCode: function(code, callback) {
      this._applyCode(code, function(value) {
        callback(value);
     }.bind(this));
    },
    applyBestCode: function(bestCode) {
      this._applyCode(bestCode, function(value) {
        location.reload();
      });   
    },
    _applyCode: (code, callback) => {
      const csrfToken = localStorage.getItem('csrfToken');
      if(window.location.href.indexOf("cart") > -1){
        const url = 'https://www.hayneedle.com/sf-service/carts/applyPromotionCode';
        $.ajax({
          url: url,
          type: 'POST',
          headers: {
                    'x-csrf-jwt': csrfToken,
                    'content-type': 'application/json'
                  },
          data: JSON.stringify({promotionCode :code }),
          success: (response) => {
            if(response.carts){
              const value = response.carts[0].total;
              callback(value);
            }else{
              callback(Number.POSITIVE_INFINITY);
            }
          },
          error: () => { callback(Number.POSITIVE_INFINITY); }
        }); 
      }else{
        const windowVariables = retrieveWindowVariables(["window.__PRELOADED_STATE__.session"]);
        const checkoutSessionId = windowVariables['window.__PRELOADED_STATE__.session'].checkoutSessionID;
        const browserSessionID = windowVariables['window.__PRELOADED_STATE__.session'].browserSessionID;
        const url = 'https://www.hayneedle.com/checkout-service/proxy/v1/checkouts/'+checkoutSessionId+'/promotions?browserSessionID='+browserSessionID;
        $.ajax({
          url: url,
          type: 'PUT',
          headers: {
                    'x-csrf-jwt': csrfToken,
                    'content-type': 'application/json'
                  },
          data: JSON.stringify({promotionCode :code }),
          success: (response) => {
            const getUrl = 'https://www.hayneedle.com/checkout-service/proxy/v1/checkouts/'+checkoutSessionId+'?bypassCache=false&includes=orderTotals';
            $.ajax({
              url: getUrl,
              type: 'GET',
              headers: {
                        'x-csrf-jwt': csrfToken,
                        'content-type': 'application/json'
                      },
              success: (responseGet) => {
                if(responseGet.orderReviews){
                  const value = responseGet.orderReviews[0].orderTotals[0].orderTotal;
                  callback(value);
                }else{
                  callback(Number.POSITIVE_INFINITY);
                }
              },
              error: () => { callback(Number.POSITIVE_INFINITY); }
            })            
          },
          error: () => { callback(Number.POSITIVE_INFINITY); }
        }); 
      }         
    },
  },

  kmart: {
    id: 201, 
    preApplyCodes: function(callback) {
      const elTotal = $('.est-total-bottom strong');
      const prevValue = elTotal.length > 0 ? 
                    Number(elTotal.text().replace( /[^0-9.]/g, '').trim()) : 
                    Number.POSITIVE_INFINITY;
      callback(prevValue);
    },
    applyCode: function(code, callback) {
      var ts = Math.round(new Date().getTime());
       const body = {
          couponRequest: {couponCode: code },
        };
      $.ajax({
        url: 'https://www.kmart.com/crsp/api/cart/v1/coupon/add?ts='+ts,
        type: 'POST',
        data: JSON.stringify(body),
        contentType: 'application/json;charset=UTF-8',
        success: () => {
          var ts2 = Math.round(new Date().getTime());
          $.ajax({
            url: `https://www.kmart.com/crsp/api/cart/v1/view?ts=`+ts2,
            type: 'GET',
            success: (data) => {               
              const value = data.response.cartSummary.mrchSubTot;                       
              var ts3 = Math.round(new Date().getTime());
              $.ajax({
                url: 'https://www.kmart.com/crsp/api/cart/v1/coupon/remove?ts='+ts3,
                type: 'POST',
                data: JSON.stringify(body),
                contentType: 'application/json;charset=UTF-8',
                success: () => {   callback(value); },
                error: () => {  callback(value);  }
              });
            },
            error: (xhr, status, error) => {
              callback(Number.POSITIVE_INFINITY);
            }
          })
        },
        error: (xhr, status, error) => {
          callback(Number.POSITIVE_INFINITY);
        }
      });
    },
    applyBestCode: (bestCode) => {
      document.querySelector('[ng-model=couponCode]').value = bestCode;
      document.querySelector('[ng-model=couponCode]').dispatchEvent(new MouseEvent('input', {bubbles: true}));
      setTimeout(function(){
        document.querySelector('.cc-add').click();
        location.reload();
      }, 1000);
    }
  },

  lacoste: {
    id: 5221,
    removePrevCode: function(code, callback) {
      const lang = getCookie('language');
      const url = 'https://'+window.location.hostname+'/on/demandware.store/Sites-FlagShip-Site/'+lang+'/CartV2-RemoveCouponLineItem';
      $.ajax({
        url: url,
        type: 'POST',
        data: {couponCode : code},
        success: () => { callback(); },
        error: () => { callback(); }
      });
    },
    preApplyCodes: function(callback) { 
      const elTotal = $('li.cart-price-total');
      const prevValue = elTotal.length > 0 ? 
                    Number(elTotal.text().replace( /[^0-9.]/g, '').trim()) : 
                    Number.POSITIVE_INFINITY;
      const prevCodeSelector = document.querySelector('.js-delete-code');
      if(prevCodeSelector){
        const prevCode = $('.js-delete-code').attr('data-coupon-code');
        this.removePrevCode(prevCode, () => callback(prevValue, prevCode));
      }else{
        callback(prevValue);
      }      
    },
    applyCode: function(code, callback) {
      this._applyCode(code, function(value) {
        $.get(window.location.href, 
        (response) => {
          const orderValueEl = $(response).find('li.cart-price-total');
          const value = orderValueEl.length > 0 ? 
                        Number(orderValueEl.first().text().replace( /[^0-9.]/g, '').trim()) : 
                        Number.POSITIVE_INFINITY;
          this.removePrevCode(code, () => callback(value));
        }).fail(function() {
            callback(Number.POSITIVE_INFINITY);
        });
     }.bind(this));
    },
    applyBestCode: function(bestCode) {
      this._applyCode(bestCode, function(value) {
        location.reload();
      });   
    },
    _applyCode: (code, callback) => {      
      const lang = getCookie('language');
      const url = 'https://'+window.location.hostname+'/on/demandware.store/Sites-FlagShip-Site/'+lang+'/Cart-AddCoupon';
      $.ajax({
        url: url,
        type: 'POST',
        data: {couponCode : code, format : 'ajax'},
        success: () => {  callback(); },
        error: () => { callback(); }
      });    
    },
  },

  popsockets: {
    id: 31559,
    removePrevCode: function(code, uuid, callback) {
      const url = 'https://'+window.location.hostname+'/on/demandware.store/Sites-AMER-Site/en_US/Cart-RemoveCouponLineItem' +
                    '?code=' + code +
                    '&uuid=' + uuid; 
      $.ajax({
        url: url,
        type: 'GET',
        data: {},
        success: () => { callback(); },
        error: () => { callback(); }
      });
    },
    preApplyCodes: function(callback) {
      const elTotal = $('p.grand-total, span.grand-total-sum');
      const prevValue = elTotal.length > 0 ? 
                    Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                    Number.POSITIVE_INFINITY;
      const el = $('button.remove-coupon');
      var url = null;
      if (el !== null && el !== undefined && el.length > 0) {
        const prevCode = el.attr('data-code');
        const uuid = el.attr('data-uuid');
        this.removePrevCode(prevCode,uuid, () => callback(prevValue, prevCode));
      } else {
        callback(prevValue);
      }     
    },
    applyCode: function(code, callback) {
      this._applyCode(code, function(value) {
        $.get('https://'+window.location.hostname+window.location.pathname, (responseGet) => {
          const el = $(responseGet).find('button.remove-coupon');
          if (el !== null && el !== undefined && el.length > 0) {
            const uuid = el.attr('data-uuid');
            this.removePrevCode(code,uuid, () => callback(value));
          }else{
            callback(value);
          }      
        }).fail(function() {
            callback(Number.POSITIVE_INFINITY);
        });
     }.bind(this));
    },
    applyBestCode: function(bestCode) {
      document.querySelector('#couponCode').value = bestCode;
      document.querySelector('#couponCode').dispatchEvent(new MouseEvent('input', { bubbles: true } )); 
      document.querySelector('.promo-code-btn').click();   
    },
    _applyCode: (code, callback) => {      
        const csrf_token = $('input[name*="csrf_token"]').first().val();
        const addCouponUrl = '/on/demandware.store/Sites-AMER-Site/en_US/Cart-AddCoupon';
        const url = 'https://'+window.location.hostname+addCouponUrl +
                    '?couponCode=' + code + 
                    '&csrf_token=' + csrf_token;
        $.ajax({
          url: url,
          type: 'GET',
          data: {},
          success: (response, status, xhr) => {
            if (response !== null) {
              const totals = response.totals;
              if (totals !== null && totals !== undefined) {
                const value = totals.grandTotal !== null ? 
                          Number(totals.grandTotal.replace( /[^0-9.]/g, '').trim()) : 
                          Number.POSITIVE_INFINITY;
                callback(value);                
                return;
              }
            }
            callback(Number.POSITIVE_INFINITY);
          },
          error: (xhr, status, error) => {
            console.log(error);
            callback(Number.POSITIVE_INFINITY);
          }
      });    
    },
  },

  geekbuying: {
    id: 16592, 
    preApplyCodes: function(callback) {
      const elTotal = $('#lbGrandTotal');
      const prevValue = elTotal.length > 0 ? 
                    Number(elTotal.text().replace( /[^0-9.]/g, '').trim()) : 
                    Number.POSITIVE_INFINITY;
      callback(prevValue);
    },
    applyCode: function(code, callback) {
      const formData = getFormFieldsAsJson(document.querySelector('#BrainTreeForm'));
      formData['CouponCode'] = code;
      $.ajax({
        url: 'https://www.geekbuying.com/checkout/GetShoppingCartViewModelAjax',
        type: 'POST',
        data: formData,
        success: (response) => {
          const value = response.GrandTotal;
          callback(value);
        },
        error: (xhr, status, error) => {
          callback(Number.POSITIVE_INFINITY);
        }
      });
    },
    applyBestCode: (bestCode) => {
      document.querySelector('#txtCouponCode').value = bestCode;
      document.querySelector('#txtCouponCode').dispatchEvent(new MouseEvent('input', {bubbles: true}));
      document.querySelector('.geekcoud_btn').click();
    }
  },

  ashleyfurniture: {
    id: 22815, 
    removePrevCode: function(code, callback) {
      const url = $('#cart-items-form').attr('action');
      const csrf_token = $('#cart-items-form [name="csrf_token"]').val();
      const formData = {dwfrm_cart_updateCart : 'dwfrm_cart_updateCart', 
                        dwfrm_cart_couponCode : '',
                        dwfrm_cart_coupons_i0_deleteCoupon : 'Remove',
                        csrf_token : csrf_token
                        };
      $.post(url, formData, 
        (response) => {
           callback();
      });
    },
    preApplyCodes: function(callback) {
      const elTotal = $('.order-total .order-value');
      const prevValue = elTotal.length > 0 ? 
                    Number(elTotal.first().text().trim().substr(1)) : 
                    Number.POSITIVE_INFINITY;
      const prevCodeSelector = document.querySelector('.cartcoupon .coupon-code');
      if(prevCodeSelector){
        const prevCode = $('.cartcoupon .coupon-code').first().text();
        this.removePrevCode(prevCode, () => callback(prevValue, prevCode));
      }else{
        callback(prevValue);
      }
    },
    applyCode: function(code, callback) {
      const url = $('#cart-items-form').attr('action');
      const csrf_token = $('#cart-items-form [name="csrf_token"]').val();
      const formData = {dwfrm_cart_updateCart : 'dwfrm_cart_updateCart', 
                        dwfrm_cart_couponCode : code,
                        dwfrm_cart_addCoupon : 'dwfrm_cart_addCoupon',
                        csrf_token : csrf_token
                        };
      $.post(url, formData, 
      (responsePost) => {
        $.get('https://'+window.location.hostname+'/cart', (response) => {
          const orderValueEl = $(response).find('.order-total .order-value');
          const value = orderValueEl.length > 0 ? 
                      Number(orderValueEl.first().text().trim().substr(1)) : 
                      Number.POSITIVE_INFINITY;  
          this.removePrevCode(code, () => callback(value));
        });
      });
    },
    applyBestCode: (bestCode) => {
      document.querySelector('#dwfrm_cart_couponCode').value = bestCode;
      document.querySelector('#dwfrm_cart_couponCode').dispatchEvent(new Event('input', { bubbles: true } ));
      document.querySelector('#add-coupon').click();
    }
  },

  karmaloop: {
    id: 1055,
    removePrevCode: function(code, callback) {
      if(window.location.href.indexOf("cart") > -1){
        const url = $('#discount-coupon-form').attr('action');
        $.post(url, { remove: 1, coupon_code: code }, 
        (response) => {  callback(); }).fail(function() { callback(); });
      }else{
        const windowVariables = retrieveWindowVariables(["window.checkoutConfig"]);
        const quoteId = windowVariables["window.checkoutConfig"].quoteId;
        const customerData = windowVariables["window.checkoutConfig"].customerData;
        var url;
        if(customerData.id){
          url = 'https://www.karmaloop.com/rest/karmaloop/V1/carts/mine/coupons';
        }else{
          url = 'https://www.karmaloop.com/rest/karmaloop/V1/guest-carts/'+quoteId+'/coupons';
        }
        $.ajax({
          url: url,
          type: 'DELETE',
          success: (response) => { callback(); },
          error: (response) => { callback(); }
        });
      }           
    },
    preApplyCodes: function(callback) {
      const elTotal = $('.grand.totals .price');
      const prevValue = elTotal.length > 0 ? 
                    Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                    Number.POSITIVE_INFINITY;
      const prevCode = $('#coupon_code, #discount-code').val();
      if(prevCode != ''){
        this.removePrevCode(prevCode, () => callback(prevValue, prevCode));
      }else{
        callback(prevValue);
      }      
    },
    applyCode: function(code, callback) {
     this._applyCode(code, function(value) {
      if(window.location.href.indexOf("cart") > -1){
        $.get('https://www.karmaloop.com'+window.location.pathname, (responseGet) => {
            const checkoutconfigindex = responseGet.indexOf("window.checkoutConfig");
            const customerDataindex = responseGet.indexOf("window.customerData");
            const finalIndex = customerDataindex-checkoutconfigindex;
            const data = JSON.parse(responseGet.substr(responseGet.indexOf("window.checkoutConfig")+22, finalIndex-23));
            const value = data.totalsData.base_grand_total;
            this.removePrevCode(code, () => callback(value));
          });
       }else{
        const ts = Math.round(new Date().getTime());
        const windowVariables = retrieveWindowVariables(["window.checkoutConfig"]);
        const quoteId = windowVariables["window.checkoutConfig"].quoteId;
        const customerData = windowVariables["window.checkoutConfig"].customerData;
        var url;
        if(customerData.id){
          url = 'https://www.karmaloop.com/rest/karmaloop/V1/carts/mine/payment-information?_='+ts;
        }else{
          url = 'https://www.karmaloop.com/rest/karmaloop/V1/guest-carts/'+quoteId+'/payment-information?_='+ts;
        }
        $.ajax({
            url: url,
            type: 'GET',
            success: (response) => {                  
               const value = response.totals.base_grand_total;
               callback(value.toFixed(2));
            },error: () => { callback(Number.POSITIVE_INFINITY); }
          });
       }   
     }.bind(this));
    },
    applyBestCode: function(bestCode) {
      this._applyCode(bestCode, function() {
        location.reload();
      }) ;
    },
    _applyCode: (code, callback) => {
      if(window.location.href.indexOf("cart") > -1){
        const url = $('#discount-coupon-form').attr('action');
        $.ajax({
          url: url,
          type: 'POST',
          data: { remove: 0, coupon_code: code },
          success: () => { callback(); },
          error: () => { callback(); }
        });
      }else{
        const windowVariables = retrieveWindowVariables(["window.checkoutConfig"]);
        const quoteId = windowVariables["window.checkoutConfig"].quoteId;
        const customerData = windowVariables["window.checkoutConfig"].customerData;
        var url;
        if(customerData.id){
          url = 'https://www.karmaloop.com/rest/karmaloop/V1/carts/mine/coupons/'+code;
        }else{
          url = 'https://www.karmaloop.com/rest/karmaloop/V1/guest-carts/'+quoteId+'/coupons/'+code;
        }
        $.ajax({
          url: url,
          type: 'PUT',
          success: () => { callback(); },
          error: () => { callback(); }
        });
      }
    },
  },

  aerogarden: {
    id: 312,
    removePrevCode: function(code, callback) {
      if(window.location.href.indexOf("cart") > -1){
        const url = $('#discount-coupon-form').attr('action');
        const form_key = $('[name="form_key"]').val();
        $.post(url, { remove: 1, coupon_code: code, form_key:form_key }, 
        (response) => {  callback(); }).fail(function() { callback(); });
      }else{
        const windowVariables = retrieveWindowVariables(["window.checkoutConfig"]);
        const quoteId = windowVariables["window.checkoutConfig"].quoteId;
        const customerData = windowVariables["window.checkoutConfig"].customerData;
        var url;
        if(customerData.id){
          url = 'https://www.aerogarden.com/rest/default/V1/carts/mine/coupons';
        }else{
          url = 'https://www.aerogarden.com/rest/default/V1/guest-carts/'+quoteId+'/coupons';
        }
        $.ajax({
          url: url,
          type: 'DELETE',
          success: (response) => { callback(); },
          error: (response) => { callback(); }
        });
      }           
    },
    preApplyCodes: function(callback) {
      const elTotal = $('.grand.totals .price');
      const prevValue = elTotal.length > 0 ? 
                    Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                    Number.POSITIVE_INFINITY;
      const prevCode = $('#coupon_code, #discount-code').val();
      if(prevCode != ''){
        this.removePrevCode(prevCode, () => callback(prevValue, prevCode));
      }else{
        callback(prevValue);
      }      
    },
    applyCode: function(code, callback) {
     this._applyCode(code, function(value) {
      if(window.location.href.indexOf("cart") > -1){
        $.get('https://www.aerogarden.com'+window.location.pathname, (responseGet) => {
            const checkoutconfigindex = responseGet.indexOf("window.checkoutConfig");
            const customerDataindex = responseGet.indexOf("window.customerData");
            const finalIndex = customerDataindex-checkoutconfigindex;
            const data = JSON.parse(responseGet.substr(responseGet.indexOf("window.checkoutConfig")+24, finalIndex-38));
            const value = data.totalsData.base_grand_total;
            this.removePrevCode(code, () => callback(value));
          });
       }else{
        const ts = Math.round(new Date().getTime());
        const windowVariables = retrieveWindowVariables(["window.checkoutConfig"]);
        const quoteId = windowVariables["window.checkoutConfig"].quoteId;
        const customerData = windowVariables["window.checkoutConfig"].customerData;
        var url;
        if(customerData.id){
          url = 'https://www.aerogarden.com/rest/default/V1/carts/mine/payment-information?_='+ts;
        }else{
          url = 'https://www.aerogarden.com/rest/default/V1/guest-carts/'+quoteId+'/payment-information?_='+ts;
        }
        $.ajax({
            url: url,
            type: 'GET',
            success: (response) => {                  
               const value = response.totals.base_grand_total;
               callback(value.toFixed(2));
            },error: () => { callback(Number.POSITIVE_INFINITY); }
          });
       }   
     }.bind(this));
    },
    applyBestCode: function(bestCode) {
      this._applyCode(bestCode, function() {
        location.reload();
      }) ;
    },
    _applyCode: (code, callback) => {
      if(window.location.href.indexOf("cart") > -1){
        const form_key = $('[name="form_key"]').val();
        const url = $('#discount-coupon-form').attr('action');
        $.ajax({
          url: url,
          type: 'POST',
          data: { remove: 0, coupon_code: code, form_key:form_key },
          success: () => { callback(); },
          error: () => { callback(); }
        });
      }else{
        const windowVariables = retrieveWindowVariables(["window.checkoutConfig"]);
        const quoteId = windowVariables["window.checkoutConfig"].quoteId;
        const customerData = windowVariables["window.checkoutConfig"].customerData;
        var url;
        if(customerData.id){
          url = 'https://www.aerogarden.com/rest/default/V1/carts/mine/coupons/'+code;
        }else{
          url = 'https://www.aerogarden.com/rest/default/V1/guest-carts/'+quoteId+'/coupons/'+code;
        }
        $.ajax({
          url: url,
          type: 'PUT',
          success: () => { callback(); },
          error: () => { callback(); }
        });
      }
    },
  },

  'kiwico': {
    id: 10236,
    removePrevCode: function(code, callback) {
      const url = 'https://www.kiwico.com/kereru/v1/me/cart/coupon';
      $.ajax({
        url: url,
        type: 'DELETE',
        success: () => { callback(); },
        error: () => { callback(); }
      });
    },
    preApplyCodes: function(callback) {
      const elTotal = $('dt:contains("Total") + dd');
      const prevValue = elTotal.length > 0 ? 
                    Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                    Number.POSITIVE_INFINITY;
      const prevCodeSelector = document.querySelector('#__next .coupon-name');
      if(prevCodeSelector){
        document.querySelector('#coupon-toggle ~ div button[aria-label="Close"]').click();
        const prevCode = prevCodeSelector.innerText;
        this.removePrevCode(prevCode, () => callback(prevValue, prevCode));
      }
      callback(prevValue);
    },
    applyCode: function(code, callback) {
      this._applyCode(code, function(value) {
       this.removePrevCode(code, () => callback(value));
     }.bind(this));
    },
    applyBestCode: function(bestCode) {
      document.querySelector('#coupon').value = bestCode;
      document.querySelector('#coupon').dispatchEvent(new Event('input', {bubbles: true}));
      document.querySelector('#coupon').dispatchEvent(new Event('change'));
      $("button span:contains('Apply')").click();
    },
    _applyCode: (code, callback) => {
      const url = 'https://www.kiwico.com/kereru/v1/me/cart/coupon/'+code;
      $.ajax({
        url: url,
        type: 'POST',
        success: (response) => { 
          const value = response.data.totals.grandTotal;
          callback(value);
         },
        error: () => { callback(Number.POSITIVE_INFINITY); }
      });    
    },
  },

  'rag-bone': {
    removePrevCode: function(code, callback) {
      const url = $('#cart-items-form').attr('action');
      const formData = getFormFieldsAsJson(document.querySelector('#cart-items-form'));
      formData['dwfrm_cart_coupons_i0_deleteCoupon'] = 'Remove';
      formData['dwfrm_cart_couponCode'] = '';
      $.post(url, formData, 
        (response) => {
           callback();
      });
    },
    preApplyCodes: function(callback) { 
      const elTotal = document.querySelector('tr.order-total td strong').innerText;
      const prevValue = elTotal.replace(/[^0-9.]/g, '').trim();
      const prevCodeSelector = document.querySelector('.promo-remove strong');
      if(prevCodeSelector){
        const prevCode = prevCodeSelector.innerText;
        this.removePrevCode(prevCode, () => callback(prevValue, prevCode));
      }else{
        callback(prevValue);
      }      
    },
    applyCode: function(code, callback) {
      this._applyCode(code, function(value) {
        $.get('https://'+window.location.hostname+'/cart', (response) => {
          const orderValueEl = $(response).find('tr.order-total td strong');          
          const value = orderValueEl.length > 0 ? 
                      Number(orderValueEl.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;
          this.removePrevCode(code, () => callback(value));               
        }).fail(function() {
          callback(Number.POSITIVE_INFINITY);
        });
     }.bind(this));
    },
    applyBestCode: function(bestCode) {
      this._applyCode(bestCode, function(value) {
        location.reload();
      });   
    },
    _applyCode: (code, callback) => {
      const url = $('#cart-items-form').attr('action');
      const formData = getFormFieldsAsJson(document.querySelector('#cart-items-form'));
      formData['dwfrm_cart_couponCode'] = code;
      formData['dwfrm_cart_addCoupon'] = 'dwfrm_cart_addCoupon';
      $.post(url, formData, 
      (responsePost) => {
        callback();
      }).fail(function() {
          callback();
      });
    },
  },

  chowbus: {
    id: 44323,
    preApplyCodes: (callback) => {
      const elTotal = $('.MuiGrid-root .MuiTypography-body1:contains("Total") +');
      const prevValue = elTotal.length > 0 ? 
               Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
               Number.POSITIVE_INFINITY;
      callback(prevValue);
    },
    applyCode: (code, callback) => {
      $('.MuiButtonBase-root:contains("Apply")').removeClass('Mui-disabled'); 
      document.querySelector('input[name="promoCode"]').value = code;
      document.querySelector('input[name="promoCode"]').dispatchEvent(new MouseEvent('input', {bubbles: true}));
      $('.MuiButtonBase-root:contains("Apply")').click();
      setTimeout(function(){              
       const fTotal = $('.MuiGrid-root .MuiTypography-body1:contains("Total") +');
       const value = fTotal.length > 0 ? 
               Number(fTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
               Number.POSITIVE_INFINITY;
        callback(value);
       }, 5000);
    },
    applyBestCode: (bestCode) => {
      $('.MuiButtonBase-root:contains("Apply")').removeClass('Mui-disabled'); 
      document.querySelector('input[name="promoCode"]').value = bestCode;
      document.querySelector('input[name="promoCode"]').dispatchEvent(new MouseEvent('input', {bubbles: true}));
      $('.MuiButtonBase-root:contains("Apply")').click();
    }
  },

  saksoff5th: {
    id: 9833,
    preApplyCodes: (callback) => {
      const elTotal = $('.grand-total-sum');
      const prevValue = elTotal.length > 0 ? 
               Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
               Number.POSITIVE_INFINITY;
      callback(prevValue);
    },
    applyCode: (code, callback) => {
      try{   document.querySelector('.promo-click').click(); }catch(e){} 
      document.querySelector('#maincontent input#couponCode').value = code;      
      try{   
        setTimeout(()=>{
          $('.promo-code-btn').prop("disabled", false);
          $('.promo-code-btn').removeAttr("disabled");
          document.querySelector('#couponCode').dispatchEvent(new Event('input', { bubbles: true }));
          document.querySelector('#couponCode').dispatchEvent(new Event('keyup'));
          document.querySelector('#couponCode').dispatchEvent(new Event('blur'));
          document.querySelector('#couponCode').dispatchEvent(new Event('focus'));
          document.querySelector('.promo-code-btn').click();   
        }, 2000); 
      }catch(e){}
      setTimeout(function(){              
       const fTotal = $('#maincontent .grand-total-sum');
       const value = fTotal.length > 0 ? 
               Number(fTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
               Number.POSITIVE_INFINITY;
        callback(value);
       }, 4000);
    },
    applyBestCode: (bestCode) => {
      location.reload();
    }
  },

  elemis: {
    removePrevCode: function(code, callback) {
     const cartId = JSON.parse(localStorage.getItem('M2_VENIA_BROWSER_PERSISTENCE__cartId')).value.replace(/"/g,'');
     const windowVariables = retrieveWindowVariables(["window.STORE_CODE"]);
     const storeCode = windowVariables["window.STORE_CODE"];
     $.ajax({
        url: 'https://'+window.location.hostname+'/graphql',
        type: 'POST',
        contentType: 'application/json',
        headers: {
                  'store': storeCode,
                },
        data: JSON.stringify({
          operationName: 'removeCouponFromCart',
          query: 'mutation removeCouponFromCart($cartId: String!) { removeCouponFromCart(input: { cart_id: $cartId}) { cart { prices { grand_total { value currency __typename } }  __typename } __typename } }',
          variables : {cartId : cartId }
        }),
        success: (response) => {
          callback();
        },
        error: (xhr, status, error) => {
           callback();
        }
      });
    },
    preApplyCodes: function(callback) {
    console.log('elemis'); 
      const elTotal = $('div:contains("Grand Total") +div:first, .cart-grand-total');
      const prevValue = elTotal.length > 0 ? 
                        Number(elTotal.first().text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                        Number.POSITIVE_INFINITY;
      if(document.querySelector('.remove-coupon')){
        var prevCode = document.querySelector('.applied-coupon').textContent;
        prevCode = prevCode.replace("Code ", "");
        prevCode = prevCode.replace(" successfully applied!", "");
        prevCode = prevCode.replace(/"/g, "").trim();
        console.log(prevCode);
        this.removePrevCode('prevCode', () => callback(prevValue,prevCode));
      }else{
        callback(prevValue);
      }      
    },
    applyCode: function(code, callback) {
      this._applyCode(code, function(value) {
       this.removePrevCode(code, () => callback(value));
     }.bind(this));
    },
    applyBestCode: function(bestCode) {
      var timeout = 100;
      try{document.querySelector('.promo-block-checkout .discount-coupon-form .collapsible-toggle, .minicart-bottom .discount-coupon-form .collapsible-toggle').click();}catch(e){}
      if(document.querySelector('.remove-coupon button')){
        document.querySelector('.remove-coupon button').click();
        timeout = 3000;
      }
      setTimeout(()=> { 
        document.querySelector('#coupon_code, input[name="coupon-code"]').value = bestCode;
        document.querySelector('#coupon_code, input[name="coupon-code"]').dispatchEvent(new Event('input', {bubbles: true}));
        document.querySelector('#coupon_code, input[name="coupon-code"]').dispatchEvent(new Event('change'));
        setTimeout(()=> { 
          document.querySelector('.promo-block-checkout .promo-text-filed .btn,.minicart-bottom .promo-text-filed .btn').click();  
        },1500); 
      },timeout);  
    },
    _applyCode: (code, callback) => {
      const cartId = JSON.parse(localStorage.getItem('M2_VENIA_BROWSER_PERSISTENCE__cartId')).value.replace(/"/g,'');
      const windowVariables = retrieveWindowVariables(["window.STORE_CODE"]);
      const storeCode = windowVariables["window.STORE_CODE"];
      $.ajax({
        url: 'https://'+window.location.hostname+'/graphql',
        type: 'POST',
        contentType: 'application/json',
        headers: {
                  'store': storeCode,
                },
        data: JSON.stringify({
          operationName: 'applyCouponToCart',
          query: 'mutation applyCouponToCart($cartId: String!, $couponCode: String!) { applyCouponToCart(input: { cart_id: $cartId,  coupon_code: $couponCode }) { cart { prices { grand_total { value currency __typename } }  __typename } __typename } }',
          variables : {cartId : cartId, couponCode: code }
        }),
        success: (response) => {
          if(response.data.applyCouponToCart){
            const value = response.data.applyCouponToCart.cart.prices.grand_total.value;
            callback(value);
          }else{
            callback(Number.POSITIVE_INFINITY);
          }
        },
        error: (xhr, status, error) => {
           callback(Number.POSITIVE_INFINITY);
        }
      });
    },
  },

  'dresslily': {
    id: 16963,
    removePrevCode: function(code, callback) {
      var ts = Math.round(new Date().getTime());
      const url = 'https://'+window.location.hostname+'/fun/index.php?act=clearCoupon&_='+ts;
      $.get(url, 
        (response) => {
        callback();
      }).fail(function() {
        callback();
      });
    },
    preApplyCodes: function(callback) { 
      const elTotal = $('.cart-summary-info li:last-child .my-shop-price:contains($), li[class*="account-total"] span[class*="js_checkoutSummary"]:contains($)');
      const prevValue = elTotal.length > 0 ? 
                        Number(elTotal.first().text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                        Number.POSITIVE_INFINITY;
      const prevCodeSelector = document.querySelector('#cart_summary_promotion_code');
      if(prevCodeSelector){
        const prevCode = prevCodeSelector.value;
        this.removePrevCode(prevCode, () => callback(prevValue, prevCode));
      }else{
        callback(prevValue);
      }      
    },
    applyCode: function(code, callback) {
      this._applyCode(code, function(value) {
        $.get('https://'+window.location.hostname+window.location.pathname, (responseGet) => {
          const checkoutconfigindex = responseGet.indexOf("o.cart.total");
          const customerDataindex = responseGet.indexOf("o.cart.list");
          const finalIndex = customerDataindex-checkoutconfigindex;
          const data = JSON.parse(responseGet.substr(responseGet.indexOf("o.cart.total")+15, finalIndex-21));
          const value = data.goods_price;
          this.removePrevCode(code, () => callback(value));               
        }).fail(function() {
          callback(Number.POSITIVE_INFINITY);
        });
     }.bind(this));
    },
    applyBestCode: function(bestCode) {
      this._applyCode(bestCode, function(value) {
        location.reload();
      });   
    },
    _applyCode: (code, callback) => {
      var ts = Math.round(new Date().getTime());
      const url = 'https://'+window.location.hostname+window.location.pathname+'?pcode='+code+'&_='+ts;
      $.get(url, 
      (responsePost) => {
        callback();
      }).fail(function() {
        callback();
      });
    },
  },

  'boutiquefeel': {
    id: 35130,
    removePrevCode: function(code, callback) {
      var ts = Math.round(new Date().getTime());
      const url = 'https://'+window.location.hostname+'/v9/shopping-cart/anon/unuse-coupon?_='+ts;
      const windowVariables = retrieveWindowVariables(["window.secret"]);
      const xtoken = windowVariables["window.secret"];
      const wid = getCookie('clientId');    
      $.ajax({
        url: url,
        type: 'GET',
         headers: {
                  'xtoken': xtoken,
                  'wid': wid,
                },
        success: (response) => { callback(); },
        error: (xhr, status, error) => { callback(); }
      });
    },
    preApplyCodes: function(callback) { 
      const elTotal = $('#root .x-cell.__right span font strong');
      const prevValue = elTotal.length > 0 ? 
                        Number(elTotal.first().text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                        Number.POSITIVE_INFINITY;
      callback(prevValue);     
    },
    applyCode: function(code, callback) {
      this._applyCode(code, function(value) {
        var ts = Math.round(new Date().getTime());
        const windowVariables = retrieveWindowVariables(["window.secret"]);
        const xtoken = windowVariables["window.secret"];
        const wid = getCookie('clientId');    
        $.ajax({
            url: 'https://'+window.location.hostname+'/v9/shopping-cart/show?_='+ts,
            type: 'GET',
             headers: {
                      'xtoken': xtoken,
                      'wid': wid,
                    },
            success: (response) => {
              const value = response.result.orderSummary.orderTotal.amount;
              this.removePrevCode(code, () => callback(value));
            },
            error: (xhr, status, error) => { callback(Number.POSITIVE_INFINITY); }
          });
     }.bind(this));
    },
    applyBestCode: function(bestCode) {
      this._applyCode(bestCode, function(value) {
        location.reload();
      });   
    },
    _applyCode: (code, callback) => {
      const windowVariables = retrieveWindowVariables(["window.secret"]);
      const xtoken = windowVariables["window.secret"];
      const wid = getCookie('clientId');    
      $.ajax({
          url: 'https://'+window.location.hostname+'/v9/coupon/anon/use-coupon-by-code',
          type: 'POST',
          data: {code: code},
           headers: {
                    'xtoken': xtoken,
                    'wid': wid,
                    'content-type': 'application/x-www-form-urlencoded'
                  },
          success: (response) => {   callback(); },
          error: (xhr, status, error) => { callback(); }
        });
    },
  },

  etnies: {
    removePrevCode: function(code, callback) {
      const url = $('#cart-items-form').attr('action');
      const formData = getFormFieldsAsJson(document.querySelector('#cart-items-form'));
      formData['dwfrm_cart_coupons_i0_deleteCoupon'] = 'Remove';
      $.post(url, formData, 
      (response) => {
        callback();
      });
    },
    preApplyCodes: function(callback) { 
      const elTotal = document.querySelector('.order-total .order-value').innerText;
      const prevValue = elTotal.replace(/[^0-9.]/g, '').trim();
      const prevCodeSelector = document.querySelector('.cartcoupon .value');
      if(prevCodeSelector){
        const prevCode = prevCodeSelector.innerText;
        this.removePrevCode(prevCode, () => callback(prevValue, prevCode));
      }else{
        callback(prevValue);
      }      
    },
    applyCode: function(code, callback) {
      this._applyCode(code, function(value) {
        this.removePrevCode(code, () => callback(value));
     }.bind(this));
    },
    applyBestCode: function(bestCode) {
      this._applyCode(bestCode, function(value) {
        location.reload();
      });   
    },
    _applyCode: (code, callback) => { 
      const url = $('#cart-items-form').attr('action');
      const formData = getFormFieldsAsJson(document.querySelector('#cart-items-form'));
      formData['dwfrm_cart_couponCode'] = code;
      formData['dwfrm_cart_addCoupon'] = 'dwfrm_cart_addCoupon';
      $.post(url, formData, 
      (responsePost) => {
        const orderValueEl = $(responsePost).find('.order-total .order-value');
        const value = orderValueEl.length > 0 ? 
                    Number(orderValueEl.first().text().trim().substr(1)) : 
                    Number.POSITIVE_INFINITY;
        callback(value);
      }).fail(function() {
        callback(Number.POSITIVE_INFINITY);
      });
    },
  },

  bronsonvitamins: {
    id: 14302,
    removePrevCode: function(code, callback) {
      if(window.location.href.indexOf("cart") > -1){
        const url = $('#discount-coupon-form').attr('action');
        const form_key = $('[name="form_key"]').val();
        $.post(url, { remove: 1, coupon_code: code, form_key: form_key }, 
        (response) => {  callback(); }).fail(function() { callback(); });
      }else{
        const windowVariables = retrieveWindowVariables(["window.checkoutConfig"]);
        const quoteId = windowVariables["window.checkoutConfig"].quoteId;
        const customerData = windowVariables["window.checkoutConfig"].customerData;
        var url;
        if(customerData.id){
          url = 'https://www.bronsonvitamins.com/rest/default/V1/carts/mine/coupons';
        }else{
          url = 'https://www.bronsonvitamins.com/rest/default/V1/guest-carts/'+quoteId+'/coupons';
        }
        $.ajax({
          url: url,
          type: 'DELETE',
          success: (response) => { callback(); },
          error: (response) => { callback(); }
        });
      }           
    },
    preApplyCodes: function(callback) {
      const elTotal = $('[data-th="Order Total"] .c-price__value');
      const prevValue = elTotal.length > 0 ? 
                    Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                    Number.POSITIVE_INFINITY;
      const prevCode = $('#coupon_code, #discount-code').val();
      if(prevCode != ''){
        this.removePrevCode(prevCode, () => callback(prevValue, prevCode));
      }else{
        callback(prevValue);
      }      
    },
    applyCode: function(code, callback) {
     this._applyCode(code, function(value) {
      if(window.location.href.indexOf("cart") > -1){
        $.get('https://www.bronsonvitamins.com'+window.location.pathname, (responseGet) => {
            const checkoutconfigindex = responseGet.indexOf("window.checkoutConfig");
            const customerDataindex = responseGet.indexOf("window.customerData");
            const finalIndex = customerDataindex-checkoutconfigindex;
            const data = JSON.parse(responseGet.substr(responseGet.indexOf("window.checkoutConfig")+24, finalIndex-38));
            const value = data.totalsData.base_grand_total;
            this.removePrevCode(code, () => callback(value));
          });
       }else{
        const ts = Math.round(new Date().getTime());
        const windowVariables = retrieveWindowVariables(["window.checkoutConfig"]);
        const quoteId = windowVariables["window.checkoutConfig"].quoteId;
        const customerData = windowVariables["window.checkoutConfig"].customerData;
        var url;
        if(customerData.id){
          url = 'https://www.bronsonvitamins.com/rest/default/V1/carts/mine/payment-information?_='+ts;
        }else{
          url = 'https://www.bronsonvitamins.com/rest/default/V1/guest-carts/'+quoteId+'/payment-information?_='+ts;
        }
        $.ajax({
            url: url,
            type: 'GET',
            success: (response) => {                  
               const value = response.totals.base_grand_total;
               callback(value.toFixed(2));
            },error: () => { callback(Number.POSITIVE_INFINITY); }
          });
       }   
     }.bind(this));
    },
    applyBestCode: function(bestCode) {
      this._applyCode(bestCode, function() {
        location.reload();
      }) ;
    },
    _applyCode: (code, callback) => {
      if(window.location.href.indexOf("cart") > -1){
        const url = $('#discount-coupon-form').attr('action');
        const form_key = $('[name="form_key"]').val();
        $.ajax({
          url: url,
          type: 'POST',
          data: { remove: 0, coupon_code: code, form_key:form_key },
          success: () => { callback(); },
          error: () => { callback(); }
        });
      }else{
        const windowVariables = retrieveWindowVariables(["window.checkoutConfig"]);
        const quoteId = windowVariables["window.checkoutConfig"].quoteId;
        const customerData = windowVariables["window.checkoutConfig"].customerData;
        var url;
        if(customerData.id){
          url = 'https://www.bronsonvitamins.com/rest/default/V1/carts/mine/coupons/'+code;
        }else{
          url = 'https://www.bronsonvitamins.com/rest/default/V1/guest-carts/'+quoteId+'/coupons/'+code;
        }
        $.ajax({
          url: url,
          type: 'PUT',
          success: () => { callback(); },
          error: () => { callback(); }
        });
      }
    },
  },

  kindsnacks: {
    id: 25518, 
    preApplyCodes: function(callback) {
      const elTotal = $('.c-cart-totals__order-summary__total__col.grand-total');
      const prevValue = elTotal.length > 0 ? 
                    Number(elTotal.text().replace( /[^0-9.]/g, '').trim()) : 
                    Number.POSITIVE_INFINITY;
      callback(prevValue);
    },
    applyCode: function(code, callback) {
       const url = $('form[name="promo-code-form"]').attr('action');
      const csrf_token = $('.promo-code-form input[name="csrf_token"]').val();
       $.get('https://www.kindsnacks.com'+url+'/?csrf_token='+csrf_token+'&couponCode='+code, 
        (response) => {
          if(response.totals){
              const value = response.totals.grandTotalDecimal;
              callback(value);                
          }else{
            callback(Number.POSITIVE_INFINITY);
          }
        });
    },
    applyBestCode: (bestCode) => {
      location.reload();
    }
  },

  timex: {
    id: 16918,
    preApplyCodes: (callback) => {
      const orderValueEl = $('.order-total .order-value');
      const prevValue = orderValueEl.length > 0 ? 
                        Number(orderValueEl.first().text().replace( /[^0-9.]/g, '').trim()) : 
                        Number.POSITIVE_INFINITY;
      callback(prevValue);
    },
    applyCode: (code, callback) => {
     if(window.location.href.indexOf("cart") > -1){ 
      const url = $('#cart-items-form').attr('action');
      const formData = getFormFieldsAsJson(document.querySelector('#cart-items-form'));
      formData['dwfrm_cart_couponCode'] = code;
      formData['dwfrm_cart_addCoupon'] = 'dwfrm_cart_addCoupon';
      $.post(url, formData, 
        (response) => {
          const orderValueEl = $(response).find('.order-total .order-value');
          const value = orderValueEl.length > 0 ? 
                            Number(orderValueEl.first().text().replace( /[^0-9.]/g, '').trim()) : 
                            Number.POSITIVE_INFINITY;
          callback(value);
        });
     }else{
      const url = $('#shipping-coupon-form').attr('action');
        $.get(url+'?couponCode='+code+'&format=ajax', 
        (response) => {
          $.get(window.location.href+'?cpnc='+code, 
            (responseGet) => {
              const orderValueEl = $(responseGet).find('.order-total .order-value');
              const value = orderValueEl.length > 0 ? 
                        Number(orderValueEl.first().text().replace( /[^0-9.]/g, '').trim()) : 
                        Number.POSITIVE_INFINITY;
              callback(value);
            }).fail(function() {
              callback(Number.POSITIVE_INFINITY);
          });
        }).fail(function() {
          callback(Number.POSITIVE_INFINITY);
        });
      }
    },
    applyBestCode: (bestCode) => {
      location.reload();
    }
  },

  'mirror': {
    id: 44880,
    removePrevCode: function(code, callback) {
      const appState = JSON.parse(localStorage.getItem('appState'));
      const entities_id = appState.orders.results[0];
      const orderNumber = appState.orders.entities[entities_id].number;
      const ordertoken = appState.orders.entities[entities_id].token;
      const url = 'https://www.mirror.co/api/v1/orders/'+orderNumber+'/remove_coupon_code?order_token='+ordertoken+'&type=order';
      $.ajax({
        url: url,
        type: 'PUT',
        contentType : 'application/json',
        data : JSON.stringify({coupon_code: code}),
        success: () => { callback(); },
        error: () => { callback(); }
      });
    },
    preApplyCodes: function(callback) {
      var eltotal, prevValue;
      if(document.querySelector('[data-testid="order-total"] .strikeout')){
        elTotal = $('[data-testid="order-total"] .price')[0].children[0].lastChild.textContent;
        prevValue = elTotal.replace( /[^0-9.]/g, '').trim();
      }else{
        elTotal = $('[data-testid="order-total"]');
        prevValue = elTotal.length > 0 ? 
                    Number(elTotal.text().replace( /[^0-9.]/g, '').trim()) : 
                    Number.POSITIVE_INFINITY;
      }
      const prevCodeSelector = document.querySelector('.coupons .code');
      if(prevCodeSelector){
        const prevCodeContent = prevCodeSelector.textContent;
        const prevCode = prevCodeContent.replace(' REMOVE','')
        this.removePrevCode(prevCode, () => callback(prevValue, prevCode));
      }else{
        callback(prevValue); 
      }    
    },
    applyCode: function(code, callback) {
      this._applyCode(code, function(value) {
        const appState = JSON.parse(localStorage.getItem('appState'));
        const entities_id = appState.orders.results[0];
        const orderNumber = appState.orders.entities[entities_id].number;
        const ordertoken = appState.orders.entities[entities_id].token;
        const url = 'https://www.mirror.co/api/v1/orders/'+orderNumber+'?order_token='+ordertoken+'&type=order';
        $.get(url, 
        (responseGet) => {
          const value = responseGet.total;
          if(responseGet.promotions[0]){
            const prevCode =responseGet.promotions[0].code;
            this.removePrevCode(prevCode, () => callback(value));
          }else{
            callback(value);
          }        
        }).fail(function() {
          callback(Number.POSITIVE_INFINITY);
        });
     }.bind(this));
    },
    applyBestCode: function(bestCode) {
      this._applyCode(bestCode, function(value) {
        location.reload();
      });   
    },
    _applyCode: (code, callback) => {
      const appState = JSON.parse(localStorage.getItem('appState'));
      const entities_id = appState.orders.results[0];
      const orderNumber = appState.orders.entities[entities_id].number;
      const ordertoken = appState.orders.entities[entities_id].token;
      const url = 'https://www.mirror.co/api/v1/orders/'+orderNumber+'/apply_coupon_code?order_token='+ordertoken+'&type=order';
      $.ajax({
        url: url,
        type: 'PUT',
        contentType : 'application/json',
        data : JSON.stringify({coupon_code: code}),
        success: () => { callback(); },
        error: () => { callback(); }
      });
    },
  },

  'rugsusa': {
    id: 4769,
    removePrevCode: function(code, callback) {
      const url = 'https://www.rugsusa.com/rugsusa/control/ajaxremovepromocode?productPromoCodeId='+code;
      $.ajax({
        url: url,
        type: 'POST',
        data : {},
        success: () => { callback(); },
        error: () => { callback(); }
      });
    },
    preApplyCodes: function(callback) {
      const orderValueEl = $('#cart-container  .order-summary__you-pay-chevron--open:first');
      const prevValue = orderValueEl.length > 0 ? 
                        Number(orderValueEl.first().text().replace( /[^0-9.]/g, '').trim()) : 
                        Number.POSITIVE_INFINITY;
      const prevFinalValue = (prevValue/100).toFixed(2);
      const prevCode = $('#cart-container .order-summary__promo--applied-number:not(:contains("undefined"))').first().text();
      if(prevCode){
        this.removePrevCode(prevCode, () => callback(prevFinalValue,prevCode));
      }else{
        callback(prevFinalValue);
      }      
    },
    applyCode: function(code, callback) {
      this._applyCode(code, function(value) {
        this.removePrevCode(code, () => callback(value));
     }.bind(this));
    },
    applyBestCode: function(bestCode) {
      this._applyCode(bestCode, function(value) {
        location.reload();
      });   
    },
    _applyCode: (code, callback) => {
      const url = 'https://www.rugsusa.com/rugsusa/control/ajaxaddpromocodeorgiftcard';
      $.ajax({
        url: url,
        type: 'POST',
        data : {productPromoCodeId: code},
        success: (response) => { 
          const value = response.grandTotal;
          callback(value);
        },
        error: () => { callback(Number.POSITIVE_INFINITY); }
      });
    },
  },

  'hearthsong': {
    id: 926,
    preApplyCodes: function(callback) {
      var prevValue;
      if(window.location.href.indexOf("cart") > -1){
        const orderValueEl = $('.cart-totals .grand-total, .cart-totals .totals');
        prevValue = orderValueEl.length > 0 ? 
                  Number(orderValueEl.first().text().replace( /[^0-9.]/g, '').trim()) : 
                  Number.POSITIVE_INFINITY;
      }else{
        const subTotal = $('.cart-totals .subtotal');
        const subTotalValue = subTotal.length > 0 ? 
                      Number(subTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;

        const tax = $('.cart-totals .tax');
        const taxValue = tax.length > 0 ? 
                      Number(tax.first().text().replace( /[^0-9.]/g, '').trim()) :  0;
        var shippingValue = 0;
        $('.cart-totals .shipping').each(function() {
            var shipping = $(this).first().text();
            shippingValue += Number(shipping.replace( /[^0-9.]/g, '').trim());
        });

        prevValue = (subTotalValue+taxValue+shippingValue).toFixed(2);
      }      
      const prevCode = $('#promoCode').val();
      if(prevCode){
        callback(prevValue,prevCode);
      }else{
        callback(prevValue);
      }  
    },
    applyCode: function(code, callback) {
      this._applyCode(code, function(value) {
        callback(value);
     }.bind(this));
    },
    applyBestCode: function(bestCode) {
      this._applyCode(bestCode, function(value) {
        location.reload();
      }.bind(this));  
    },
    _applyCode: (code, callback) => {
      const url = $('#voucherForm').attr('action');
      const formData = getFormFieldsAsJson(document.querySelector('#voucherForm'));
      formData['promoCode'] = code;
      $.ajax({
        url: 'https://www.hearthsong.com'+url,
        type: 'POST',
        data: formData,
        success:  (data, textStatus, request1) => {         
          var value;
          if(window.location.href.indexOf("cart") > -1){
             $.get(location.href, 
              (responseget) => {
                const elTotal = $(responseget).find('.cart-totals .grand-total, .cart-totals .totals');
                value = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                      Number.POSITIVE_INFINITY;
                callback(value); 
              }).fail(function() {
              callback(Number.POSITIVE_INFINITY);
            }); 
          }else{
            $.get(location.href, 
            (responseget) => {
              const subTotal = $(responseget).find('.cart-totals .subtotal');
              const subTotalValue = subTotal.length > 0 ? 
                            Number(subTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                            Number.POSITIVE_INFINITY;
              const tax = $(responseget).find('.cart-totals .tax');
              const taxValue = tax.length > 0 ? 
                            Number(tax.first().text().replace( /[^0-9.]/g, '').trim()) :  0;
              var shippingValue = 0;
              $(responseget).find('.cart-totals .shipping').each(function() {
                var shipping = $(this).first().text();
                shippingValue += Number(shipping.replace( /[^0-9.]/g, '').trim());
              });
              value = (subTotalValue+taxValue+shippingValue).toFixed(2);
              callback(value);
             }).fail(function() {
              callback(Number.POSITIVE_INFINITY);
            }); 
          }
         },
        error: () => { callback(Number.POSITIVE_INFINITY); }
      });    
    },
  },

  'plowhearth': {
    id: 3081,
    preApplyCodes: function(callback) { 
      const orderValueEl = $('.cart-totals .grand-total, .cart-totals .totals');
      const prevValue = orderValueEl.length > 0 ? 
                        Number(orderValueEl.first().text().replace( /[^0-9.]/g, '').trim()) : 
                        Number.POSITIVE_INFINITY;
      const prevCode = $('#promoCode').val();
      if(prevCode){
        callback(prevValue,prevCode);
      }else{
        callback(prevValue);
      }  
    },
    applyCode: function(code, callback) {
      this._applyCode(code, function(value) {
        callback(value);
     }.bind(this));
    },
    applyBestCode: function(bestCode) {
      this._applyCode(bestCode, function(value) {
        location.reload();
      }.bind(this));  
    },
    _applyCode: (code, callback) => {
      const url = $('#voucherForm').attr('action');
      const formData = getFormFieldsAsJson(document.querySelector('#voucherForm'));
      formData['promoCode'] = code;
      $.ajax({
        url: 'https://www.plowhearth.com'+url,
        type: 'POST',
        data: formData,
        success:  (data, textStatus, request1) => {
          $.get(location.href, 
            (responseget) => {
              const elTotal = $(responseget).find('.cart-totals .grand-total, .cart-totals .totals');
              const value = elTotal.length > 0 ? 
                            Number(elTotal.first().text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                            Number.POSITIVE_INFINITY; 
              callback(value);
          }).fail(function() {
            callback(Number.POSITIVE_INFINITY);
          }); 
         },
        error: () => { callback(Number.POSITIVE_INFINITY); }
      });    
    },
  },

  'vivino': {
    id: 41843,
    removePrevCode: function(code, callback) {
      const windowVariables = retrieveWindowVariables(["window.__PRELOADED_STATE__"]);
      const cartId = windowVariables['window.__PRELOADED_STATE__'].cartId;        
      const url = 'https://www.vivino.com/checkout/api/carts/'+cartId;
      const csrf = $('meta[name="csrf-token"]').attr('content');
      $.ajax({
        url: url,
        type: 'PUT',
        headers: {
                  'x-csrf-token': csrf,
                  'content-type': 'application/json',
                  'accept' :  'application/json'
                },
        data : JSON.stringify({carrier_service_system_id : 'vivino.ground', coupon_code : null }),
        success: () => { callback(); },
        error: () => { callback(); }
      });
    },
    preApplyCodes: function(callback) {
      const orderValueEl = $('[class*=OrderConfirmationStep__orderConfirmationStep] tfoot tr:last-child td:last-child [class*=OrderConfirmationStep]');
      const prevValue = orderValueEl.length > 0 ? 
                        Number(orderValueEl.first().text().replace( /[^0-9.]/g, '').trim()) : 
                        Number.POSITIVE_INFINITY;
      const prevCode = $('[class*=OrderConfirmationStep__orderConfirmationStep] input#couponCode').val();
      if(prevCode != ''){
        if (document.querySelector('#couponCode').hasAttribute('disabled')) {
          document.querySelector('[class*=OrderConfirmationStep__orderConfirmationStep] button[class*=CouponCode__button]').click();
           setTimeout(function(){
            callback(prevValue, prevCode);
          }, 2000);
        }else{
          this.removePrevCode(prevCode, () => callback(prevValue, prevCode));
         }       
      }else{
        callback(prevValue);
      }      
    },
    applyCode: function(code, callback) {
      this._applyCode(code, function(value) {
        this.removePrevCode(code, () => callback(value));
     }.bind(this));
    },
    applyBestCode: function(bestCode) {      
      document.querySelector('[class*=OrderConfirmationStep__orderConfirmationStep] input#couponCode').value = bestCode;
      if (!document.querySelector('#couponCode').hasAttribute('disabled')){
        document.querySelector('[class*=OrderConfirmationStep__orderConfirmationStep] input#couponCode').dispatchEvent(new Event('input', {bubbles: true}));
        document.querySelector('[class*=OrderConfirmationStep__orderConfirmationStep] input#couponCode').dispatchEvent(new Event('change'));
        document.querySelector('[class*=OrderConfirmationStep__orderConfirmationStep] button[class*=CouponCode__button]').click();
      }   
    },
    _applyCode: (code, callback) => {
      const windowVariables = retrieveWindowVariables(["window.__PRELOADED_STATE__"]);
      const cartId = windowVariables['window.__PRELOADED_STATE__'].cartId;        
      const url = 'https://www.vivino.com/checkout/api/carts/'+cartId;
      const csrf = $('meta[name="csrf-token"]').attr('content');
      $.ajax({
        url: url,
        type: 'PUT',
        headers: {
                  'x-csrf-token': csrf,
                  'content-type': 'application/json',
                  'accept' :  'application/json'
                },
        data : JSON.stringify({carrier_service_system_id : 'vivino.ground', coupon_code : code }),
        success: (response) => {
          if(response.cart){
            const value = response.cart.total_amount;
            callback(value); 
          }else{
            callback(Number.POSITIVE_INFINITY);
          }          
        },
        error: () => { callback(Number.POSITIVE_INFINITY); }
      });
    },
  },

  currentcatalog: {
    id: 640,
    removePrevCode: function(code, callback) {
      callback();          
    },
    preApplyCodes: function(callback) {
      const elTotal = $('.grand.totals .price');
      const prevValue = elTotal.length > 0 ? 
                    Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                    Number.POSITIVE_INFINITY;
      const prevCode = $('#coupon_code, #discount-code').val();
      if(prevCode != ''){
        callback(prevValue, prevCode);
      }else{
        callback(prevValue);
      }      
    },
    applyCode: function(code, callback) {
     this._applyCode(code, function(value) {
      if(window.location.href.indexOf("cart") > -1){
        $.get('https://www.currentcatalog.com'+window.location.pathname, (responseGet) => {
            const checkoutconfigindex = responseGet.indexOf("window.checkoutConfig");
            const customerDataindex = responseGet.indexOf("window.customerData");
            const finalIndex = customerDataindex-checkoutconfigindex;
            const data = JSON.parse(responseGet.substr(responseGet.indexOf("window.checkoutConfig")+24, finalIndex-38));
            const value = data.totalsData.base_grand_total;
            callback(value);
          });
       }else{
        const ts = Math.round(new Date().getTime());
        const windowVariables = retrieveWindowVariables(["window.checkoutConfig"]);
        const quoteId = windowVariables["window.checkoutConfig"].quoteData.entity_id;
        const customerData = windowVariables["window.checkoutConfig"].customerData;
        var url;
        if(customerData.id){
          url = 'https://www.currentcatalog.com/rest/currentcatalog/V1/carts/mine/payment-information?_='+ts;
        }else{
          url = 'https://www.currentcatalog.com/rest/currentcatalog/V1/guest-carts/'+quoteId+'/payment-information?_='+ts;
        }
        $.ajax({
            url: url,
            type: 'GET',
            success: (response) => {                  
               const value = response.totals.base_grand_total;
               callback(value.toFixed(2));
            },error: () => { callback(Number.POSITIVE_INFINITY); }
          });
       }   
     }.bind(this));
    },
    applyBestCode: function(bestCode) {
      this._applyCode(bestCode, function() {
        location.reload();
      }) ;
    },
    _applyCode: (code, callback) => {
      if(window.location.href.indexOf("cart") > -1){
        const url = $('#discount-coupon-form').attr('action');
        const form_key = $('[name="form_key"]').val();
        $.ajax({
          url: url,
          type: 'POST',
          data: { remove: 0, coupon_code: code, form_key:form_key },
          success: () => { callback(); },
          error: () => { callback(); }
        });
      }else{
        const windowVariables = retrieveWindowVariables(["window.checkoutConfig"]);
        const quoteId = windowVariables["window.checkoutConfig"].quoteData.entity_id;
        const customerData = windowVariables["window.checkoutConfig"].customerData;
        var url;
        if(customerData.id){
          url = 'https://www.currentcatalog.com/rest/currentcatalog/V1/carts/mine/coupons/'+code;
        }else{
          url = 'https://www.currentcatalog.com/rest/currentcatalog/V1/guest-carts/'+quoteId+'/coupons/'+code;
        }
        $.ajax({
          url: url,
          type: 'PUT',
          success: () => { callback(); },
          error: () => { callback(); }
        });
      }
    },
  },

  'ikrush_uk': {
    id: 13253,
    removePrevCode: function(code, callback) {
      const formData = getFormFieldsAsJson(document.querySelector('#payment-form'));
      formData['ajax'] = 'true';
      formData['action'] = 'clear_coupon';
      formData['basket[coupon_code]'] = code;
      formData['basket[coupon_name]'] = code;      
      $.ajax({
        url: 'https://www.ikrush.com/shop/checkout/ajax.php',
        type: 'POST',
        data: formData,
        success: () => { callback(); },
        error: () => { callback(); }
      });         
    },
    preApplyCodes: function(callback) { 
      const orderValueEl = $('#basketTotal .show');
      const prevValue = orderValueEl.length > 0 ? 
                        Number(orderValueEl.first().text().replace( /[^0-9.]/g, '').trim()) : 
                        Number.POSITIVE_INFINITY;
      const prevCodeSelector = $('#totals td:contains("Discount Code")');
      if(prevCodeSelector.length > 0){
        const prevCodeText = prevCodeSelector.text().trim();
        const matches = prevCodeText.match(/\"(.*?)\"/);
        if (matches) {
            const prevCode = matches[1];
            this.removePrevCode(prevCode, () => callback(prevValue,prevCode));
        }else{
          callback(prevValue);
        }        
      }else{
        callback(prevValue); 
      } 
    },
    applyCode: function(code, callback) {
      this._applyCode(code, function(value) {
        this.removePrevCode(code, () => callback(value));
     }.bind(this));
    },
    applyBestCode: function(bestCode) {
      this._applyCode(bestCode, function(value) {
        location.reload();
      }.bind(this));  
    },
    _applyCode: (code, callback) => {
      const formData = getFormFieldsAsJson(document.querySelector('#payment-form'));
      formData['ajax'] = 'true';
      formData['action'] = 'validate_coupon';
      formData['basket[coupon_code]'] = code;
      $.ajax({
        url: 'https://www.ikrush.com/shop/checkout/ajax.php',
        type: 'POST',
        data: formData,
        success:  (response) => {
          const value = response.basket.cost_total;
          callback(value); 
        },
        error: () => { callback(Number.POSITIVE_INFINITY); }
      });    
    },
  },

  thredup: {
    id: 6340,
    removePrevCode: function(code, callback) {
      var shippingOptionId = '1';
      const xtupvisitorid = decodeURI(document.cookie.split(';').filter(function(c) { return c.indexOf('visitor_id') !== -1 })[0]).trim().split('=')[1];
      const authtoken = decodeURI(document.cookie.split(';').filter(function(c) { return c.indexOf('tup_jwt_token') !== -1 })[0]).trim().split('=')[1];
      const tuppt = decodeURI(document.cookie.split(';').filter(function(c) { return c.indexOf('tuppt') !== -1 })[0]).trim().split('=')[1];
      const guid = decodeURI(document.cookie.split(';').filter(function(c) { return c.indexOf('guid') !== -1 })[0]).trim().split('=')[1];
      const xclientapp = 'web'; 
      $.ajax({
        url: 'https://www.thredup.com/v2.0/carts/mine/remove_coupon',
        type: 'PUT',
        headers: {
        'Content-Type': 'application/json',
        'x-tup-visitor-id': xtupvisitorid,
        'x-client-app': xclientapp,
        'x-tup-guid' : guid,
        'tuppt': tuppt,
        'auth-token': authtoken,
        },
        data: JSON.stringify({
          shippingOptionId:shippingOptionId                
        }),
          success: (response) => { callback(); },
          error: (response) => { callback(); }
      }); 
    },
    preApplyCodes: function(callback) {
      const elTotal = $('#root .u-font-weight-bold.u-flex div:contains("Total")+, #js-shop-app-root .flex.checkout__LineItem.checkout__LineItem__large.uppercase div:contains("Total")+, #root .u-font-weight-bold div:contains("Total") +, #root .u-font-bold.u-flex.u-justify-between div:contains("Total") +');
      const prevValue = elTotal.length > 0 ? 
                        Number(elTotal.text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                        Number.POSITIVE_INFINITY;
      const prevCode = $('#root input#promo, #js-shop-app-root input#promo_code').val();
      if(prevCode != ''){
        this.removePrevCode(prevCode, () => callback(prevValue,prevCode));
      }else{
        callback(prevValue);
      }      
    },
    applyCode: function(code, callback) {
      this._applyCode(code, function(value) {
       this.removePrevCode(code, () => callback(value));
     }.bind(this));
    },
    applyBestCode: function(bestCode) {
      this._applyCode(bestCode, function(value) {
        location.reload();
      });   
    },
    _applyCode: (code, callback) => {
      var shippingOptionId='1';
      const xtupvisitorid = decodeURI(document.cookie.split(';').filter(function(c) { return c.indexOf('visitor_id') !== -1 })[0]).trim().split('=')[1];
      const authtoken = decodeURI(document.cookie.split(';').filter(function(c) { return c.indexOf('tup_jwt_token') !== -1 })[0]).trim().split('=')[1];
      const tuppt = decodeURI(document.cookie.split(';').filter(function(c) { return c.indexOf('tuppt') !== -1 })[0]).trim().split('=')[1];
      const guid = decodeURI(document.cookie.split(';').filter(function(c) { return c.indexOf('guid') !== -1 })[0]).trim().split('=')[1];
      const xclientapp = 'web'; 
      $.ajax({
        url: 'https://www.thredup.com/v2.0/carts/mine/add_coupon',
        type: 'PUT',              
        headers: {
        'Content-Type': 'application/json',
        'x-tup-visitor-id': xtupvisitorid,
        'x-client-app': xclientapp,
        'x-tup-guid' : guid,
        'tuppt': tuppt,
        'auth-token': authtoken,
        },
        data: JSON.stringify({
           code : code, shippingOptionId: shippingOptionId
        }),
        success: (response) => {
          if(response.cart.cart_totals){                  
            const value = (response.cart.cart_totals.amount_charged)/100;
            callback(value.toFixed(2));
          }else{
            callback(Number.POSITIVE_INFINITY);
          }
        },
        error: (xhr, status, error) => { callback(Number.POSITIVE_INFINITY); }
      });
    },
  },

  'tvc-mall': {
    id: 23667,
    removePrevCode: function(code, callback) {
      const orderId = $('#orderItemsList').attr('data-orderid');
      $.ajax({
        url: 'https://www.tvc-mall.com/AppService/OrderDiscount/CancelDiscount?UserID=%7BuserId%7D&OrderID='+orderId,
        type: 'GET',
          success: (response) => { callback(); },
          error: (response) => { callback(); }
      }); 
    },
    preApplyCodes: function(callback) {
      const elTotal = $('.order-amount');
      const prevValue = elTotal.length > 0 ? 
                        Number(elTotal.text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                        Number.POSITIVE_INFINITY;
      const prevCodeSelector = document.querySelector('[data-type="remove-coupon"]');
      if(prevCodeSelector){
        const prevCode = $('[data-type="remove-coupon"]').attr('data-code');
        this.removePrevCode(prevCode, () => callback(prevValue,prevCode));
      }else{
        callback(prevValue);
      }      
    },
    applyCode: function(code, callback) {
      this._applyCode(code, function(value) {
       this.removePrevCode(code, () => callback(value));
     }.bind(this));
    },
    applyBestCode: function(bestCode) {
      this._applyCode(bestCode, function(value) {
        location.reload();
      });   
    },
    _applyCode: (code, callback) => {
      const orderId = $('#orderItemsList').attr('data-orderid');
      $.ajax({
        url: 'https://www.tvc-mall.com/AppService/OrderDiscount/ApplyCoupon?UserId=%7BuserId%7D&OrderID='+orderId+'&CouponCode='+code,
        type: 'GET',
        success: (response) => {
          $.ajax({
            url: 'https://www.tvc-mall.com/Order/OrderInfo/'+orderId,
            type: 'GET',
            success: (responseget) => {
              const elTotal = $(responseget).find('.order-amount');
              const value = elTotal.length > 0 ? 
                            Number(elTotal.first().text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                            Number.POSITIVE_INFINITY; 
              callback(value);
            },
            error: () => { callback(Number.POSITIVE_INFINITY); }
          });
        },
        error: () => { callback(Number.POSITIVE_INFINITY); }
      });
    },
  },

  'viking-direct': {
    id: 8457,
    removePrevCode: function(code, callback) {
      const CSRFToken = $('input[name="CSRFToken"]').val();
      $.ajax({
        url: 'https://www.viking-direct.co.uk/ajax/voucher/remove-voucher',
        type: 'POST',
        headers: {
                  'CSRFToken': CSRFToken
                },
        data : { voucherCode : code },
        success: () => { callback(); },
        error: () => { callback(); }
      });
    },
    preApplyCodes: function(callback) {
      const orderValueEl = $('#orderTotals #total');
      const prevValue = orderValueEl.length > 0 ? 
                    Number(orderValueEl.first().text().replace( /[^0-9.]/g, '').trim()) : 
                    Number.POSITIVE_INFINITY;
      const prevCodeSelector = document.querySelector('#cartVoucherApplied');
      if(prevCodeSelector){
        const prevCode = prevCodeSelector.innerText;
        this.removePrevCode(prevCode, () => callback(prevValue, prevCode));       
      }else{
        callback(prevValue);
      }      
    },
    applyCode: function(code, callback) {
      this._applyCode(code, function(value) {
        this.removePrevCode(code, () => callback(value));
     }.bind(this));
    },
    applyBestCode: function(bestCode) {      
      this._applyCode(bestCode, function(value) {
        location.reload();
      });  
    },
    _applyCode: (code, callback) => {
      const CSRFToken = $('input[name="CSRFToken"]').val();
      $.ajax({
        url: 'https://www.viking-direct.co.uk/ajax/voucher/apply-voucher',
        type: 'POST',
        headers: {
                  'CSRFToken': CSRFToken
                },
        data : { voucherCode : code },
        success: (response) => {
          const elTotal = $(response).find('#total');
          const value = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                      Number.POSITIVE_INFINITY;
          callback(value);          
        },
        error: () => { callback(Number.POSITIVE_INFINITY); }
      });
    },
  },

  coolhockey: {
    id: 32750,
    removePrevCode: function(code, callback) {
      if(window.location.href.indexOf("cart") > -1){
        const url = $('#discount-coupon-form').attr('action');
        const form_key = $('[name="form_key"]').val();
        $.post(url, { remove: 1, coupon_code: code, form_key: form_key }, 
        (response) => {  callback(); }).fail(function() { callback(); });
      }else{
        const windowVariables = retrieveWindowVariables(["window.checkoutConfig"]);
        const quoteId = windowVariables["window.checkoutConfig"].quoteId;
        const customerData = windowVariables["window.checkoutConfig"].customerData;
        const storeCode = windowVariables["window.checkoutConfig"].storeCode
        var url;
        if(customerData.id){
          url = 'https://www.coolhockey.com/'+storeCode+'/rest/'+storeCode+'/V1/carts/mine/coupons';
        }else{
          url = 'https://www.coolhockey.com/'+storeCode+'/rest/'+storeCode+'/V1/guest-carts/'+quoteId+'/coupons';
        }
        $.ajax({
          url: url,
          type: 'DELETE',
          success: (response) => { callback(); },
          error: (response) => { callback(); }
        });
      }           
    },
    preApplyCodes: function(callback) {
      const elTotal = $('[data-th="Order Total"] .price');
      const prevValue = elTotal.length > 0 ? 
                    Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                    Number.POSITIVE_INFINITY;
      const prevCode = $('#coupon_code, #discount-code').val();
      if(prevCode != ''){
        this.removePrevCode(prevCode, () => callback(prevValue, prevCode));
      }else{
        callback(prevValue);
      }      
    },
    applyCode: function(code, callback) {
     this._applyCode(code, function(value) {
      if(window.location.href.indexOf("cart") > -1){
        $.get('https://www.coolhockey.com'+window.location.pathname, (responseGet) => {
            const checkoutconfigindex = responseGet.indexOf("window.checkoutConfig");
            const customerDataindex = responseGet.indexOf("window.customerData");
            const finalIndex = customerDataindex-checkoutconfigindex;
            const data = JSON.parse(responseGet.substr(responseGet.indexOf("window.checkoutConfig")+24, finalIndex-38));
            const value = data.totalsData.base_grand_total;
            this.removePrevCode(code, () => callback(value));
          });
       }else{
        const ts = Math.round(new Date().getTime());
        const windowVariables = retrieveWindowVariables(["window.checkoutConfig"]);
        const quoteId = windowVariables["window.checkoutConfig"].quoteId;
        const customerData = windowVariables["window.checkoutConfig"].customerData;
        const storeCode = windowVariables["window.checkoutConfig"].storeCode
        var url;
        if(customerData.id){
          url = 'https://www.coolhockey.com/'+storeCode+'/rest/'+storeCode+'/carts/mine/payment-information?_='+ts;
        }else{
          url = 'https://www.coolhockey.com/'+storeCode+'/rest/'+storeCode+'/guest-carts/'+quoteId+'/payment-information?_='+ts;
        }
        $.ajax({
            url: url,
            type: 'GET',
            success: (response) => {                  
               const value = response.totals.base_grand_total;
               callback(value.toFixed(2));
            },error: () => { callback(Number.POSITIVE_INFINITY); }
          });
       }   
     }.bind(this));
    },
    applyBestCode: function(bestCode) {
      this._applyCode(bestCode, function() {
        location.reload();
      }) ;
    },
    _applyCode: (code, callback) => {
      if(window.location.href.indexOf("cart") > -1){
        const url = $('#discount-coupon-form').attr('action');
        const form_key = $('[name="form_key"]').val();
        $.ajax({
          url: url,
          type: 'POST',
          data: { remove: 0, coupon_code: code, form_key:form_key },
          success: () => { callback(); },
          error: () => { callback(); }
        });
      }else{
        const windowVariables = retrieveWindowVariables(["window.checkoutConfig"]);
        const quoteId = windowVariables["window.checkoutConfig"].quoteId;
        const customerData = windowVariables["window.checkoutConfig"].customerData;
        const storeCode = windowVariables["window.checkoutConfig"].storeCode
        var url;
        if(customerData.id){
          url = 'https://www.coolhockey.com/'+storeCode+'/rest/'+storeCode+'/V1/carts/mine/coupons/'+code;
        }else{
          url = 'https://www.coolhockey.com/'+storeCode+'/rest/'+storeCode+'/V1/guest-carts/'+quoteId+'/coupons/'+code;
        }
        $.ajax({
          url: url,
          type: 'PUT',
          success: () => { callback(); },
          error: () => { callback(); }
        });
      }
    },
  },

  'philips_uk': {
    id: 11894,
    removePrevCode: function(code, callback) {
      const formData = getFormFieldsAsJson(document.querySelector('#voucherForm'));
      formData['removeVoucherCode'] = code;
      const url = $('#voucherForm').attr('action');
      $.ajax({
        url : 'https://'+window.location.hostname+'/shop/cart/removeVoucher',
        type : 'POST',
        data : formData,
        success: () => { callback(); },
        error: () => { callback(); }
      });
    },
    preApplyCodes: function(callback) { 
      const orderValueEl = $('#tagging-price');
      const prevValue = orderValueEl.length > 0 ? 
                        Number(orderValueEl.first().text().replace( /[^0-9.]/g, '').trim()) : 
                        Number.POSITIVE_INFINITY;
      const prevCodeSelector = document.querySelector('.ph-applied-vouchers__item__code');
      if(prevCodeSelector){
        const prevCode = prevCodeSelector.innerText;
        this.removePrevCode(prevCode, () => callback(prevValue, prevCode));
      }else{
        callback(prevValue);
      }  
    },
    applyCode: function(code, callback) {
      this._applyCode(code, function(value) {
        this.removePrevCode(code, () => callback(value));
     }.bind(this));
    },
    applyBestCode: function(bestCode) {
      this._applyCode(bestCode, function(value) {
        location.reload();
      }.bind(this));  
    },
    _applyCode: (code, callback) => {
      const formData = getFormFieldsAsJson(document.querySelector('#voucherForm'));
      formData['voucherText'] = code;
      const url = $('#voucherForm').attr('action');
      $.ajax({
        url: 'https://'+window.location.hostname+url,
        type: 'POST',
        data: formData,
        success:  (data, textStatus, request1) => {
          $.get(location.href, 
            (responseget) => {
              const elTotal = $(responseget).find('#tagging-price');
              const value = elTotal.length > 0 ? 
                        Number(elTotal.first().text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                        Number.POSITIVE_INFINITY; 
              callback(value);
          }).fail(function() {
            callback(Number.POSITIVE_INFINITY);
          }); 
         },
        error: () => { callback(Number.POSITIVE_INFINITY); }
      });    
    }
  },

  'appliancesconnection': {
    id: 5421,
    preApplyCodes: function(callback) { 
      const orderValueEl = $('.total-price');
      const prevValue = orderValueEl.length > 0 ? 
                        Number(orderValueEl.first().text().replace( /[^0-9.]/g, '').trim()) : 
                        Number.POSITIVE_INFINITY;
      callback(prevValue);  
    },
    applyCode: function(code, callback) {
      this._applyCode(code, function(value) {
        callback(value);
     }.bind(this));
    },
    applyBestCode: function(bestCode) {
      this._applyCode(bestCode, function(value) {
        location.reload();
      }.bind(this));  
    },
    _applyCode: (code, callback) => {
      const url = $('#mainform').attr('action');
      const formData = getFormFieldsAsJson(document.querySelector('#mainform'));
      formData['promo_code'] = code;
      $.ajax({
        url: url,
        type: 'POST',
        data: formData,
        success:  (data, textStatus, request1) => {
          $.get(location.href, 
            (responseget) => {
              const elTotal = $(responseget).find('.total-price');
              const value = elTotal.length > 0 ? 
                            Number(elTotal.first().text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                            Number.POSITIVE_INFINITY; 
              callback(value);
          }).fail(function() {
            callback(Number.POSITIVE_INFINITY);
          }); 
         },
        error: () => { callback(Number.POSITIVE_INFINITY); }
      });    
    },
  },

  balibras: {
    id: 44883,
    preApplyCodes: function(callback) {
      const elTotal = $('#cart-totals .price.bfx-price.bfx-total-grandtotal, tr.grand.totals');
      const prevValue = elTotal.length > 0 ? 
                    Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                    Number.POSITIVE_INFINITY;
      this.totalBefore = prevValue;
      callback(prevValue);
    },
    applyCode: function(code, callback) {
      const self = this;
      if (!self.codes) {
        self.codes = [];
      }
      self.codes.push(code);
      const couponCodes = self.codes;
      const url = $('#discount-coupon-form').attr('action');
      const formData = getFormFieldsAsJson(document.querySelector('#discount-coupon-form'));
      formData['coupon_code_fake'] = code;
      formData['coupon_code'] = couponCodes.join();
      formData['last_code'] = code;
      $.ajax({
        url: url,
        type: 'POST',
        data: formData,
        success: () => {
          $.get('https://'+window.location.hostname+window.location.pathname, (responseGet) => {
            const checkoutconfigindex = responseGet.indexOf("window.checkoutConfig");
            const customerDataindex = responseGet.indexOf("window.isCustomerLoggedIn");
            const finalIndex = customerDataindex-checkoutconfigindex;
            const data = JSON.parse(responseGet.substr(responseGet.indexOf("window.checkoutConfig")+23, finalIndex-107));
            const value = data.totalsData.base_grand_total;
            callback(value);              
          });
        },
        error: (xhr, status, error) => {
           callback(Number.POSITIVE_INFINITY);
        }
      });
    },
    applyBestCode: function(bestCode) {
      location.reload();
    }
  },

  tognar: {
    removePrevCode: function(url, callback) {
      if(window.location.href.indexOf("cart") > -1){
        $.ajax({
          url: url,
          type: 'GET',
          success: () => { callback(); },
          error: () => { callback(); }
        });
      }else{
        setTimeout(function(){
          document.querySelector('[data-test="cart-price-callback"]').click();
          callback();
        }, 2000);        
      }
    },
    preApplyCodes: function(callback) { 
      const elTotal = document.querySelector('.cart-total-grandTotal, .cart-priceItem--total [data-test="cart-price-value"]').innerText;
      const prevValue = elTotal.replace(/[^0-9.]/g, '').trim();
      const prevCodeSelector = $('a:contains(Remove), [data-test="cart-price-code"]');
      if(prevCodeSelector.length > 0 ){
        const prevCodeUrl = $('a:contains(Remove)').attr('href');
        this.removePrevCode(prevCodeUrl, () => callback(prevValue));
      }else{
        callback(prevValue);
      }      
    },
    applyCode: function(code, callback) {
      this._applyCode(code, function(value) {
        if(window.location.href.indexOf("cart") > -1){
          $.get('https://www.tognar.com/cart.php', 
            (response) => {
              const orderValueEl = $(response).find('.cart-total-grandTotal');
              const value = orderValueEl.length > 0 ? 
                      Number(orderValueEl.text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY; 
              const removeUrl = $(response).find('a:contains(Remove)').attr('href');
              this.removePrevCode(removeUrl, () => callback(value));
          }).fail(function() {
              callback(Number.POSITIVE_INFINITY);
          });
        }else{
          setTimeout(function(){
            if(!document.querySelector('[name="redeemableCode"]')){
              try{  document.querySelector('.layout-cart .redeemable-label').click(); }catch(e){}
            }
          document.querySelector('[name="redeemableCode"]').value = code;
          document.querySelector('[name="redeemableCode"]').dispatchEvent(new Event('input', {bubbles: true}));
          document.querySelector('[name="redeemableCode"]').dispatchEvent(new Event('change'));
          document.querySelector('#applyRedeemableButton').click();          
          setTimeout(function(){
           const elTotal = $('.cart-priceItem--total [data-test="cart-price-value"]');
           const value = elTotal.length > 0 ? 
                      Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY; 
           prevCodeSelector = $('[data-test="cart-price-code"]');
           if(prevCodeSelector){
              try{  document.querySelector('[data-test="cart-price-callback"]').click(); }catch(e){}
              callback(value); 
             }else{
              callback(value); 
             } 
           }, 3000);
          }, 3000);
        }
     }.bind(this));
    },
    applyBestCode: function(bestCode) {
      if(window.location.href.indexOf("cart") > -1){
        this._applyCode(bestCode, function(value) {        
          location.reload();        
        }); 
      }else{
        setTimeout(function(){
          if(!document.querySelector('[name="redeemableCode"]')){
            try{  document.querySelector('.layout-cart .redeemable-label').click(); }catch(e){}
          }
          document.querySelector('[name="redeemableCode"]').value = bestCode;
          document.querySelector('[name="redeemableCode"]').dispatchEvent(new Event('input', {bubbles: true}));
          document.querySelector('[name="redeemableCode"]').dispatchEvent(new Event('change'));
          document.querySelector("#applyRedeemableButton").click();
        }, 1000);
      }  
    },
    _applyCode: (code, callback) => {
      if(window.location.href.indexOf("cart") > -1){
        const windowVariables = retrieveWindowVariables(["BCData"]);
        const csrf_token = windowVariables.BCData.csrf_token;
        $.ajax({
          url: 'https://www.tognar.com/remote/v1/apply-code',
          type: 'POST',
          headers: {
                    'x-xsrf-token': csrf_token,
                  },
          data : {code: code},
          success: (response) => { callback(); },
          error: () => { callback(); }
        });
      }else{
        callback();
      }
    },
  },

  racewax: {
    removePrevCode: function(url, callback) {
      $.ajax({
        url: url,
        type: 'GET',
        success: () => { callback(); },
        error: () => { callback(); }
      });
    },
    preApplyCodes: function(callback) { 
      const elTotal = document.querySelector('.cart-total-grandTotal').innerText;
      const prevValue = elTotal.replace(/[^0-9.]/g, '').trim();
      const prevCodeSelector = $('a:contains(Remove)');
      if(prevCodeSelector.length > 0 ){
        const prevCodeUrl = $('a:contains(Remove)').attr('href');
        this.removePrevCode(prevCodeUrl, () => callback(prevValue));
      }else{
        callback(prevValue);
      }      
    },
    applyCode: function(code, callback) {
      this._applyCode(code, function(value) {
        $.get('https://www.racewax.com/cart.php', 
          (response) => {
            const orderValueEl = $(response).find('.cart-total-grandTotal');
            const value = orderValueEl.length > 0 ? 
                    Number(orderValueEl.text().replace( /[^0-9.]/g, '').trim()) : 
                    Number.POSITIVE_INFINITY; 
            const removeUrl = $(response).find('a:contains(Remove)').attr('href');
            this.removePrevCode(removeUrl, () => callback(value));
        }).fail(function() {
            callback(Number.POSITIVE_INFINITY);
        });
     }.bind(this));
    },
    applyBestCode: function(bestCode) {
      this._applyCode(bestCode, function(value) {
        location.reload();
      });   
    },
    _applyCode: (code, callback) => {
      const windowVariables = retrieveWindowVariables(["BCData"]);
      const csrf_token = windowVariables.BCData.csrf_token;
      $.ajax({
        url: 'https://www.racewax.com/remote/v1/apply-code',
        type: 'POST',
        headers: {
                  'x-xsrf-token': csrf_token,
                },
        data : {code: code},
        success: (response) => { callback(); },
        error: () => { callback(); }
      });
    },
  },
  
  'bakemeawish': {
    id: 3770,
    preApplyCodes: function(callback) { 
      const orderValueEl = $('.cart-contents table:last-of-type tbody tr:last-child .price');
      const prevValue = orderValueEl.length > 0 ? 
                        Number(orderValueEl.first().text().replace( /[^0-9.]/g, '').trim()) : 
                        Number.POSITIVE_INFINITY;
      callback(prevValue);  
    },
    applyCode: function(code, callback) {
      this._applyCode(code, function(value) {
        callback(value);
     }.bind(this));
    },
    applyBestCode: function(bestCode) {
      document.querySelector('[name="promo_code"]').value = bestCode;
      document.querySelector('[name="promo_code"]').dispatchEvent(new Event('input', {bubbles: true}));
      document.querySelector('[name="promo_code"]').dispatchEvent(new Event('change'));
      $(".form-promo-code [type='submit']").click();
    },
    _applyCode: (code, callback) => {
      const url = $('[name="promoform"]').attr('action');
      const formData = getFormFieldsAsJson(document.querySelector('[name="promoform"]'));
      formData['promo_code'] = code;
      $.ajax({
        url: url,
        type: 'POST',
        data: formData,
        success:  (data, textStatus, request1) => {
          $.get(location.href, 
            (responseget) => {
              const elTotal = $(responseget).find('.cart-contents table:last-of-type tbody tr:last-child .price');
              const value = elTotal.length > 0 ? 
                            Number(elTotal.first().text().replace( /[^0-9.]/g, '').replace(',', '').trim()) : 
                            Number.POSITIVE_INFINITY; 
              callback(value);
          }).fail(function() {
            callback(Number.POSITIVE_INFINITY);
          }); 
         },
        error: () => { callback(Number.POSITIVE_INFINITY); }
      });    
    },
  },

  rockport: {
    removePrevCode: function(prevCodeUrl, callback) {
      if(document.querySelector('.pt_cart')){
        const url = $('.cart-coupons-form').attr('action');
        const formData = getFormFieldsAsJson(document.querySelector('.cart-coupons-form'));
        formData['dwfrm_cart_coupons_i0_deleteCoupon'] = 'Remove';
        $.post(url, formData, 
        (response) => {
          callback();
        }).fail(function() {
          callback();
        });
      }else{
        $.get(prevCodeUrl+'&format=ajax', 
        (response) => {
          callback();
        }).fail(function() {
          callback();
        });         
      }
    },
    preApplyCodes: function(callback) { 
      const elTotal = $('.cart-right .order-total .order-value, .onepage-summary .order-total .order-value');
      const prevValue = elTotal.length > 0 ? 
                    Number(elTotal.text().replace( /[^0-9.]/g, '').trim()) : 
                    Number.POSITIVE_INFINITY;
      const prevCodeSelector = document.querySelector('.remove.coupon-remove');
      if(prevCodeSelector){
        const prevCodeUrl = $('.remove.coupon-remove').attr('href');
        this.removePrevCode(prevCodeUrl, () => callback(prevValue));
      }else{
        callback(prevValue)
      }      
    },
    applyCode: function(code, callback) {
      this._applyCode(code, function(value) {
       if(document.querySelector('.pt_cart')){
          this.removePrevCode(code, () => callback(value));
        }else{
          $.get(location.href, (response) => {
            const removeUrlSelector = $(response).find('.remove.coupon-remove');
            if(removeUrlSelector.length > 0 ){
              const prevCodeUrl = $(response).find('.remove.coupon-remove').attr('href');
              this.removePrevCode(prevCodeUrl, () => callback(value));
            }else{
              callback(value);
            }        
          });
        }
     }.bind(this));
    },
    applyBestCode: function(bestCode) {
      this._applyCode(bestCode, function(value) {
        location.reload();
      });
    },
    _applyCode: (code, callback) => {
      if(document.querySelector('.pt_cart')){
        const url = $('.cart-coupons-form').attr('action');
        const formData = getFormFieldsAsJson(document.querySelector('.cart-coupons-form'));
        formData['dwfrm_cart_couponCode'] = code;
        formData['dwfrm_cart_addCoupon'] = 'dwfrm_cart_addCoupon';
        $.post(url, formData, 
        (responsePost) => {
          const orderValueEl = $(responsePost).find('.cart-right .order-total .order-value');
          const value = orderValueEl.length > 0 ? 
                      Number(orderValueEl.text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;  
          callback(value);
        }).fail(function() {
          callback(Number.POSITIVE_INFINITY);
        }); 
      }else{
        const url = $('#summary-coupon-form').attr('action');
        $.post('https://www.rockport.com'+url+'?onepageentry=true&format=ajax', {couponCode : code}, 
        (responsePost) => {
          const orderValueEl = $(responsePost).find('.order-total .order-value');
          const value = orderValueEl.length > 0 ? 
                      Number(orderValueEl.text().replace( /[^0-9.]/g, '').trim()) : 
                      Number.POSITIVE_INFINITY;  
          callback(value);
        }).fail(function() {
          callback(Number.POSITIVE_INFINITY);
        }); 
      }    
    },
  },

  misspap: {
    removePrevCode: function(code, callback) {
      const windowVariables = retrieveWindowVariables(["window.Urls"]);
      const removeCouponUrl = windowVariables["window.Urls"].removeCoupon;
      $.ajax({
        url: removeCouponUrl+'?couponID='+code,
        type: 'GET',
        success: () => { callback(); },
        error: () => { callback(); }
      });
    },
    preApplyCodes: function(callback) { 
      const elTotal = document.querySelector('.js-checkout-order-totals .order-total .order-value').innerText;
      const prevValue = elTotal.replace(/[^0-9.]/g, '').trim();
      const prevCodeSelector = document.querySelector('#remove-coupon');
      if(prevCodeSelector){
        const prevCode = $('#remove-coupon').attr('data-coupon');
        this.removePrevCode(prevCode, () => callback(prevValue));
      }else{
        callback(prevValue);
      }      
    },
    applyCode: function(code, callback) {
      this._applyCode(code, function(value) {
        $.get(location.href, 
          (response) => {
            const orderValueEl = $(response).find('.js-checkout-order-totals .order-total .order-value');
            const value = orderValueEl.length > 0 ? 
                    Number(orderValueEl.first().text().replace( /[^0-9.]/g, '').trim()) : 
                    Number.POSITIVE_INFINITY;
            this.removePrevCode(code, () => callback(value));
        }).fail(function() {
            callback(Number.POSITIVE_INFINITY);
        });
     }.bind(this));
    },
    applyBestCode: function(bestCode) {
      document.querySelector('#dwfrm_billing_couponCode').value = bestCode;
      document.querySelector('#dwfrm_billing_couponCode').dispatchEvent(new Event('input', {bubbles: true}));
      document.querySelector('#dwfrm_billing_couponCode').dispatchEvent(new Event('change'));
      document.querySelector("#add-coupon").click();  
    },
    _applyCode: (code, callback) => {
      const windowVariables = retrieveWindowVariables(["window.Urls"]);
      const addCouponUrl = windowVariables["window.Urls"].addCoupon;
      $.ajax({
        url: addCouponUrl+'?couponCode='+code+'&format=ajax',
        type: 'POST',
        success: (response) => { callback(); },
        error: () => { callback(); }
      });
    },
  },

  olightstore: {
    id: 42780,
    removePrevCode: function(code, callback) {
      if(window.location.href.indexOf("cart") > -1){
        const url = $('#discount-coupon-form').attr('action');
        const form_key = $('[name="form_key"]').val();
        $.post(url, { remove: 1, coupon_code: code, form_key:form_key }, 
        (response) => {  callback(); }).fail(function() { callback(); });
      }else{
        const windowVariables = retrieveWindowVariables(["window.checkoutConfig"]);
        const quoteId = windowVariables["window.checkoutConfig"].quoteId;
        const customerData = windowVariables["window.checkoutConfig"].customerData;
        var url;
        if(customerData.id){
          url = 'https://www.olightstore.com/rest/default/V1/carts/mine/coupons';
        }else{
          url = 'https://www.olightstore.com/rest/default/V1/guest-carts/'+quoteId+'/coupons';
        }
        $.ajax({
          url: url,
          type: 'DELETE',
          success: (response) => { callback(); },
          error: (response) => { callback(); }
        });
      }           
    },
    preApplyCodes: function(callback) {
      const elTotal = $('.grand.totals .price');
      const prevValue = elTotal.length > 0 ? 
                    Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                    Number.POSITIVE_INFINITY;
      const prevCode = $('#coupon_code, #discount-code').val();
      if(prevCode != ''){
        this.removePrevCode(prevCode, () => callback(prevValue, prevCode));
      }else{
        callback(prevValue);
      }      
    },
    applyCode: function(code, callback) {
     this._applyCode(code, function(value) {
      if(window.location.href.indexOf("cart") > -1){
        $.get('https://www.olightstore.com'+window.location.pathname, (responseGet) => {
            const checkoutconfigindex = responseGet.indexOf("window.checkoutConfig");
            const customerDataindex = responseGet.indexOf("window.customerData");
            const finalIndex = customerDataindex-checkoutconfigindex;
            const data = JSON.parse(responseGet.substr(responseGet.indexOf("window.checkoutConfig")+24, finalIndex-38));
            const value = data.totalsData.base_grand_total;
            this.removePrevCode(code, () => callback(value));
          });
       }else{
        const ts = Math.round(new Date().getTime());
        const windowVariables = retrieveWindowVariables(["window.checkoutConfig"]);
        const quoteId = windowVariables["window.checkoutConfig"].quoteId;
        const customerData = windowVariables["window.checkoutConfig"].customerData;
        var url;
        if(customerData.id){
          url = 'https://www.olightstore.com/rest/default/V1/carts/mine/payment-information?_='+ts;
        }else{
          url = 'https://www.olightstore.com/rest/default/V1/guest-carts/'+quoteId+'/payment-information?_='+ts;
        }
        $.ajax({
            url: url,
            type: 'GET',
            success: (response) => {                  
               const value = response.totals.base_grand_total;
               callback(value.toFixed(2));
            },error: () => { callback(Number.POSITIVE_INFINITY); }
          });
       }   
     }.bind(this));
    },
    applyBestCode: function(bestCode) {
      this._applyCode(bestCode, function() {
        location.reload();
      }) ;
    },
    _applyCode: (code, callback) => {
      if(window.location.href.indexOf("cart") > -1){
        const form_key = $('[name="form_key"]').val();
        const url = $('#discount-coupon-form').attr('action');
        $.ajax({
          url: url,
          type: 'POST',
          data: { remove: 0, coupon_code: code, form_key:form_key },
          success: () => { callback(); },
          error: () => { callback(); }
        });
      }else{
        const windowVariables = retrieveWindowVariables(["window.checkoutConfig"]);
        const quoteId = windowVariables["window.checkoutConfig"].quoteId;
        const customerData = windowVariables["window.checkoutConfig"].customerData;
        var url;
        if(customerData.id){
          url = 'https://www.olightstore.com/rest/default/V1/carts/mine/coupons/'+code;
        }else{
          url = 'https://www.olightstore.com/rest/default/V1/guest-carts/'+quoteId+'/coupons/'+code;
        }
        $.ajax({
          url: url,
          type: 'PUT',
          success: () => { callback(); },
          error: () => { callback(); }
        });
      }
    },
  },

  focuscamera: {
    removePrevCode: function(code, callback) {
      const windowVariables = retrieveWindowVariables(["window.NREUM"]);
      const xpid = windowVariables["window.NREUM"].loader_config.xpid;
      const url = 'https://www.focuscamera.com/awesomecheckout/discount/apply';
      $.ajax({
          url: url,
          type: 'POST',
          headers: {
          'Content-Type': 'application/x-www-form-urlencoded; charset=UTF-8',
          'x-newrelic-id': xpid
          },
          data: {
            remove: '1',
          },
          success: () => {callback();}, error: () => {callback();}
        })
    },
    preApplyCodes: function(callback) { 
      const elTotal = $('#shopping-cart-totals-table tfoot strong span.price, .grand_total td:last-child .update');
      const prevValue = elTotal.length > 0 ? 
                    Number(elTotal.first().text().replace( /[^0-9.]/g, '').trim()) : 
                    Number.POSITIVE_INFINITY;
      const prevCode = $('#discount_code').val();
      if(prevCode != ''){         
        this.removePrevCode(prevCode, () => callback(prevValue, prevCode));
      }else{
        callback(prevValue);
      }      
    },
    applyCode: function(code, callback) {
      this._applyCode(code, function(value) {
       this.removePrevCode(code, () => callback(value));
     }.bind(this));
    },
    applyBestCode: function(bestCode) {
      document.querySelector('#discount_code').value = bestCode;
      document.querySelector('#discount_code').dispatchEvent(new Event('input', { bubbles: true }));
      document.querySelector('#discount_code').dispatchEvent(new Event('keyup'));
      document.querySelector('#discount_code').dispatchEvent(new Event('blur'));
      document.querySelector('#discount_code').dispatchEvent(new Event('focus'));
      document.querySelector('#discount-coupon-form fieldset button[value="Apply"], [name="add_couponaction"], [value="Apply Coupon"]').click();  
    },
    _applyCode: (code, callback) => {      
     const windowVariables = retrieveWindowVariables(["window.NREUM"]);
      const xpid = windowVariables["window.NREUM"].loader_config.xpid;
      const url = 'https://www.focuscamera.com/awesomecheckout/discount/apply';
      $.ajax({
          url: url,
          type: 'POST',
          headers: {
          'Content-Type': 'application/x-www-form-urlencoded; charset=UTF-8',
          'x-newrelic-id': xpid
          },
        data: {discount_code: code},
        success: (response, status, xhr) => {
          if(response.totals){
            const basket = response.totals;
            const orderValueEl = $(basket).find('tfoot strong span.price, .grand_total td:last-child .update');
            const value = orderValueEl.length > 0 ? 
                        Number(orderValueEl.text().replace( /[^0-9.]/g, '').trim()) : 
                        Number.POSITIVE_INFINITY;
            callback(value);
          }else{
            callback(Number.POSITIVE_INFINITY);
          }          
        },
        error: (xhr, status, error) => {
          callback(Number.POSITIVE_INFINITY);
        }
      });    
    },
  },

}


function extractFormValues(formSelector) {
    var formEl = document.querySelector(formSelector);
    var formFields = getFormFields(formEl);
    var requestData = new URLSearchParams('?' + formFields);
    requestData.action = formEl.action;
    return requestData;
}
  
function getFormFields(formEl) {
    var nodeNameRegexp = /^(?:input|select|textarea|keygen)/i;
    var nodeTypeRegexp = /^(?:submit|button|image|reset|file)$/i;
    var formFields = '';
  
    for (var i = 0; i < formEl.elements.length; i++) {
      var el = formEl.elements[i];
      if (nodeNameRegexp.test(el.nodeName) && !nodeTypeRegexp.test(el.type)) {
        if (el.type !== 'radio' && el.type !== 'select-multiple') {
          formFields = addFormField(formFields, el.name, el.value);
        } else if (el.type === 'radio' && el.checked) {
          formFields = addFormField(formFields, el.name, el.value);
        }
        el.type === 'select-multiple' && multipleCount++
      }
    }
    return formFields;
}

function getFormFieldsAsJson(formEl) {
  if (formEl === null || formEl === undefined) {
    return {};
  }

  var nodeNameRegexp = /^(?:input|select|textarea|keygen)/i;
  var nodeTypeRegexp = /^(?:submit|button|image|reset|file)$/i;
  var formFields = {};

  for (var i = 0; i < formEl.elements.length; i++) {
    var el = formEl.elements[i];
    if (nodeNameRegexp.test(el.nodeName) && !nodeTypeRegexp.test(el.type)) {
      if (el.name === null || el.name === undefined || el.length === 0) { continue; }
      if (el.type !== 'radio' && el.type !== 'select-multiple') {
        formFields[el.name] = el.value;
      } else if (el.type === 'radio' && el.checked) {
        formFields[el.name] = el.value;
      }
      el.type === 'select-multiple' && multipleCount++
    }
  }
  return formFields;
}

function addFormField(uri, name, value) {
    value = value.replace(/(\r)?\n/g, '\r\n');
    value = encodeURIComponent(value);
    value = value.replace(/%20/g, '+');
    return uri + (uri ? '&' : '') + encodeURIComponent(name) + '=' + value;
}
  
function sameOriginRequest(request, callback) {
    var headers = Object.keys(request.headers).map(function(header) {
      return `xhr.setRequestHeader('${header}', '${request.headers[header]}');`
    }).join('\n');
    var open = `xhr.open('${request.method}', '${request.url}');`
    var withCredentials = request.withCredentials ?
      `xhr.withCredentials = true;` : '';
    var send = `xhr.send('${request.body || ''}');`;
  
    var result = document.createElement('div');
    result.id = 'pb-autocoupons-eval-result';
    document.body.appendChild(result);
  
    var mutationCallback = function(mutationsList) {
      for(var mutation of mutationsList) {
        if (mutation.attributeName === 'result') {
          callback(document.getElementById(result.id).getAttribute('result'));
          observer.disconnect();
          result.remove();
          script.remove();
          break;
        }
      }
    };
  
    var observer = new MutationObserver(mutationCallback);
    observer.observe(result, { attributes: true });
  
    var script = document.createElement('script');
    script.type = 'text/javascript';
    code = `
      (function () {
        try {
          var xhr = new XMLHttpRequest();
          xhr.onreadystatechange = function () {
            if (xhr.readyState == 4) {
              document.getElementById('pb-autocoupons-eval-result').setAttribute('result', xhr.response);
            }
          };
          ${open}
          ${headers}
          ${withCredentials}
          ${send}
        } catch(e) {
          e.error = true;
          document.getElementById('pb-autocoupons-eval-result')
            .setAttribute('result', JSON.stringify(e, ['message', 'name', 'error']));
        }
      }())`;
    script.text = code;
    document.getElementsByTagName('head').item(0).appendChild(script);
}
  
function log(name, value) {
    console.log('!!! ' + name, value);
}
  
function HTMLParser(aHTMLString){
    var html = document.implementation.createDocument("http://www.w3.org/1999/xhtml", "html", null);
    var body = document.createElementNS("http://www.w3.org/1999/xhtml", "body");
    html.documentElement.appendChild(body);

    body.appendChild(Components.classes["@mozilla.org/feed-unescapehtml;1"]
        .getService(Components.interfaces.nsIScriptableUnescapeHTML)
        .parseFragment(aHTMLString, false, null, body));

    return body;
}
  
function getParam(parameter, url) {
    url = new URL(url || location.href);
    return url.searchParams.get(parameter);
}


function retrieveWindowVariables(variables) {
    var ret = {};

    var scriptContent = "";
    for (var i = 0; i < variables.length; i++) {
        var currVariable = variables[i];
        scriptContent += "if (typeof " + currVariable + " !== 'undefined') document.body.setAttribute('tmp_" + currVariable + "', JSON.stringify(" + currVariable + "));\n"
    }

    var script = document.createElement('script');
    script.id = 'tmpScript';
    script.appendChild(document.createTextNode(scriptContent));
    (document.body || document.head || document.documentElement).appendChild(script);

    for (var i = 0; i < variables.length; i++) {
        var currVariable = variables[i];
        ret[currVariable] = $.parseJSON($("body").attr("tmp_" + currVariable));
        $("body").removeAttr("tmp_" + currVariable);
    }

     $("#tmpScript").remove();

    return ret;
}

function getCookie(cname) {
  var name = cname + "=";
  var decodedCookie = decodeURIComponent(document.cookie);
  var ca = decodedCookie.split(';');
  for(var i = 0; i <ca.length; i++) {
    var c = ca[i];
    while (c.charAt(0) == ' ') {
      c = c.substring(1);
    }
    if (c.indexOf(name) == 0) {
      return c.substring(name.length, c.length);
    }
  }
  return "";
}